import static java.lang.Math.*;
import static java.util.Arrays.*;

import java.util.*;
import java.io.*;

public class Main {

	static final String FILENAME = "joke";
	public static void main(String[] args) {
		new Thread(null, new Runnable() {
			@Override
			public void run() {
				try {
					new Main().run();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		},"1", 1 << 24).start();
	}
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st = new StringTokenizer("");
	
	void run() throws IOException{
		in = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		in.close();
		out.close();
	}
	
	final int n = 51;
	
	boolean[] a = new boolean[n];
	int[] seq = new int[n];
	int cntSeq = 0;
	char[] s;
	
	boolean getOne(int i) {
		int si = s[i] - '0';
		if (!a[si] && si != 0)
			a[si] = true;
		else
			return false;
		seq[cntSeq++] = si;
		if (rec(i+1))
			return true;
		a[si] = false;
		cntSeq--;
		return false;
	}
	
	boolean getTwo(int i) {
		int si = s[i] - '0';
		int si_1 = s[i + 1] - '0';
		si = si * 10 + si_1;
		if (!a[si])
			a[si] = true;
		else
			return false;
		seq[cntSeq++] = si;
		if (rec(i+2))
			return true;
		a[si] = false;
		cntSeq--;
		return false;
	}
	
	boolean rec(int i) {
		if (i == s.length) {
			if (a[0])
				return false;
			int j;
			for (j = 1; j < n; j++) {
				if (!a[j]) break;
			}
			for (; j < n; j++)
				if(a[j])
					return false;
			return true;
		} else {
			if (i != s.length - 1) {
				int si = s[i] - '0';
				int si_1 = s[i + 1] - '0';
				if (si == 0)
					return false;
				if ((si_1 == 0 || a[si] || (si_1 > 5 && a[si_1])) && si < 6) {
					if (getTwo(i))
						return true;
				}
				if (getOne(i))
					return true;
				if (getTwo(i))
					return true;
			} else {
				if (getOne(i))
					return true;
			}
		}
		return false;
	}
	
	void solve() throws IOException{
		s = nextToken().toCharArray();
		fill(a, false);
		rec(0);
		for (int i = 0; i < cntSeq; i++)
			out.print(seq[i] + " ");
	}
	
	String nextToken() throws IOException{
		while(!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}
	
	int nextInt()  throws IOException{
		return Integer.parseInt(nextToken());
	}
	
	long nextLong() throws IOException{
		return Long.parseLong(nextToken());
	}
	
	double nextDoutble() throws IOException{
		return Double.parseDouble(nextToken());
	}
	
	boolean EOF() throws IOException{
		while (!st.hasMoreTokens()) {
			String s = in.readLine();
			if (s == null)
				return true;
			st = new StringTokenizer(s);
		}
		return false;
	}

}
