import static java.lang.Math.*;
import static java.util.Arrays.*;

import java.util.*;
import java.io.*;

public class Main {

	static final String FILENAME = "joke";
	public static void main(String[] args) {
		new Thread(null, new Runnable() {
			@Override
			public void run() {
				try {
					new Main().run();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		},"1", 1 << 24).start();
	}
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st = new StringTokenizer("");
	
	void run() throws IOException{
		in = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		in.close();
		out.close();
	}
	
	final int N = 51;
	final int M = 1000 * 1000 * 5;
	long ls[] = new long[M];
	int p[] = new int[M];
	
	int cnt = 0;
	
	void solve() throws IOException{
		
		char c[] = nextToken().toCharArray();
		int n = 1;
		int len = 1;
		int m = c.length;
		while (len < c.length) {
			len++;
			n++;
			if (n > 9)
				len++;
		}
		int ids[] = new int[m + 1];
		int mc[] = new int[m + 1];
		
		mc[0] = 1;
		ids[0] = 0;
		cnt = 1;
		for (int i = 1; i <= m; i++) {
			HashSet<Long> set = new HashSet<Long>();
			int ocnt = cnt;
			if (i > 1 && c[i - 2] != '0') {
				int v = (c[i - 1] - '0') + (c[i - 2] - '0') * 10 - 1;
				if (v + 1 <= n)
				{
					for (int j = 0; j < mc[i - 2]; j++) {
						long om = ls[ids[i - 2] + j];
						if (((1L << v) & om) == 0L) {
							long mask = om | (1L << v);
							if (!set.contains(mask)) {
								set.add(mask);
//								System.err.println(i + " " + mask + " " + (v + 1));
								p[cnt] = ids[i - 2] + j;
								ls[cnt++] = mask;
							}
						}
					}
				}
			}
			if (c[i - 1] != '0') {
				int v = (c[i - 1] - '0') - 1;
				if (v + 1 <= n)
				{
					for (int j = 0; j < mc[i - 1]; j++) {
						long om = ls[ids[i - 1] + j];
						if (((1L << v) & om) == 0L) {
							long mask = om | (1L << v);
							if (!set.contains(mask)) {
//								System.err.println(i + " " + mask + " " + (v + 1));
								set.add(mask);
								p[cnt] = ids[i - 1] + j;
								ls[cnt++] = mask;
							}
						}
					}
				}
			}
			mc[i] = cnt - ocnt;
			ids[i] = ocnt;
		}
		long mask = 0;
		int pos = 0;
		for (int i = 0; i < mc[m]; i++) {
			if (ls[ids[m] + i] > mask) {
				mask = ls[ids[m] + i];
				pos = ids[m] + i;
			}
		}
//		System.err.println(mask);
		int ans[] = new int[n];
		for (int i = n - 1; i > -1; i--) {
			long omask = ls[p[pos]];
			long diff = omask ^ mask;
			int k = 0;
			while (((diff & (1L << k)) == 0))
				k++;
			ans[i] = (k + 1);
			pos = p[pos];
			mask = omask;
		}
		for (int i = 0; i < n; i++)
			out.print(ans[i] + " ");
	}
	
	String nextToken() throws IOException{
		while(!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}
	
	int nextInt()  throws IOException{
		return Integer.parseInt(nextToken());
	}
	
	long nextLong() throws IOException{
		return Long.parseLong(nextToken());
	}
	
	double nextDoutble() throws IOException{
		return Double.parseDouble(nextToken());
	}
	
	boolean EOF() throws IOException{
		while (!st.hasMoreTokens()) {
			String s = in.readLine();
			if (s == null)
				return true;
			st = new StringTokenizer(s);
		}
		return false;
	}

}
