import static java.lang.Math.*;
import static java.util.Arrays.*;

import java.util.*;
import java.io.*;

public class Main {

	static final String FILENAME = "knockout";
	public static void main(String[] args) {
		new Thread(null, new Runnable() {
			@Override
			public void run() {
				try {
					new Main().run();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		},"1", 1 << 24).start();
	}
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st = new StringTokenizer("");
	
	void run() throws IOException{
		in = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		in.close();
		out.close();
	}
	
	void solve() throws IOException{
		
		int n = nextInt();
		int m = nextInt();
		
		int a[] = new int[n];
		int b[] = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextInt();
			b[i] = nextInt();
		}
		
		for (int i = 0; i < m; i++) {
			int x = nextInt();
			int y = nextInt();
			int t = nextInt();
			int ans = 0;
			for (int j = 0; j < n; j++) {
				int d = abs(a[j] - b[j]);
				int dl = 1;
				if (a[j] > b[j])
					dl = -1;
				int z = t % (d * 2);
				int k = a[j] + z * dl;
				if (z > d) {
					k = b[j] - (z - d) * dl;
				}
				if (k >= x && k <= y)
					ans++;
			}
			out.println(ans);
		}
		
	}
	
	String nextToken() throws IOException{
		while(!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}
	
	int nextInt()  throws IOException{
		return Integer.parseInt(nextToken());
	}
	
	long nextLong() throws IOException{
		return Long.parseLong(nextToken());
	}
	
	double nextDoutble() throws IOException{
		return Double.parseDouble(nextToken());
	}
	
	boolean EOF() throws IOException{
		while (!st.hasMoreTokens()) {
			String s = in.readLine();
			if (s == null)
				return true;
			st = new StringTokenizer(s);
		}
		return false;
	}

}
