import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.StringTokenizer;


public class Main {
	
	long []hash;
	int [][] ost;
	int [][] names;
	ArrayList<Integer> files = new ArrayList<Integer>();
//	boolean []used;
	
	public void solve() throws IOException {
		int m=nextInt(), f=nextInt();
		hash = new long[f];
		for (int i=0; i<f; i++) {
			hash[i]=nextLong();
		}
		int n = nextInt();
		names = new int[n][m];
//		used = new boolean[n];
		for (int i=0; i<n; i++) {
			char file[] = nextToken().toCharArray();
			int cnt=0;
			for (int j=0; j<file.length-1; j++) {
				int num=0;
				if (file[j]>='a' && file[j]<='f') {
					num=file[j]-'a'+10;
				} else {
					num=file[j]-'0';
				}
				for (int k=0; k<4; k++, num/=2) {
					if (num%2!=0) {
						names[i][cnt++]=1;
					} else {
						names[i][cnt++]=0;
					}
				}
			}
			int num=0;
			if (file[file.length-1]>='a' && file[file.length-1]<='f') {
				num=file[file.length-1]-'a'+10;
			} else {
				num=file[file.length-1]-'0';
			}
			for (int j=0, b=(m%4==0) ? 4 : m%4; j<b; j++, num/=2) {
				if (num%2!=0) {
					names[i][cnt++]=1;
				} else {
					names[i][cnt++]=0;
				}		
			}
		}
//		for (int i=0; i<m; i++) {
//			out.printf("%2d ", i);
//		}
//		out.println();out.println();
//		for (int i=0; i<n; i++) {
//			for (int j=0; j<m; j++) {
//				out.printf("%2d ", names[i][j]);
//			}
//			out.println();
//		}
		int q = nextInt();
		ost = new int[q][f];
		for (int i=0; i<q; i++) {
			long u=nextLong();
			for (int j=0; j<f; j++) {
				ost[i][j]=(int)  ((u*hash[j])%m);
			}
		}
		for (int i=0; i<n; i++) {
			for (int j=0; j<q; j++) {
				boolean ok=true;
				for (int k=0; k<f; k++) {
					if (names[i][ost[j][k]]==0) {
						ok=false;
						break;
					}
				}
				if (ok) {
					files.add(j);
					break;
				}
			}
		}
		
//		for (int i=0; i<q; i++) {
//			for (int j=0; j<n; j++) {
//				if (used[j]) continue;
//				boolean ok=true;
//				for (int k=0; k<f; k++) {
//					if (names[j][ost[i][k]]==0) {
//						ok=false;
//						break;
//					}
//				}
//				if (ok) {
//					used[j]=true;
//					files.add(j);
//				}
//			}
//		}
		out.print(files.size()+" ");
		Collections.sort(files);
		for (Integer i:files) {
			out.print(i+" ");
		}
	}
	
	public static void main(String[] args) throws IOException {
		new Main().run();
	}
	
	final String fileIn  = "filter.in";
	final String fileOut = "filter.out";
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st = new StringTokenizer("");
	
	private void run() throws IOException {
		in = new BufferedReader(new FileReader(fileIn));
//		in = new BufferedReader(new InputStreamReader(System.in));
		
		out = new PrintWriter(new FileWriter(fileOut));
//		out = new PrintWriter(System.out);
		
		solve();
		
		in.close();
		out.close();
	}
	
	String nextToken() throws IOException {
		while (!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}
	
	Integer nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	Double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	Long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}
	
	String nextString() throws IOException {
		st = new StringTokenizer("");
		return in.readLine();
	}
	
	boolean EOF() throws IOException {
		while (!st.hasMoreTokens()) {
			String s = in.readLine();
			if (s == null)
				return true;
			st = new StringTokenizer(s);
		}
		return false;
	}
}
