import java.io.*;
import java.util.*;


public class Main {
	
	boolean used[];
	char a[];
	int n;
	
	LinkedList<Integer> stack = new LinkedList<Integer>();
	
	boolean good(int index) {
		if (index >= a.length) return true;
		
		int x = a[index] - '0';
		if (x == 0) return false;
		
		
		if (index < a.length-1) {
			int xx = x*10 + (a[index+1] - '0');
			if (xx <= n) {
				if (used[x] && used[xx]) return false;
				
				if (!used[xx]) {
					used[xx] = true;
					stack.push(xx);
					if (good(index+2)) return true;
					stack.pop();
					used[xx] = false;
				}
				
			} else if (used[x]) return false;
		} else if (used[x]) return false;
		
		if (used[x]) return false;
		
		used[x] = true;
		stack.push(x);
		if (good(index+1)) return true;
		stack.pop();
		used[x] = false;
		
		return false;
	}
	
	public void solve() throws IOException {
		a = nextToken().toCharArray();
		
		int c = a.length;	
		if (c <= 9) {
			n = c;
		} else {
			n = 9 + (c-9)/2;
		}
		
		used = new boolean[n+1];
		
		good(0);
		
		while (stack.size() > 0) {
			out.print(stack.pollLast() + " ");
		}
			
//		for (int i = 1; i < 51; ++i) {
//			System.out.print(i);
//		}
	}
	
	public static void main(String[] args) throws IOException {
		new Main().run();
	}
	
	final String fileIn = "joke.in";
	final String fileOut = "joke.out";
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st = new StringTokenizer("");
	
	private void run() throws IOException {
		in = new BufferedReader(new FileReader(fileIn));
//		in = new BufferedReader(new InputStreamReader(System.in));
		
		out = new PrintWriter(new FileWriter(fileOut));
//		out = new PrintWriter(System.out);
		
		solve();
		
		in.close();
		out.close();
	}
	
	String nextToken() throws IOException {
		while (!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}
	
	Integer nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	Double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	Long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}
	
	String nextString() throws IOException {
		st = new StringTokenizer("");
		return in.readLine();
	}
	
	boolean EOF() throws IOException {
		while (!st.hasMoreTokens()) {
			String s = in.readLine();
			if (s == null)
				return true;
			st = new StringTokenizer(s);
		}
		return false;
	}
}
