#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <stdio.h>
#include <string.h>
#include <cstdio>
#include <iomanip>

using namespace std;
#define all(v) v.begin(),v.end()
typedef long long ll;
typedef long double db;

struct T{
	int id;
	db a, b, k, g, gr;
};
bool operator <(const T &a, const T &b){
	return a.k > b.k;
}
bool cmp(const T &a, const T &b){
	return a.id < b.id;
}
int n;
db A, B;
vector < T > w;

int main(){
		ios::sync_with_stdio(0);
		freopen("burrito.in", "r", stdin); freopen("burrito.out", "w", stdout);
	//	cin >> n >> A >> B;
	ll t1, t2, t3;
	//scanf("%d%lf%lf", &n, &t2, &t3);
	cin >> n >> t2 >> t3;
	A = t2, B = t3;
	w.resize(n);

	for (int i = 0; i < n; i++){
//		scanf("%lf%lf%lf", &t1, &t2, &t3);
		cin >> t1 >> t2 >> t3;
		w[i].g = (db)t1;
		w[i].a = (db)t2;
		w[i].b = (db)t3;
		w[i].k = w[i].a / w[i].b;
		w[i].id = i;
	}

	sort(all(w));
	db q = 0, ans = 0;
	for (int i = 0; i < n; i++){
		w[i].gr = min((db)w[i].g, (B - q) / w[i].b);
		q += w[i].gr*w[i].b;
		ans += w[i].gr*w[i].a;
	}
	sort(all(w), cmp);

	if (ans + (1e-9) < A){ puts("-1 -1"); return 0; }
	
	double tt1 = (double)ans, tt2 = (double)q;
	//printf("%.8lf %.8lf\n", tt1, tt2);
	cout << tt1 << ' ' << tt2 << '\n';
	for (int i = 0; i < n; i++){
		//cout << (double)w[i].gr << ' ';
		double tt = (double)w[i].gr;
		//printf("%.8lf ", tt);
		cout <<tt << ' ';
	}
	return 0;
}
/*
2 5 5
2 2 1
2 2 4
*/
