#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <sstream>
#include <algorithm>
#include <cstdio>
#include<functional>

using namespace std;
#define all(v) v.begin(),v.end()
typedef long long ll;
typedef double db;

struct T{
	int id;
	db a, b, k, g, gr;
};
bool operator <(const T &a, const T &b){
	return a.k > b.k;
}
bool cmp(const T &a, const T &b){
	return a.id < b.id;
}
int n;
db A, B;
vector < T > w;

void main(){
	freopen("burrito.in", "r", stdin); freopen("burrito.out", "w", stdout);
	scanf("%d%lf%lf", &n, &A, &B);
	w.resize(n);

	for (int i = 0; i < n; i++){
		scanf("%lf%lf%lf", &w[i].g, &w[i].a, &w[i].b);
		w[i].k = w[i].a / w[i].b;
		w[i].id = i;
	}

	sort(all(w));
	db q = 0, ans=0;
	for (int i = 0; i < n; i++){
		w[i].gr = min((db)w[i].g, (B - q) / w[i].b);
		q += w[i].gr*w[i].b;
		ans += w[i].gr*w[i].a;
	}
	sort(all(w), cmp);

	if (ans < A){ puts("-1 -1"); return ; }
	printf("%.9lf %.9lf\n", ans, q);
	for (int i = 0; i < n; i++){
		printf("%.9lf ", w[i].gr);
	}
}
/*
2 5 5
2 2 1
2 2 4
*/