#include <iostream>
#include <stdio.h>
#include <cmath>
#include <string>
#include <string.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <time.h>
#include <stdlib.h>
#include <memory.h>

#define F first
#define S second

typedef long long ll;

const int N = 1e5+3;
const int inf = 1e9;
const double eps = 1e-10;

using namespace std;

int a[N], b[N], g[N];
pair<double, int> st[N];
double an[N];

bool solve()
{
    int i, j, n, x, m;
    double A, B, anA, anB;
    scanf("%d%lf%lf", &n, &A, &B);
   // printf("%.10f\n", A);
    for(i=0; i<n; ++i) scanf("%d%d%d", &g[i], &a[i], &b[i]);
    for(i=0; i<n; ++i) an[i]=0;
    anA=0, anB=0; m=0;
    for(i=0; i<n; ++i)
        if(!b[i])
        {
            an[i]=g[i];
            anA+=a[i]*g[i];
        }
        else
        {
            st[m++]=make_pair(double(a[i])/b[i], i);
        }
    sort(st, st+m);
    for(j=m-1; j>=0; --j)
    {
        i=st[j].S;
        if(!a[i]) break;
        x=g[i]*b[i];
        if(x+anB>=B)
        {
            x=B-anB;
            an[i]=double(x)/b[i];
            anA+=an[i]*a[i];
            anB+=an[i]*b[i];
            break;
        }
        else
        {
            an[i]=g[i];
            anA+=an[i]*a[i];
            anB+=an[i]*b[i];
        }
    }
   // printf("%.10f\n", A-anA);
    if(A-anA>eps)
    {
        printf("-1 -1\n");
        return 0;
    }
    printf("%.10f %0.10f\n", anA, anB);
    for(i=0; i<n; ++i) printf("%.10f ", an[i]);
    printf("\n");
    return 0;
}

int main()
{
    freopen("burrito.in","r",stdin);
    freopen("burrito.out","w",stdout);
    while (solve());
    return 0;
}
