#include <iostream>
#include <stdio.h>
#include <cmath>
#include <string>
#include <string.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <time.h>
#include <stdlib.h>
#include <memory.h>

typedef long long ll;

const int N = 1e5+3;
const int inf = 1e9;

using namespace std;

char t[N];
int to[N][3];

int vn;
char ans[N];
int at[N][3];

int inv(int x){
    if(x=='R') return 'P';
    if(x=='P') return 'S';
    if(x=='S') return 'R';
}

int tp(int x){
    if(x=='R') return 0; else
        if(x=='P') return 1;
        if(x=='S') return 2;
}

bool u[N];


int dfs(set<int> s, int par = -1){
    //cout<<"!";for(int x : s) cout<<x<<' '; cout<<endl;
    int id = ++vn;
    if(s.size()==1){
            int res = id;
        int i = *s.begin();
       // cout<<"?"<<i<<' '<<t[i]<<endl;

        memset(u,0,sizeof u);
        for(;;){
            if(u[i]) break;
            u[i]= 1;
            ans[id] = inv(t[i]);
            for(int j=0;j<3;++j) at[id][j] = id;
            i = to[i][tp(ans[id])];
            //cout<<"??"<<i<<' '<<u[i]<<endl;
            if(u[i]) break;
            int pr = id;
            at[pr][tp(t[i])] = id = ++vn;
        }

        return res;
    }

    bool fl = false;
    for(int j=0;j<3;++j){
        set<int> q;
        for(int x : s) q.insert(to[x][j]);
        if(q.size() && q.size()<s.size()){
            int v = dfs(q);
            ans[v] = "RPS"[j];
            at[id][inv(ans[v])] = v;
            fl = true;
            break;
        }
    }
    if(!fl){
        ans[id] = inv(t[*s.begin()]);
        for(int j=0;j<3;++j) at[id][j] = id;
    }
    return id;
}

set<int> q[3];

bool solve()
{
    int n;
    cin>>n;
    for(int i=0;i<n;++i){
        string z;
        cin>>z;
        t[i] = z[0];
        for(int j=0;j<3;++j){
            cin>>to[i][j];
            --to[i][j];
        }
        q[tp(t[i])].insert(i);
    }

    vn = 1;
    ans[vn] = 'P';
    for(int j=0;j<3;++j){
        if(q[j].size()){
            at[1][j] = dfs(q[j]);
        }else{
            at[1][j] = 1;
        }

    }


    cout<<vn<<endl;
    for(int i=1;i<=vn;++i){
    cout<<ans[i]<<' ';
    for(int j=0;j<3;++j) cout<<at[i][j]<<' '; cout<<endl;
    }

    return 0;
}

int main()
{
    freopen("epic.in","r",stdin);
    freopen("epic.out","w",stdout);
    while (solve());
    return 0;
}
