#include <iostream>
#include <string>
#include <stdio.h>
#include <sstream>

using namespace std;
int N;
bool flag[55];
string int_to_str(int n) {
	string res;
	while (n) {
		char a = '0' + (char)(n % 10);
		res = a + res;
		n /= 10;
	}
	return res;
}
string mask(string n) {
	int len = n.length();
	for (int i = 0; i < len; i++) {
		n[i] = n[i] + 10;
	}
	return n;
}

string unmask(string n) {
	int len = n.length();
	for (int i = 0; i < len; i++) {
		n[i] = n[i] - 10;
	}
	return n;
}

int str_to_int(string n) {
	int res = 0;
	if (n[0] > '9') n = unmask(n);
	int len = n.length();
	if (len > 5) return 100000;
	for (int i = 0; i < len; i++) {
		res = res * 10 + n[i] - '0';
	}
	return res;
}

bool check(string str) {
	bool f[55];
	for (int i = 0; i < N; i++) f[i] = false;
	stringstream ss(str);
	string s;
	while (ss >> s) {
		int a = str_to_int(s);
		if (a <= N) { flag[a] = true; }
	}
	bool res = true; for (int i = 0; i < N; i++) res &= f[i] ;
	return res;
}



string rec(string str, int n) {
	while (flag[n] && n <= N) n++;
	if (n > N) return str;
	string str2;
	string a = int_to_str(n);
	int pos = str.find(a);
	if (pos != string::npos) {
		//found
		str2 = str.substr(0, pos) + ' ' + mask(a) + ' ' + str.substr(pos + a.length(), str.length());
	}
	flag[n] = true;
	string res = rec(str2, n + 1);
	flag[n] = false;
	if (check(res)) return res;
    
	 pos = str.rfind(a);
	if (pos != string::npos) {
		//found
		str2 = str.substr(0, pos) + ' ' + mask(a) + ' ' + str.substr(pos + a.length(), str.length());
	}
	flag[n] = true;
	res = rec(str2, n + 1);
	flag[n] = false;
	return res;
	//cout << str;
}


int main(){
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
	string str;
	cin >> str;
	int len = str.length();
	int n;
	if (len <= 9) n = len; else n = (len - 9) / 2 + 9;
	N = n;
	//big nums;
	for (int i = 0; i < n; i++) flag[i] = false;

	for (int i = 0; i < str.length() - 1; i++) {
		string a = str.substr(i, 2);
		//cout << a << endl;
		if (str_to_int(a) > n) {
			str = str.substr(0, i + 1) + ' ' + str.substr(i + 1, str.length()); i++;
			//cout << str << endl;
		}
	}



	//10 20 30 40 50
	for (int i = 10; i <= n; i += 10) {
		string a = int_to_str(i);
		int pos = str.find(a);
		if (pos != string::npos) {
			//found
			str = str.substr(0, pos) + ' ' + mask(a) + ' ' + str.substr(pos + 2, str.length());
		}
		//cout << str;
	}
	stringstream ss(str);
	string s;
	string ssout;
	while (ss >> s) {
		int a = str_to_int(s);
		if (a <= n) { if (!flag[a]) ssout += mask(s) + ' '; else ssout += s + ' '; flag[a] = true; }
		else ssout += s + ' ';
	}
	//cout << str << endl;

	//cout << ssout << endl;
	string res = rec(str, 1);
	stringstream ress(res);
	while (ress >> s) {
		cout << str_to_int(s) << ' ';
	}
	return 0;
}