// isit sfu 1 - comp. 6 ---- cab 301
import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {

    public static void main(String[] args) {
        Reader in = null;
        PrintWriter out = null;
        try {
            in = new Reader(new FileInputStream("burrito.in"));
            out = new PrintWriter(new FileOutputStream("burrito.out"));
        } catch (FileNotFoundException e) {
            throw new RuntimeException();
        }

        int n = in.nextInt();
        int A = in.nextInt();
        int B = in.nextInt();
        Ingr [] l = new Ingr[n];
        for (int i = 0; i <n; i++) {
            l[i] = new Ingr();
            l[i].index = i;
            l[i].amount = in.nextInt();
            l[i].a = in.nextInt();
            l[i].b = in.nextInt();
        }
        Arrays.sort(l);

        int at=0, bt=B;
        double add=0;
        double [] ans = new double[n];
        Arrays.fill(ans, 0.d);
        for (int i = 0; i < n; i++) {
            int can = l[i].amount;
            int can2 = bt/l[i].b;
            if (!Double.isInfinite(can2) && can2<can ) {
                ans[l[i].index] = (double)bt/l[i].b;
                int tmp = bt*l[i].a/l[i].b;
                at+=tmp;
                add = (double)bt*l[i].a/l[i].b - tmp;
                bt = 0;
                break;
            }
            at+= can*l[i].a;
            bt-= can*l[i].b;
            ans[l[i].index] = can;
        }

        if (at>=A){
            out.println(String.format("%.10f %d", at+add, B-bt));
            for (int i = 0; i < n; i++) {
                out.print(String.format("%.10f ", ans[i]));
            }
            out.println();
        }
        else{
            out.println("-1 -1");
        }
       out.close();
    }
}

class Ingr implements Comparable<Ingr>{
    public int index;
    public int amount;
    public int a;
    public int b;

    @Override
    public int compareTo(Ingr o) {
        double a = this.a;
        double b = this.b;
        if (Double.isInfinite(a/b) && Double.isInfinite((double)o.a /o.b)) return -Double.compare(a, o.a);
        if (Double.isInfinite(a/b)) return -1;
        if (Double.isInfinite((double)o.a/o.b)) return 1;
        return -Double.compare(a/b, (double)o.a/o.b);
    }
}

class Reader{
    StringTokenizer st;
    BufferedReader is;

    public Reader(InputStream pis){
        Locale.setDefault(Locale.US);
        is = new BufferedReader(new InputStreamReader(pis));
        st = new StringTokenizer("");
    }

    public String nextLine(){
        st = new StringTokenizer("");
        try {
            return is.readLine();
        } catch (IOException e) {
            throw new RuntimeException();
        }
    }

    public String next(){
        while (!st.hasMoreTokens())st = new StringTokenizer(nextLine());
        return st.nextToken();
    }

    public long nextLong(){
        return Long.parseLong(next());
    }
    public int nextInt(){
        return Integer.parseInt(next());
    }
}