import java.io.*;
import java.util.HashSet;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {

    public static void main(String[] args) {
        Reader in = null;
        PrintWriter out = null;
        try {
            in = new Reader(new FileInputStream("improvements.in"));
            out = new PrintWriter(new FileOutputStream("improvements.out"));
        } catch (FileNotFoundException e) {
            throw new RuntimeException();
        }

        int n = in.nextInt();
        int [] x = new int[n];
        for (int i = 0; i <n; i++) {
            x[i] = in.nextInt()-1;
        }

        int st = 0;
        int end = n-1;
        HashSet<Integer> rem = new HashSet<Integer>();

        for (int i = 0; i < n; i++) {
            while (rem.contains(st)) ++st;
            while (rem.contains(end)) --end;
            if (x[i]==st)++st;
            else if (x[i]==end)--end;
            else rem.add(x[i]);
        }

        out.println(n-rem.size());

        out.close();
    }
}

class Reader{
    StringTokenizer st;
    BufferedReader is;

    public Reader(InputStream pis){
        Locale.setDefault(Locale.US);
        is = new BufferedReader(new InputStreamReader(pis));
        st = new StringTokenizer("");
    }

    public String nextLine(){
        st = new StringTokenizer("");
        try {
            return is.readLine();
        } catch (IOException e) {
            throw new RuntimeException();
        }
    }

    public String next(){
        while (!st.hasMoreTokens())st = new StringTokenizer(nextLine());
        return st.nextToken();
    }

    public long nextLong(){
        return Long.parseLong(next());
    }
    public int nextInt(){
        return Integer.parseInt(next());
    }
}