import com.sun.org.apache.xpath.internal.SourceTree;

import java.io.*;
import java.util.*;

public class Main {


    public static StringTokenizer tokenizer;
    public static BufferedReader reader;
    public static PrintWriter writer;

    public static void init() {
        try {
            reader = new BufferedReader(new InputStreamReader(new FileInputStream("joke.in")));
            writer = new PrintWriter(new FileOutputStream("joke.out"));
        } catch (IOException e) {
            System.out.println(e);
            System.exit(1);
        }
    }

    public static String nextToken() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                System.out.println(e);
                System.exit(1);
            }
        }
        return tokenizer.nextToken();
    }

    public static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    public static Long nextLong() {
        return Long.parseLong(nextToken());
    }

    public static Byte nextByte() {
        return Byte.parseByte(nextToken());
    }

    public static Double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    public static Short nextShort() {
        return Short.parseShort(nextToken());
    }

    public static Float nextFloat() {
        return Float.parseFloat(nextToken());
    }

    public static void close() {
        try {
            reader.close();
            writer.flush();
            writer.close();
        } catch (IOException e) {
            System.out.println(e);
            System.exit(1);
        }
    }

    public static void solve() {
        String str = nextToken();
        Boolean[] z = new Boolean[51];
        for (int i = 0; i < z.length; i++) {
            z[i] = false;
        }

        int max = str.length();


        if (max > 10) {
            max = (max - 9) / 2 + 9;
        }

        writer.print(joker(str, "", z, max).trim());
//        System.out.println();
    }

    public static String joker(String s, String s1, Boolean[] arr, int max) {
//        System.out.println(s+" "+s1);
        String ss = s;
        String ss1 = s1;
        String result = "";
        if ((s.length() == 1 || (s.length() == 2) && (s.charAt(0) != '0')) && (Integer.parseInt(s) <= max) && !arr[Integer.parseInt(s)]) {
            s1 += " " + s;
            return s1;
        } else if (s.length() >= 2) { // !!!!!!!!
            if (s.length() > 2) {

                Boolean br = true;

                int x = Integer.parseInt(String.valueOf(s.charAt(0)) + String.valueOf(s.charAt(1)));
                if (x < 10) br = false;
                if (x > max) {
                    br = false;
                } else {
//------------------------
                    if (arr[x]) br = false;
                    if (br) {
                        arr[x] = true;
                        ss1 += " " + x;
                        ss = s.substring(2, ss.length());
                        result = joker(ss, ss1, arr, max);
                        arr[x] = false;
                    }

                    if (result.equals("#")) {
                        br = false;
                    } else {
                        if (br) return result;
                    }
//------------------------


                }
            }
            ss = s;
            ss1 = s1;
            //start
            Boolean br1 = true;
            int x = Integer.parseInt(String.valueOf(s.charAt(0)));
//            System.out.println(x);
                if (arr[x]) br1 = false;
                if (br1) {
                    arr[x] = true;
                    ss1 += " " + x;
                    ss = s.substring(1, ss.length());
                    result = joker(ss, ss1, arr, max);
                    arr[x] = false;
                }

                if (result.equals("#")) {
                    br1 = false;
                } else {
                    if (br1)
                    return result;
                }

        }
//        System.out.println(s1+" "+s);
        return "#";
    }

    public static void main(String[] args) {
        init();
        solve();
        close();
    }
}
