#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#include <vector>

using namespace std;

int n, m;
pair<int, int> ranges[1009];

void ReadData()
{
	scanf("%d %d", &n, &m);
	for (int i = 0; i < n; i++)
	{
		scanf("%d %d", &ranges[i].first, &ranges[i].second);
	}
}

vector<int> answer;

void Solve()
{
	for (int i = 0; i < m; i++)
	{
		int l, r, t;
		scanf("%d %d %d", &l, &r, &t);
		int current = 0;
		for (int j = 0; j < n; j++)
		{
			int d = ranges[j].second - ranges[j].first;
			int pos;
			int dd = t / d;
			if (dd % 2 == 0)
			{
				pos = ranges[j].first + t % d;
			}
			else
			{
				pos = ranges[j].second - t % d;
			}
			//printf("%d %d\n", t, pos);
			if (pos >= l && pos <= r)
			{
				current++;
			}
		}
		answer.push_back(current);
	}
}

void WriteData()
{
	for (vector<int>::iterator it = answer.begin(); it != answer.end(); ++it)
	{
		printf("%d\n", *it);
	}
}

int main()
{
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);
	ReadData();
	Solve();
	WriteData();
	return 0;
}