#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

int main(){
	ifstream in("burrito.in");
	ofstream out("burrito.out");
	cin.set_rdbuf(in.rdbuf());
	cout.set_rdbuf(out.rdbuf());

	cout.precision(10);

	ll n, A, B;

	cin >> n >> A >> B;
	vector<ll> g(n);
	vector<ll> a(n);
	vector<ll> b(n);
	vector<double> s(n, 0.0);
	multimap<double, int> hap;


	double suma(0);
	double sumb(0);

	for (int i = 0; i < n; i++){
		cin >> g[i] >> a[i] >> b[i];
		if (b[i] == 0) {
			s[i] = g[i];
			suma += s[i] * a[i];
		}
		else{
			if (a[i] == 0) continue;
			hap.insert(make_pair(a[i] * 1.0 / b[i], i));
		}
	}

	for (auto i = hap.rbegin(); i != hap.rend(); i++){
		int ind = i->second;
		if (sumb + g[ind] * b[ind] <= B){
			s[ind] = g[ind];
		}
		else{
			s[ind] = (B - sumb) * 1.0 / b[ind];
		}
		suma += s[ind] * a[ind];
		sumb += s[ind] * b[ind];
	}

	if (suma < A) cout << "-1 -1";
	else{
		cout << suma << ' ' << sumb << endl;
		for (int i = 0; i < n; i++){
			cout << s[i] << ' ';
		}
	}
	return 0;
}
