#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <deque>
#include <ctime>
#include <set>
#include <map>
#include <cstdint>
#include <fstream>

using namespace std;

ifstream in("burrito.in");
ofstream out("burrito.out");
#define EPS (1e-8)
bool order(pair<pair<double, int>, pair<double, double>>& a, pair<pair<double, int>, pair<double, double>>& b)
{
	int result = a.second.first / a.second.second - b.second.first / b.second.second;
	return ((abs(result) < EPS) ? a.first.first < b.first.first :
		result > -EPS);
}

int main()
{
	int64_t n, a, b;
	in >> n >> a >> b;
	vector<pair<pair<double,int>,pair<double,double>>> v(n);
	vector<double> vresult(n, 0);
	double aresult = 0, bresult = 0;

	for (int i = 0; i < n; ++i)
	{
		in >> v[i].first.first >> v[i].second.first >> v[i].second.second;
		v[i].first.second = i;
	}
	sort(v.begin(), v.end(), order);

	for (int i = 0; i < n; ++i)
	{
		if (v[i].second.second * v[i].first.first + bresult - b < -EPS)
		{
			bresult += v[i].second.second*v[i].first.first;
			aresult += v[i].second.first*v[i].first.first;
			vresult[v[i].first.second] = v[i].first.first;
		}
		else
		{
			double mn = b - bresult;
			if (abs(mn) < EPS)
				break;
			mn = mn / (v[i].second.second*v[i].first.first);
			bresult += mn * v[i].second.second * v[i].first.first;
			aresult += mn * v[i].second.first * v[i].first.first;
			vresult[v[i].first.second] = mn * v[i].first.first;
			break;
		}
	}

	if (aresult < a) out << "-1 -1";

	else
	{
		out << aresult << ' ' << bresult << endl;
		for (auto vi : vresult) out << vi << ' ';
	}
	
}

//int main()
//{
//	long long n, m;
//	in >> n >> m;
//	vector<long long> a(n), b(n),delta(n);
//	vector<long long> x(m), y(m), t(m);
//	for (long long i = 0; i < n; i++)
//	{
//		in >> a[i] >> b[i];
//		delta[i] = 2 * (b[i] - a[i]);
//	}
//	for (long long i = 0; i < m; i++)
//	{
//		in >> x[i] >> y[i] >> t[i];
//		long long count = 0;
//		for (long long j = 0; j < n; j++)
//		{
//			long long v = t[i] % delta[j];
//			if (v>delta[j]/2)
//				v = v - delta[j]/2;
//			v += a[j];
//			if (v >= x[i] && v <= y[i])
//				count++;
//		}
//		out << count << endl;
//	}
//}
/*int main()
{
	int n, m;
	in >> n >> m;
	out << n / 2 + m / 2<<endl;
	for (int i = 2; i <= n; i+=2)
	{
		out << i << ' ' << 1 << ' ' << i << ' ' << m<<endl;
	}
	for (int i = 2; i <= m; i += 2)
	{
		out << 1 << ' ' << i << ' ' << n << ' ' << i << endl;
	}
	return 0;
}*/
//
//int main()
//{
//	int64_t count;
//	string str;
//	deque<int> st;
//	in >> str;
//
//	size_t size = str.size();
//	if (size > 9)
//	{
//		count = (size - 9) / 2 + 9;
//		
//
//	}
//	else for (auto a : str) out << a << ' ';
//		
//
//
//	return 0;
//}