#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <deque>
#include <ctime>
#include <set>
#include <map>
#include <cstdint>
#include <fstream>

using namespace std;

ifstream in("burrito.in");
ofstream out("burrito.out");
#define EPS (1e-16)
bool order(pair<pair<double, int>, pair<double, double>>& a, pair<pair<double, int>, pair<double, double>>& b)
{
	int result = a.second.first / a.second.second - b.second.first / b.second.second;
	return result > 0;
}

int main()
{
	int64_t n, a, b;
	in >> n >> a >> b;
	vector<pair<pair<double,int>,pair<double,double>>> v(n);
	vector<double> vresult(n, 0);
	double aresult = 0, bresult = 0;

	for (int i = 0; i < n; ++i)
	{
		in >> v[i].first.first >> v[i].second.first >> v[i].second.second;
		v[i].first.second = i;
	}
	sort(v.begin(), v.end(), order);

	for (int i = 0; i < n; ++i)
	{
		if (v[i].second.second * v[i].first.first + bresult - b < -EPS)
		{
			bresult += v[i].second.second*v[i].first.first;
			aresult += v[i].second.first*v[i].first.first;
			vresult[v[i].first.second] = v[i].first.first;
		}
		else
		{
			double mn = b - bresult;
			if (abs(mn) < EPS)
				break;
			mn = mn / (v[i].second.second);
			bresult += mn * v[i].second.second;
			aresult += mn * v[i].second.first;
			vresult[v[i].first.second] = mn;
			break;
		}
	}

	if (aresult < a) out << "-1 -1";

	else
	{
		out << aresult << ' ' << bresult << endl;
		for (auto vi : vresult) out << vi << ' ';
	}
	
}