#include <vector>
#include <string>
#include <fstream>
#include <algorithm>
using namespace std;

struct Burrito {
	__int64 val, ind, g;
};

bool mless(const Burrito& b1, const Burrito& b2) {
	return b1.val * b1.g < b2.val * b2.g;
}

int main()
{
	ifstream in("burrito.in");
	ofstream out("burrito.out");

	__int64 n;
	double A, B;
	in >> n >> A >> B;

	vector<__int64> va(n);
	vector<__int64> vb(n);
	vector<__int64> vg(n);
	vector<Burrito> vd(n);
	vector<double> answ(n);
	double Amax = 0.0, Bmax = 0.0;
	for (int i = 0; i < n; i++) {
		in >> vg[i] >> va[i] >> vb[i];
		
		vd[i].val = va[i] - vb[i];
		vd[i].ind = i;
		vd[i].g = vg[i];
	}
	sort(vd.rbegin(), vd.rend(), mless);

	for (int i = 0; i < n; i++) {
		int ind = vd[i].ind;

		if (vg[ind] * vb[ind] + Bmax > B) {
			answ[ind] = (B - Bmax) / vb[ind];
			Bmax = B;
			Amax += answ[ind] * va[ind];
		}
		else {
			Bmax += vg[ind] * vb[ind];
			Amax += vg[ind] * va[ind];
			answ[ind] = vg[ind];
		}
	}

	if (Bmax > B || Amax < A) {
		out << "-1 -1";
		return 0;
	}
	out.setf(std::ios_base::fixed);
	out.precision(9);
	out << Amax << " " << Bmax << "\n";
	for (int i = 0; i < n; i++)
		out << answ[i] << " ";

	return 0;
}