#include <iostream>
#include <string>
#include <vector>
#include <time.h>
#include <algorithm>



using namespace std;
typedef long long int i64;
typedef pair<int, int> pint;
typedef pair<i64, i64> pi64;

#define forn(i,n) for (int i = 0; i < n; ++i)
#define down(i,n) for (int i = n-1; i >= 0; --i)
#define ALL(x) x.begin(), x.end()

i64 my_abs(i64 x)
{
	return x >= 0 ? x : (-x);
}
i64 my_sign(i64 x)
{
	return x >= 0 ? 1 : (-1);
}

#define CONTEST "filter"

string ddt = "0123456789abcdef";

bool get_bit(const string& s, int char_pos, int bit_pos) {
	if (char_pos >= s.size()) {
		return false;
	}
	int d = ddt.find(s[char_pos]);
	return (d >> bit_pos) & 1;
}

int main()
{
#ifdef FI
	freopen("file.in", "r", stdin);
	freopen("file.out", "w", stdout);
#else
	freopen(CONTEST ".in", "r", stdin);
	freopen(CONTEST ".out", "w", stdout);
#endif
	
	int m, f;
	cin >> m >> f;
	vector<int> a(f);
	forn(i, f) {
		cin >> a[i];
	}
	int n;
	cin >> n;
	vector<string> files(n);
	forn(i, n) {
		cin >> files[i];
	}
	int q;
	cin >> q;
	vector<int> u(q);
	forn(i, q) {
		cin >> u[i];
	}

	vector<int> ans;
	forn(i, n) {
		forn(j, q) {
			bool good = true;
			forn(k, f) {
				int hash = (u[j] * a[k]) % m;
				int char_pos = hash >> 2;
				int bit_pos = hash & 0x3;
				good &= get_bit(files[i], char_pos, bit_pos);

				if (!good) break;
			}
			if (good) {
				ans.push_back(i);
				break;
			}
		}
	}

	cout << ans.size();
	forn(i, ans.size()) {
		cout << ' ' << ans[i];
	}
	cout << '\n';

	return 0;
}