#include <iostream>
#include <string>
#include <vector>
#include <time.h>
#include <algorithm>
#include <iomanip>


using namespace std;
typedef long long int i64;
typedef pair<int, int> pint;
typedef pair<i64, i64> pi64;

#define forn(i,n) for (int i = 0; i < n; ++i)
#define down(i,n) for (int i = n-1; i >= 0; --i)
#define ALL(x) x.begin(), x.end()

i64 my_abs(i64 x)
{
	return x >= 0 ? x : (-x);
}
i64 my_sign(i64 x)
{
	return x >= 0 ? 1 : (-1);
}

#define CONTEST "improvements"

struct St
{
	i64 first, second;
	i64 n;
	bool operator<(const St & b) const
	{
		if (first != b.first)
			return first < b.first;
		if (second != b.second)
			return second < b.second;
		return n < b.n;
	}


};

int main()
{


	ios_base::sync_with_stdio(false);
#ifdef FI
	freopen("file.in", "r", stdin);
	freopen("file.out", "w", stdout);
#else
	freopen(CONTEST ".in", "r", stdin);
	freopen(CONTEST ".out", "w", stdout);
#endif
	int n;
	cin >> n;

	vector<i64> arr(n);

	forn(i, n)
	{
		cin >> arr[i];
	}
	i64 a = arr[n-1], b = arr[n-1];
	i64 bad = 0;

	down(i, n)
	{

		i64 d = arr[i];
		if (d > a && d < b)
		{
			++bad;

		}
		else
		{
			a = min(d, a);
			b = max(d, b);
		}


	}


	cout << (n - bad);
	return 0;
}