#include <iostream>
#include <string>
#include <vector>
#include <time.h>
#include <algorithm>
#include <iomanip>
#include <map>


using namespace std;
typedef long long int i64;
typedef pair<int, int> pint;
typedef pair<i64, i64> pi64;

#define forn(i,n) for (int i = 0; i < n; ++i)
#define down(i,n) for (int i = n-1; i >= 0; --i)
#define ALL(x) x.begin(), x.end()

i64 my_abs(i64 x)
{
	return x >= 0 ? x : (-x);
}
i64 my_sign(i64 x)
{
	return x >= 0 ? 1 : (-1);
}

#define CONTEST "improvements"


map<pi64, map<i64, i64>> ans;

vector<i64>  arr;


vector<pi64> arr2;

i64 getMin(i64 l, i64 r, i64 i)
{
	if (ans.count(pi64(l, r)))
	{
		if (ans[pi64(l, r)].count(i))
		{
			return ans[pi64(l, r)][i];
		}
	}
	i64 best = 100000000;
	for (int j = l; j< r; ++j)
	{
		if (arr2[j].second < best && arr2[j].second > i)
		{
			best = arr2[j].second;
		}
	}
	ans[pi64(l, r)][i] = best;
	return best;
}



vector<i64> rig, leg;

i64 getRight(i64 i)
{
	return rig[i];
}

i64 getLeft(i64 i)
{
	return leg[i];
}


i64 solve(vector<i64> & arr, int i, int l, int r)
{

	i64 ans = 10000000000LL;
	if (i >= arr.size() - 1)
		return 0;

	ans = min(ans, solve(arr, getMin(l, arr[i], i), l, arr[i] - 1) + getRight(i));
	ans = min(ans, solve(arr, getMin(arr[i], r, i), arr[i] +1, r) + getLeft(i));



	ans = min(ans, solve(arr, getMin(l, r, i), arr[i] + 1, r) + 1);

	return ans;

}

int main()
{


	ios_base::sync_with_stdio(false);
#ifdef FI
	freopen("file.in", "r", stdin);
	freopen("file.out", "w", stdout);
#else
	freopen(CONTEST ".in", "r", stdin);
	freopen(CONTEST ".out", "w", stdout);
#endif
	int n;
	cin >> n;
	rig.resize(n);
	leg.resize(n);


	
	arr2.resize(n);


	arr.resize(n);

	forn(i, n)
	{
		cin >> arr[i];
		arr2[i].first = arr[i];
		arr2[i].second = i;
	}
	sort(arr2.begin(), arr2.end());
	forn(i, n)
	{
		int c = 0;
		for (int j = i + 1; j < n; ++j)
		{
			if (arr[j] > arr[i])
			{
				++c;
			}
		}
		rig[arr[i]-1] = c;
		c = 0;
		for (int j = i - 1; j >= 0; --j)
		{
			if (arr[j] > arr[i])
			{
				++c;
			}
		}
		leg[arr[i]-1] = c;
		
	}


	

	cout << n - solve(arr, 0, 0, n) << endl;




	return 0;
}