#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

#define TASK "filter"

int getInt(char c){
	if (c <= '9'){
		return c - '0';
	}
	else return 10 + c - 'a';
}

int main() {
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen(TASK".in", "r", stdin); freopen(TASK".out", "w", stdout);
	int m, f;
	cin >> m >> f;
	vector<int>param(f);
	for (int i = 0; i < f; ++i){
		scanf("%d", &param[i]);
	}
	int n;
	cin >> n;
	vector<vector<int>>mask(n, vector<int>(m));
	string str;
	int crr = 0;
	for (int i = 0; i < n; ++i){
		cin >> str;
		int crr = 0;
		for (int j = 0; j < str.size(); ++j){
			int t = getInt(str[j]);
			for (int p = 0; p < 4; ++p){
				if (crr >= m){
					break;
				}
				mask[i][crr++] = t % 2;
				t /= 2;
			}
		}
	}

	int q;
	cin >> q;
	vector<int>u(q);
	for (int i = 0; i < q; ++i){
		scanf("%d", &u[i]);
	}
	vector<vector<int>>need(q, vector<int>(f));
	for (int i = 0; i < q; ++i){
		for (int j = 0; j < f; ++j){
			need[i][j] = (u[i] * param[j]) % m;
		}
	}
	vector<int>res;
	for (int i = 0; i < n; ++i){
		for (int j = 0; j < q; ++j){
			bool ok = true;
			for (int p = 0; p < f; ++p){
				if (!mask[i][need[j][p]]){
					ok = false;
					break;
				}
			}
			if (ok){
				res.push_back(i);
				break;
			}
		}
	}
	cout << res.size();
	for (int i = 0; i < res.size(); ++i){
		printf(" %d", res[i]);
	}
	return 0;
}