#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;

#define TASK "improvements"

bool inter(pair<int, int>a, pair<int, int>b){
	if (a.first > b.first){
		swap(a, b);
	}
	return b.first > a.first && b.first < a.second && a.second > b.first && a.second < b.second;
}

vector<int>t(4 * 20001);
vector<pair<int, int>>vec;


void build(int v, int tl, int tr){
	if (tl == tr){
		t[v] = vec[tl].second;
	}
	else{
		int tt = (tr + tl) / 2;
		build(2 * v, tl, tt);
		build(2 * v + 1, tt + 1, tr);
		t[v] = max(t[2 * v], t[2 * v + 1]);
	}
}

int getm(int v, int tl, int tr, int l, int r){
	if (tl > tr || l > r){
		return -99999999;
	}
	if (tl == l && tr == r){
		return t[v];
	}
	int a1, a2;
	int tt = (tl + tr) / 2;
	a1 = getm(2 * v, tl, tt, l, min(r, tt));
	a2 = getm(2 * v + 1, tt+1, tr, max(tt + 1, l), r);
	return max(a1, a2);
}

int getMax(int l, int r){
	return getm(1, 0, vec.size() - 1, l, r);
}

int main() {
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen(TASK".in", "r", stdin); freopen(TASK".out", "w", stdout);
	int n;
	cin >> n;
	vec.resize(n);
	map<int, vector<int>>mm;
	int prev = 0;
	int t;
	vector<int>lefts;
	for (int i = 0; i < n; ++i){
		scanf("%d", &t);
		int L = min(prev, t);
		int R = max(prev, t);
		mm[L].push_back(R);
		vec[i] = make_pair(L, R);
		lefts.push_back(L);
		prev = t;
	}
	sort(vec.begin(), vec.end());

	lefts.push_back(9999999);
	sort(lefts.begin(), lefts.end());

	map<int, int>start, end;
	start[9999999] = n + 1;

	build(1, 0, vec.size() - 1);

	for (int i = 0; i < n; ++i){
		if (!start.count(vec[i].first)){
			start[vec[i].first] = i;
		}
		else{
			start[vec[i].first] = min(start[vec[i].first], i);
		}
		if (!end.count(vec[i].first)){
			end[vec[i].first] = i;
		}
		else{
			end[vec[i].first] = max(end[vec[i].first], i);
		}
	}
	int cnt = 0;
	for (int i = 0; i < n; ++i){
		if (vec[i].first + 1 == vec[i].second)continue;
		int ll = *upper_bound(lefts.begin(), lefts.end(), vec[i].first);
		int cL = start[ll];
		int rr = *upper_bound(lefts.begin(), lefts.end(), vec[i].second);
		int cR = start[rr] - 1;
		cR = min(cR, n - 1);
		if (getMax(cL, cR) > vec[i].second){
			cnt++;
		}
	}
	cout << n - cnt;

	return 0;
}