#include <cstdio>
#include <iostream>
#include <set>
#include <vector>
#include <cstdlib>
#include <map>
#include <algorithm>
#include <cmath>
#include <climits>
#include <string>
#include <cctype>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

typedef long long ll;

#define TASK "burrito"

const int maxn = 1111;

bool cmp(pair <ll, pair <ll, ll> > p1, pair <ll, pair <ll, ll> > p2) {
	return (p1.Y.Y * p2.Y.X <= p2.Y.Y * p1.Y.X);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	ll n, A, B;
	scanf("%lld%lld%lld", &n, &A, &B);
	vector <ll> ansg(n);
	for (ll i = 0; i < n; i++)
		ansg[i] = 0;
	vector <ll> g(n);
	vector <pair <ll, pair <ll, ll> > > v(n);
	for (ll i = 0; i < n; i++) {
		ll aa, bb;
		scanf("%lld%lld%lld", &g[i], &aa, &bb);
		v[i] = mp(i, mp(aa, bb));
	}
	sort(all(v), cmp);
	pair <ll, ll> olds = mp(0, 0);
	for (ll i = 0; i < n; i++) {
		pair <ll, ll> news = olds;
		news.X += g[v[i].X] * v[i].Y.X;
		news.Y += g[v[i].X] * v[i].Y.Y;
		if (news.Y > B) {
			double k = (double)(B - olds.Y) / (double)(v[i].Y.Y);
			double ansA = (double)olds.X + (double)v[i].Y.X * k;
			if (ansA < (double)A) {
				printf("-1 -1\n");
				return 0;
			}
			printf("%.9lf %9lf\n", ansA, (double)B);
			for (ll j = 0; j < n; j++) {
				if (j == v[i].X)
					printf("%.9lf ", k);
				else
					printf("%lld ", ansg[j]);
			}
			return 0;
		}
		ansg[v[i].X] = g[v[i].X];
		olds = news;
	}
	if (olds.X < A) {
		printf("-1 -1\n");
		return 0;
	}
	else {
		printf("%lld %lld\n", olds.X, olds.Y);
		for (ll i = 0; i < n; i++) {
			printf("%lld ", ansg[i]);
		}
	}
	return 0;
}