#include <cstdio>
#include <iostream>
#include <set>
#include <vector>
#include <cstdlib>
#include <map>
#include <algorithm>
#include <cmath>
#include <climits>
#include <string>
#include <cstring>
#include <cctype>
#include <ctime>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

typedef long long ll;

#define TASK "improvements"


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	int n;
	scanf("%d", &n);
	vector <int> v(n + 1);
	set <pair <int, int> > s1, s2;
	for (int i = 1; i <= n; i++) {
		int x;
		scanf("%d", &x);
		v[i] = x;
		s1.insert(mp(i, x));
		s2.insert(mp(x, i));
	}
	int count = 0;
	for (int i = 1; i <= n; i++) {
		auto it = s2.lower_bound(mp(v[i], i));
		auto t = it;
		t++;
		if (it == s2.begin() || t == s2.end()) {
		}
		else {
			count++;
		}
		s2.erase(mp(v[i], i));
		s1.erase(mp(i, v[i]));
	}
	printf("%d", n - count);
	return 0;
}