#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define TASK "burrito"

int n, A, B;
struct bur{
	int id;
	int g;
	int a;
	int b;
	double s;
};
 
bool const operator<(bur A, bur B){
	return A.a*B.b < A.b*B.a;
}

vector<bur> bs;
double b, a;

double ids[(int)1e5];

int main()
{
#ifdef MYCOMP
	freopen("input.txt", "r", stdin);
#else
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#endif

	cin >> n >> A >> B;
	bur t;
	for (int i = 0; i < n; i++)
	{
		cin >> t.g >> t.a >> t.b;
		t.id = i;
		t.s = 0; 
		bs.push_back(t);
	}
	sort(bs.begin(), bs.end());
	for (int i = bs.size()-1; i >= 0; i--)
	{
		bur & t = bs[i];
		t.s = b + t.b*t.g <= B ? t.g : (B - b) / t.b;
		b += t.s*t.b;
		a += t.s*t.a;
	}

	cout.precision(12);
	if (a < A) cout << "-1 -1";
	else
	{
		cout << a << " " << b << endl;
		for (int i = 0; i < n; i++)
			ids[bs[i].id] = bs[i].s;
		for (int i = 0; i < n; i++)
			cout << ids[i] << " ";
	}

	return 0;
}