#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <set>
#include <cstring>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <climits>
//#include <cstring>

using namespace std;

#define CPPINP
#define CPPOUTP
//#define STDINP
//#define STDOUTP

int main()
{
	char inpfname[100] = "filter.in";
	char outpfname[100] = "filter.out";
#ifdef CPPINP
#ifdef STDINP
#define inp cin
#else
	ifstream inp(inpfname);
#endif
#else
#ifndef STDINP
	freopen(inpfname, "r", stdin);
#endif
#endif

#ifdef CPPOUTP
#ifdef STDOUTP
#define outp cout
#else
	ofstream outp(outpfname);
#endif
#else
#ifndef STDOUTP
	freopen(outpfname, "w", stdout);
#endif
#endif

	long long m, f, a[100];
	long long n;
	char files[1000][1001];
	long long u, users[1000];

	inp >> m >> f;

	for (int i = 0; i < f; ++i)
	{
		inp >> a[i];
	}

	inp >> n;

	for (int i = 0; i < n; ++i)
	{
		inp >> files[i];
	}

	inp >> u;

	for (int i = 0; i < u; ++i)
	{
		inp >> users[i];
	}

	long long count = 0;
	long long res[1000];
	for (int i = 0; i < 1000; i++)
	{
		res[i] = 0;
	}

	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < u; ++j)
		{
			bool bad = false;

			for (int k = 0; k < f; ++k)
			{
				long long ju = (users[j] * a[k]) % m;
				long long pos = ju / 4;
				ju = ju % 4;

				char symb = files[i][pos];
				int code[4];

				switch (symb)
				{
				case '0':
					code[0] = 0;
					code[1] = 0;
					code[2] = 0;
					code[3] = 0;
					break;
				case '1':
					code[0] = 1;
					code[1] = 0;
					code[2] = 0;
					code[3] = 0;
					break;
				case '2':
					code[0] = 0;
					code[1] = 1;
					code[2] = 0;
					code[3] = 0;
					break;
				case '3':
					code[0] = 1;
					code[1] = 1;
					code[2] = 0;
					code[3] = 0;
					break;
				case '4':
					code[0] = 0;
					code[1] = 0;
					code[2] = 1;
					code[3] = 0;
					break;
				case '5':
					code[0] = 1;
					code[1] = 0;
					code[2] = 1;
					code[3] = 0;
					break;
				case '6':
					code[0] = 0;
					code[1] = 1;
					code[2] = 1;
					code[3] = 0;
					break;
				case '7':
					code[0] = 1;
					code[1] = 1;
					code[2] = 1;
					code[3] = 0;
					break;
				case '8':
					code[0] = 0;
					code[1] = 0;
					code[2] = 0;
					code[3] = 1;
					break;
				case '9':
					code[0] = 1;
					code[1] = 0;
					code[2] = 0;
					code[3] = 1;
					break;
				case 'a':
					code[0] = 0;
					code[1] = 1;
					code[2] = 0;
					code[3] = 1;
					break;
				case 'b':
					code[0] = 1;
					code[1] = 1;
					code[2] = 0;
					code[3] = 1;
					break;
				case 'c':
					code[0] = 0;
					code[1] = 0;
					code[2] = 1;
					code[3] = 1;
					break;
				case 'd':
					code[0] = 1;
					code[1] = 0;
					code[2] = 1;
					code[3] = 1;
					break;
				case 'e':
					code[0] = 0;
					code[1] = 1;
					code[2] = 1;
					code[3] = 1;
					break;
				case 'f':
					code[0] = 1;
					code[1] = 1;
					code[2] = 1;
					code[3] = 1;
					break;
				default:
					break;
				}
				if (!code[ju])
				{
					bad = true;
					break;
				}
			}

			if (!bad)
			{
				count++;
				res[i]++;
				break;
			}
		}
	}

	outp << count;

	for (int i = 0; i < n; ++i)
	{
		if (res[i]>0)
			outp << ' ' << i;
	}

	return 0;
}
