//package com.company;

import java.io.*;
import java.util.Arrays;
import java.util.Comparator;

public class Main {

    public static void main(String[] args) throws IOException {
	    BufferedReader br = new BufferedReader(new FileReader("burrito.in"));
        BufferedWriter bw = new BufferedWriter(new FileWriter("burrito.out"));
        String[] str = br.readLine().split(" ");
        int ingrNum = Integer.valueOf(str[0]);
        double minHapi = Double.valueOf(str[1]);
        double maxUnhapi = Double.valueOf(str[2]);
        double[][] ingrArr = new double[ingrNum][6];
        for(int i = 0; i < ingrNum; i++) {
            str = br.readLine().split(" ");
            ingrArr[i][0] = Double.valueOf(str[0]);
            ingrArr[i][1] = Double.valueOf(str[1]);
            ingrArr[i][2] = Double.valueOf(str[2]);
            ingrArr[i][3] = ingrArr[i][1] / ingrArr[i][2];
            ingrArr[i][4] = i;
            ingrArr[i][5] = 0;
        }
        Arrays.sort(ingrArr, cmp);
        double currentHapi = 0;
        double currentUnhapi = 0;
        for(int i = 0; i < ingrNum; i++) {
            if(currentUnhapi + ingrArr[i][0] * ingrArr[i][2] < maxUnhapi) {
                ingrArr[i][5] = ingrArr[i][0];
                currentHapi += ingrArr[i][0] * ingrArr[i][1];
                currentUnhapi += ingrArr[i][0] * ingrArr[i][2];
            } else {
                ingrArr[i][5] = (maxUnhapi - currentUnhapi) / ingrArr[i][2];
                currentHapi += ingrArr[i][5] * ingrArr[i][1];
                currentUnhapi = maxUnhapi;
                break;
            }
        }
        Arrays.sort(ingrArr, cmpPlus);
        if(currentHapi < minHapi) {
            bw.write("- 1 -1");
        } else {
            String out = "";
            bw.write(Double.toString(currentHapi) + " " + Double.toString(currentUnhapi));
            bw.newLine();
            for(int i = 0; i < ingrNum; i++) {
                out += ingrArr[i][5] + " ";
            }
            bw.write(out);
        }
        bw.close();
    }

    public static Comparator cmp = new Comparator() {
        @Override
        public int compare(Object i1, Object i2) {

            if(Math.abs(((double[]) i1)[3] - ((double[]) i2)[3]) < 1e-8) {
                return 0;
            } else if(((double[]) i1)[3] < ((double[]) i2)[3]) {
                return 1;
            } else {
                return -1;
            }
        }
    };

    public static Comparator cmpPlus = new Comparator() {
        @Override
        public int compare(Object i1, Object i2) {

            if(Math.abs(((double[]) i1)[4] - ((double[]) i2)[4]) < 1e-8) {
                return 0;
            } else if(((double[]) i1)[4] < ((double[]) i2)[4]) {
                return -1;
            } else {
                return 1;
            }
        }
    };
}
