#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
using namespace std;

typedef long long int LL;

int fs;
LL m, a[102];

int n;
int bloom[1002][1002];
bool good[1002];
vector <int> gutten;

int q;
LL users[1002];

int fromhex(char letter){
	if (letter >= '0' && letter <= '9') return letter - '0';
	return letter - 'a' + 10;
}

int main()
{
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);

	cin >> m >> fs;

	for (int i = 0; i < fs; ++i) cin >> a[i];
	
	cin >> n;
	string stopka;

	for (int i = 0; i < n; ++i){
		cin >> stopka;
		int stopis = stopka.size();
		for (int j = 0; j < stopis; ++j){
			bloom[i][j] = fromhex(stopka[j]);
		}
	}

	cin >> q;

	for (int i = 0; i < q; ++i) cin >> users[i];

	for (int i = 0; i < n; ++i){

		for (int j = 0; j < q; ++j){

			bool freud = true;

			for (int k = 0; k < fs; ++k){
				int ha = users[j] * a[k] % m;
				freud &= 0 != (bloom[i][ha >> 2] & 1 << (ha & 3));
				if (!freud) break;
			}

			good[i] |= freud;
		}

	}

	for (int i = 0; i < n; ++i){
		if (good[i]) gutten.push_back(i);
	}

	cout << gutten.size() << ' ';
	for (auto it = gutten.begin(); it != gutten.end(); ++it) cout << *it << ' ';

	return 0;
}