#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>

using namespace std;

int loc(int a, int b, int t) {
	int len = 2 * abs(a - b);
	t %= len;
	len = abs(a - b);
	if (t <= len) {
		if (b > a) return a + t;
		else return a - t;
	}
	else {
		if (b > a) return b - (t - len);
		else return b + (t - len);
	}
}

int main()
{
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);
	int n, m;
	cin >> n >> m;
	vector <pair<int, int> > data;
	int a, b;
	for (int i = 0; i < n; ++i) {
		cin >> a >> b;
		data.push_back(make_pair(a, b));
	}
	for (int i = 0; i < m; ++i) {
		int x, y, t;
		cin >> x >> y >> t;
		int ans = 0;
		for (int j = 0; j < n; ++j) {
			int pos = loc(data[j].first, data[j].second, t);
			if (x <= pos && pos <= y)
				++ans;
		}
		cout << ans << endl;
	}
	return 0;
}