
//#pragma comment(linker, "/STACK:1000000000")
#define _CRT_SECURE_NO_DEPRECATE
#define _USE_MATH_DEFINES
#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <memory.h>
#include <utility>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <string>
#include <queue>
using namespace std;

#define forn(i, n) for (int i = 0; i < (n); ++i)
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define mod 1000000007
#define inf 2000000000
typedef long long ll;
typedef unsigned long long ull;

struct ing{
	int g, a, b, id;
	ing()
	{
		g = a = b = id = 0;
	}
	ing(int _g, int _a, int _b, int _id)
	{
		a = _a;
		b = _b;
		g = _g;
		id = _id;
	}
	bool operator < (const ing c)
	{
		return a * c.b < b * c.a;
	}

};
vector<ing>p;
vector<double>ans;
int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0);
	//freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
	freopen("burrito.in", "rt", stdin); freopen("burrito.out", "wt", stdout);
	int n, A, B, g, a, b;
	cin >> n >> A >> B;
	p.resize(n);
	ans.resize(n, 0);
	for (int i = 0; i < n; ++i)
	{
		cin >> g >> a >> b;
		p[i] = ing(g, a, b, i);
	}
	sort(p.begin(), p.end());
	reverse(p.begin(), p.end());
	double sumA = 0, sumB = 0;
	for (int i = 0; i < n; ++i)
	{
		double ds = B - sumB;
		double amount = p[i].g;
		if (p[i].a == 0)
			continue;
		if (p[i].b != 0)
		  amount = min(amount, ds / (double)p[i].b);
		sumA += amount * (double)p[i].a;
		sumB += amount * (double)p[i].b;
		ans[p[i].id] = amount;
	}
	cout.precision(15);
	if ((double)A - sumA <= 1e-12 && sumB - (double)B <= 1e-12)
	{
		cout << fixed << sumA << ' ' << sumB << '\n';
		for (int i = 0; i < n; ++i)
			cout << fixed << ans[i] << ' ';
	}
	else
		cout << "-1 -1";
	return 0;
}