#include <cstdlib>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <functional>
#include <cctype>
#include <string>
#include <stack>
#include <queue>
#include <ctime>
#include <iostream>

#define MIN(A, B) ((A) < (B) ? (A) : (B))
#define MAX(A, B) ((A) > (B) ? (A) : (B))
#define ABS(A, B) ((A) < 0 ? -1 * (A) : (A))

using namespace std;

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	vector<int> g, a, b;

	int n, A;
	double B;
	cin >> n >> A >> B;
	int BSAVE = B;

	g.resize(n, 0);
	a.resize(n, 0);
	b.resize(n, 0);

	for (int i = 0; i < n; i++)
		cin >> g[i] >> a[i] >> b[i];

	vector<pair<double, int>> k;
	vector<int> b_zero;
	for (int i = 0; i < n; i++)
	{
		if (!a[i])
			continue;

		if (!b[i])
			b_zero.push_back(i);
		else
			k.push_back(make_pair((double)a[i] / b[i], i));
	}

	sort(k.begin(), k.end());

	double aR = 0;
	vector<double> result;
	result.resize(n, 0);

	for (int i = b_zero.size() - 1; i >= 0; i--)
	{
		int ind = b_zero[i];
		result[ind] = g[ind];
		aR += result[ind] * a[ind];
	}

	if (B)
	{
		for (int i = k.size() - 1; i >= 0; i--)
		{
			int ind = k[i].second;

			double x = ((double)B) / b[ind];
			if (x < g[ind])
			{
				result[ind] = x;
				aR += x * a[ind];
				B = 0;
				break;
			}
			else
			{
				result[ind] = g[ind];
				B -= result[ind] * b[ind];
				aR += result[ind] * a[ind];
			}
		}
	}

	if ((aR + 1e-10) > (double)A)
	{
		printf("%.8lf %.8lf\n", aR, BSAVE - B);

		for (int i = 0; i < n; i++)
			printf("%.8lf ", result[i]);
		printf("\n");
	}
	else
	{
		cout << "-1 -1" << endl;
	}

	return 0;
}
