#include <cstdlib> 
#include <cstdio> 
#include <vector> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <functional> 
#include <cctype> 
#include <string> 
#include <stack> 
#include <queue> 
#include <ctime> 
#include <iostream> 

#define MIN(A, B) ((A) < (B) ? (A) : (B)) 
#define MAX(A, B) ((A) > (B) ? (A) : (B)) 
#define ABS(A, B) ((A) < 0 ? -1 * (A) : (A)) 

using namespace std;

string s;
int n;
bool d[200] = {};
bool q[200] = {};
int pos[51] = {};
int cnt = 0;

bool proh()
{
	bool f = false;

	int c[200] = {};
	int r[200] = {};

	for (int i = 0; i < s.length(); i++)
	{
		if (d[i])
			continue;

		int x = s[i] - '0';
		if (!q[x])
		{
			c[x] ++;
			r[x] = i;
		}

		if (i != s.length() - 1 && !d[i + 1])
		{
			int y = 10 * (s[i] - '0') + s[i + 1] - '0';
			if (!q[y])
			{
				c[y] ++;
				r[y] = i;
			}
		}
	}

	for (int i = 1; i <= n; i++)
	{
		if (!q[i] && c[i] == 1)
		{
			f = true;
			q[i] = true;
			d[r[i]] = true;
			if (i > 9)
				d[r[i] + 1] = true;

			pos[i] = r[i];
			cnt++;
		}
	}

	return f;
}

void wich()
{
	int c[200] = {};
	int r[200] = {};

	for (int i = 0; i < s.length(); i++)
	{
		if (d[i])
			continue;

		int x = s[i] - '0';
		if (!q[x])
		{
			c[x] ++;
			r[x] = i;
		}

		if (i != s.length() - 1 && !d[i + 1])
		{
			int y = 10 * (s[i] - '0') + s[i + 1] - '0';
			if (!q[y])
			{
				c[y] ++;
				r[y] = i;
			}
		}
	}

	vector <int> mg(n);
	for (int i = 0; i < n; i++)
		mg[i] = i + 1;
	random_shuffle(mg.begin(), mg.end());

	for (int j = 0; j < n; j++)
	{
		int i = mg[j];
		if (i < 10)
			continue;

		if (!q[i] && c[i])
		{
			q[i] = true;
			d[r[i]] = true;
			if (i > 9)
				d[r[i] + 1] = true;
			pos[i] = r[i];
			cnt++;

			return;
		}
	}
}

int main()
{
	srand(42);

	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);

	cin >> s;

	int len = s.length();
	if (len <= 9)
		n = len;
	else
		n = 9 + (len - 9) / 2;

	while (1)
	{
		while (proh());
		if (cnt < n)
			wich();
		else
			break;
	}

	vector <pair<int, int> > p;
	p.resize(n);
	for (int i = 1; i <= n; i++)
	{
		p[i - 1] = make_pair(pos[i], i);
	}

	sort(p.begin(), p.end());

	for (int i = 0; i < n; i++)
		printf("%d ", p[i].second);

	cout << endl;

	return 0;
}