#include <stdio.h>
#include <cstdio>
#include <cmath>
#include <vector>
#include <map>
#include <queue>
#include <algorithm>
#include <iostream>

using namespace std;

#define int64 long long
#define FOR(i, n) for (int i =0; i < n ; i++)

#define TASK "burrito"

struct row
{
	double c;
	double g;
	double a, b;
	int n;
};

bool comp(row a, row b)
{
	return a.c > b.c;
}

vector<row> rows;
double res[100005];

int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	int n;
	double A, B;
	cin >> n >> A >> B;
	double Amax = 0;
	int l = -1, r = -1;
	double dB = 0;
	double dA = 0;
	FOR(i, n)
	{
		double g, a, b;
		cin >> g >> a >> b;
		row cur;
		if (b != 0)
			cur.c = a / b;
		else
			cur.c = 1000;
		cur.a = a;
		cur.b = b;
		cur.g = g;
		cur.n = i;
		rows.push_back(cur);
		Amax += g * a;
	}
	if (Amax < A)
	{
		cout << "-1 -1";
		return 0;
	}
	sort(rows.begin(), rows.end(), comp);
	FOR(i, n)
	{
		if (r == -1)
			dB += rows[i].g * rows[i].b;
		if (dB > B && r == -1)
			r = i;
		if (l == -1)
			dA += rows[i].g * rows[i].a;
		if (dA >= A && l == -1)
			l = i;
	}
	if ((l > r && r != -1) || l == -1)
	{
		cout << "-1 -1";
		return 0;
	}
	else
	{
		double rA, rB;
		rA = rB = 0;
		if (r == -1)
		{
			FOR(i, n)
			{
				res[rows[i].n] = rows[i].g;
				rA += rows[i].g * rows[i].a;
				rB += rows[i].g * rows[i].b;
			}
		}
		else
		{
			FOR(i, r)
			{
				res[rows[i].n] = rows[i].g;
				rA += rows[i].g * rows[i].a;
				rB += rows[i].g * rows[i].b;
			}
			res[rows[r].n] = (B - (dB - rows[r].g * rows[r].b)) / rows[r].b;
			rA += rows[r].a * res[rows[r].n];
			rB += rows[r].b * res[rows[r].n];
			for (int i = r + 2; i < n; i++)
				res[rows[i].n] = 0;
		}
		if (A - rA > 1e-8 || rB - B > 1e-8)
		{
			cout << "-1 -1";
			return 0;
		}
		printf("%.9llf %.9llf\n", rA, rB);
		FOR(i, n)
			printf("%.9llf ", res[i]);
	}
	return 0;
}