#include <stdio.h>
#include <cstdio>
#include <cmath>
#include <vector>
#include <map>
#include <queue>
#include <algorithm>

using namespace std;

#define int64 long long
#define FOR(i, n) for (int i =0; i < n ; i++)

#define TASK "joke"

vector<char> in;

int used[50];
int used2[50];

bool ready = false;

int n = 0;

bool solve(int pos)
{
	bool g = true;
	FOR(i, n)
		if (used[i] == -1)
			g = false;
	if (g)
		return true;
	if (pos >= in.size())
		return false;
	int cur = in[pos] - '0';
	if (cur == 0)
		return false;

	if (cur != 0 && used[cur - 1] == -1)
	{
		used[cur - 1] = pos;
		used2[cur - 1] = 1;
		if (solve(pos + 1))
			return true;
		used[cur - 1] = -1;
	}
	if (pos < in.size() - 1)
	{
		cur = cur * 10 + in[pos + 1] - '0';
		if (used[cur - 1] == -1)
		{
			used[cur - 1] = pos;
			used2[cur - 1] = 2;
			if (solve(pos + 2))
				return true;
			used[cur - 1] = -1;
		}
	}
	return false;
}

int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);

	FOR(i, 50)
		used[i] = -1;
	char c;
	while (true)
	{
		c = '\n';
		scanf("%c", &c);
		if (c == '\n')
			break;
		in.push_back(c);
	}
	if (in.size() < 10)
		n = in.size();
	else
		n = (in.size() - 9) / 2 + 9;

	solve(0);
	vector<pair<int, int>> p;
	FOR(i, n)
		p.push_back(make_pair(used[i], i));
	sort(p.begin(), p.end());
	vector<int> res;
	FOR(i, n)
	{
		res.push_back(p[i].second + 1);
	}

	FOR(i, n)
		printf("%d ", res[i]);
	return 0;
}