#include <stdio.h>
#include <cstdio>
#include <cmath>
#include <vector>
#include <map>
#include <queue>
#include <algorithm>

using namespace std;

#define int64 long long
#define FOR(i, n) for (int i =0; i < n ; i++)

#define TASK "knockout"

vector<char> in;

int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	int n, m;
	
	scanf("%d %d", &n, &m);

	vector<pair<int, int>> cars;

	for (int i = 0; i < n; ++i)
	{
		int a, b;
		scanf("%d %d", &a, &b);
		cars.push_back(make_pair(a, b));
	}

	for (int i = 0; i < m; ++i)
	{
		int a, b, t;
		scanf("%d %d %d", &a, &b, &t);
		int ans = 0;
		for (int j = 0; j < cars.size(); ++j)
		{
			int l = cars[j].second - cars[j].first;
			int o = t % l;
			int c = t / l;
			int x = cars[j].first + l - o;
			if (c % 2 == 0)
				x = cars[j].first + o;
			if (x >= min(a, b) && x <= max(a, b))
				++ans;
		}
		printf("%d\n", ans);
	}
	return 0;
}