#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <sstream>
#include <cstring>
#include <deque>
#include <queue>
#include <cmath>
using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef long double ldouble;
typedef long long llong;
typedef unsigned long long ullong;

#define forn(i,n) for(int i=0; i<(n); i++)
#define sz(x) int((x).size())
#define pb push_back
#define mp make_pair
#define inf int(1e9)
#define linf llong(4e18)

void gen(string& s, vi& p, vi& r) {
	int pos = -1;
	forn(i, sz(p)) {
		r.push_back(atoi(s.substr(pos + 1, p[i] - pos).c_str()));
		pos = p[i];
	}
}

bool check(vi& p) {
	set<int> s;
	forn(i, sz(p)) 
		if (1 <= p[i] && p[i] <= sz(p))
			s.insert(p[i]);
	//5;
	return sz(s) == sz(p);
}

bool rec(string& s, set<int>& m, vi& p, int mxn, int pos) {
	if (pos == sz(s) - 1) {
		static vi test;
		test.clear();
		gen(s, p, test);
		return check(test);
	}
	int num;
	num = s[pos + 1] - '0';
	if (pos + 1 < sz(s) && num <= mxn && !m.count(num)) {
		p.pb(pos + 1);
		m.insert(num);
		if (rec(s, m, p, mxn, pos + 1))
			return true;
		m.erase(num);
		p.pop_back();
	}
	num = (s[pos + 1] - '0') * 10 + (s[pos + 2] - '0');
	if (pos + 2 < sz(s) && num <= mxn && !m.count(num)) {
		p.pb(pos + 2);
		m.insert(num);
		if (rec(s, m, p, mxn, pos + 2))
			return true;
		m.erase(num);
		p.pop_back();
	}
	return false;
}

int get_max(int len) {
	int l = 0;
	for (int i = 1;; i++) {
		if (1 <= i && i <= 9)
			++l;
		else
			++l, ++l;
		if (l >= len)
			return i;
	}
	return -1;
}

#define TASK "j"
int main() {
#ifdef LOCAL_PROJECT
	freopen(TASK ".in", "r", stdin);
	//freopen(TASK ".out", "w", stdout);
#endif

	string s; 
	while (cin >> s){
		vi p;
		set<int> m;
		int mxn = get_max(sz(s));
		rec(s, m, p, mxn, -1);
		vi res;
		gen(s, p, res);
		forn(i, sz(res))
			cout << res[i] << " ";
		cout << "\n";
	}

	return 0;
}