#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <sstream>
#include <cstring>
#include <deque>
#include <queue>
#include <cmath>
using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef long double ldouble;
typedef long long llong;
typedef unsigned long long ullong;

#define forn(i,n) for(int i=0; i<(n); i++)
#define sz(x) int((x).size())
#define pb push_back
#define mp make_pair
#define inf int(1e9)
#define linf llong(4e18)

#define TASK "knockout"

vector<int> a, b;

int main() {
	freopen(TASK ".in", "r", stdin);
#ifndef LOCAL_PROJECT
	freopen(TASK ".out", "w", stdout);
#endif
	int i, n, m;
	while (cin >> n >> m) {
		a.resize(n);
		b.resize(n);
		for (i = 0; i < n; i++) {
			cin >> a[i] >> b[i];
			if (a[i] > b[i])
				swap(a[i], b[i]);
		}
		while (m--) {
			int x, y, t;
			cin >> x >> y >> t;
			int result = 0;
			for (i = 0; i < n; i++) {
				int cur;
				if ((t / (b[i] - a[i])) & 0x1)
					cur = b[i] - t % (b[i] - a[i]);
				else
					cur = a[i] + t % (b[i] - a[i]);
				if (x <= cur && cur <= y)
					result++;
			}
			cout << result << '\n';
		}
	}


	return 0;
}