#define USE_MATH_DEFINES
#include <iostream>
#include <cmath>
#include <cstdlib>
#include <cstdio>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <iomanip>
#include <stack>
#include <map>
#include <queue>
#include <memory>
#include <algorithm>

#define pb push_back
#define vi vector<int>
#define ll long long
#define vii vector<pair< int, int> >
#define f first
#define s second
#define mp make_pair
using namespace std;
//___________________________

int n, sat_min, dissat_max;
int G[100000];
int A[100000];
int B[100000];

vector<double> anss;

vector<pair<double, int> > P;


int main(){
	//ifstream cin("input.txt");
//	ofstream cout("output.txt");
	ifstream cin("burrito.in");
    ofstream cout("burrito.out");

	cin >> n >> sat_min >> dissat_max;
	P.resize(n);
	anss.resize(n, 0);

	for (int i = 0; i < n; i++)
	{
		cin >> G[i] >> A[i] >> B[i];
		double c;
		if (B[i] == 0)
			c = 1e5;
		else
			c = double(A[i]) / B[i];
		P[i] = mp(c, i);
	}



	sort(P.rbegin(), P.rend());

	double dissat = 0;
	double sat = 0;

	for (int i = 0; i < n; i++)
	{
		int dissat_remaining = dissat_max - dissat;
		int sat_coeff = A[P[i].second];
		int dissat_coeff = B[P[i].second];
		int max_grams = G[P[i].second];

		//cout << "dissat_remaining=" << dissat_remaining << ", sat_coeff=" << sat_coeff << ", dissat_coeff=" << dissat_coeff << ", max_grams=" << max_grams << endl;


		if (dissat_remaining == 0 && dissat_coeff != 0) break; 

		if (max_grams*dissat_coeff <= dissat_remaining)
		{
			anss[P[i].second] = max_grams;
			dissat += max_grams*dissat_coeff;
			sat += max_grams*sat_coeff;

			continue;
		}
		

		double grams_possible = double(dissat_remaining) / dissat_coeff;
		//cout << "grams_possible = " << grams_possible << endl;
		//anss.push_back(grams_possible);
		anss[P[i].second] = grams_possible;
		dissat += grams_possible*dissat_coeff;
		sat += grams_possible*sat_coeff;

		break; 
	}

	//cout << sat << endl;

	if (sat < sat_min)
	{
		cout << "-1 -1";
		return 0;
	}

	cout << fixed<<setprecision(10) << sat << " " << dissat << endl;
	for (int i = 0; i < anss.size(); i++) cout << anss[i] << " ";



	return 0;
}