#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <queue>
using namespace std;

map< char, string> mp;

string toFilt(string s)
{
	string temp = "";
	for (long long i = 0; i < s.length(); i++)
		temp += mp[s[i]];
	return temp;
}

int main()
{
	mp['0'] = "0000";
	mp['1'] = "1000";
	mp['2'] = "0100";
	mp['3'] = "1100";
	mp['4'] = "0010";
	mp['5'] = "1010";
	mp['6'] = "0110";
	mp['7'] = "1110";
	mp['8'] = "0001";
	mp['9'] = "1001";
	mp['a'] = "0101";
	mp['b'] = "1101";
	mp['c'] = "0011";
	mp['d'] = "1011";
	mp['e'] = "0111";
	mp['f'] = "1111";

	if (true)
	{
		freopen("filter.in", "r", stdin);
		freopen("filter.out", "w", stdout);
	}

	long long bitNum, hashNum;
	cin >> bitNum >> hashNum;
	vector<long long> hashes(hashNum);
	for (long long i = 0; i < hashNum; i++)
	{
		cin >> hashes[i];
	}
	long long filtNum;
	cin >> filtNum;
	vector<string>filters(filtNum);
	vector<long long>filterstoprin(filtNum, 0);

	for (long long i = 0; i < filtNum; i++)
	{
		string temp;
		cin >> temp;
		filters[i] = toFilt(temp);
	}
	long long userCount;
	cin >> userCount;

	long long fltCnt = 0;

	vector<long long>users(userCount);
	for (long long i = 0; i < userCount; ++i)
	{
		cin >> users[i];

		vector <long long> userBit;


		for (long long q = 0; q < hashNum; q++)
		{
			long long j = (users[i] * hashes[q]) % bitNum;
			userBit.push_back(j);
		}

		for (long long f = 0; f < filtNum; f++)
		{
			bool found = true;
			for (long long u = 0; u < userBit.size(); u++)
			{
				if (filters[f][userBit[u]] == '0')
				{
					found = false;
					break;
				}
				if (found == false)
					break;
			}
			
			if (found == true)
			{
				if (filterstoprin[f] == 0)fltCnt++;
				filterstoprin[f] = 1;
				
			}

		}

	}


	cout << fltCnt;
	for (long long i = 0; i < filtNum; i++)
	{
		if (filterstoprin[i])
			cout << " " << i;
	}


	return 0;
}