#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <climits>
#include <functional>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define mp make_pair
#define X first
#define Y second

#define For(i,s,n) for (int i=s;i<=n;i++)
#define FOR(i,s,n) for (int i=s;i<n;i++)


typedef long long ll;

string ff(char c) {
	string res = "";

	int n = c < 'a' ? (c - '0') : (10 + c - 'a');
	for (int i = 0; i < 4; i++) {
		if (n & (1 << i))
			res += "1";
		else
			res += "0";
	}
	
	return res;
}

int get_hash(int u, int a, int m) {
	return (int)(((ll)u * a) % m);
}

int main() {
	freopen("filter.in", "r", stdin); freopen("filter.out", "w", stdout);
	int m, f;
	scanf("%d %d", &m, &f);

	vector<int> a(f);
	for (int i = 0; i < f; i++) {
		scanf("%d", &a[i]);
	}

	int n;
	scanf("%d", &n);

	vector<string> d(n, "");
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < sz(s) - 1; j++)
			d[i] += ff(s[j]);

		if (sz(s) % 4) {
			string tmp = ff(s[sz(s) - 1]);
			for (int j = 0; j < 3; j++)
				d[i] += tmp[j];
		}
		else {
			d[i] += ff(s[sz(s) - 1]);
		}
	}

	int q;
	scanf("%d", &q);

	vector<int> u(q);
	for (int i = 0; i < q; i++)
		scanf("%d", &u[i]);

	vector<int> ans;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < q; j++) {
			bool ok = 1;
			for (int k = 0; k < f; k++) {
				if (d[i][get_hash(u[j], a[k], m)] != '1') {
					ok = 0;
					break;
				}
			}
			if (ok) {
				ans.pb(i);
				break;
			}
		}
	}

	printf("%d", sz(ans));
	for (int i = 0; i < sz(ans); i++)
		printf(" %d", ans[i]);

	puts("");
	return 0;
}