#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <string>
#include <math.h>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <queue>
#include <stack>
#include <list>

#define LL long long
#define ULL unsigned long long
#define LD long double

using namespace std;

const double EPS = 1e-7, eps = 1e-7;
const double PI = 2.*acos(0.0), pi = 2.*acos(0.0);

#define fName "filter"

unsigned long long a[110];
unsigned long long bitVecs[1010][25], curVec[25];
bool used[1010];
void clearIt()
{
	for (unsigned long long i = 0; i < 20; i++)
		curVec[i] = 0;
}

unsigned long long levonIt(unsigned long long c, unsigned long long v)
{
	v = ((4 - v) + 4) % 4;
	c <<= v;
	return c;
}

void setBits(unsigned long long i, unsigned long long j, unsigned long long c)
{
	j *= 4;
	unsigned long long ind = j / 64;
	unsigned long long offs = (60 - (j % 64));
	unsigned long long cur = c;
	c <<= offs;
	bitVecs[i][ind] |= c;
}

void setBit(unsigned long long v)
{
	unsigned long long ind = v / 64;
	unsigned long long offs = 63-(v % 64);
	curVec[ind] |= (1ll << offs);
}

bool isGood(unsigned long long ind)
{
	for (unsigned long long i = 0; i < 20; i++)
	{
		if ((curVec[i] & bitVecs[ind][i]) != curVec[i])
			return false;
	}
	return true;
}

int doIt(int x, int rem)
{
	if (!rem)
		rem = 4;
	vector <int> v;
	int ret = 0;
	for (int i = 0; i < rem;i++)
	{
		ret *= 2;
		ret += x;
		x /= 2;
	}
	return ret;
}

int main()
{
	freopen(fName".in", "r", stdin);
	freopen(fName".out", "w", stdout);
	unsigned long long m, f, n, q, i, j, k, l, ansCnt, u, v;
	string str;
	while (cin >> m >> f)
	{
		for (i = 0; i < f; i++)
			cin >> a[i];
		cin >> n;
		l = m / 4;
		if (m % 4)
			l++;
		for (i = 0; i < n; i++)
		{
			used[i] = 0;
			cin >> str;
			unsigned long long c;
			for (j = 0; j < l - 1; j++)
			{
				c = str[j];
				if (c >= 'a')
				{
					c -= 'a';
					c += 10;
				}
				else
					c -= '0';
				c = doIt(c, 0);
				setBits(i, j, c);
			}
			c = str[j];
			if (c >= 'a')
			{
				c -= 'a';
				c += 10;
			}
			else
				c -= '0';
			c = doIt(c, m % 4);
			unsigned long long ch = levonIt(c, m % 4);
			setBits(i, j, ch);
		}
		cin >> q;
		ansCnt = 0;
		while (q--)
		{
			cin >> u;
			clearIt();
			for (i = 0; i < f; i++)
			{
				v = (a[i] * u) % m;
				setBit(v);
			}
			for (i = 0; i < n; i++)
			{
				if (used[i])
					continue;
				if (isGood(i))
				{
					ansCnt++;
					used[i] = 1;
				}
			}
		}
		cout << ansCnt;
		for (i = 0; i < n; i++)
		{
			if (used[i])
				cout << " " << i;
		}
		cout << "\n";
	}
	return 0;
}


/*
23 4 3 5 7 11
3
effde7
c07902
0800c1
3 2 4 6
*/