#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;

#define _CRT_SECURE_NO_WARNING

struct ts {
    long long x, y, z, id;
};

bool operator <(ts a, ts b) {
    double y1 = a.y, y2 = b.y, z1 = a.z, z2 = b.z;
    if (z1 == 0 && z2 == 0) {
        return (a.id > b.id);
    }
    if (z1 == 0) return true;
    if (z2 == 0) return false;
    if (y1/z1 == y2/z2) return a.id > b.id;
    return (y1/z1 > y2/z2);
}

int main() {
    freopen("burrito.in", "r", stdin);
    freopen("burrito.out", "w", stdout);
    long long n, m, k;
    cin >> n >> m >> k;
    vector <ts> v;
    set <ts> st;
    for (int i=0; i<n; i++) {
        long long x, y, z;
        cin >> x >> y >> z;
        ts newOne;
        newOne.x = x;
        newOne.y = y;
        newOne.z = z;
        newOne.id = i;
        v.push_back(newOne);
        st.insert(newOne);
    }
//    sort(v.begin(), v.end(), cmp);
    vector <double> ans(n, 0);
    double a=0, b=0;/*
    for (int i=0; i<n; i++)
        cout << v[i].z << endl;*/
    set <ts> :: iterator pt;
    int i = 0;
    for (pt=st.begin(); pt!=st.end(); pt++) {
        v[i] = *pt;
        if (v[i].x * v[i].z + b <= (double) k) {
            b+=v[i].x * v[i].z;
            a+=v[i].x * v[i].y;
            ans[v[i].id] = v[i].x;
        } else {
            double kk = (k - b)/(double) v[i].z;
            b+=kk*v[i].z;
            a+=kk*v[i].y;
            ans[v[i].id] = kk;
            break;
        }
    }/*
    for (int i=0; i<v.size(); i++) {
        if (b > k) break;
        if (v[i].x * v[i].z + b <= (double) k) {
            b+=v[i].x * v[i].z;
            a+=v[i].x * v[i].y;
            ans[v[i].id] = v[i].x;
        } else {
            double kk = (k - b)/(double) v[i].z;
            b+=kk*v[i].z;
            a+=kk*v[i].y;
            ans[v[i].id] = kk;
            break;
        }
    }*/
    if (a < m) {
        cout << -1 << " " << -1 << endl;
        return 0;
    }
    printf("%.8f %.8f\n", a, b);
    for (int i=0; i<ans.size(); i++)
        printf("%.8f ", ans[i]);
    return 0;
}
