#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

int getlength(string s) {
	if (s.length() < 10) return s.length();
	return (s.length() - 10) / 2 + 10;
}

bool rec(string s, int n, vector <int> &v, set<int> &st) {
    if (n == 0 && st.size() == getlength(s)) return true;
    if (n == 0) return false;
    for (int i=0; i<s.length(); i++) {
        if (n >= 10)
            if (s[i] - '0'== n/10 && s[i+1]-'0' == n%10) {
                string db = s;
                db[i] = '#';
                db[i+1] = '#';
                v.push_back(i);
                st.insert(n);
                bool p = rec(db, n-1, v, st);
                if (p) return true;
                if (!p) {
                    st.erase(n);
                    v.erase(v.begin() + v.size()-1);
                }
            }
        if (n < 10)
            if (s[i] - '0' == n){
                string db = s;
                v.push_back(i);
                st.insert(n);
                db[i] = '#';
                bool p = rec(db, n-1, v, st);
                if (p) return true;
                if (!p) {
                        st.erase(n);
                        v.erase(v.begin() + v.size()-1);
                }
            }

    }
    return false;
}

bool cmp(pair<int, int> a, pair<int, int> b) {
    if (a.second < b.second) return true;
    return false;
}

int main() {
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
	string s;
	cin >> s;
	int n = getlength(s);
	vector <int> v;
	set <int> st;
	rec(s, n, v, st);
	/*
	for (int i = n; i >= 1; i--) {
		for (int j = 0; j < s.length(); j++) {
			if (i < 10) {
				if (s[j] - '0' == i){
                    v[j] = i;
                    s[j] = '#';
                    break;
				}
			}
			if (i >= 10) {
				if (s[j] - '0' == i / 10 && s[j + 1] - '0' == i % 10 && s[j+2] - '0'!= 0){
                    s[j] = '#';
                    s[j+1] = '#';
                    v[j] = i;
                    break;
				}
			}
		}
	} */
	vector <pair <int, int> > ans;
	for (int i = 0; i < v.size(); i++)
		if (v[i] != -1)
            ans.push_back(make_pair(n-i, v[i]));
    sort(ans.begin(), ans.end(), cmp);
    for (int i=0; i<ans.size(); i++)
        cout << ans[i].first << " ";
}
