//G41

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <map>

using namespace std;

#define FILE_NAME ""
const int IINF = 1000000000;
const long long LING = 100000000000000000LL;
const double INF = 1000. * 1000 * 1000 + 1;
const double EPS = 1e-14;
const double PI = acos(-1.0);

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	int n;
	double A, B;
	while (cin >> n >> A >> B)
	{
		vector < pair <double, pair <int, int> > > v(n);
		vector < pair <int, int> > weights(n);
		int g, a, b;
		for (int i = 0; i < n; ++i)
		{
			cin >> g >> a >> b;
			weights[i].first = a;
			weights[i].second = b;
			v[i].second.first = g;
			v[i].second.second = i;
			if (b == 0)
				v[i].first = INF;
			else
				v[i].first = a * 1. / b;
		}
		sort(v.rbegin(), v.rend());
		double happiness = 0;
		double badness = 0;
		vector <double> ans(n);
		for (int i = 0; i < n; ++i)
		{
			double currg = v[i].second.first;
			int curra = weights[v[i].second.second].first;
			int currb = weights[v[i].second.second].second;
			double maxg = B - badness;
			if (currb != 0)
				maxg /= currb;
			else
				maxg = INF;
			maxg = min(maxg, currg);
			ans[v[i].second.second] = maxg;
			happiness += maxg * curra;
			badness += maxg * currb;
		}
		if (fabs(happiness - A) < EPS) {
			cout << happiness << ' ' << badness << endl;
			for (int i = 0; i < n; ++i)
				printf("%.lld ", ans[i]);
			cout << endl;
		}
		else if (happiness - A < EPS) {
			cout << -1 << ' ' << -1 << endl;
		}
		else
		{
			cout << happiness << ' ' << badness << endl;
			for (int i = 0; i < n; ++i)
				printf("%.13lf ", ans[i]);
			printf("\n");
		}
	}
	return 0;
}