#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>

using namespace std;

#define FILE_NAME ""
const int IINF = 1000000000;
const int LING = 100000000000000000LL;
const double EPS = 1e-9;
const double PI = acos(-1.0);
bool used[51];

int N;
string s;
map< pair<int, long long>, bool> memo;

bool go(int pos, long long mask) {
	if (pos == s.size()) {
		return mask == (1LL << (N + 1)) - 2;
	}
	pair<int, long long> c = make_pair(pos, mask);
	if (memo.find(c) != memo.end()) {
		return memo[c];
	}
	bool& ref = memo[c];
	ref = false;
	if (s[pos] == '0') return ref;
	int k = s[pos] - '0';
	if ((mask & (1LL << k)) == 0 && k <= N) {
		ref = max(ref, go(pos + 1, mask ^ (1LL << k)));
	}
	if (pos + 1 < s.size()) {
		k = k * 10 + s[pos + 1] - '0';
		if ((mask & (1LL << k)) == 0 && k <= N) {
			ref = max(ref, go(pos + 2, mask ^ (1LL << k)));
		}
	}
	return ref;
}

void construct(int pos, long long mask) {
	if (pos == s.size())
		return;
	int k = s[pos] - '0';
	if ((mask & (1LL << k)) == 0 && k <= N) {
		if (go(pos + 1, mask ^ (1LL << k))) {
			printf("%d ", k);
			construct(pos + 1, mask ^ (1LL << k));
			return;
		}
	}
	if (pos + 1 < s.size()) {
		k = k * 10 + s[pos + 1] - '0';
		if (go(pos + 2, mask ^ (1LL << k))) {
			printf("%d ", k);
			construct(pos + 2, mask ^ (1LL << k));
			return;
		}
	}
	return ;
}

int main()
{
#ifndef RAU_1
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
#else
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	cin >> s;
	int n = 0;
	for (int i = 1; i < 55; ++i) {
		if (i / 10)
			n = n + 2;
		else
			n = n + 1;
		if (n == s.size()) {
			n = i;
			break;
		}
	}
	if (n <= 9) {
		for (int i = 0; i < s.size(); ++i) {
			cout << s[i] << " ";
		}
		return 0;
	}
	N = n;
	construct(0, 0);
	return 0;
}