#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>

using namespace std;

#define FILE_NAME ""
const int IINF = 1000000000;
const int LING = 100000000000000000LL;
const double EPS = 1e-9;
const double PI = acos(-1.0);

long long a[1007], b[1007], x[1007], y[1007], t[1007], s1[1007], s2[1007];
bool good[1007];

int main() {
#ifndef RAU_1
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);
#else
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m, i, j;
	cin >> n >> m;
	for (i = 0; i < n; ++i)
	{
		cin >> a[i] >> b[i];
		
		if (a[i] > b[i])
		{
			swap(a[i], b[i]);
			good[i] = true;
		}
		s1[i] = b[i] - a[i];
		s2[i] = 2 * s1[i];
	}

	long long ans, cnt;
	for (i = 0; i < m; ++i)
	{
		
		cnt = 0;
		cin >> x[i] >> y[i] >> t[i];
		for (j = 0; j < n; ++j)
		{
			ans = t[i]%s2[j];

			if (ans > s1[j])
			{
				if (good[j])
					ans = a[j] - s1[j] + ans;
				else
					ans = b[j] - ans + s1[j];
			}
			else
			{
				if (good[j])
					ans = b[j] - ans;
				else
					ans = a[j] + ans;
			}

			if ((ans >= x[i]) && (ans <= y[i]))
				++cnt;
		}
		cout << cnt << endl;
	}

	return 0;
}
