package test;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Main {
	
	private static String[] data = null;
	static String[] bin = {"0000", "1000", "0100", "1100", "0010", "1010", "0110","1110", 
		"0001", "1001", "0101", "1101", "0011", "1011", "0111","1111"};
	static int m, f;

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader("filter.in"));
		BufferedWriter bw = new BufferedWriter(new FileWriter("filter.out"));
		String ln = br.readLine();
		String[] arr = ln.split(" ");
		m = Integer.parseInt(arr[0]);
		f = Integer.parseInt(arr[1]);
		int[] param = new int[f];
		for(int i = 2; i < arr.length; i++){
			param[i-2] = Integer.parseInt(arr[i]);
		}
		int n = Integer.parseInt(br.readLine());
		data = new String[n];
		for(int i = 0; i < n; i++){
			String hash = br.readLine();
			data[i] = getBinary(hash);
		}
		int q;
		ln = br.readLine();
		arr = ln.split(" ");
		q = Integer.parseInt(arr[0]);
		int[] id = new int[q];
		for(int i =1; i < arr.length; i++){
			id[i-1] = Integer.parseInt(arr[i]);
		}
//		for(int i = 0; i < data.length; i++){
//			System.out.println(data[i]);
//		}
//		for(int i = 0; i < param.length; i++){
//			System.out.println(param[i]);
//		}
//		for(int i = 0; i < id.length; i++){
//			System.out.println(id[i]);
//		}
		ArrayList<Integer> ans = new ArrayList<Integer>();
		for(int  i =0; i < data.length; i++){
			boolean solv = false;
			for(int j = 0; j < id.length; j++){
				boolean x = true;
				for(int k = 0; k < param.length; k++){
					if(data[i].charAt((id[j]*param[k])%m) == '0'){
						x = false;
						break;
					}
				}
				if(x){
					solv = true;
					break;
				}
			}
			if(solv){
				ans.add(i);
			}
		}
		bw.append(ans.size()+" ");
		for(int i = 0; i < ans.size(); i++){
			bw.append(ans.get(i)+" ");
		}
		bw.close();
		br.close();
	}

	private static String getBinary(String hash) {
		StringBuilder res = new StringBuilder();
		for(int i = 0; i < hash.length(); i++){
			char c = hash.charAt(i);
			if(c >= '0' && c <= '9'){
				res.append( rev(bin[c-'0']));
			}else{
				res.append(rev(bin[c-'a' + 10]));
			}
		}
		return res.substring(0, m).toString();
	}
	
	static String rev(String s){
//		String res = "";
//		for(int i = s.length()-1; i > -1; i--){
//			res += s.charAt(i);
//		}
//		return res;
		return s;
	}
}
