import java.util.*;
import java.io.*;

public class Racing
{
	public static void main(String[] args) throws IOException
	{
		
		BufferedReader bf = new BufferedReader(new FileReader("knockout.in"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("knockout.out")));
		
		StringTokenizer st = new StringTokenizer(bf.readLine());
		//******************************************************************* 
		int n = Integer.parseInt(st.nextToken());
		int m = Integer.parseInt(st.nextToken());
		
		if(n >= 1 && n <= 1000 && m >= 1 && m <= 1000)
		{
		long[] a = new long[n];
		long[] b = new long[n];
		long[] x = new long[m];
		long[] y = new long[m];
		long[] t = new long[m];
		for(int i = 0; i < n; i++)
		{
			st = new StringTokenizer(bf.readLine());
			
			long ai = Long.parseLong(st.nextToken());
			long bi = Long.parseLong(st.nextToken());
			
			if(ai != bi && ai >= 0 && ai <= 10e9 && bi >= 0 && bi <= 10e9)
			{
				a[i] = ai;
				b[i] = bi;
			}
		}
		for(int i = 0; i < m; i++)
		{
			st = new StringTokenizer(bf.readLine());
			long xi = Long.parseLong(st.nextToken());
			long yi = Long.parseLong(st.nextToken());
			long ti = Long.parseLong(st.nextToken());
			
			if(xi >= 0 && yi >= xi && yi <= 10e9 && ti >= 0 && ti <= 10e9)
			{
				x[i] = xi;
				y[i] = yi;
				t[i] = ti;
			}
		}
		//******************************************************************* 
		
		for ( int i = 0; i < m; i++ )
		{
			
			int carcounts = 0 ;
			for (int j = 0; j < n; j++)
			{
				if ((t[i] / Math.abs(b[j] - a[j])) % 2 == 0)
				{
						long newA = a[j] +  (t[i] %  Math.abs(b[j] - a[j])) ;
						if (newA >= x[i] && newA <= y[i])  
						{
							carcounts++;
						}	
				}
				else
				{
					long newA = b[j] - (t[i] %  Math.abs(b[j] - a[j]));
					if (newA >= x[i] && newA <= y[i])  
					{
						carcounts++;
					}	
				}
				
				
			}
			out.println(carcounts);
		}
		
		}
		
		out.close();
	}
}