#include <iostream>
#include <sstream>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <string>
#include <iomanip>


using namespace std;
typedef pair<int, int> ii;

struct ingr
{
	int number;
	double amount;
	double albert;
	double barn;
	double value;
	double ans;
};

bool lesss(ingr a, ingr b)
{
	return a.value < b.value;
}

bool nummm(ingr a, ingr b)
{
	return a.number < b.number;
}

int main()
{
	ifstream cin("burrito.in");
	ofstream cout("burrito.out");
	int n;
	double A, B;
	cin >> n >> A >> B;
	vector<ingr> v(n);
	for (int i = 0; i < n; ++i)
	{
		v[i].number = i;
		cin >> v[i].amount >> v[i].albert >> v[i].barn;
		v[i].value = v[i].albert / A - v[i].barn / B;
	}
	sort(v.rbegin(), v.rend(), lesss);
	double joy = 0, unhap = 0;
	bool c = true;
	for (int i = 0; i < n; i++)
	{
		if (unhap + v[i].barn * v[i].amount <= B)
		{
			unhap += v[i].barn * v[i].amount;
			joy += v[i].albert * v[i].amount;
			v[i].ans = v[i].amount;
		}
		else
		{
			if (c)
			{
				v[i].ans = (B - unhap) / v[i].barn;
				joy += (B - unhap) / v[i].barn * v[i].albert;
				unhap = B;
				c = false;
			}
			else
				v[i].ans = 0;
		}
	}
	if (joy < A)
	{
		cout << -1 << ' ' << -1;
		return 0;
	}
	cout << joy << ' ' << unhap << endl;
	sort(v.begin(), v.end(), nummm);
	for (int i = 0; i < v.size(); i++)
		cout << v[i].ans << ' ';
}