#include <iostream>
#include <sstream>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <string>
#include <iomanip>


using namespace std;
typedef pair<int, int> ii;

bool used[51];

vector<vector<int>> P;
void find(string s, string t) {
	int n = s.size();
	int m = t.size();
	for (int i = 0; i + m <= n; i++) {
		vector<int> index;
		for (int j = 0; j < m; j++) {
			if (s[i + j] != t[j] || used[i + j]) break;
			index.push_back(i + j);
		}
		if (index.size() == m) {
			for (int k = 0; k < m; k++) {
				used[index[k]] = 1;
			}
			P.push_back(index);
			break;
		}
	}

}

bool used2[51];
string tostring(int n) {
	stringstream str;
	str << n;
	string t;
	str >> t;
	return t;
}


int main() {
	ifstream cin("joke.in");
	ofstream cout("joke.out");
	string s;
	cin >> s;
	int sz = s.size();
	int n = 0;
	if (sz < 10) {
		n = sz;
	}
	else {
		n = 9 + (sz - 9) / 2;
	}

	for (int i = 1; i <= n; i++) {
		string t = tostring(i);
		int cnt = 0;
		for (int i = 0; i + t.size() <= s.size(); i++) {
			if (s.substr(i, t.size()) == t) cnt++;
		}
		if (cnt == 1) {
			used2[i] = 1;
			find(s, t);
		}
	}

	for (int i = n ; i >= 1 ; i--) {
		if (used2[i]) continue;
		string t = tostring(i);
		find(s, t);
	}
	sort(P.begin(), P.end());
	for (int i = 0; i < P.size(); i++, cout << " ") {
		for (int j = 0; j < P[i].size(); j++)
			cout << s[P[i][j]];
	}
}