#include <iostream>
#include <iomanip>
#include <algorithm>

using namespace std;

const int maxn = 100500;


struct pr
{
	int a;
	int b;
	int g;
	int ind;
};

bool operator < (const pr& lhs, const pr& rhs)
{
	return lhs.a * rhs.b > lhs.b * rhs.a;
}

pr ab[maxn];

double ans[maxn];

int main()
{
	freopen("burrito.in", "r", stdin);
  freopen("burrito.out", "w", stdout);
	int n, A, B;
	cin >> n >> A >> B;
	int i, j;
	for (i = 0; i < n; ++i)
	{
		cin >> ab[i].g >> ab[i].a >> ab[i].b;
		ab[i].ind = i;
	}
	sort(ab, ab + n);

	double joy = 0, sad = 0;

	const double eps = 1e-18;

	for (i = 0; i < n; ++i)
	{
		if (sad + ab[i].b * ab[i].g < B + eps)
		{
			sad += ab[i].b * ab[i].g;
			joy += ab[i].a * ab[i].g;
			ans[ab[i].ind] = ab[i].g;
		}
		else
		{
			ans[ab[i].ind] = ((double)B - sad) / ab[i].b;
			sad = B;
			joy += ans[ab[i].ind] * ab[i].a;
		}
	}


	if (joy < A - eps)
		cout << -1 << ' ' << -1 << endl;
	else
	{
		cout << setprecision(12) << fixed;
		cout << joy << ' ' << sad << endl;
		for (i = 0; i < n; ++i)
			cout << ans[i] << ' ';
		cout << endl;
	}
	return 0;
}


/*

2 5 5
2 2 1
2 2 4

2 5 5
2 2 2
2 2 4



*/