#include <iostream>
#include <iomanip>
#include <algorithm>

using namespace std;

const int maxn = 100500;

typedef long long ll;

struct pr
{
	int a;
	int b;
	int g;
	int ind;
};

bool operator < (const pr& lhs, const pr& rhs)
{
	if (lhs.b == 0 && rhs.b == 0)
		return lhs.a > rhs.a;
	if (lhs.b == 0)
		return true;
	if (rhs.b == 0)
		return false;
	return lhs.a * rhs.b > lhs.b * rhs.a;
}

pr ab[maxn];

long double ans[maxn];

int main()
{
	freopen("burrito.in", "r", stdin);
    freopen("burrito.out", "w", stdout);
	int n, A, B;
	cin >> n >> A >> B;
	int i, j;
	for (i = 0; i < n; ++i)
	{
		cin >> ab[i].g >> ab[i].a >> ab[i].b;
		ab[i].ind = i;
	}
	sort(ab, ab + n);

	int joy = 0;
	int sad = 0;

	long double lastmove = 0;
	
	bool good = false;

	for (i = 0; i < n; ++i)
	{
		if (sad + ab[i].b * ab[i].g <= B)
		{
			sad += ab[i].b * ab[i].g;
			joy += ab[i].a * ab[i].g;
			ans[ab[i].ind] = ab[i].g;
		}
		else
		{
			ans[ab[i].ind] = (B - sad) / (long double)ab[i].b;
			
			lastmove = ans[ab[i].ind] * ab[i].a;
			good = (ll)joy * ab[i].b + (ll)(B - sad) * ab[i].a >= (ll)A * ab[i].b;
			sad = B;
			break;
		}
	}
		

	if ( good || joy >= A )
	{
		cout << setprecision(12) << fixed;
		cout << joy + lastmove << ' ' << sad << endl;
		for (i = 0; i < n; ++i)
			cout << ans[i] << ' ';
		cout << endl;
	}
	else
		cout << -1 << ' ' << -1 << endl;

	return 0;
}


/*

2 5 5
2 2 1
2 2 4

2 5 5
2 2 2
2 2 4



*/