#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <sstream>
using namespace std;


string p;
int N;
bool counted[100];
vector<int> perm;

void init()
{
	cin >> p;
	vector<int> v;
	int sum = 0;
	for (int i = 1;; ++i)
	{
		if (i < 10)
			++sum;
		else
			sum += 2;
		if (sum == p.length())
		{
			N = i;
			break;
		}

	}


}

bool backtrack(int idx)
{
	if (idx == p.size())
	{
		return perm.size() == N;
	}
	int a = p[idx] - '0';
	if (a == 0)
		return false;
	if (!counted[a])
	{
		counted[a] = true;
		perm.push_back(a); 
		if (!backtrack(idx+1))
		{
			counted[a] = false;
			perm.pop_back();
		}
		else
		{
			return true;
		}
	}
	if (idx == p.size() - 1)
		return false;
	int b = p[idx + 1] - '0';
	int num = a * 10 + b;
	if (num > N)
	{
		return false;
	}
	if (!counted[num])
	{
		counted[num] = true;
		perm.push_back(num);
		if (!backtrack(idx + 2))
		{
			counted[num] = false;
			perm.pop_back();
			return false;
		}
		else
		{
			return true;
		}
	}
	else
	{
		return false;
	}
	return false;
}

int main()
{
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);

		init();

	/*for (int t = 0; t < 100; ++t)
	{
		perm.clear();
		fill(counted, counted + 100, false);
		ostringstream oss;
		vector<int> arr(50);
		for (int i = 1; i <= 50; ++i)
			arr[i - 1] = i;
		random_shuffle(arr.begin(), arr.end());
		for (int i = 0; i < 50; ++i)
			oss << arr[i];
		
		p = oss.str();
		N = 50;*/
		backtrack(0);
		for (int i = 0; i < N; ++i)
			cout << perm[i] << " ";
	//	cout << endl; 
//	}
	
	
}
