#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define fi first
#define se second
#define sz(x) ((int) (x).size())

const int INF = 1000000101;
const ll INFL = 2000000000000000101;

#define NAME "filter"

const int maxn = 1100;
const int maxm = 1100;
const int maxf = 110;
const int maxq = 1100;

bitset<maxn> filter[maxm];
long long a[maxf], id[maxq];
bool ok[maxn];
int n, m, f, q;

int getval(char c)
{
    if (isdigit(c)) return c - '0';
    return 10 + tolower(c) - 'a';
}

inline int bit(int x, int i)
{
    return (x >> i) & 1;
}

void solve()
{
    cin >> m >> f;
    for (int i = 0; i < f; ++i) cin >> a[i];
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        string s;
        cin >> s;
        
        int sum = 0;
        for (size_t j = 0; j < s.length(); ++j)
        {
            int sh = min(4, m - (int) j * 4);
            int val = getval(s[j]);
            for (int k = 0; k < sh; ++k)
                filter[i].set(sum + k, bit(val, k));
            sum += sh;
        }
    }
    cin >> q;
    fill(ok, ok + n, false);
    for (int i = 0; i < q; ++i) 
    {
        cin >> id[i];
        bitset<maxm> curf;
        for (int j = 0; j < f; ++j)
        {
            int cur = id[i] * a[j] % m;
            curf.set(cur);
        }
        for (int j = 0; j < n; ++j)
            if (!ok[j] && (curf & filter[j]) == curf)
                ok[j] = true;
    }
    int ans = 0;
    for (int i = 0; i < n; ++i)
        if (ok[i]) ++ans;
    cout << ans;
    for (int i = 0; i < n; ++i)
        if (ok[i]) cout << " " << i;
    cout << endl;
}

int main()
{
    cout.precision(10);
    cout.setf(ios::fixed);
    srand(420);
    assert(freopen(NAME ".in", "r", stdin));
    #ifndef LOCAL
    assert(freopen(NAME ".out", "w", stdout));
    #endif
    solve();
    return 0;
}
