#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define fi first
#define se second
#define sz(x) ((int) (x).size())

const int INF = 1000000101;
const ll INFL = 2000000000000000101;

#define NAME "improvements"

int p[300001];
int a[300001];

int d[300001];

int pr[300001];
int suf[300001];

int main()
{
    cout.precision(10);
    cout.setf(ios::fixed);
    srand(420);
    assert(freopen(NAME ".in", "r", stdin));
    #ifndef LOCAL
    assert(freopen(NAME ".out", "w", stdout));
    #endif
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        int t;
        scanf("%d", &t);
        --t;
        p[t] = i;
    }
    
    d[0] = -INF;
    for (int i = 1; i <= n; ++i)
        d[i] = INF;
    int ans = 0;
    for (int i = 0; i < n; ++i)
    {
        int pos = lower_bound(d, d + n, p[i]) - d;
        d[pos] = p[i];
        ans = max(ans, pos);
        pr[i + 1] = ans;
    }
    
    
    d[0] = -INF;
    for (int i = 1; i <= n; ++i)
        d[i] = INF;
    ans = 0;
    reverse(p, p + n);
    for (int i = 0; i < n; ++i)
    {
        int pos = lower_bound(d, d + n, p[i]) - d;
        d[pos] = p[i];
        ans = max(ans, pos);
        suf[i + 1] = ans;
    }
    
    ans = 0;
    for (int i = 0; i <= n; ++i)
        ans = max(ans, pr[i] + suf[n - i]);
    
    cout << ans << '\n';
}
