#include <iostream>
#include <vector>
#include <cstdio>
#include <cmath>
#include <memory.h>
#include <algorithm>

typedef long double LD;
typedef long long LL;
using namespace std;

const int N = 111111;
struct tp {
	int g, a, b, i;
	bool operator<(const tp& t) const {
		if (b == 0 && t.b == 0) return false;
		if (b == 0 && t.b != 0) return true;
		if (b != 0 && t.b == 0) return false;
		return a * t.b > b * t.a;
	}
} a[N];
double ans[111111];

int main() {
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	int n, A, B;
	scanf("%d%d%d", &n, &A, &B);
	LD joy = 0;
	for (int i = 0; i < n; ++i) {
		scanf("%d%d%d", &a[i].g, &a[i].a, &a[i].b);
		a[i].i = i;
	}
	sort(a, a + n);
	LL noj = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i].g * a[i].b <= (B - noj)) {
			ans[a[i].i] = a[i].g;

			joy += a[i].g * a[i].a;
			noj += a[i].g * a[i].b;
		} else {
			ans[a[i].i] = LD(B - noj) / a[i].b;

			joy += LD(B - noj) / a[i].b * a[i].a;
			noj = B;
			break;
		}
	}
	if (joy + 1e-10 >= A) {
		printf("%.12f %I64d\n", double(joy), noj);
		for (int i = 0; i < n; ++i) printf("%.12f ", ans[i]);
		puts("");
	} else {
		printf("-1 -1\n");
	}

	return 0;
}
