#include <iostream>
#include <vector>
#include <cstdio>
#include <cmath>
#include <memory.h>

typedef long long LL;
using namespace std;

const int N = 2111;

char s[2111];
unsigned msk1[2111][35];
unsigned msk2[2111][35];


bool used[N];
int rem[3111];

int main() {
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);


	int m, f;
	unsigned a[111];
	scanf("%d%d", &m, &f);
	for (int i = 0; i < f; ++i) { 
		scanf("%u", &a[i]);
		a[i] %= m;
	}

	int n;
	scanf("%d\n", &n);
	for (int i = 0; i < n; ++i) {
		gets(s);

		int offset = 0;
		unsigned* msk = msk1[i];
		for (int j = 0; s[j]; ++j) {
			unsigned x = (s[j] >= '0' && s[j] <= '9') ? (s[j] - '0') : (s[j] - 'a' + 10);
			(*msk) |= (x << offset);
			offset += 4;
			if (offset == 32) {
				offset = 0;
				++msk;
			}
		}
	}

    int T;
    scanf("%d", &T);
    int ans = 0;
    for (int _i = 0; _i < T; _i++) {
    	int uid; scanf("%d", &uid);
		uid %= m;
		for (int h = 0; h < f; ++h) {
			rem[h] = (uid * a[h]) % m;
		}

    	for (int file = 0; file < n; ++file) {
    		if (used[file]) continue;

    		bool cool = true;
    		for (int h = 0; h < f; ++h) {
    			int bit = rem[h];
                                  
    			if (msk1[file][bit / 32] & (1u << (bit & 31))) {
    				
    			} else {
    				cool = false;
    				break;
    			}
    		} 

    		if (cool) { 
    			used[file] = true;
    			ans++;
    		}
    	}
    }

	printf("%d", ans);
	for (int i = 0; i < n; ++i)
		if (used[i]) printf(" %d", i);
	cout << endl;

	return 0;
}