#include <iostream>
#include <vector>
#include <cstdio>
#include <cmath>
#include <memory.h>
#include <algorithm>

typedef long long LL;
using namespace std;

const int N = 222222;
int f[N], g[N], a[N], h[N];

int main() {
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);

	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		int x;
		scanf("%d", &x);
		a[x - 1] = i;
	}

	int hn = 0;
	for (int i = 0; i < n; ++i) {
		int c = lower_bound(h, h + hn, a[i]) - h;
		if (c == hn) {
			h[hn++] = a[i];
		} else {
			h[c] = a[i];
		}
		f[i] = hn;
	}
	hn = 0;
	for (int i = n - 1; i >= 0; --i) {
		int c = lower_bound(h, h + hn, a[i]) - h;
		if (c == hn) {
			h[hn++] = a[i];
		} else {
			h[c] = a[i];
		}
		g[i] = hn;
	}
	int ans = 0;
	for (int i =0 ; i < n; ++i) ans = max(ans, f[i] + g[i] - 1);
	cout << ans << endl;

	return 0;
}