#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cstring>
#include <queue>
#include <ctime>
#include <cassert>
using namespace std;

const int N = 100500;

struct Item
{
	int g, a, b, ind;

	Item() : g(), a(), b(), ind() {}

	void scan()
	{
		scanf("%d%d%d", &g, &a, &b);
	}

	bool operator < (const Item & other) const
	{
		return a * other.b > other.a * b;
	}
};

int n;
int A, B;
int suma, sumb;
vector<Item> items;
double amount[N];

void print_answer(double ansa, double ansb)
{
	printf("%.10lf %.10lf\n", ansa, ansb);
	for (int i = 0; i < n; i++)
		printf("%.10lf ", amount[i]);
	printf("\n");
	exit(0);
}

void print_no()
{
	printf("-1 -1\n");
	exit(0);
}

void solve()
{
	scanf("%d%d%d", &n, &A, &B);
	for (int i = 0; i < n; i++)
	{
		Item it;
		it.scan();
		it.ind = i;
		if (it.b > 0)
			items.push_back(it);
		else
		{
			suma += it.g * it.a;
			amount[i] = it.g;
		}
	}

	sort(items.begin(), items.end());

	for (int i = 0; i < (int)items.size(); i++)
	{
		if (sumb + items[i].g * items[i].b > B)
		{
			int nom = B - sumb;
			int denom = items[i].b;
			if ((long long)suma * denom + (long long)nom * items[i].a >= (long long)A * denom)
			{
				double adding = (double)nom / denom;
				amount[items[i].ind] = adding;
				double full_suma = suma + adding * items[i].a;
				double full_sumb = B;
				print_answer(full_suma, full_sumb);
			}
			else
				print_no();
		}
		else
		{
			suma += items[i].g * items[i].a;
			sumb += items[i].g * items[i].b;
			amount[items[i].ind] = items[i].g;
		}
	}

	if (suma >= A)
		print_answer(suma, sumb);
	else
		print_no();
}

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	solve();

	return 0;
}