#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cstring>
#include <queue>
#include <ctime>
#include <cassert>
using namespace std;

const int N = 1020;

int n, m;
int a[N], b[N];

int sign(int a)
{
	if (a < 0)
		return -1;
	if (a == 0)
		return 0;
	return 1;
}

int get_cord(int a, int b, int t)
{
	int dist = abs(a - b);
	t %= (2 * dist);
	int dir = sign(b - a);
	
    if (t <= dist)
	{
		return a + dir * t;
	}
	else
	{
		t -= dist;
		return b - dir * t;
	}
}

void solve()
{
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; i++)
		scanf("%d%d", &a[i], &b[i]);

	for (int i = 0; i < m; i++)
	{
		int x, y, t;
		scanf("%d%d%d", &x, &y, &t);
		int cnt = 0;
		for (int j = 0; j < n; j++)
		{
			int c = get_cord(a[j], b[j], t);
			if (x <= c && c <= y)
				cnt++;
		}
		printf("%d\n", cnt);
	}
}

int main()
{
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);

	solve();

	return 0;
}