#pragma comment(linker, "/STACK:100000000")
#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <cctype>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <deque>
#include <queue>
#include <string>
using namespace std;
#define int64 long long
#define ldb long double
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const double pi = acos(-1.0);
#define taskname "filter"

const int size = 1000 + 10;
const int ssize = (size / 32) + 2;

long long a[size];
int m, f, n;
int q;
unsigned int msk[size][ssize];
char buf[size];
long long id[size];
unsigned int usermsk[size][ssize];
bool ans[size];

int getval(char c) {
	if (c >= '0' && c <= '9')
		return c - '0';
	return c - 'a' + 10;
}

bool good(int i, int j) {
	for (int p = 0; p < (m + 31) / 32; p++) {
		if ((msk[i][p] & usermsk[j][p]) != usermsk[j][p])
			return false;
	}

	return true;
}

int main() {
	assert(freopen(taskname".in", "r", stdin));
	assert(freopen(taskname".out", "w", stdout));

	scanf("%d%d", &m, &f);
	for (int i = 0; i < f; i++)
		scanf("%lld", &a[i]);
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%s", buf);
		int len = strlen(buf);
		for (int j = 0; j < len; j++) {
			int val = getval(buf[j]);
			for (int k = 0; k < 4; k++)
				msk[i][(j * 4 + k) / 32] |= ((val >> k) & 1) << ((j * 4 + k) & 31);
		}
	}

	scanf("%d", &q);
	for (int i = 0; i < q; i++) {
		scanf("%lld", &id[i]);
		for (int j = 0; j < f; j++) {
			int ps = (id[i] * a[j]) % m;
			usermsk[i][ps / 32] |= (1 << (ps & 31));
		}
    }

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < q; j++)
			if (good(i, j)) {
			    ans[i] = true;
				break;
			}
	}

	int cnt = 0;
	for (int i = 0; i < n; i++)
		cnt += ans[i];
	printf("%d", cnt);
	for (int i = 0; i < n; i++)
		if (ans[i])
			printf(" %d", i);
	printf("\n");


	return 0;
}