// LU - 1
#include <iostream>
#include <fstream>
#include <cstdio>
#include <string>
#include <sstream>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef pair<int, int> ii;
typedef double real;

struct car
{
    int a, b;
};

int move_dir(int st, int fin, int t)
{
    int dir = st < fin ? 1 : -1;
    return st + t * dir;
}

int position(car C, int t)
{
    int d = abs(C.b-C.a);
    t %= 2*d;

    if(t < d)
    {
        return move_dir(C.a, C.b, t);
    }
    else
    {
        return move_dir(C.b, C.a, t-d);
    }
}

const int MX=1009;

int n, m;
car C[MX];

int main()
{
    freopen("knockout.in", "r", stdin);
    freopen("knockout.out", "w", stdout);
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL); //cout.tie(NULL);
    cin >> n >> m;
    for(int i=0; i<n; i++) cin >> C[i].a >> C[i].b;
    for(int j=0; j<m; j++)
    {
        int result=0;
        int x, y, t;
        cin >> x >> y >> t;
        for(int i=0; i<n; i++)
        {
            int pos = position(C[i], t);
            if(x <= pos && pos <=y) result++;
        }
        cout << result << '\n';
    }
    return 0;
}
