#define FILENAME "alter"

#ifdef SU1
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <iomanip>

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <climits>
#include <ctime>

#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forl(i, n) for (int i = 1; i <= int(n); i++)
#define fore(i, l, r) for (int i = int(l); i <= int(r); i++)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define ft first
#define sc second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X sqr(const X &a) { return a * a; }
template<typename X> inline X abs(const X &a) { return a < 0 ? -a : a; }

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9, PI = acosl(ld(-1));

int n, m;

inline bool read()
{
	return cin >> n >> m;
}

inline void solve()
{
	cout << n / 2 + m / 2 << endl;
	forn(j, m)
	{
		if (j % 2 == 1)
		{
			cout << 1 << ' ' << j + 1 << ' ' << n << ' ' << j + 1 << endl;
		}
	}
	
	forn(i, n)
	{
		if (i % 2 == 1)		
		{
			cout << i + 1 << ' ' << 1 << ' ' << i + 1 << ' ' << m << endl;
		}
	}
		
}

int main()
{
#ifdef SU1
	freopen("input.txt", "rt", stdin);
	//freopen("output.txt", "wt", stdout);
#else
	freopen(FILENAME ".in", "rt", stdin);	
	freopen(FILENAME ".out", "wt", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(5) << fixed;
	
	assert(read());
	solve();

	return 0;
}