#include <stdio.h>
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
using namespace std;

typedef long long LL;
typedef long long ll;
typedef pair<int, int> pii;

const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

#ifdef LOCAL
#include <windows.h>
#endif

#define PROBLEM "burrito"

vector<int> g, a, b;

bool comp(int x, int y) {
  return b[x] * a[y] < b[y] * a[x];
}

int main() {
  std::ios_base::sync_with_stdio(false);
  cin.tie(NULL);
#ifdef LOCAL
  freopen("input.txt", "rt", stdin);
  freopen("output.txt", "wt", stdout);
  int _tt = GetTickCount();
#else
  freopen(PROBLEM ".in", "rt", stdin);
  freopen(PROBLEM ".out", "wt", stdout);
#endif
  int n;
  LL A, B;
  cin >> n >> A >> B;
  g.resize(n); a.resize(n); b.resize(n);
  FOR(i, 0, n) cin >> g[i] >> a[i] >> b[i];

  vector<double> ans(n, 0);
  vector<int> coords(n);
  FOR(i, 0, n) coords[i] = i;
  sort(coords.begin(), coords.end(), comp);
  LL cura = 0;
  LL curb = 0;
  LL curau = 0, curad = 1;
  for (int i : coords) {
    if (b[i] && b[i] * g[i] > B - curb) {
      ans[i] = double(B - curb) / b[i];
      curau = (B - curb) * a[i];
      curad = b[i];
      curb = B;
      break;
    } else {
      ans[i] = g[i];
      cura += g[i] * a[i];
      curb += g[i] * b[i];
      if (curb >= B) break;
    }
  }

  if (cura * curad + curau < A * curad) {
    cout << "-1 -1";
    return 0;
  }

  cout.precision(10);
  cout << fixed << cura + double(curau) / curad << " " << curb << "\n";
  FOR(i, 0, n) cout << fixed << ans[i] << " ";

#ifdef LOCAL
  cerr << double(GetTickCount() - _tt) * 0.001 << endl;
#endif
  return 0;
}
