#include <stdio.h>
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
using namespace std;

typedef long long LL;
typedef long long ll;
typedef pair<int, int> pii;

const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

#ifdef LOCAL
#include <windows.h>
#endif

#define PROBLEM "problem"

int main() {
  std::ios_base::sync_with_stdio(false);
  cin.tie(NULL);
#ifdef LOCAL
  freopen("input.txt", "rt", stdin);
  freopen("output.txt", "wt", stdout);
  int _tt = GetTickCount();
#else
  freopen(PROBLEM ".in", "rt", stdin);
  freopen(PROBLEM ".out", "wt", stdout);
#endif

  int n, m;
  cin >> n >> m;
  vector<pii> cars(n);
  FOR(i, 0, n) {
    cin >> cars[i].first >> cars[i].second;
  }

  FOR(i, 0, m) {
    int x, y, t;
    cin >> x >> y >> t;
    int cnt = 0;
    FOR(j, 0, n) {
      int d = abs(cars[j].second - cars[j].first);
      int pos = cars[j].first;
      if (d) {
        int z = t % (2 * d);
        if (z >= d) z = 2 * d - z;
        if (cars[j].second < cars[j].first) z = -z;
        pos += z;
//        cout << j << " " << t << " " << pos << endl;
      }
      cnt += (pos >= x && pos <= y);
    }
    cout << cnt << endl;
  }

#ifdef LOCAL
  cerr << double(GetTickCount() - _tt) * 0.001 << endl;
#endif
  return 0;
}
