#include <stdio.h>
#include <algorithm>
#include<iostream>
#include<string>
#include<vector>
#include<assert.h>
#include <cmath>
#include <set>
#include <bitset>
using namespace std;

int a[110];
//bitset<1100> b[1100];

double eps = 1e-7;

int main(){
#ifdef _CONSOLE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
#endif

	int n, A, B;
	cin >> n >> A >> B;
	vector<int> g(n), a(n), b(n);
	vector< pair<double, int> > c(n);
	vector<double> res(n);
	vector<bool> used(n);
	for (int i = 0; i < n; ++i) {
		scanf("%d%d%d", &g[i], &a[i], &b[i]);
		if (b[i] == 0) {
			res[i] = g[i];
			used[i] = true;
		}
		else {
			c[i].first = (double)a[i] / b[i];
		}
		c[i].second = i;
	}

	sort(c.begin(), c.end());
	reverse(c.begin(), c.end());

	double rem = B;
	double sumA = 0;
	
	for (int i = 0; i < n; ++i) {
		int id = c[i].second;
		if (used[id]) continue;
		double can = g[id] * b[id];
		double take = min(rem, can);
		res[id] = take;
		sumA += take * c[id].first;
		rem -= take;
	}

	double sumB = B - rem;

	if (sumA + eps < A) {
		printf("-1 -1"); 
		return 0;
	}

	printf("%.10f %.10f\n", sumA, sumB);
	for (int i = 0; i < n; ++i) {
		printf("%.10f ", res[i] / b[i]);
	}
	
	return 0;
}