#include <stdio.h>
#include <algorithm>
#include<iostream>
#include<string>
#include<vector>
#include<assert.h>
#include <cmath>
#include <set>
#include <bitset>
#include <memory.h>
#include <ctime>
using namespace std;

struct Node{
	char c;
	int b[3], cnt;
};

vector<Node> ans;

char c[110];
int b[110][3];
int d[255];

void rec(vector<int> a, int last){
	if (a.size() == 1 || ans[last].cnt > 350){
		// one option
		int marked[110][3];
		memset(marked, 0, sizeof(marked));

		int x = a[0];

		do{
			char his = c[x];
			char ours = (his + 1) % 3;

			ans[last].c = ours;
			if (marked[x][ours]){
				ans[last].b[his] = marked[x][ours];
				break;
			}

			Node w;
			memset(&w, 0, sizeof(w));
			w.c = -1;
			ans.push_back(w);

			ans[last].b[his] = ans.size() - 1;
			last = ans.size() - 1;

			marked[x][ours] = last;
			x = b[x][ours];
		} while (true);

	}else{
		vector<int> q[3][3];
		int jMax = 0, wMax = 0;
		for (int j = 0; j < 3; j++){
			for (int i = 0; i < a.size(); i++){
				q[j][c[a[i]]].push_back(b[a[i]][j]);
			}

			int his = (j - 1 + 3) % 3;

			if (q[j][his].size() > wMax){
				wMax = q[j][his].size();
				jMax = j;
			}
		}

		ans[last].c = jMax;

		for (int i = 0; i < 3; i++){
			if (q[jMax][i].size()){
				Node w;
				memset(&w, 0, sizeof(w));
				w.c = -1;
				w.cnt = (q[jMax][i].size() == a.size()) ? ans[last].cnt + 1 : 0;
				ans.push_back(w);

				ans[last].b[i] = ans.size() - 1;

				rec(q[jMax][i], ans.size() - 1);
			}
		}
	}
}

int main(){
#ifdef _CONSOLE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("epic.in", "r", stdin);
	freopen("epic.out", "w", stdout);
#endif

	srand(time(NULL));

	d['R'] = 0;
	d['P'] = 1;
	d['S'] = 2;

	int n;
	cin >> n;
	vector<int> q;
	for (int i = 0; i < n; i++){
		cin >> c[i] >> b[i][0] >> b[i][1] >> b[i][2];
		
		b[i][0]--;
		b[i][1]--;
		b[i][2]--;
		c[i] = d[c[i]];

//		b[i][0] = rand() % n;
//		b[i][1] = rand() % n;
//		b[i][2] = rand() % n;
//		c[i] = rand() % 3;

		q.push_back(i);
	}

	Node w;
	memset(&w, 0, sizeof(w));
	w.c = -1;
	ans.push_back(w);
	rec(q, 0);

	printf("%d\n", ans.size());
	for (int i = 0; i < ans.size(); i++){
		char c;
		switch (ans[i].c){
			case 0: c = 'R'; break;
			case 1: c = 'P'; break;
			case 2: c = 'S'; break;
		}
		printf("%c %d %d %d\n", c, ans[i].b[0] + 1, ans[i].b[1] + 1, ans[i].b[2] + 1);
	}	
	return 0;
}