#include <cstdio>
#include <cstring>
#include <cassert>
#include <algorithm>

using namespace std;

const int N = 12345;

char s[N];
vector <int> res;
int len, n;
bool have[N];

void dfs(int v) {
  if (v == len) {
    for (int i = 0; i < (int)res.size(); i++) {
      if (i > 0) printf(" ");
      printf("%d", res[i]);
    }
    printf("\n");
    exit(0);
  }
  int num = s[v] - '0';
  if (1 <= num && num <= n && !have[num]) {
    res.push_back(num);
    have[num] = true;
    dfs(v + 1);
    have[num] = false;
    res.pop_back();
  }
  if (v + 1 < len) {
    num = (s[v] - '0') * 10 + (s[v + 1] - '0');
    if (1 <= num && num <= n && !have[num]) {
      res.push_back(num);
      have[num] = true;
      dfs(v + 2);
      have[num] = false;
      res.pop_back();
    }
  }
}

int main() {
  freopen("joke.in", "r", stdin);
  freopen("joke.out", "w", stdout);
  scanf("%s", s);
  len = strlen(s);
  int sum = 0;
  n = -1;
  for (int i = 1; i <= 50; i++) {
    sum += (i >= 10 ? 2 : 1);
    if (sum == len) {
      n = i;
      break;
    }
  }
  assert(n != -1);
  for (int i = 1; i <= n; i++) {
    have[i] = false;
  }
  res.clear();
  dfs(0);
  return 0;
}
