#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef double ld;

#define mp make_pair
#define pb push_back
#define sz(x) ((int)(x).size())
#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#define TASK "damage"
const ld inf = 1e18;
const ld eps = 1e-9;

struct pnt {
	ld x, y;
	pnt() {
	}
	pnt(ld x, ld y):x(x),y(y) {		
	}
};
pnt operator - (pnt a, pnt b) {
	return pnt(a.x - b.x, a.y - b.y);
}
pnt operator + (pnt a, pnt b) {
	return pnt(a.x + b.x, a.y + b.y);
}
pnt operator * (pnt a, ld c) {
	return pnt(a.x * c, a.y * c);
}
pnt operator / (pnt a, ld c) {
	return pnt(a.x / c, a.y / c);
}
ld sp(pnt a, pnt b) {
	return a.x * b.x + a.y * b.y;
}
ld vp(pnt a, pnt b) {
	return a.x * b.y - a.y * b.x;
}

ld dst(pnt a, pnt b) {
	return sqrt(sp(a - b, a - b));
}
ld d, l, r, t, h;
int solve() {
	if (scanf("%lf %lf %lf %lf %lf", &d, &l, &r, &t, &h) != 5)
		return 0;
	d /= 1e2;
	l /= 1e2;
	r /= 1e2;
	t /= 1e2;
	h /= 1e2;
	pnt p1 = pnt(0, 0);
	ld alp = asin(t / l);
	pnt p2 = pnt(l * cos(alp), t);
	pnt v1 = (p2 - p1) / dst(p1, p2);
	pnt v2 = pnt(-v1.y, v1.x);
	pnt o1 = p1 + v2 * d / 2;
	pnt o2 = p2 + v2 * d / 2;
  ld leftx = -d / 2;
  ld rightx = d / 2;
  ld downy = -d / 2;
  ld upy = d / 2;
  int N = 5000;
  int M = 2 * N;
  ld dx = (rightx - leftx) / M;
  ld dy = (upy - downy) / M;
  ld ans = 0;
  ld C = sqrt(r * r - d / 2 * d / 2);
 	for (int i = 0; i <= M; i++) {
 		ld X0 = leftx + i * dx;
	 	ld dd0 = X0 * X0;
		if (dd0 > d / 2 * d / 2) continue;
		if (fabs(t) <= eps && X0 > h - d / 2) continue;
		for (int j = 0; j <= M; j++) {
	  	ld ci = (i == 0 || i == M) ? 1 : (i % 2 == 1 ? 4 : 2);
	  	ld cj = (j == 0 || j == M) ? 1 : (j % 2 == 1 ? 4 : 2);
	  	pnt p0 = pnt(X0, downy + j * dy);
	  	ld dd = p0.x * p0.x + p0.y * p0.y;
	  	if (dd > d / 2 * d / 2) continue;
	  	ld H = sqrt(max((ld)0, r * r - dd)) - C;
			ld LZ = -H;
			ld RZ = l + H;
			pnt pp0 = o1 + v2 * p0.x;
			ld go = (h - pp0.y) / v1.y;
			if (fabs(t) <= eps) go = inf;
			ans += max((ld)0, min(go, RZ) - LZ) * ci * cj;
  	}
  }
  printf("%.18f\n", (double)(ans * dx * dy / 9));
	return 1;	
}

int main() {
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);

	while (1) {
		if (!solve())
			break;
		#ifdef DEBUG
		eprintf("%.10f\n", (double)clock() / CLOCKS_PER_SEC);
		#endif
	}

	return 0;
}
