#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) ((int)(x).size())
#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#define TASK "joke"

int len;
int n;

const int maxlen = 200;
char s[maxlen];
int used[maxlen];
int put[maxlen];

#define next mynext
int next[maxlen], value[maxlen];

bool use(int l, int r, int val) {
	assert(0 <= l && l <= r && r < len);
	assert(r - l <= 1);
	int cur = s[l] - '0';
	if (r > l)
		cur = 10 * cur + (s[r] - '0');	
	//eprintf("try [%d,%d] %d\n", l, r, cur);
	if (cur == 0 || cur > n)
		return 0;
	if (val == 1 && used[cur])
		return 0;
	//eprintf("use [%d,%d] %d\n", l, r, val);
	//eprintf("cur = %d\n", cur);
	put[l] = put[r] = val;
	used[cur] = val;
	next[l] = r + 1;
	value[l] = cur;
	return 1;
}

bool solve2(int pos) {
	if (pos == len) {
		vector<int> ans;
		for (int x = 0; x < len; x = next[x])
			ans.pb(value[x]);
		for (int i = 0; i < n; ++i)
			printf("%d%c", ans[i], " \n"[i == n - 1]);
		assert(sz(ans) == n);
		return 1;
	}
	if (put[pos])
		return solve2(pos + 1);
			
	for (int t = 0; t < 2; ++t) {
		if (t && (pos == len - 1 || put[pos + 1]))
			continue;
		if (use(pos, pos + t, 1)) {
			if (solve2(pos + t + 1))
				return 1;
			use(pos, pos + t, 0);
		}
	}
	return 0;
}

bool solve1(int c) {
	if (c == 1)
		return solve2(0);
	if (c == 10)
		c = 0;

	int x = 0;
	while (x * 10 + c <= n)
		++x;

	int cnt[10];
	memset(cnt, 0, sizeof(cnt));
	for (int i = 0; i < len; ++i) {
		if (s[i] != '0' + c)
			continue;
		char pr = '0';
		if (i)
			pr = s[i - 1];
		if (pr - '0' >= x)
			pr = '0';
		cnt[pr - '0'] += 1;
	}

	//for (int i = 0; i < x; ++i)
	//	eprintf("%d%c", cnt[i], " \n"[i == x - 1]);
	int tmp = -1;
	for (int i = 1; i < x; ++i) {
		assert(cnt[i] >= 1);
		if (cnt[i] > 1) {
			assert(cnt[i] == 2);
			assert(tmp == -1);
			tmp = i;
		}	
	}

	for (int type = 0; type < 2; ++type) {
		if (type && tmp == -1)
			continue;
		for (int iter = 1; iter >= 0; --iter) {
			int left = type;
			for (int i = 0; i < len; ++i) {
				if (s[i] != '0' + c)
					continue;
				char pr = '0';
				if (i)
					pr = s[i - 1];
				if (pr - '0' >= x)
					pr = '0';
				int val = pr - '0';
				if (val == tmp) {
					if (!left)
						val = 0;
					--left;
			 	}
	  
				assert(use(i - !!val, i, iter));
			}
			if (iter && solve1(c + 1))
				return 1;
		}
				
	}
	return 0;
}

int solve() {
	if (scanf("%s", s) != 1)
		return 0;

	len = (int)strlen(s);

	if (len <= 9)
		n = len;
	else {
		assert(len & 1);
		n = 9 + (len - 9) / 2;
	}

	for (int i = 0; i < len; ++i)
		put[i] = 0;
	for (int i = 1; i <= n; ++i)
		used[i] = 0;
	assert(solve1(6));

	return 1;	
}

int main() {
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);

	while (1) {
		if (!solve())
			break;
		#ifdef DEBUG
		eprintf("%.6f\n", (double)clock() / CLOCKS_PER_SEC);
		#endif
	}

	return 0;
}
