#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
using namespace std;
#define TASK "burrito"

struct T
{
	int g, a, b;
	int index;
	bool operator <(const T& other) const
	{
		return a * other.b < other.a * b;
	}

};

const int N = 200000;
double A, B;
int n;
T a[N];
double ans[N];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	scanf("%d%lf%lf", &n, &A, &B);
	for (int i = 0; i < n; i++)
	{
		scanf("%d%d%d", &a[i].g, &a[i].a, &a[i].b);
		a[i].index = i;
	}
	sort(a, a + n);
	reverse(a, a + n);
	double tA = 0;
	double tB = B;
	for (int i = 0; i < n; i++)
	{
		double v = min(tB, 1.0 * a[i].b * a[i].g);
		tB -= v;
		double t = a[i].g;
		if (a[i].b != 0) t = v / a[i].b;
		ans[a[i].index] = t;
		tA += t * a[i].a;
	}
	if (tA < A) printf("-1 -1");
	else
	{
		printf("%.8lf %.8lf\n", tA, B - tB);
		for (int i = 0; i < n; i++)
		{
			printf("%.8lf ", ans[i]);
		}
	}
	return 0;
}