#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <string>
using namespace std;

int n, minA, maxB;
int g[100010], a[100010], b[100010];

double take[100010];

struct S {
	int a, b, i;
	S() {}
	bool operator < (const S &s) const {
		return a * s.b > s.a * b;
	}
} s[100010];


int main() {
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	scanf("%d%d%d", &n, &minA, &maxB);
	for (int i = 0; i < n; i++) {
		scanf("%d%d%d", &g[i], &a[i], &b[i]);
		s[i].a = a[i];
		s[i].b = b[i];
		s[i].i = i;
	}
	sort(s, s + n);

	double sumA = 0, sumB = 0;
	for (int i = 0; i < n; i++) {
		int si = s[i].i;
		double allowedGrams = g[si];
		double allowedUnhappiness = maxB - sumB;
		double unhappinessGrams;
		if (s[i].b == 0)
			unhappinessGrams = 110;
		else
			unhappinessGrams = allowedUnhappiness / s[i].b;
		double takeGrams = min(allowedGrams, unhappinessGrams);

		take[si] = takeGrams;

		sumA += a[si] * takeGrams;
		sumB += b[si] * takeGrams;
	}

	if (sumA + 1e-9 < minA) {
		printf("-1 -1");
	}
	else {
		printf("%.10lf %.10lf\n", sumA, sumB);
		for (int i = 0; i < n; i++)
			printf("%.10lf ", take[i]);
	}
}