#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <string>
using namespace std;

int n, minA, maxB;
int g[100010], a[100010], b[100010];

double take[100010];

struct S {
	int a, b, i;
	S() {}
	bool operator < (const S &s) const {
		return a * s.b > s.a * b;
	}
} s[100010];


int main() {
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	scanf("%d%d%d", &n, &minA, &maxB);
	for (int i = 0; i < n; i++) {
		scanf("%d%d%d", &g[i], &a[i], &b[i]);
		s[i].a = a[i];
		s[i].b = b[i];
		s[i].i = i;
	}
	sort(s, s + n);

	__int64 curB = 0, curA = 0;
	int pos = 0;
	for (; pos < n; pos++) {
		int si = s[pos].i;
		if (curB + g[si] * b[si] > maxB)
			break;
		curB += g[si] * b[si];
		curA += g[si] * a[si];
		take[si] = g[si];
	}

	double addA = 0;
	if (pos < n) {
		int left = maxB - curB;
		int bPos = s[pos].b;
		double amount = (left + 0.0) / bPos;
		take[s[pos].i] = amount;
		addA = amount * s[pos].a;
		curB = maxB;
	}

	if (curA + addA - 1e-8 < minA || curA + addA == 0) {
		printf("-1 -1");
	}
	else {
		printf("%.10lf %I64d\n", curA + addA, curB);
		for (int i = 0; i < n; i++)
			printf("%.10lf ", take[i]);
	}
}