#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cctype>
#include <cassert>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <sstream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <queue>
#include <functional>

using namespace std;

#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <class T> inline T sqr(const T& a) { return a * a; }
template <class T> inline void updMin(T& a, const T& b) { if (b < a) a = b; }
template <class T> inline void updMax(T& a, const T& b) { if (a < b) a = b; }

int n, m; 
bool used[1000]; 
int a[1000]; 
string s; 

bool can(char c) {
	if (c == '0') return false;
	if (c - '0' > n) return false;
	if (used[c - '0']) return false;
	return true;
}

bool can(char c, char cc) {
	if (c == '0') return false;
	int k = (c - '0') * 10 + (cc - '0'); 
	if (k > n) return false;
	if (used[k]) return false;
	return true;
}

void f(int i, int cnt) {
	if (i == m) {
		for (int i = 0; i < n; i++) {
			cout << a[i] << " "; 
		}
		cout << "\n"; 
		exit(0); 
	}
	if (can(s[i])) {
		used[s[i] - '0'] = 1; 
		a[cnt] = s[i] - '0'; 
		f(i + 1, cnt + 1);
		used[s[i] - '0'] = 0; 
	}
	if (i + 1 < m && can(s[i], s[i + 1])) {
		int k = (s[i] - '0') * 10 + (s[i + 1] - '0');
		used[k] = 1; 
		a[cnt] = k; 
		f(i + 2, cnt + 1); 
		used[k] = 0; 
	}
}

int p[100]; 
string gen() {
	int N = 50; 
	string ret; 
	for (int i = 0; i < N; i++) {
		p[i] = i + 1; 
	}
	//reverse(p, p + N); 
	random_shuffle(p, p + N); 
	for (int i = 0; i < N; i++) {
		if (p[i] < 10) ret += p[i] + '0'; 
		else {
			ret += p[i] / 10 + '0'; 
			ret += p[i] % 10 + '0'; 
		}
	}
	return ret; 
}

int main()
{
    //freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#define TASKNAME "joke"
	freopen(TASKNAME ".in", "r", stdin); freopen(TASKNAME ".out", "w", stdout);

	ios::sync_with_stdio(false);


	cin >> s; 

	//s = gen(); 

	m = s.length(); 

	if (m >= 9) {
		n = 9 + (m - 9) / 2; 
	}
	else n = m; 

	f(0, 0); 

	cout << "NO\n"; 

	return 0;
}


