import java.io.*;
import java.util.StringTokenizer;

/**
 * Created by neerc on 07.12.2014.
 */
public class A {

    private BufferedReader in;
    private PrintWriter out;
    private StringTokenizer st;

    public static void main(String[] args) throws IOException {
        final A solver = new A();
        solver.open();
        solver.solve();
        solver.close();
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreElements()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    private int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    private final String filename = "alter";

    public void solve() throws IOException {
        final int n = nextInt();
        final int m = nextInt();
        out.println(n / 2 + m / 2);
        for (int i = 2; i <= n; i += 2) {
            out.println(i + " 1 " + i + " " + m);
        }
        for (int i = 2; i <= m; i += 2) {
            out.println("1 " + i + " " + n + " " + i);
        }
    }

    public void open() throws IOException {
        in = new BufferedReader(new FileReader(filename + ".in"));
        out = new PrintWriter(new FileWriter(filename + ".out"));
//        out = new PrintWriter(System.out);
    }

    public void close() {
        out.flush();
        out.close();
    }

}
