#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

const int maxn = 1 << 17;
const double eps = 1e-6;

int n, A, B;
int g[maxn], a[maxn], b[maxn], p[maxn];
double ans[maxn];

bool cmp(int i, int j) {
 	return a[i] * b[j] > a[j] * b[i];
}

int main() {
 	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	cout.precision(10);
	cout << fixed;
	cin >> n >> A >> B;
	for (int i = 0; i < n; i++) {
		cin >> g[i] >> a[i] >> b[i];
	}
	for (int i = 0; i < n; i++) p[i] = i;
	sort(p, p + n, cmp);

	int curSumA = 0, curSumB = 0;
	bool printed = false;
	for (int i = 0; i < n; i++) {
	 	int j = p[i];
		if (curSumB + g[j] * b[j] <= B) {
		 	curSumB += b[j] * g[j];
			curSumA += a[j] * g[j];
			ans[j] = g[j];
		} else {
			double can = (double)(B - curSumB) / b[j];
			ans[j] = can;
			if (1LL * curSumA * b[j] + 1LL * a[j] * (B - curSumB) < 1LL * A * b[j]) {
			 	cout << "-1 -1" << endl;
				return 0;
			}
			cout << curSumA + can * a[j] << " " << curSumB + can * b[j] << endl;
			printed = true;
			break;
		}
	}	
	if (!printed && curSumA < A) {
	 	cout << "-1 -1" << endl;
	 	return 0;
	}
	if (!printed) cout << curSumA << " " << curSumB << endl;
	for (int i = 0; i < n; i++) cout << ans[i] << " \n"[i + 1 == n];	

	return 0;
}