#pragma comment(linker, "/STACK:64000000")

#include <iostream>
#include <cassert>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <ctime>
#include <sstream>
#include <string>
#include <cstring>
#include <functional>
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef double ld;

const ld eps = 1e-8;

void solve() {
	int n;
	i64 A, B;
	cin >> n >> A >> B;
	vector<pair<ld, int>> w;
	vector<ld> ans(n, 0);
	ld cA = 0, cB = 0;
	vi64 a(n), b(n), g(n);
    forn(i, n)
	{
    	cin >> g[i] >> a[i] >> b[i];
		if (g[i] && a[i])
		{
			if (!b[i])
			{
				cA += a[i] * g[i];
				ans[i] = g[i];
			}
            else
			    w.push_back(mp(ld(a[i]) / b[i], i));
		}
	}
	sort(all(w), greater<pair<ld, int>>());
	for (auto t : w){
		int ind = t.second;
		ans[ind] = min((B - cB) / b[ind], (ld)g[ind]);
		cB += ans[ind] * b[ind];
        cA += ans[ind] * a[ind];
	}
	if (cA < A - eps) {
		cout << "-1 -1" << "\n";
	}
	else{
		cout << cA << " " << cB << "\n";
		forn(i, n)
			cout << ans[i] << " ";
		cout << "\n";
    }
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.precision(25);
	cout << fixed;
#define TASK "burrito"
#ifdef HOME
	freopen("input.txt", "rt", stdin);
#else 
	freopen(TASK".in", "rt", stdin);
	freopen(TASK".out", "wt", stdout);
#endif
	solve();
#ifdef HOME
	cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " sec.\n";
#endif
	return 0;
}
