#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstdio>
#include <set>
#include <list>
using namespace std;

typedef long double ld;
typedef unsigned long long ull;
const ld INF = 1 << 30;

#define mp(x,y) make_pair(x, y)

vector<pair<int, int> > seg;
vector<int> st;


int main()
{
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);
	int n;
	cin >> n;
	int L = 0, R = INF;
	int l = 0, r;
	cin >> r;
	int res = 0;
	int prevX;
	prevX = r;
	for (int i = 1; i < n; ++i)
	{
		int x;
		cin >> x;
		if (x>l && x < r)
		{
			if (x < prevX)
			{
				L = l;
				l = x;
				R = x;
			}
			else
			{
				L = x;
				R = r;
				r = x;
			}
			prevX = x;
		}
		else if (x>L && x<R)
		{
			if (x > prevX)
			{
				l = prevX;
				r = x;
				L = x;
			}
			else
			{
				l = x;
				r = prevX;
				R = x;
			}
			prevX = x;
		}
		else res++;
	}
	cout << n-res << endl;
	return 0;
}