#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

int mp[300];
int a[1010], u[1010];
string h[1010];
int m, f, n, q;
bool can[1010];
vector <int> ans;

int main()
{
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
	
	const int foo[16] = {0, 8, 4, 12, 2, 10, 6, 14, 1, 9, 5, 13, 3, 11, 7, 15};
	for (int i = 0; i < 10; ++i)
		mp['0' + i] = i;
	for (int i = 0; i < 6; ++i)
		mp['a' + i] = 10 + i;
	cin >> m >> f;
	for (int i = 0; i < f; ++i)
	{
		cin >> a[i];
		a[i] %= m;
	}
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		string tmp;
		cin >> tmp;
		if (tmp.length() % 2 == 1)
			tmp.push_back(0);
		h[i] = "";
		for (int j = 0; j < tmp.length(); j += 2)
		{
			h[i].push_back(16 * mp[tmp[j + 1]] + mp[tmp[j]]);
		}
	}
	cin >> q;
	for (int i = 0; i < q; ++i)
	{
		cin >> u[i];
		u[i] %= m;
		string id;
		for (int j = 0; j < h[0].size(); ++j)
			id.push_back(0);
		for (int j = 0; j < f; ++j)
		{
			int pos = (u[i] * a[j]) % m;
			id[pos / 8] ^= (1 << (pos % 8));
		}
		for (int j = 0; j < n; ++j)
		{
			if (can[j])
				continue;
			can[j] = true;
			for (int k = 0; k < id.size(); ++k)
			{
				int c = h[j][k], d = id[k];
				if ((c & d) != d)
				{
					can[j]  = false;
					break;
				}
			}
			if (can[j])
				break;
		}
	}

	for (int i = 0; i < n; ++i)
		if (can[i])
			ans.push_back(i);
	
	cout << ans.size() << " ";
	for (int i = 0; i < ans.size(); ++i)
		cout << ans[i] << " ";
	return 0;
}