#include <iostream>
#include <sstream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <algorithm>
#include <iomanip>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); i++)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; i--)
#define fore(i,l,r) for (int i = int(l); i <= int(r); i++)
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ft first
#define sc second
#define x first
#define y second

template<typename X> inline X abs(const X& a) { return a < 0 ? -a : a; }
template<typename X> inline X sqr(const X& a) { return a * a; }

typedef pair<int, int> pt;
typedef long double ld;
typedef long long li;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld PI = 3.1415926535897932384626433832795L;
const ld EPS = 1e-9;

int n, m;

inline bool read()
{
	if (scanf("%d%d", &n, &m) != 2)
		return false;
	return true;
}

inline void solve()
{
	int ans = n / 2 + m / 2;
	printf("%d\n", ans);
	for(int i = 2; i <= n; i += 2) {
		printf("%d %d %d %d\n", i, 1, i, m);
	}
	for(int j = 2; j <= m; j += 2) 
		printf("%d %d %d %d\n", 1, j, n, j);
}

int main()
{
#ifdef SU2_PROJ
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("alter.in", "rt", stdin);
	freopen("alter.out", "wt", stdout);
#endif	

	cerr << setprecision(10) << fixed;
	cout << setprecision(15) << fixed;
	
	srand(time(NULL));
	
	assert(read());
	solve();
	
#ifdef SU2_PROJ
	cerr << "TIME: " << clock() << endl;
#endif	
	
	return 0;
}