#include <iostream>
#include <sstream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <algorithm>
#include <iomanip>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); i++)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; i--)
#define fore(i,l,r) for (int i = int(l); i <= int(r); i++)
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ft first
#define sc second
#define x first
#define y second

template<typename X> inline X abs(const X& a) { return a < 0 ? -a : a; }
template<typename X> inline X sqr(const X& a) { return a * a; }

typedef pair<int, int> pt;
typedef long double ld;
typedef long long li;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld PI = 3.1415926535897932384626433832795L;
const ld EPS = 1e-9;

const int N = 150;

string s;
int perm[N];

string intToStr(int x) {
	string res = "";
	while (x) {
		res += '0' + x % 10;
		x /= 10;
	}	
	reverse(all(res));
	return res;
	
}

inline bool read()
{
	if (!getline(cin, s))
		return false;
/*	forn(i, 50) {
		perm[i] = i + 1;
	}
	random_shuffle(perm, perm + 50);
	s = "";
	forn(i, 50) {
		s += intToStr(perm[i]);
	}
	cerr << s << endl;*/
	return true;
}

set<li> z[N];
map<li, int> p[N];

inline void solve()
{
	int len = 0;
	int n = -1;
	for(int i = 1;;i++) {
		len += (i < 10 ? 1 : 2);
		if (len == sz(s)){ 
			n = i;
			break;
		}
	}
	z[0].insert(1);
	forn(i, sz(s)) {
		for(set<li>::iterator it = z[i].begin(); it != z[i].end(); it++) {
			li mask = *it;
			{
				int d = s[i] - '0';
				if (1 <= d && d <= n && (mask & (1ll << d)) == 0) {
					li nmask = (mask | (1ll << d));
					z[i + 1].insert(nmask);
					p[i + 1][nmask] = d;
			 	}
			}
			if (i + 1 < sz(s)) {
				int d = 10 * (s[i] - '0') + s[i + 1] - '0';
				if (10 <= d && d <= n && (mask & (1ll << d)) == 0) {
					li nmask = (mask | (1ll << d));
					z[i + 2].insert(nmask);
					p[i + 2][nmask] = d;
			 	}
			}
		}
	}
	li cur = (1ll << (n + 1)) - 1;
	assert(z[sz(s)].count(cur));
	vector<int> ans;
	int i = sz(s);
	for(;;) {
		if (cur == 1)
			break;
		int d = p[i][cur];
		ans.pb(d);
		i -= (d < 10 ? 1 : 2);
		cur ^= (1ll << d);
	}
	reverse(all(ans));
	assert(sz(ans) == n);
	forn(i, sz(ans)) {
		printf("%d ", ans[i]);
	}
	
}

int main()
{
#ifdef SU2_PROJ
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("joke.in", "rt", stdin);
	freopen("joke.out", "wt", stdout);
#endif	

	cerr << setprecision(10) << fixed;
	cout << setprecision(15) << fixed;
	
	srand(time(NULL));
	
	assert(read());
	solve();
	
#ifdef SU2_PROJ
	cerr << "TIME: " << clock() << endl;
#endif	
	
	return 0;
}