#include <iostream>
#include <sstream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <algorithm>
#include <iomanip>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); i++)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; i--)
#define fore(i,l,r) for (int i = int(l); i <= int(r); i++)
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ft first
#define sc second
#define x first
#define y second

template<typename X> inline X abs(const X& a) { return a < 0 ? -a : a; }
template<typename X> inline X sqr(const X& a) { return a * a; }

typedef pair<int, int> pt;
typedef long double ld;
typedef long long li;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld PI = 3.1415926535897932384626433832795L;
const ld EPS = 1e-9;

const int N = 1000 + 13;
int n, m;
pt a[N];

inline bool read()
{
	if (scanf ("%d%d", &n, &m) != 2)
		return false;
		
	forn (i, n)
	{
		int x, y;
		assert(scanf ("%d%d", &x, &y) == 2);
		
		a[i] = mp(x, y);
	}
	
	return true;
}

inline bool in (int a, int b, int l, int r, int t)
{
	int len = b - a;
	t %= (2 * len);
	
	int pos;
	
	if (t >= len)
		pos = b - (t - len);
	else
		pos = a + t;
		
	return pos >= min(l, r) && pos <= max(l, r);
}

inline void solve()
{
	forn (i, m)
	{
		int l, r, t;
		assert(scanf ("%d%d%d", &l, &r, &t) == 3);
		
		int ans = 0;
		forn (j, n)
			if (in(a[j].ft, a[j].sc, l, r, t))
				ans++;
				
		printf ("%d\n", ans);
	}
}

int main()
{
#ifdef SU2_PROJ
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("knockout.in", "rt", stdin);
	freopen("knockout.out", "wt", stdout);
#endif	

	cerr << setprecision(10) << fixed;
	cout << setprecision(15) << fixed;
	
	srand(time(NULL));
	
	assert(read());
	solve();
	
#ifdef SU2_PROJ
	cerr << "TIME: " << clock() << endl;
#endif	
	
	return 0;
}