#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cassert>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cstdlib>
#include <cmath>
#include <bitset>
#include <iostream>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)

using namespace std;

const int MAXN = 1010;
int a[MAXN];
int u[MAXN];
bitset<MAXN> mask[MAXN];
bitset<MAXN> cur;
char s[MAXN];
bool fl[MAXN];


int main() {
  assert(freopen("filter.in", "r", stdin));
  assert(freopen("filter.out", "w", stdout));
  int m, f;
  scanf("%d %d", &m, &f);
  forn(i, f) {
    scanf("%d", a + i);
  }
  int n;
  scanf("%d", &n);
  forn(i, n) {
    scanf("%s", s);
    mask[i] = 0;
    for (int k = 0; 4 * k < m; ++k) {
      int t = (s[k] <= '9') ? (s[k] - '0') : (10 + s[k] - 'a');
//      cerr << t << endl;
      for (int j = 0; j < 4; ++j) {
        mask[i][4 * k + j] = t % 2;
//        cerr << (t % 2);
        t >>= 1;
      }      
    }//    cerr << endl;
  }
  int q;
  scanf("%d", &q);
  forn(i, q) {
    scanf("%d", u + i);
  }
  forn(j, q) {
    cur = 0;
    forn(i, f) {
      int val = (1ll * a[i] * u[j]) % m;
      cur[val] = 1;
    }
/*    for (int j = 0; j < m; ++j) {
      cerr << cur[j];
    }
    cerr << endl;*/
    forn(i, n) if (!fl[i]) {
      if ((mask[i] | cur) == mask[i]) {
        fl[i] = true;
      }
    }
  }
  vector<int> ans;
  forn(i, n) if (fl[i]) {
    ans.push_back(i);
  }
  printf("%d", ans.size());
  forn(i, ans.size()) {
    printf(" %d", ans[i]);
  }
}
