#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cassert>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cstdlib>
#include <cmath>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()

using namespace std;

const int maxn = 100;
vector<int> ans;
char str[maxn];
set<long long> h[maxn];
int n;
int m;

int go(int ind, long long mask) {
	if (ind == m) return 1;
	int val = str[ind] - '0';
	if (h[ind].count(mask)) return 0;
	if (val > 0 && val <= n && !(mask & (1LL << val))) {
		if (go(ind + 1, mask | (1LL << val))) {
			ans.push_back(val);
			return 1;
		}
	}
	if (str[ind + 1] != 0) {
		if (str[ind] != '0') {
			int val = (str[ind] - '0') * 10 + (str[ind + 1] - '0');
			if ( val > 0 && val <= n && !(mask & (1LL << val))) {
				if (go(ind + 2, mask | (1LL << val))) {
					ans.push_back(val);
					return 1;
				}
			}
		}
	}
	return 0;
}


int main() {
	freopen("joke.in", "rt", stdin);
	freopen("joke.out", "wt", stdout);
	scanf("%s", str);
	m = strlen(str);	
	int s = 0;
	for (n = 1; true; n++) {
		if (n < 10) s+=1; else s += 2;
		if (s == m) break;
	}
	assert(go(0, 0));
	reverse(ans.begin(), ans.end());
	//eprintf("n = %d\n", n);
	for (int i = 0; i < (int)ans.size(); i++) {
		printf("%d%c", ans[i], " \n"[i + 1 == m]);
	}
}