#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 51;

int getSize(int n){
	if (n < 10)
		return n;
	return (n - 9) / 2 + 9;
}

bool used[MAXN];

string s;
int n;
vector<int> ans;

void printAns(){
	//sort(ans.begin(), ans.end());
	for (int i = 0; i < ans.size(); ++i){
		printf("%d ", ans[i]);
	}
}

void bruteforce(int index = 0, int strPos = 0, bool doPair = false){
	if (index == n){
		printAns();
		exit(0);
	}

//	printf("%d\n", index);

	if (doPair){
		if (strPos + 1 >= s.length())
			return;
		int num = (s[strPos] - '0') * 10 + (s[strPos + 1] - '0');

		if (num > n || used[num])
			return;
        
		ans.push_back(num);
		used[num] = true;
		bruteforce(index + 1, strPos + 2, false);
		bruteforce(index + 1, strPos + 2, true);
		ans.pop_back();
		used[num] = false;
    }
	else {
		if (strPos >= s.length())
			return;
		int num = s[strPos] - '0';

		if (num > n || used[num])
			return;

		ans.push_back(num);
		used[num] = true;
		bruteforce(index + 1, strPos + 1, false);
		bruteforce(index + 1, strPos + 1, true);
		ans.pop_back();
		used[num] = false;
	}
}

int main(){
	freopen("joke.in", "rt", stdin);
	freopen("joke.out", "wt", stdout);

	/*vector<int> tmp;
	for (int i = 1; i <= 50; ++i){
		tmp.push_back(i);
	}
	random_shuffle(tmp.begin(), tmp.end());
	for (int i = 0; i < tmp.size(); ++i){
		cout << tmp[i];
	}

	return 0;*/

	cin >> s;
	n = getSize(s.length());

	bruteforce();
	bruteforce(0, 0, true);
}