#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>

using namespace std;

struct car{
	int l, r;

	car(){
		l = r = 0;
	}
	car(int l, int r){
		this->l = l;
		this->r = r;
	}

	int getPosition(int time){
		int rotationCount = time / abs(l - r);
		int last = time % abs(l - r);

		if (rotationCount & 1){
			return r - last;
		}
		else {
			return l + last;
		}
	}

	void read(){
		scanf("%d%d", &l, &r);
	}
};

int n, m;
vector<car> cars;

int main(){
	freopen("knockout.in", "rt", stdin);
	freopen("knockout.out", "wt", stdout);

	scanf("%d%d", &n, &m);
	cars.resize(n);

	for (int i = 0; i < n; ++i){
		cars[i].read();
	}

	for (int i = 0; i < m; ++i){
		int a, b, time;
		scanf("%d%d%d", &a, &b, &time);

		int ans = 0;
		for (int j = 0; j < cars.size(); ++j){
			int pos = cars[j].getPosition(time);
			if (pos <= b && pos >= a){
				++ans;
			}
		}
		printf("%d\n", ans);
	}
}