#include <iostream>
#include <cstdio>
#include <iomanip>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>

using namespace std;

int pos (const pair <int, int> &car, int t)
{
    int a = car.first, b = car.second;
    int dir = t / (b - a);
    if (dir % 2 == 0)
    {
        return a + (t % (b - a));
    }

    return b - (t % (b - a));
}

int main()
{
    freopen ("knockout.in", "rt", stdin);
    freopen ("knockout.out", "wt", stdout);
    int n, m;
    cin >> n >> m;
    vector <pair <int, int> > v (n);
    for (int i = 0; i < n; ++i)
        cin >> v[i].first >> v[i].second;
    for (int i = 0; i < m; ++i)
    {
        int a, b, t, cnt = 0;
        cin >> a >> b >> t;
        for (int j = 0; j < n; ++j)
        {
            int p = pos (v[j], t);
            if (a <= p && p <= b)
                ++cnt;
        }
        cout << cnt << endl;
    }
    return 0;
}
