#if 1
#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cstdlib>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <bitset>
using namespace std;

const int bits = 1024;
typedef long long LL;
#define forn(i, n) for (int i = 0; i < n; ++i)

int conv(char c)
{
	if ('0' <= c && c <= '9')
		return c - '0';
	return 10 + int(c - 'a');
}

bitset<bits> to_bitset(string s)
{
	reverse(s.begin(), s.end());
	const int n = s.size();
	bitset<bits> res;
	forn(i, n)
	{
		int val = conv(s[n - 1 - i]);
		forn(j, 4)
			if ((val & (1 << j)) > 0)
				res[j + i * 4] = 1;
	}
	return res;
}
char st[10000] = {};

void solve()
{
	// cout << to_bitset("a1").to_string() << endl;
	int m, f;
	scanf("%d %d", &m, &f);
	vector <int> a(f);
	for (int i = 0; i < f; i++)
		scanf("%d", &a[i]);

	int n;
	scanf("%d", &n);
	vector <bitset<bits> > b(n);
	for (int i = 0; i < n; i++)
	{
		scanf("%s\n", st);
		b[i] = to_bitset(st);
	}

	int q;
	scanf("%d", &q);

	vector <int> c(q);
	vector <bitset<bits> > c2(q);
	for (int i = 0; i < q; i++)
	{
		scanf("%d", &c[i]);
		for (int k = 0; k < f; k++)
		{
			int j = (LL(c[i]) * a[k]) % m;
			c2[i][j] = 1;
		}
	}

	vector <int> ans;
	for (int i = 0; i < n; i++)
	{
		for (int k = 0; k < q; k++)
		{
			if ((b[i] & c2[k]) == c2[k])
			{
				ans.push_back(i);
				break;
			}
		}
	}

	printf("%d ", ans.size());
	for (int i = 0; i < ans.size(); i++)
		printf("%d ", ans[i]);
	printf("\n");
}

int main()
{
	freopen("filter.in", "r", stdin); freopen("filter.out", "w", stdout);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);

	solve();

	return 0;
}
#endif