#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <bitset>
#include <cassert>

using namespace std;

#define _USE_MATH_DEFINES
#include <math.h>

#define LL long long
#define forn(i,n) for (LL i=0;i<n;i++)
#define rforn(i,n) for (LL i=n-1;i>=0;i--)
#define mp make_pair

void smain();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
#endif

	smain();

	return 0;
}

#define N 100001
#define EPS 1e-8
#define int long long

int n, A, B;
struct node{
	int g, a, b, i;
};
node a[N];

bool compare(node i, node j){
	int di = i.a - i.b, dj = j.a - j.b;
	if (i.a == 0) return j.a == 0 ? i.i < j.i : false;
	if (j.a == 0) return i.a == 0 ? i.i < j.i : true;
	if (j.b == 0 && i.b == 0) return i.a == j.a ? i.i < j.i : i.a > j.a;
	if (i.b == 0) return true;
	if (j.b == 0) return false;
	if (di == dj) return i.i < j.i;
	return di > dj;
}

void smain() {
	cin >> n >> A >> B;
	forn(i, n){
		cin >> a[i].g >> a[i].a >> a[i].b;
		a[i].i = i;
	}

	sort(a, a + n, compare);

	double curA = 0, curB = 0;
	vector<double> ans(n, 0.);
	forn(i, n){
		double t;
		if (a[i].b == 0){
			if (a[i].a == 0) continue;
			t = a[i].g;
		}else t = min((double)a[i].g, max(0., B - curB) / a[i].b);
		ans[a[i].i] = t;
		curA += t * a[i].a, curB += t * a[i].b;
	}
	if (curA + EPS < A) return void(cout << "-1 -1");
	cout.precision(9);

	cout << fixed << curA << ' ' << fixed << curB << '\n';
	forn(i, n) cout << ans[i] << ' ';
}