#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <bitset>
#include <cassert>

using namespace std;

#define _USE_MATH_DEFINES
#include <math.h>

#define LL long long
#define forn(i,n) for (LL i=0;i<n;i++)
#define rforn(i,n) for (LL i=n-1;i>=0;i--)
#define mp make_pair

void smain();

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("burrito.in", "r", stdin);
	//freopen("burrito.out", "w", stdout);
#endif

	smain();

	return 0;
}

#define N 20


int f[N+10][N+10], s = 0;
int x, y;

inline bool check(int x, int y){
	return x > 0 && y > 0 && x < N && y < N;
}

pair<int, int> get_move(){
	forn(i, N) forn(j, N) if(f[i][j] == 1) {
		for (int dx = -1; dx < 2; dx++){
			for (int dy = -1; dy < 2; dy++) if (!(dx == 0 && dy == 0)){
				int cnt = 0, k = 0, ki = -1;
				for (; k < 5; ++k) if (check(i + k * dx, j + k * dy)){
					if (f[i + k * dx][j + k * dy] == 1) cnt += 1;
					else if (f[i + k * dx][j + k * dy] == 0) ki = k;
				}
				if (cnt == 4 && ki != -1) return mp(i + ki * dx, j + ki * dy);
			}
		}
	}

	pair<int, int> res;
    int cres = 0;
	forn(i, N) forn(j, N) if (f[i][j] == 2) {
		for (int dx = -1; dx < 2; dx++){
			for (int dy = -1; dy < 2; dy++) if (!(dx == 0 && dy == 0)){
				int cnt = 0, k = 0;
				for (; k < 5; ++k) {
					if (check(i + k * dx, j + k * dy) && f[i + k * dx][j + k * dy] == 2) cnt += 1;
					else break;
				}
				if (cnt > cres && check(i + k * dx, j + k * dy) && f[i + k * dx][j + k * dy] == 0){
		            cres = cnt, res = mp(i + k * dx, j + k * dy);
				}
			}
		}
	}
	return res;
}

void smain() {
	for(int i=0;;i++) {
		cin >> x >> y;
		if (x == -1) break;
		f[x][y] = 1;
		
		if (i == 0)
            f[x - 1][y] = 2, cout << x - 1 << ' ' << y << endl;
		else if (i == 1){
			if (f[10][11] == 0) f[10][11] = 2, cout << 10 << ' ' << 11 << endl;
			else f[10][9] = 2, cout << 10 << ' ' << 9 << endl;
		}else{
			pair<int, int> res = get_move();
			f[res.first][res.second] = 2;
			cout << res.first << ' ' << res.second << endl;
		}
	}
}