#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <bitset>
#include <cassert>

using namespace std;

#define _USE_MATH_DEFINES
#include <math.h>

#define LL long long
#define forn(i,n) for (LL i=0;i<n;i++)
#define rforn(i,n) for (LL i=n-1;i>=0;i--)
#define mp make_pair

void smain();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("burrito.in", "r", stdin);
	//freopen("burrito.out", "w", stdout);
#endif

	smain();

	return 0;
}

#define N 200001

int n;
int a[N];
pair<int, int> seg[N];

struct ev{
	int x, tp, i;
	ev(int a, int b, int c) : x(a), tp(b), i(c){}
};

bool compare(ev a, ev b){
	if (a.x == b.x) {
		if (a.tp == b.tp){
			if (a.tp == 1) {
				return seg[a.i].second > seg[b.i].second;
			}
			else{
				return seg[a.i].first > seg[b.i].first;
			}
		}
		return a.tp < b.tp;
	}
	return a.x < b.x;
}

void smain() {
	cin >> n;
	forn(i, n) cin >> a[i];

	forn(i, n){
		seg[i].second = a[i];
		seg[i].first = i ? a[i - 1] : 0;
		if (seg[i].first > seg[i].second) swap(seg[i].first, seg[i].second);
	}

	sort(seg, seg + n);
	int res = 0;
    

	vector< ev > events;
	forn(i, n){
		events.push_back(ev(seg[i].second, -1, i));
		events.push_back(ev(seg[i].first, 1, i));
	}

	sort(events.begin(), events.end(), compare);

	stack<int> q;
	vector<bool> used(n);
	for (auto it = events.begin(); it != events.end(); ++it){
		pair<int, int> cur(it->tp, it->i);
		if (cur.first == -1){
			if (q.top() == cur.second) q.pop();
			else {
				res += 1;
			}
			used[cur.second] = true;
		}
		else{
			q.push(cur.second);
		}
		for (; !q.empty() && used[q.top()];) q.pop();
	}

	cout << n - res;
}