import java.io.*;
import java.util.StringTokenizer;

public class TaskA extends PrintWriter {
    BufferedReader in;
    StringTokenizer stok;

    static String FILENAME = "alter";

    void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        println(n / 2 + m / 2);
        for (int i = 2; i <= n; i+=2) {
            println(i + " 1 " + i + " " + m);
        }
        for (int i = 2; i <= m; i+=2) {
            println("1 " + i + " " + n + " " + i);
        }
    }

    void run() {
        try {
            solve();
            close();
        } catch (Exception e) {
            System.exit(1);
        }
    }

    TaskA() throws IOException {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    TaskA(String s) throws IOException {
        super(s + ".out");
        in = new BufferedReader(new FileReader(s + ".in"));
    }

    public static void main(String[] args) throws IOException {
        if (FILENAME == null) {
            new TaskA().run();
        } else {
            new TaskA(FILENAME).run();
        }
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }
}