import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class TaskJ extends PrintWriter {
    BufferedReader in;
    StringTokenizer stok;

    static String FILENAME = "joke";

    boolean check(int[] a, int i1, int i2, int i3, int i4, int[] cnt) {
        Arrays.fill(cnt, 0);
        for (int i = 0; i < a.length; i++) {
            if (i == i1) {
                cnt[1]++;
            } else if (i == i2) {
                cnt[2]++;
            } else if (i == i3) {
                cnt[3]++;
            } else if (i == i4) {
                cnt[4]++;
            } else {
                if (a[i] == 0) {
                    return false;
                }
                if (i + 1 < a.length && a[i + 1] == 0) {
                    cnt[a[i] * 10]++;
                    i++;
                } else if (a[i] >= 5) {
                    cnt[a[i]]++;
                } else {
                    if (i + 1 >= a.length) {
                        return false;
                    }
                    cnt[a[i] * 10 + a[i + 1]]++;
                    i++;
                }
            }
        }
        boolean was0 = false;
        for (int i = 1; i <= 50; i++) {
            if (cnt[i] > 1) {
                return false;
            }
            if (cnt[i] == 0) {
                was0 = true;
            } else {
                if (was0) {
                    return false;
                }
            }
        }
        return true;
    }

    void print1(int a) {
        print(a);
        print(" ");
    }

    void print(int[] a, int i1, int i2, int i3, int i4) {
        for (int i = 0; i < a.length; i++) {
            if (i == i1) {
                print1(1);
            } else if (i == i2) {
                print1(2);
            } else if (i == i3) {
                print1(3);
            } else if (i == i4) {
                print1(4);
            } else {
                if (i + 1 < a.length && a[i + 1] == 0) {
                    print1(a[i] * 10);
                    i++;
                } else if (a[i] >= 5) {
                    print1(a[i]);
                } else {
                    print1(a[i] * 10 + a[i + 1]);
                    i++;
                }
            }
        }
    }

    void solve() throws IOException {
        char[] s = next().toCharArray();
        int n = s.length;
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = s[i] - '0';
        }
        if (n <= 9) {
            for (int i : a) {
                print1(i);
            }
        }
        int[] cnt = new int[51];
        for (int i1 = 0; i1 < n; i1++) {
            if (a[i1] != 1) {
                continue;
            }
            for (int i2 = 0; i2 < n; i2++) {
                if (a[i2] != 2) {
                    continue;
                }
                for (int i3 = 0; i3 < n; i3++) {
                    if (a[i3] != 3) {
                        continue;
                    }
                    for (int i4 = 0; i4 < n; i4++) {
                        if (a[i4] != 4) {
                            continue;
                        }
                        if (check(a, i1, i2, i3, i4, cnt)) {
                            print(a, i1, i2, i3, i4);
                            return;
                        }
                    }
                }
            }
        }
        throw new AssertionError();
    }

    void run() {
        try {
            solve();
            close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    TaskJ() throws IOException {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    TaskJ(String s) throws IOException {
        super(s + ".out");
        in = new BufferedReader(new FileReader(s + ".in"));
    }

    public static void main(String[] args) throws IOException {
        if (FILENAME == null) {
            new TaskJ().run();
        } else {
            new TaskJ(FILENAME).run();
        }
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }
}