#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cmath>
#include <algorithm>

using namespace std;

int n, A, B;

#define long

long double g[100100];
long double a[100100];
long double b[100100];

int p[100100];

long double ans[100100];


bool cmp(int i, int j)
{
	return a[i]/b[i] > a[j]/b[j];
}

int main()
{
    freopen("burrito.in", "rt", stdin);
    freopen("burrito.out", "wt", stdout);
    cin >> n >> A >> B;
    for(int i = 0; i < n; ++i)
    {
    	cin >> g[i] >> a[i] >> b[i];
		if (b[i] == 0.0)
			b[i] = 1e-100;
	}
	for(int i = 0; i < n; ++i)
		p[i] = i;
	sort(p, p + n, cmp);
	long double ca = 0.0;
	long double cb = 0.0;
	int i;
	cout << fixed << setprecision(9);
	for(int k = 0; k < n; ++k)
	{
		i = p[k];
		if ((cb+g[i]*b[i] - B) > 1e-9)
		{
			long double x = min((B-cb)/b[i], g[i]);
			if (ca + x*a[i] > A || fabs(ca + x*a[i] - A) < 1e-11)
			{	
				cout << ca + x*a[i] << ' ' << cb + x*b[i] << '\n';
				for(int j = 0; j < n; ++j)
					ans[j] = 0.0;
				for(int j = 0; j < k; ++j)
					ans[p[j]] = g[p[j]];
				ans[p[k]] = x;
				for(int j = 0; j < n; ++j)
					cout << ans[j] << ' ' ;
				return 0;
			}	
			else
			{
				cout << -1 << ' ' << -1;
				return 0;
			}
		}
		cb += g[i]*b[i];
		ca += g[i]*a[i];
	}
	if(ca<A)
	{
		cout <<"-1 -1";
		return 0;
	}
	cout << ca << ' ' << cb << '\n';
	for(int i = 0; i < n; ++i)
		cout << g[i] << ' ';
	return 0;
}
