#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cmath>
#include <algorithm>

using namespace std;

int n;
double  A, B;

#define long

long double g[100100];
long double a[100100];
long double b[100100];

int p[100100];

long double ans[100100];


bool cmp(int i, int j)
{
	return a[i]/b[i] > a[j]/b[j];
}

int main()
{
    freopen("burrito.in", "rt", stdin);
    freopen("burrito.out", "wt", stdout);
    scanf("%d %lf %lf",&n,&A,&B);
    for(int i = 0; i < n; ++i)
    {
    	//cin >> g[i] >> a[i] >> b[i];
		scanf("%lf %lf %lf",&g[i],&a[i],&b[i]);
		if (b[i] == 0.0)
			b[i] = 1e-100;
	}
	for(int i = 0; i < n; ++i)
		p[i] = i;
	sort(p, p + n, cmp);
	long double ca = 0.0;
	long double cb = 0.0;
	int i;

	for(int k = 0; k < n; ++k)
	{
		i = p[k];
		if ((cb+g[i]*b[i] - B) > 1e-9)
		{
			long double x = min((B-cb)/b[i], g[i]);
			if (ca + x*a[i] > A || fabs(ca + x*a[i] - A) < 1e-11)
			{	
				printf("%0.9f %0.9f\n",ca+x*a[i],cb+x*b[i]);
				for(int j = 0; j < n; ++j)
					ans[j] = 0.0;
				for(int j = 0; j < k; ++j)
					ans[p[j]] = g[p[j]];
				ans[p[k]] = x;
				for(int j = 0; j < n; ++j)
					printf("%0.9f ",ans[j]);
				return 0;
			}	
			else
			{
				printf("-1 -1\n");
				return 0;
			}
		}
		cb += g[i]*b[i];
		ca += g[i]*a[i];
	}
	if(ca<A)
	{
		printf("-1 -1\n");
		return 0;
	}
	printf("%0.9f %0.9f\n",ca,cb);
	for(int i = 0; i < n; ++i)
		printf("%0.9f ",g[i]);
	return 0;
}
