#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstdlib>

using namespace std;

typedef long long i64;

int n, m;
i64 a[1024], b[1024];

inline i64 pos(int i, i64 t)
{
	i64 c = t/(b[i] - a[i]);
	i64 rem = t % (b[i] - a[i]);
	if (c % 2 == 0)
		return a[i] + rem;
	return b[i] - rem;
}

int main()
{
	freopen("knockout.in", "rt", stdin);
	freopen("knockout.out", "wt", stdout);
	cin >> n >> m;
	for(int i = 0; i < n; ++i)
		cin >> a[i] >> b[i];
	i64 x, y, t;
	i64 p;
	int ans;
	for(int i = 0; i < m; ++i)
	{
		cin >> x >> y >> t;
		ans = 0;
		for(int j = 0; j < n; ++j)
		{
			p = pos(j, t);
			if (p >= x && p <=y)
				++ans;	
		}	
		cout << ans << '\n';
	}
	return 0;
}