#include <iostream>
#include <cstdio>
#include <climits>
#include <memory.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <numeric>
#include <string>

using namespace std;

set < pair<int, long long> > dp;

int n, len;
string s;
vector<int> res;

int f(int pos, int i, long long mask)
{
	if (pos == len)
		return 1;
	int k = s[pos] - '0';
	if (k <= n && k > 0 && (mask & (1LL << k)) == 0 && (!dp.count(make_pair(pos + 1, mask | (1LL << k)))))
	{
		res[i] = k;
		if (f(pos + 1, i + 1, mask | (1LL << k)))
			return 1;
	}
	if (pos == len - 1)
	{
		dp.insert(make_pair(pos, mask));
    	return 0;
	}
	k = (s[pos] - '0') * 10 + s[pos + 1] - '0';
	if (k <= n && k > 0 && (mask & (1LL << k)) == 0 && (!dp.count(make_pair(pos + 2, mask | (1LL << k)))))
	{
		res[i] = k;
		if (f(pos + 2, i + 1, mask | (1LL << k)))
			return 1;
	}
	dp.insert(make_pair(pos, mask));
	return 0;
}

int main()
{
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("joke.in", "rt", stdin);
	freopen("joke.out", "wt", stdout);
#endif
	cin >> s;
	len = s.size();
	if (len < 10)
		n = len;
	else
		n = (len - 9) / 2 + 9;
	res.assign(n+1, 0);
	int b = f(0, 0, 0);
	for (int i = 0; i < n; i++)
		cout << res[i] << ' ';

	return 0;
}