#include <cstdio>
#include <iostream>
#include <cstdlib>

#define FOR(a, b) for (int a = 0; a < (b); ++a)

using namespace std;

const int MAXN = 1100;

int a[MAXN], b[MAXN];

int sign(int a) {
	if (a < 0)
		return -1;
	if (a > 0)
		return 1;
	return 0;
}

int getP(int n, int t) {
	int len = abs(a[n] - b[n]);
	t %= 2 * len;
	if (t <= len) {
		return a[n] + sign(b[n] - a[n]) * t;
	}
	t -= len;
	return b[n] + sign(a[n] - b[n]) * t;
}

int main() {
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);
	int n, m;
	scanf("%d%d", &n, &m);
	FOR(i, n) {
		scanf("%d%d", &a[i], &b[i]);
	}
	FOR(i, m) {
		int x, y, t;
		scanf("%d%d%d", &x, &y, &t);
		int ans = 0;
		FOR(j, n) {
			int p = getP(j, t);
			if (x <= p && p <= y)
				ans++;
		}
		printf("%d\n", ans);
	}

}
