#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <queue>

#define all(v) v.begin(), v.end()
typedef long long ll;

using namespace std;

vector<int> bits['z'];
vector<int> a;
int m;

vector<bool> files_used;

inline bool in_file(const vector<bool> &file, int id) {

	for (int i = 0; i < a.size(); ++i) {
		int j = id * a[i] % m;
		if (!file[j])
			return false;
	}

	return true;
}

int main()
{
	ios_base::sync_with_stdio(false);
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
	bits['0'] = vector<int>({});
	bits['1'] = vector<int>({3});
	bits['2'] = vector<int>({2});
	bits['3'] = vector<int>({2, 3});
	bits['4'] = vector<int>({1});
	bits['5'] = vector<int>({1, 3});
	bits['6'] = vector<int>({1, 2});
	bits['7'] = vector<int>({1, 2, 3});
	bits['8'] = vector<int>({0});
	bits['9'] = vector<int>({0, 3});
	bits['a'] = vector<int>({0, 2});
	bits['b'] = vector<int>({0, 2, 3});
	bits['c'] = vector<int>({0, 1});
	bits['d'] = vector<int>({0, 1, 3});
	bits['e'] = vector<int>({0, 1, 2});
	bits['f'] = vector<int>({0, 1, 2, 3});
	for (char c = '0'; c <= '9'; ++c) {
		for (int i = 0; i < bits[c].size(); ++i)
			bits[c][i] = 3 - bits[c][i];
	}

	for (char c = 'a'; c <= 'f'; ++c) {
		for (int i = 0; i < bits[c].size(); ++i)
			bits[c][i] = 3 - bits[c][i];
	}


	//for (int i = 0; i < bits['a'].size(); ++i)
	//	cout << bits['a'][i];


	int f, n;
	cin >> m >> f;
	a.resize(f);
	for (int i = 0; i < f; ++i) {
		cin >> a[i];
		a[i] %= m;
	}
	vector<vector<bool> > hs;
	cin >> n;

	hs.resize(n);	
	files_used.resize(n);
	int sz = m / 4 + ((m % 4) > 0);
	for (int i = 0; i < n; ++i) {
		string s;
		hs[i].resize(m, false);
		cin >> s;
		for (int j = 0; j < s.length(); ++j) {
			char c = s[j];
			for (int k = 0; k < bits[c].size(); ++k) {
				if (j * 4 + bits[c][k] < m)
					hs[i][j * 4 + bits[c][k]] = true;
			}
		}
		//reverse(all(hs[i]));
	}

	//for (int i = 0; i < hs.size(); ++i) {
	//	for (int j = 0; j < hs[i].size(); ++j) {
	//		cout << hs[i][j];
	//	}
	//	cout << endl;
	//}
	int q;
	cin >> q;

	for (int i = 0; i < q; ++i) {
		int u;
		cin >> u;
		u %= m;
		int sm = 0;
		for (int j = 0; j < hs.size(); ++j) {
			if (!files_used[j])
				files_used[j] = in_file(hs[j], u);
		}
	}
	vector<int> ans;

	for (int i = 0; i < files_used.size(); ++i)
		if (files_used[i])
			ans.push_back(i);
	cout << ans.size() << " ";

	for (int i = 0; i < ans.size(); ++i)
		cout << ans[i] << " ";
	return 0;
}