#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <list>
#include <vector>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)((a).size())
#define mp make_pair
#define X first
#define Y second
#define y1 __y1
#define sqr(x) ((x) * (x))
#define endl '\n'

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld eps = 1e-9;
const ld pi = ld(3.1415926535897932384626433832795);

inline int myrand()
{
	return rand() ^ (rand() << 15);
}

const int N = 1111;

int n, A, B;
struct bur{
	int n, a, b, idx;
	bur() {};
	bur(int _n, int _a, int _b, int _idx){
		a = _a, b = _b, n = _n, idx = _idx;
	};
};

bool operator < (const pair< ld, bur> &a, const pair< ld, bur> &b){
	if (a.X != b.X)
		return a.X < b.X;
	return false;
}

bool operator < (const bur &a, const bur &b){
	return false;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

#ifndef _DEBUG
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(10) << fixed;
	ios_base::sync_with_stdio(false);
	srand(int(time(NULL)));
	
	cin >> n >> A >> B;
	vector <pair<int, ld> > ans;
	vector <pair< ld, bur> > v;
	ld nA = .0, nB = .0;
	forn(i, n){
		int nn, a, b;
		cin >> nn >> a >> b;
		if (a == 0){
			ans.push_back(mp(i + 1, .0));
			continue;
			
		}
		if (b == 0){
			ans.push_back(mp(i + 1, nn));
			nA += nn * a;
			continue;
		}

		ld d = ld(a) / ld(b);
		bur now = bur(nn, a, b, i + 1);
		v.push_back(mp(d, now));
	}
	

	sort(all(v));
	reverse(all(v));
	
	forn(i, sz(v)){
		bur now = v[i].Y;
		ld mx = min((B - nB) / ld(now.b), ld(now.n));
		nA += mx * now.a, nB += mx * now.b;
		ans.push_back(mp(now.idx, mx));
	}
	if (nA + eps < ld(A)){
		cout << "-1 -1";
		return 0;
	}
	cout << nA << " " << nB << endl;
	sort(all(ans));
	forn(i, sz(ans))
		cout << ans[i].Y << ' ';
	cerr << "TIME == " << ld(clock()) / CLOCKS_PER_SEC << endl;
	return 0;
}