#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <list>
#include <vector>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>
#include <bitset>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)((a).size())
#define mp make_pair
#define X first
#define Y second
#define y1 __y1
#define sqr(x) ((x) * (x))
#define endl '\n'

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld eps = 1e-9;
const ld pi = ld(3.1415926535897932384626433832795);

inline int myrand()
{
	return rand() ^ (rand() << 15);
}

const int N = 1111;

bitset<1009> files[N];
int a[N];
int n, m, q, f;
string ss[N];
bool used[N];

int to[256];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

#ifndef _DEBUG
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(10) << fixed;

	for (char c = '0'; c <= '9'; c++)
		to[c] = int(c - '0');

	for (char c = 'a'; c <= 'f'; c++)
		to[c] = int(c - 'a' + 10);

	for (char c = 'a'; c <= 'f'; c++)
		cerr << c << " == " << to[c] << endl;

	ios_base::sync_with_stdio(false);

	srand(int(time(NULL)));
	
	cin >> m >> f;
	forn(i, f)
		cin >> a[i], a[i] %= m;

	cin >> n;
	forn(i, n)
	{
		cin >> ss[i];
		string s = ss[i];

		int len = sz(s);

		int idx = 0;

		forn(j, len)
		{
			char c = s[j];
			int val = to[c];
			int curlen = 0;
			while (val > 0 || curlen < 4)
			{
				files[i][idx] = (val & 1);
				idx++;
				curlen++;
				val >>= 1;
			}
		}

		for (int pos = m; pos < 1009; pos++)
			files[i][pos] = 0;
	}

	cin >> q;
	vector<int> ans;

	forn(i, q)
	{
		bitset<1009> mask;
		int val;
		cin >> val;
		val %= m;

		forn(j, f)
		{
			int cur = (val * a[j]) % m;
			mask[cur] = 1;
		}

		int anss = 0;

		forn(j, n)
		{
			if ((files[j] & mask) == mask)
				used[j] = true;
		}
	}

	forn(i, n)
		if (used[i])
			ans.push_back(i);

	cout << sz(ans) << ' ';
	forn(i, sz(ans))
		cout << ans[i] << ' ';
	cout << endl;

	cerr << "TIME == " << ld(clock()) / CLOCKS_PER_SEC << endl;
	return 0;
}