#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <list>
#include <vector>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)((a).size())
#define mp make_pair
#define X first
#define Y second
#define y1 __y1
#define sqr(x) ((x) * (x))
#define y1 '\n'

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld eps = 1e-9;
const ld pi = ld(3.1415926535897932384626433832795);

inline int myrand()
{
	return rand() ^ (rand() << 15);
}

string s;
bool good;
int n, cnt;
stack <int> st;
bool u[10000];

void rec(int pos){
	if (cnt == n)
		good = true;
	if (good)
		return;

	if (pos >= s.size())
		return;

	int now = s[pos] - '0';
	if (!u[now] && now <= n && now > 0){
		u[now] = true;
		++cnt;
		st.push(now);
		rec(pos + 1);
		if (good)
			return;
		u[now] = false;
		--cnt;
		st.pop();
	}

	if (good)
		return;

	if (pos + 1 < s.size()){
		now = (s[pos] - '0') * 10 + s[pos + 1] - '0';
		if (!u[now] && now <= n && now > 0){
			u[now] = true;
			++cnt;
			st.push(now);
			rec(pos + 2);
			if (good)
				return;
			u[now] = false;
			--cnt;
			st.pop();
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

#ifndef _DEBUG
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(10) << fixed;

	srand(int(time(NULL)));
	/*
	vector < int > v;
	forn(i, 50)
		v.push_back(i + 1);
	random_shuffle(all(v));
	forn(i, sz(v))
		cout << v[i];*/
	cin >> s;
	
	int len = 0;
	for (int i = 1; len < s.size(); ++i){
		int ii = i;
		while (ii)
			ii /= 10, ++len;
		++n;
	}

	rec(0);
	assert(good);
	stack<int> ans;
	while (!st.empty()){
		int now = st.top();
		st.pop();
		ans.push(now);
	}

	while (!ans.empty()){
		int now = ans.top();
		ans.pop();
		cout << now << ' ';
	}
	cerr << "TIME == " << ld(clock()) / CLOCKS_PER_SEC << endl;
	return 0;
}