#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <list>
#include <vector>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)((a).size())
#define mp make_pair
#define X first
#define Y second
#define y1 __y1
#define sqr(x) ((x) * (x))
#define y1 '\n'

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld eps = 1e-9;
const ld pi = ld(3.1415926535897932384626433832795);

inline int myrand()
{
	return rand() ^ (rand() << 15);
}

const int N = 1111;

int n, m;
int a[N], b[N];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

#ifndef _DEBUG
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(10) << fixed;

	srand(int(time(NULL)));
	
	cin >> n >> m;

	forn(i, n)
		cin >> a[i] >> b[i];

	forn(kk, m)
	{
		int x, y, t;
		cin >> x >> y >> t;

		int ans = 0;

		forn(i, n)
		{
			int len = abs(a[i] - b[i]);
			int all = t / len;
			int res = -1;
			int ost = t % len;

			if (all % 2 == 0)
			{
				if (a[i] < b[i])
					res = a[i] + ost;
				else
					res = a[i] - ost;
			}
			else
			{
				if (b[i] < a[i])
					res = b[i] + ost;
				else
					res = b[i] - ost;
			}

			if (res >= x && res <= y)
				ans++;
		}

		cout << ans << endl;
	}
	
	cerr << "TIME == " << ld(clock()) / CLOCKS_PER_SEC << endl;
	return 0;
}