#define FNAME "epic"

#include<bits\stdc++.h>

#define forn(i,N) for(int i=0;i<(N);++i)
#define forit(i,V) for(__typeof(V.begin()) i=V.begin();i!=V.end();++i)
#define mp make_pair
#define pb push_back
#define fst first
#define snd second

using namespace std;

const char RPS[]="RPS";
const int WIN[]={1,2,0};

const int MAX_N=5e4+100;
int N;
int ToUs[MAX_N][3], ToHim[MAX_N][3], Do[MAX_N], T[MAX_N];
bool Was[MAX_N];
int Map[MAX_N];

int Cnt=0;

inline int Add(int t){
	assert(Cnt<int(5e4));
	Do[Cnt]=t;
	return Cnt++;
}

int DFS(int v){
	if(Was[v])
		return Map[v];
	Was[v]=1;
	int mv=WIN[T[v]];
	int curus=Map[v]=Add(mv);
	forn(j,3)
		ToUs[curus][j]=-1;
	ToUs[curus][T[v]]=DFS(ToHim[v][mv]);
	return curus;
}


int Build(int start,int cur){
	forn(i,N)
		Was[i]=0;
	int z=DFS(cur);
	start++;
	while(start < N){
		forn(i,Cnt)
			Was[i]=0;
		int curus=0;
		cur=start;
		while(!Was[curus]){
			Was[curus]=1;
			int &v=ToUs[curus][T[cur]];
			cur=ToHim[cur][Do[curus]];
			if(v==-1){
				v=Cnt;
				assert(Build(start,cur)==v);
				return z;
			}else{
				curus=v;
			}
		}
		++start;
	}
	return z;
}

int main(){
	assert(freopen(FNAME".in","r",stdin));
	assert(freopen(FNAME".out","w",stdout));

	scanf("%d",&N);
	forn(i,N){
		char type;
		scanf(" %c",&type);
		T[i]=strchr(RPS,type)-RPS;
		forn(j,3)
			scanf("%d",&ToHim[i][j]), --ToHim[i][j];
	}

	Build(0,0);
	printf("%d\n",Cnt);
	forn(i,Cnt){
		printf("%c ",RPS[Do[i]]);
		forn(j,3){
			if(ToUs[i][j]==-1)
				ToUs[i][j]=rand()%Cnt;
			printf("%d ",ToUs[i][j]+1);
		}
		puts("");
	}

	return 0;
}