#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <cstdio>
#include <cstring>
#include <set>


const int maxn = 1046;


using namespace std;


int a[maxn];
char s[maxn];
int bit[maxn][maxn];
set<int> st;
int rs[maxn];


int getNum(char c)
{
	if(isdigit(c))
		return c - '0';
	return 10 + c - 'a';
}


int getBit(char c, int pos)
{
	int x = getNum(c);
	return ((x & (1 << pos)) >> pos);
}


int main()
{
	freopen("filter.in","r",stdin);
	freopen("filter.out","w",stdout);
	int m, f;
	scanf("%d%d", &m, &f);
	for(int i = 0; i < f; i++)
		scanf("%d", &a[i]);
	int n;
	scanf("%d", &n);
	for(int i = 0; i < n; i++)
	{
		scanf("%s", s);
		for(int j = 0; j < m; j++)
		{
			bit[i][j] = getBit(s[j / 4], j % 4);
		}
	}
	int q;
	scanf("%d", &q);
	for(int i = 0; i < q; i++)
	{
		int x;
		scanf("%d", &x);
		for(int j = 0; j < f; j++)
		{
			rs[j] = (x * 1LL * a[j]) % m;
		}
		for(int j = 0; j < n; j++)
		{
			int cnt = 0;
			for(int k = 0; k < f; k++)
				cnt += bit[j][rs[k]];
			if(cnt == f)
				st.insert(j);
		}
	}
	printf("%d ", st.size());
	for(set<int>::iterator it = st.begin(); it != st.end(); it++)
		printf("%d ", *it);
	printf("\n");
}