#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>
#include <cmath>


const int maxn = 1046;


using namespace std;


int a[maxn], b[maxn];


int getx(int l, int r, int t)
{
	int len = abs(l - r);
	t %= 2 * len;
	int dir = (r - l) / len;
	if(t <= len)
		return l + dir * t;
	return r - dir * (t - len);
}


int main()
{
	freopen("knockout.in","r",stdin);
	freopen("knockout.out","w",stdout);
	int n, m;
	scanf("%d%d", &n, &m);
	for(int i = 0; i < n; i++)
	{
		scanf("%d%d", &a[i], &b[i]);
	}
	for(int i = 0; i < m; i++)
	{
		int l, r, t;
		scanf("%d%d%d", &l, &r, &t);
		int ans = 0;
		for(int j = 0; j < n; j++)
		{
			int cur = getx(a[j], b[j], t);
			if(l <= cur && cur <= r)
				ans++;
		}
		printf("%d\n", ans);
	}
	return 0;
}