import java.util.*;
import java.io.*;

/**
 * Created by neerc on 07.12.2014.
 */
public class F {
    int m;
    int f;
    long[] as;

    boolean[] get_bits(String str) {
        boolean[] bits = new boolean[m];
        for (int i = 0; i < str.length(); ++i) {
            char c = str.charAt(i);
            int off = 0;
//            if (m - i * 4 < 4){
//                off = 4 - (m - i * 4);
//            }

            for (int j = 0; j < Math.min(m - i * 4, 4); ++j) {
                if (j + off == 3) {
                    bits[i * 4 + j] = c=='8'||c=='9'||c=='a'||c=='b'||c=='c'||c=='d'||c=='e'||c=='f';
                }
                if (j + off == 2) {
                    bits[i * 4 + j] = c=='4'||c=='5'||c=='6'||c=='7'||c=='c'||c=='d'||c=='e'||c=='f';
                }
                if (j + off == 1) {
                    bits[i * 4 + j] = c=='2'||c=='3'||c=='6'||c=='7'||c=='a'||c=='b'||c=='e'||c=='f';
                }
                if (j + off == 0) {
                    bits[i * 4 + j] = c=='1'||c=='3'||c=='5'||c=='7'||c=='9'||c=='b'||c=='d'||c=='f';
                }

//                out.print(bits[i * 4 + j] ? 1 :0);
            }
        }
//        out.println();

        return bits;
    }

    void solve() throws IOException {
        m = nextInt();
        f = nextInt();
        as = new long[f];
        for (int i = 0; i < f; ++i) {
            as[i] = nextLong();
        }

        int files_num = nextInt();
        String[] strs = new String[files_num];
        for (int i = 0; i < files_num; ++i) {
            strs[i] = nextToken();
        }

        int q = nextInt();
        long[] users = new long[q];
        for (int i = 0; i < q; ++i) {
            users[i] = nextLong();
        }


        ArrayList<Integer> files = new ArrayList<Integer>();
        for (int i = 0; i < files_num; ++i) {
            boolean[] bits = get_bits(strs[i]);

            for (int j = 0; j < q; ++j) {
                long u = users[j];
                boolean is_ok = true;

                for (int k = 0; k < f; ++k) {
                    long a = as[k];
                    is_ok &= bits[(int) ((u * a) % m)];

                    if (!is_ok) {
                        break;
                    }
                }

                if (is_ok) {
                    files.add(i);
                    break;
                }
            }
        }

        out.print(files.size());
        for (int i = 0; i < files.size(); ++i) {
            out.print(" " + files.get(i));
        }
    }
//    23 4 3 5 7 11
//    3
//    effde7
//    c07902
//    0800c1
//    3 2 4 6

    public static void main(String[] args) throws IOException {
        new F().run();
    }

    BufferedReader reader;
    PrintWriter out;
    StringTokenizer tokenizer;

    void run() throws IOException {
        reader = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(new OutputStreamWriter(System.out));
        reader=new BufferedReader(new FileReader("filter.in"));
        out=new PrintWriter(new FileWriter("filter.out"));
        tokenizer = null;
        solve();
        reader.close();
        out.flush();
    }


    String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}
