#include <algorithm>
#include <string>
#include <iostream>
#include <vector>
#include <memory.h>
#include <fstream>
#include <cmath>

using namespace std;

int g[222222], a[222222], b[222222], num[222222];
double ret[222222];

struct vertex{
	int a;
	int b;
	int g;
	int num;
};

vertex my[222222];

bool cmp(vertex a, vertex b) {
	long long a1 = a.a, b1 = a.b;
	long long a2 = b.a, b2 = b.b;
	return (a1 * b2 >= a2 * b1);
	
}
        
int main() {
	freopen("burrito.in","r",stdin);
	freopen("burrito.out","w",stdout);  
	int n, A, B;
	cin >> n >> A >> B;
	int cnt = 0;
	double needA = A * 1.0;
	double needB = B * 1.0;
	double sumA = 0.0;
	double sumB = 0.0;
	for (int i = 1; i<=n; ++i) {
		int curG, curA, curB;
		cin >> curG >> curA >> curB;
		if (curB == 0) {
			ret[i] = (double)(curG);
			needA -= (double)curG * (double)curA;
			sumA += (double)curG * (double)A;
		} else {
			++cnt;    
			my[cnt].a = curA;
			my[cnt].b = curB;
			my[cnt].num = i;
			my[cnt].g = curG;                                                  
		}
	}         
	if (needA < 0) needA = 0;                 
	for (int i = 1; i<=10; ++i) sort(my + 1, my + cnt + 1, cmp);
	for (int i = 1; i<=cnt; ++i) {
		double minQ = needA / double(my[i].a);
		if (minQ < (double)my[i].g) minQ = (double)my[i].g;
		double maxQ = min(double(my[i].g), needB / double(my[i].b));
		double Q = min(minQ, maxQ);
		ret[my[i].num] = Q;
		needA -= Q * my[i].a;
		needB -= Q * my[i].b;
		sumA += Q * my[i].a;
		sumB += Q * my[i].b;
	}                      
	if (sumA < A || sumB > B) {
		printf("-1 -1 \n");
		return 0;
	}
	printf("%.10lf %.10lf\n", sumA, sumB);
	for (int i = 1; i<= n; ++i) printf("%.10lf ",abs(ret[i]));
	printf("\n");
	return 0;
}