#include <algorithm>
#include <string>
#include <iostream>
#include <vector>
#include <memory.h>
#include <fstream>
#include <cmath>

using namespace std;

int D[1111][1111];
int cnt[1111];
string A[1111];
int a[1111];
int used[1111];
int cur[1111];
string s;
int m,f,q,n;

int rev(char ch) {
	if (ch <= '9') return ch-'0';
	return ch-'a'+10;	
}

void add(int num, char ch) {
	int Q = rev(ch);
	int bit1, bit2, bit3, bit4;
	if ((Q&8)) bit1 = 1; else bit1 = 0;
	if ((Q&4)) bit2 = 1; else bit2 = 0;
	if ((Q&2)) bit3 = 1; else bit3 = 0;
	if ((Q&1)) bit4 = 1; else bit4 = 0;
	swap(bit1, bit4);
	swap(bit2, bit3);   	
	D[num][cnt[num] + 1] = bit1;
	D[num][cnt[num] + 2] = bit2;
	D[num][cnt[num] + 3] = bit3;
	D[num][cnt[num] + 4] = bit4;
	cnt[num] += 4;
} 

void add2(int num, char ch, int m) {
	int Q = rev(ch);
	int bit1, bit2, bit3, bit4;
	if ((Q&8)) bit1 = 1; else bit1 = 0;
	if ((Q&4)) bit2 = 1; else bit2 = 0;
	if ((Q&2)) bit3 = 1; else bit3 = 0;
	if ((Q&1)) bit4 = 1; else bit4 = 0;   	
	if (m == 3) swap(bit2, bit4); else
	if (m == 2) swap(bit3, bit4);
	if (m>=3){
		D[num][cnt[num] + 1] = bit2;
		cnt[num]++;
	}
	if (m>=2){
		D[num][cnt[num] + 1] = bit3;
		cnt[num]++;
	}
	if (m>=1){
		D[num][cnt[num] + 1] = bit4;
		cnt[num]++;
	}
}

void F(int num, string s, int m) {
	if (m % 4 == 0) {
		for (int i = 0; i < s.size(); ++i) add(num, s[i]);
	} else {
		for (int i = 0; i + 1 < s.size(); ++i) add(num, s[i]);
		add2(num, s[s.size() - 1], m % 4);
	}
}

bool good(int j){
	for (int i = 1; i<=f; ++i) {
		int pos = cur[i] + 1;
		if (D[j][pos] == 0) return false; 
	}
	return true;
}
        
int main() {
	freopen("filter.in","r",stdin);
	freopen("filter.out","w",stdout);  
	cin >> m >> f;
	for (int i = 1; i<=f; ++i) cin >> a[i];
	cin >> n;
	getline(cin, s);
	for (int i = 1; i<=n; ++i){
		getline(cin, s);  
		A[i] = s;
	}      
	memset(D, 0, sizeof(D));
	for (int i = 1; i<=n; ++i) F(i, A[i], m);
	cin >> q;   	
	memset(used, 0, sizeof(used));
	for (int i = 1; i<=q; ++i ){
		int t;
		cin >> t;
		for (int j = 1; j<=f; ++j) cur[j] = ((long long)(t) * (long long)(a[j])) % m;
		for (int j = 1; j<=n; ++j)
			if (good(j)) {
				used[j] = 1;	
			}
	}
	vector<int> my;
	for (int i = 1; i<=n; ++i)
		if (used[i]) my.push_back(i-1);
	cout << my.size() << " ";
	for (int i = 0; i < my.size(); ++i) cout << my[i] << " "; cout << endl;
	return 0;
}