#include <algorithm>
#include <string>
#include <iostream>
#include <vector>
#include <memory.h>
#include <fstream>
#include <cmath>

using namespace std;

bool used[555];
string s;
int n, len;
bool print = false;

int cur[555],cnt = 0;

void dfs(int v) {  
	if (print) return;
	if (v >= n) {
		for (int i = 1; i <= len; ++i)
			if (used[i] == false) return;
		for (int i = 1; i <= len; ++i) {
			cout << cur[i] << " ";
		}
		cout << endl;
		 print = true;
		return;	
		
	}
	for (int i = v; i < n; ++i) {
		if (print) return;
		int code = s[i] - '0';
		if (code == 0 && i != n - 1) continue;
		if (used[code]) continue;
		if (i + 2 < n && s[i + 1] == '0') continue;
		if ((i - v) % 2 == 1) continue;  	
		int j = v;
		bool f = true; 		
		vector<int> my; 
		my.clear();
		while (j < i) {
			int value = (s[j] - '0') * 10 + s[j + 1] - '0';
			my.push_back(value);
			if (value > len || used[value]) f = false;
			if (!f) break;
			j += 2;	
		}  
		if (f) {
			for (int j = 0; j < my.size(); ++j)
				++cnt, cur[cnt] = my[j];
			for (int j = 0; j < my.size(); ++j) used[my[j]] = true;                
			used[s[i]-'0'] = true;
			++cnt, cur[cnt] = s[i] - '0'; 
			
			dfs(i + 1);
			for (int j = 0; j < my.size(); ++j) --cnt, cur[cnt+1] = 0;
			--cnt, cur[cnt+1]=0;
			for (int j = 0; j < my.size(); ++j) used[my[j]] = false;
			used[s[i]-'0'] = false;
				
		}
	}
}
        
int main() {
	freopen("joke.in","r",stdin);
	freopen("joke.out","w",stdout);   
	getline(cin, s);
	n = s.size();
	if (s.size() <= 9) {
		for (int i = 0; i < s.size(); ++i) cout << s[i] << " "; cout << endl;
		return 0;
	}   
	len = 0;
	s = s + "0";
	for (int i = 10; i<=50; ++i) {
		if (i * 2 - 9 + 1 >= s.size()) {
			len = i;
			break;
		}
	}  
	++n;                 
	memset(used, 0, sizeof(used));  
	dfs(0);                                   
	return 0;
}