#include <iostream>
#include <algorithm>

using namespace std;

typedef long long ll;

struct Ing
{
	ll g, a, b;
};

Ing input[110000];

int compare(const void *i1, const void *i2)
{
	Ing *l = (Ing*)i1;
	Ing *r = (Ing*)i2;

	if (l->b * r->a > l->a * r->b)
		return 1;

	if (l->b * r->a < l->a * r->b)
		return -1;

	return 0;
}

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	ll N, A, B, i, j;
	ll K;

	cin >> N >> A >> B;

	for (i = 0; i < N; ++i)
	{
		scanf("%lld %lld %lld", &input[i].g, &input[i].a, &input[i].b);
	}

	qsort(input, N, sizeof(input[0]), compare);
	double *buf = new double [N];
	ll totalUnhappiness = 0, totalHappiness = 0;
	long double tUH, tH, tB;
	for (i = 0; i < N; ++i)
	{
		if (input[i].a < 1e-11)
			break;

		K = input[i].g;
		if (input[i].b * K <= B - totalUnhappiness)
		{
			totalHappiness += K * input[i].a;
			totalUnhappiness += K * input[i].b;
			tUH = totalUnhappiness;
			tH = totalHappiness;
			buf[i] = K;
		}
		else
		{
			tB = (long double) (B - totalUnhappiness) / input[i].b;
			tUH += tB * input[i].b;
			tH += tB * input[i].a;
			buf[i] = tB;
			break;
		}
	}

	if (tH >= A && tUH <= B)
	{
		cout << tH << " " << tUH << endl;
		for (int i = 0; i < N; i++)
		{
			printf("%.10lf ", buf[i]);
		}
		printf("\n");
	}
	else
	{
		printf("-1 -1\n");
	}

	return 0;
}