#pragma comment(linker,"/STACK:256000000")

#include <iostream>
#include <iomanip>

#include <cstdlib>
#include <cstring>
#include <cmath>

#include <algorithm>

#include <vector>
#include <string>

using namespace std;

int m, f, n, q;

int a[107];
int u[1007];
char d[1007][257];

int bits[1007];

int module[1007][107];

int getVal(char c)
{
	if (isdigit(c)) return c - '0';
	return toupper(c) - 'A' + 10;
}

void prepare(const string &s)
{
	int ind = 0;
	for (int i = 0; i < (int)s.size(); i++)
	{
		int val = getVal(s[i]);
		for (int j = 0; j < 4; j++)
		{
			bits[ind + j] = val & 1;
			val >>= 1;
		}

		ind += 4;
	}

	while (ind < m)
		bits[ind++] = 0;
}



int main()
{
	#ifdef CRABEN
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#else
	#define FILE_NAME "filter"
	freopen(FILE_NAME".in", "r", stdin);
	freopen(FILE_NAME".out", "w", stdout);
	#endif

	scanf("%d%d", &m, &f);	
	for (int i = 0; i < f; i++)
		scanf("%d", a + i);

	scanf("%d\n", &n);	
	for (int i = 0; i < n; i++)
		gets(d[i]);

	scanf("%d", &q);
	for (int i = 0; i < q; i++)
		scanf("%d", u + i);

	for (int k = 0; k < q; k++)
		for (int i = 0; i < f; i++)
			module[k][i] = (1ll * u[k] * a[i]) % m;

	vector<int> ans;
	for (int t = 0; t < n; t++)
	{
		prepare(d[t]);

		for (int k = 0; k < n; k++)
		{
			bool flag = true;
			for (int i = 0; i < f; i++)
			{
				int val = module[k][i];
				if (bits[val] != 1) { flag = false; break; }
			}

			if (!flag) continue;

			ans.push_back(t);
			break;
		}
	}

	printf("%d", ans.size());
	for (int i = 0; i < (int)ans.size(); i++)
		printf(" %d", ans[i]);

	return 0;
}