#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <set>
#include <map>
#include <functional>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cctype>

using namespace std;

#define forn(i,n) for(int i = 0; i < (int)(n); ++i)
#define forit(it, x) for(it = (x).begin(); it != (x).end(); ++it)
#define all(x) (x).begin(), (x).end()
#define mp make_pair


typedef long long int64;
typedef vector<int> vint;
typedef vector<int64> vint64;
typedef pair<int, int> pii;
typedef pair<int, int> pint;
typedef pair<int64, int64> pint64;



struct P
{
	int g, a, b, idx;
};

bool operator < (P a, P b)
{
	return (a.a - a.b < b.a - b.b);
}
const int MAXN = 100005;
vector<P> cf;


const double EPS = 0.00000000001;


//#define __SFEDU__KRAVTSUN
#define TASK_NAME "burrito"
int main()
{
#ifdef __SFEDU__KRAVTSUN
	freopen("readme.txt", "r", stdin);
#else
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

	int n, A, B;
	cin >> n >> A >> B;

	cf.resize(n);
	forn(i, n)
	{
		scanf("%ld%ld%ld", &cf[i].g, &cf[i].a, &cf[i].b);
		cf[i].idx = i;
	}

	vector<double> answer(MAXN, -1);

	sort(all(cf));
	reverse(all(cf));

	double curA = 0, curB = 0;
	forn(i, n)
	{
		if (cf[i].a == 0) continue;
		double curMaxB = (B - curB);
		if (cf[i].b != 0) curMaxB /= cf[i].b;
		else curMaxB = cf[i].g;
		if (curMaxB > cf[i].g) curMaxB = cf[i].g;

		curB += cf[i].b * curMaxB;
		curA += cf[i].a * curMaxB;
		answer[cf[i].idx] = curMaxB;
	}

	if (curB - B <= EPS && curA - A >= -EPS)
	{
		printf("%0.10lf %0.10lf\n", curA, curB);
		forn(i, n)
		{
			if (answer[i] > 0)
				printf("%0.10lf ", answer[i]);
			else
				printf("0 ");
		}
	}
	else
		cout << "-1 -1";






	return 0;
}