#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <set>
#include <map>
#include <functional>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cctype>
#include <cassert>

using namespace std;

#define forn(i,n) for(int i = 0; i < (int)(n); ++i)
#define forit(it, x) for(it = (x).begin(); it != (x).end(); ++it)
#define all(x) (x).begin(), (x).end()
#define mp make_pair


typedef long long int64;
typedef vector<int> vint;
typedef vector<bool> vbool;
typedef vector<int64> vint64;
typedef pair<int, int> pii;
typedef pair<int, int> pint;



int toInt(char c)
{
	if (c == 'R') return 0;
	if (c == 'P') return 1;
	return 2;
}

struct State
{
	int ans;
	int go[3];
};

const int MAXN = 105, MAXM = 50005;
State enemy[MAXN];
int n, r, p, s;

vector<State> me[MAXN];
int ansCnt = 0;
void findState()
{

}

int getWin(int s)
{
	if (s == 0) return 1;
	if (s == 1) return 2;
	return 0;
}

State answer[MAXM]; 

int curEnemyStates[MAXN];

void recalcAll(int ans)
{
	for (int i = 1; i <= n; i++)
	{
		curEnemyStates[i] = enemy[curEnemyStates[i]].go[ans];
	}
}

void out(int idx)
{
	if (answer[idx].ans == 0) printf("R");
	if (answer[idx].ans == 1) printf("P");
	if (answer[idx].ans == 2) printf("S");

	forn(t, 3) printf(" %ld", answer[idx].go[t]);
	printf("\n");
}


//#define __SFEDU__KRAVTSUN
#define TASK_NAME "epic"
int main()
{
#ifdef __SFEDU__KRAVTSUN
	freopen("readme.txt", "r", stdin);
#else
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

	char buf;

	cin >> n;
	for (int i = 1; i <= n; i++)
	{
		cin >> buf >> r >> p >> s;
		enemy[i].ans = toInt(buf);
		enemy[i].go[0] = r;
		enemy[i].go[1] = p;
		enemy[i].go[2] = s;
		curEnemyStates[i] = i;
	}


	int curWaiting = 1, curEnemy = 1, curMyNumber = 1;
	map<int, int> statesBuf;
	for (int i = 1; i <= n; i++)
	{
		me[i].push_back(State());
		statesBuf.clear();
		while (1) 
		{
			me[i].push_back(State());
			int a = getWin(enemy[curEnemy].ans);
			me[i][curMyNumber].ans = a;
			me[i][curMyNumber].go[enemy[curEnemy].ans] = curMyNumber + 1;

			if (statesBuf.find(curEnemy) != statesBuf.end())
			{
				me[i][curMyNumber].go[enemy[curEnemy].ans] = statesBuf[curEnemy];
				break;
			}
			else
			{
				statesBuf[curEnemy] = curMyNumber;
			}
			curEnemy = enemy[curEnemy].go[a];
			curMyNumber++;
		}

		curEnemy = i + 1; curMyNumber = 1;
	}



	int curStart = 0, curEnd, s = 1;
	for (int i = 1; i <= n; i++)
	{
		curEnd = curStart + me[i].size() - 1;
		for (int j = 1; j < me[i].size(); j++)
		{
			answer[s] = me[i][j];
			forn(t, 3)
			{
				if (answer[s].go[t] == 0)
				{
					if (i != n)
						answer[s].go[t] = curEnd + (1+j)%me[i + 1].size();
					else
						answer[s].go[t] = 1;
				}
			}
			s++;
		}
	}
	cout << s-1 << endl;
	for (int i = 1; i < s; i++)
	{
		out(i);
	}


	return 0;
}