#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <set>
#include <map>
#include <functional>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cctype>

using namespace std;

#define forn(i,n) for(int i = 0; i < (int)(n); ++i)
#define forit(it, x) for(it = (x).begin(); it != (x).end(); ++it)
#define all(x) (x).begin(), (x).end()
#define mp make_pair


typedef long long int64;
typedef vector<int> vint;
typedef vector<int64> vint64;
typedef pair<int, int> pii;
typedef pair<int, int> pint;
typedef pair<int64, int64> pint64;



//#define __SFEDU__KRAVTSUN
#define TASK_NAME "knockout"


int main()
{
#ifdef __SFEDU__KRAVTSUN
	freopen("readme.txt", "r", stdin);
#else
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

	int64 n, m;
	cin >> n >> m;
	vector<pint64> v(n);

	forn(i, n)
	{
		scanf("%lld%lld", &v[i].first, &v[i].second);
	}

	forn(i, m)
	{
		int64 res = 0;
		int64 s, e, time;
		scanf("%lld%lld%lld", &s, &e, &time);
		forn(j, n)
		{
			int64 cTime = time;
			int64 curT = v[j].second - v[j].first;
			cTime %= (2*curT);
			int64 cPos = v[j].first;
			if (cTime > curT)
			{
				cPos = v[j].second - (cTime - curT);
			}
			else
			{
				cPos = v[j].first + cTime;
			}
			
			if (cPos >= s && cPos <= e) res++;
		}

		cout << res << endl;
	}


	return 0;
}