#pragma warning(disable:4996) 
#pragma comment(linker,"/STACK:67108864") 


#include<iostream> 
#include<stdio.h> 
#include<string.h> 
#include<string> 
#include<algorithm> 
using namespace std;
typedef unsigned long long ulint;
const long double eps = 0.000000001;
ulint BASE = 1000 * 1000 * 1000*ulint(10);

const int SIZE = 1000 * 1000;

int a[SIZE], b[SIZE], g[SIZE];
int m[SIZE];
int N;
ulint A, B;
ulint G[SIZE];


bool cmp(int i, int j)
{
	if (a[i] * b[j] == a[j] * b[i])
	{
		return b[i] > b[j];
	}
	return a[i] * b[j] > a[j] * b[i];
}

void show(ulint v)
{
	long long a = v / BASE;
	printf("%I64d", a);
	printf(".");
	v = v % BASE;
	for (int i = 0; i < 10; i++)
	{
		v *= 10;
		printf("%I64d", v / BASE);
		v %= BASE;
	}
	printf(" ");
}


int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	scanf("%d%I64d%I64d", &N, &A, &B);
	int i, j;
	for (i = 0; i < N; i++)
	{
		scanf("%d%d%d", &g[i], &a[i], &b[i]);
		m[i] = i;
	}
	sort(m, m + N, cmp);
	ulint AA, BB;
	B *= BASE;
	AA = 0;
	BB = B;
	A *= BASE;
	for (i = 0; i < N; i++)
	{
		j = m[i];
		G[j] = BASE*g[j];
		if (b[j] != 0)
		{
			G[j] = min(G[j], BB / b[j]);
		}
		AA += G[j] * a[j];
		BB -= G[j] * b[j];
	}
	if (AA < A)
	{
		printf("-1 -1");
		return 0;
	}
	B -= BB;
	show(AA);
	show(B);
	printf("\n");
	//printf("%.9lf %.9lf\n", (double)AA, (double)(B - BB));
	for (i = 0; i < N; i++)
	{
		show(G[i]);
//		printf("%.9lf ", (double)G[i]);
	}
	return 0;
}