#include <cstdio>
#include <iostream>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (int)2e5;
const ld eps = 1.0e-12;

#define file "burrito"

struct pr
{
  int a, b;
  int id;
};
bool operator < (pr a, pr b)
{
  if (a.a == 0 && a.b == 0) return 1;
  else if (b.a == 0 && b.b == 0) return 0;
  else return a.a * b.b - b.a * a.b > 0;
}
pr p[N];
int g[N];
ld ans[N];

int main()
{
  freopen(file".in", "r", stdin);
  freopen(file".out", "w", stdout);

  int n, A, B;
  cin >> n >> A >> B;
  for (int i = 0; i < n; i++)
  {
    scanf("%d%d%d", &g[i], &p[i].a, &p[i].b);
    p[i].id = i;
  }
  sort(p, p + n);
  ll cnt = 0;
  for (int i = 0; i < n; i++)
    cnt += g[p[i].id] * p[i].b;
  if (cnt <= B)
  {
    for (int i = 0; i < n; i++) ans[i] = g[i];
  }
  else
  {
    ll sum = 0;
    int i = 0;
    for (; i < n; i++)
    {
      if (sum + g[p[i].id] * p[i].b <= B)
        sum += g[p[i].id] * p[i].b, ans[p[i].id] = g[p[i].id];
      else
        break;
    }
    ans[p[i].id] = (ld)(B - sum) / p[i].b;
  }
  ld sum = 0.0, sum1 = 0.0;
  for (int i = 0; i < n; i++)
    sum += ans[p[i].id] * p[i].a, sum1 += ans[p[i].id] * p[i].b;
  if (sum < A - eps)
  {
    printf("%d %d\n", -1, -1);
  } 
  else
  {
    printf("%.8lf %.8lf\n", sum, sum1);
    for (int i = 0; i < n; i++)
      printf("%.8lf ", ans[i]);
    printf("\n");
  }

  return 0;
}
