import java.io.*;
import java.util.StringTokenizer;

public class Main {

    public static BufferedReader in;
    public static PrintWriter out;
    public static StringTokenizer tok = null;

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static String nextToken() throws IOException {
        if (tok == null || !tok.hasMoreTokens()) {
            tok = new StringTokenizer(in.readLine());
        }

        return tok.nextToken();
    }

    public static char nextChar() throws IOException {
        return (char) in.read();
    }

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(new FileInputStream("alter.in")));
        out = new PrintWriter(new BufferedOutputStream(new FileOutputStream("alter.out")));

        int n = nextInt();
        int m = nextInt();

        int k = n / 2 + m / 2;
        out.println(k);
        for (int i = 1; i < m; i += 2) {
            out.println(String.format("%d %d %d %d", 1, i + 1, n, i + 1));
        }

        for (int j = 1; j < n; j += 2) {
            out.println(String.format("%d %d %d %d", j + 1, 1, j + 1, m));
        }

        out.flush();
    }
}
