#include <bits/stdc++.h>

using namespace std;

#define FILE "filter"

struct point{
    int g, a, b;

    bool operator <(const point& x) const {
        return (1ll * a * x.b > 1ll * b * x.a);
    }
};

int get(char c) {
    if (isdigit(c)) {
        return c - '0';
    } else {
        return 10 + c - 'a';
    }
}

int main()
{
    #ifndef LOCAL
        freopen(FILE".in", "r", stdin);
        freopen(FILE".out", "w", stdout);
    #else
        freopen("input.txt", "r", stdin);
    #endif

    int m, f;
    cin >> m >> f;
    int a[f];

    for (int i = 0; i < f; ++i) {
        cin >> a[i];
    }
    int n;
    cin >> n;
    bitset <1024> x[n];

    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < (int)s.length(); ++j) {
            int p = get(s[j]);
            for (int k = 0; k < 4; ++k) {
                if (p & (1 << k)) {
                    x[i].set(4 * j + k);
                }
            }
        }
    }

    int q;
    cin >> q;

    int used[n];
    memset(used, 0, sizeof(used));

    for (int i = 0; i < q; ++i) {
        int u;
        cin >> u;
        bitset <1024> b;
        for (int j = 0; j < f; ++j) {
            b.set((a[j] * (long long)u) % m);
        }
        for (int j = 0; j < n; ++j) {
            bitset <1024> v = x[j] & b;
            if ((v ^ b).count() == 0) {
                used[j] = 1;
            }
        }
    }

    cout << accumulate(used, used + n, 0);

    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            cout << " " << i;
        }
    }
    cout << endl;


    return 0;
}
