#include <cstdio>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cassert>
using namespace std;
#define REP(i,n) for(int i=0;i<(n);i++)

#define FILENAME "burrito"
struct FileOpener
{
	FileOpener()
	{
		FILE* f = fopen(FILENAME".in", "r");
		if (f)
		{
			fclose(f);
			freopen(FILENAME".in", "r", stdin);
			freopen(FILENAME".out", "w", stdout);
		}
	}
} fileopener;

typedef long long ll;

struct Node
{
	int a, b, g;
	int id;
	Node(int a, int b, int g, int id) :a(a), b(b), g(g), id(id)
	{
	}
	bool operator<(const Node& o) const
	{
		if (b == 0 & o.b == 0)
			return false;
		if (b == 0)
			return true;
		if (o.b == 0)
			return false;
		return ll(a)*o.b > ll(o.a)*b;
	}
};

const double EPS = 1e-7;

int main()
{
	int n, a, b;
	scanf("%d%d%d", &n, &a, &b);
	vector<Node> v;
	vector<double> res(n);
	REP(i, n)
	{
		int a, b, g;
		scanf("%d%d%d", &g, &a, &b);
		v.push_back(Node(a, b, g,i));
	}
	sort(v.begin(), v.end());
	int left = b;
	double result=0;
	int intresult = 0;
	for (int i = 0; i < n; i++)
	{
		double take = 0;
		if (left >= v[i].g*v[i].b)
		{
			take = v[i].g;
			left -= v[i].g*v[i].b;
			intresult += v[i].g*v[i].a;
		}
		else if (left!=0)
		{
			
			take = double(left) / v[i].b;
			intresult += v[i].a*ll(left) / v[i].b;
			left = 0;
		}
		
		result += v[i].a*take;
		res[v[i].id] = take;
	}
	if (intresult >=a )
	{
		printf("%.9lf %d\n", result, b - left);
		REP(i, n)
		{
			printf("%.9lf ", res[i]);
		}
	}
	else
		puts("-1 -1");
	return 0;
}