#include <cstdio>
#include <algorithm>
#include <numeric>
#include <vector>
#include <cmath>
#include <cassert>
#include <bitset>
using namespace std;
#define REP(i,n) for(int i=0;i<(n);i++)

#define FILENAME "filter"
struct FileOpener
{
	FileOpener()
	{
		FILE* f = fopen(FILENAME".in", "r");
		if (f)
		{
			fclose(f);
			freopen(FILENAME".in", "r", stdin);
			freopen(FILENAME".out", "w", stdout);
		}
	}
} fileopener;

typedef long long ll;
bitset<1000> bst[1001];
char buf[1001];

int testbit(int n, int k)
{
	return (n >> k) & 1;
}

int main()
{
	int m, f;
	scanf("%d%d", &m, &f);
	vector<int> v(f);
	REP(i, f)
	{
		scanf("%d", &v[i]);
		v[i] %= m;
	}
	int n;
	scanf("%d", &n);
	REP(i, n)
	{
		scanf("%s", buf);
		int top = 0;
		for (int j = 0; buf[j]; j++)
		{
			int v;
			if (isdigit(buf[j]))
				v = buf[j] - '0';
			else
				v = buf[j] + 10 - 'a';
			REP(k, 4)
				bst[i][top++] = testbit(v,k);
		}
	}

	int q;
	scanf("%d", &q);
	vector<int> res(n);
	while (q--)
	{
		int u;
		scanf("%d", &u);
		u %= m;
		bitset<1000> b;
		REP(i, f)
			b[v[i] * u%m] = 1;
		REP(i, n)
		{
			bitset<1000> bb = b;
			bb &= bst[i];
			if (bb == b)
				res[i] = true;
		}
	}
	printf("%d", accumulate(res.begin(), res.end(), 0));
	REP(i, n)
		if (res[i]) printf(" %d", i);
	puts("");
	return 0;
}