#include <cstdio>
#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <cassert>
using namespace std;
#define REP(i,n) for(int i=0;i<(n);i++)

#define FILENAME "joke"
struct FileOpener
{
	FileOpener()
	{
		FILE* f = fopen(FILENAME".in", "r");
		if (f)
		{
			fclose(f);
			freopen(FILENAME".in", "r", stdin);
			freopen(FILENAME".out", "w", stdout);
		}
	}
} fileopener;

char buf[201];
int mx;
int used[201];
int n;
vector<int> res;

bool solve(int cur)
{
	if (cur == n) return true;
	
	if (!used[buf[cur] - '0'] && buf[cur] - '0' <= mx)
	{
		used[buf[cur] - '0'] = true;
		if (solve(cur + 1))
		{
			res.push_back(buf[cur] - '0');
			return true;
		}
		used[buf[cur] - '0'] = false;
	}
	if (cur+1 != n && buf[cur] != '0')
	{
		int val = (buf[cur] - '0') * 10 + buf[cur + 1] - '0';
		if (!used[val])
		{
			used[val] = true;
			if (solve(cur + 2))
			{
				res.push_back(val);
				return true;
			}
			used[val] = false;
		}
	}
	return false;
}

void generate(int n)
{
	vector<int> p(n);
	REP(i, n)
		p[i] = i+1;
	random_shuffle(p.begin(), p.end());
	REP(i, n)
		printf("%d", p[i]);
}

int main()
{
	//generate(50); return 0;
	scanf("%s", buf);
	n = strlen(buf);
	int len = 0;
	for (int i = 1; len < n; i++)
	{
		if (i < 10)
			len += 1;
		else
			len += 2;
		if (len == n)
		{
			mx = i;
			break;
		}
	}
	used[0] = true;
	assert(solve(0));
	reverse(res.begin(), res.end());
	REP(i, res.size())
		printf("%d ", res[i]);
	puts("");
	return 0;
}