#define _USE_MATH_DEFINES

#include <cstdio>
#include <cstring>
#include <string>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <map>
#include <vector>
#include <set>
#include <bitset>
#include <stack>
#include <queue>
#include <list>
#include <ctime>
#include <cmath>

using namespace std;

#define forn(i,n) for(int i = 0; i < int(n); ++i)
#define all(a) a.begin(),a.end()
#define sz(a) int(a.size())
#define mp make_pair
#define pb push_back

typedef long long li;
typedef long double ld;

typedef pair<int, int> pt;
#define ft first
#define sc second
#define x first
#define y second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

#define TASK_NAME "alter"

int n, m; 

bool read() {
	if (!(cin >> n >> m))
		return false;
	return true;
}

void solve() {
	vector <pair<pt, pt> > v;
	forn(i, n)
		if (i & 1)
			v.push_back(mp(mp(i + 1, 1), mp(i + 1, m)));

	forn(i, m)
		if (i & 1)
			v.push_back(mp(mp(1, i + 1), mp(n, i + 1)));

	cout << sz(v) << endl;
	forn(i, sz(v))
		cout << v[i].ft.ft << " " << v[i].ft.sc << " " << v[i].sc.ft << " " << v[i].sc.sc << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while (read())
		solve();

	cerr << "Time: " << clock() << endl;
	return 0;

	return 0;
}