#define _USE_MATH_DEFINES

#include <cstdio>
#include <cstring>
#include <string>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <map>
#include <vector>
#include <set>
#include <bitset>
#include <stack>
#include <queue>
#include <list>
#include <ctime>
#include <cmath>

using namespace std;

#define forn(i,n) for(int i = 0; i < int(n); ++i)
#define all(a) a.begin(),a.end()
#define sz(a) int(a.size())
#define mp make_pair
#define pb push_back

typedef long long li;
typedef long double ld;

typedef pair<int, int> pt;
#define ft first
#define sc second
#define x first
#define y second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-12;

#define TASK_NAME "burrito"

const int N = 200 * 1000 + 5;

int n, A, B, a[N], b[N], g[N];
pair<pt,int> p[N];
ld take[N];

bool cmp(const pair<pt, int>& a, const pair<pt, int>& b) {
	return li(a.ft.ft) * li(b.ft.sc) > li(a.ft.sc) * li(b.ft.ft);
}

bool read() {
	if (scanf("%d %d %d", &n, &A, &B) != 3)
		return false;
	forn(i, n) {
		scanf("%d %d %d", &g[i], &a[i], &b[i]);
		p[i] = mp(mp(a[i], b[i]), i);
	}
	return true;
}

void solve() {
	sort(p, p + n, cmp);
	ld lft = B;
	ld a1 = 0;
	forn(i, n) {
		li a = p[i].ft.ft;
		li b = p[i].ft.sc;
		li m = g[p[i].sc];

		ld c = li(b) * m;
		take[p[i].sc] = m;
		
		if (b > 0 && c > lft) {
			c = lft;
			take[p[i].sc] = lft / b;
		}

		a1 += take[p[i].sc] * a;

		lft -= c;
	}

	if (a1 + EPS < A) {
		puts("-1 -1");
		return;
	}

	cout << setprecision(15) << double(a1) << " " << double(B - lft) << endl;
	forn(i, n) {
		cout << setprecision(15) << double(take[i]) << " ";
	}
	puts("");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while (read())
		solve();

	cerr << "Time: " << clock() << endl;
	return 0;

	return 0;
}