#define _USE_MATH_DEFINES

#include <cstdio>
#include <cstring>
#include <string>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <map>
#include <vector>
#include <set>
#include <bitset>
#include <stack>
#include <queue>
#include <list>
#include <ctime>
#include <cmath>

using namespace std;

#define forn(i,n) for(int i = 0; i < int(n); ++i)
#define all(a) a.begin(),a.end()
#define sz(a) int(a.size())
#define mp make_pair
#define pb push_back

typedef long long li;
typedef long double ld;

typedef pair<int, int> pt;
#define ft first
#define sc second
#define x first
#define y second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

#define TASK_NAME "joke"

int n, len;
char s[105];
bool used[60];
vector <int> res;

bool read() {
	if (scanf("%s", s) <= 0)
		return false;

	/*int n = 50;
	vector <int> p(n);
	forn(i, n)
		p[i] = i + 1;
	random_shuffle(all(p));

	int pos = 0;
	forn(i, n) {
		itoa(p[i], s + pos, 10);
		pos += 1 + (p[i] >= 10);
	}*/
	
	res.clear();
	memset(used, 0, sizeof(used));
	
	return true;
}



bool good(int d) {
	return 1 <= d && d <= n && !used[d];
}

bool rec(int pos) {
	if (pos == len)
		return true;

	if (s[pos] == '0')
		return false;

	int d = s[pos] - '0';

	if (good(d)) {
		used[d] = true;
		if (rec(pos + 1)) {
			res.push_back(d);
			return true;
		}
		used[d] = false;
	}

	if (pos + 1 == len)
		return false;

	d = d * 10 + s[pos + 1] - '0';

	if (good(d)) {
		used[d] = true;
		if (rec(pos + 2)) {
			res.push_back(d);
			return true;
		}
		used[d] = false;
	}

	return false;
}

void solve() {
	len = strlen(s);
	
	if (len <= 9)
		n = len;
	else
		n = 9 + (len - 9) / 2;

	assert(rec(0));
	reverse(all(res));
	forn(i, n) {
		if (i)
			cout << " ";
		cout << res[i];
	}

	puts("");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while (read())
		solve();

	cerr << "Time: " << clock() << endl;

	return 0;
}