#define _USE_MATH_DEFINES

#include <cstdio>
#include <cstring>
#include <string>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <map>
#include <vector>
#include <set>
#include <bitset>
#include <stack>
#include <queue>
#include <list>
#include <ctime>
#include <cmath>

using namespace std;

#define forn(i,n) for(int i = 0; i < int(n); ++i)
#define all(a) a.begin(),a.end()
#define sz(a) int(a.size())
#define mp make_pair
#define pb push_back

typedef long long li;
typedef long double ld;

typedef pair<int, int> pt;
#define ft first
#define sc second
#define x first
#define y second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

#define TASK_NAME "knockout"

const int N = 1000 + 5;

int n, m, a[N], b[N];

bool read() {
	if (!(cin >> n >> m))
		return false;
	forn(i, n)
		cin >> a[i] >> b[i];
	return true;
}

void solve() {
	forn(_, m) {
		int l, r, t;
		cin >> l >> r >> t;

		int res = 0;
		
		forn(i, n) {
			int len = abs(a[i] - b[i]);
			int cur = t % (2 * len);

			int x;
			int mul = a[i] < b[i] ? +1 : -1;

			if (cur < len)
				x = a[i] + mul * cur;
			else
				x = b[i] - mul * (cur - len);

			if (l <= x && x <= r)
				res++;
		}

		cout << res << endl;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while (read())
		solve();

	cerr << "Time: " << clock() << endl;
	return 0;

	return 0;
}