#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <cstdio>
#include <set>
#include <list>
#include <iomanip>
#include <string>
#include <cstring>
#include <queue>
#include <stack>
#include <sstream>

using namespace std;

#define pb push_back
#define mp make_pair
#define REP(i, n) for(int i = 0; i < (int)(n); ++i)
typedef long long LL;
typedef pair<int, int> PII;

int n;
int g[100000], a[100000], b[100000], A, B;
int ord[100000];
double ans[100000] = {};
const double EPS = 1e-9;

bool cmp(const int &lhs, const int &rhs) {
    if (b[lhs] == 0) return true;
    if (b[rhs] == 0) return false;
    return a[lhs] * b[rhs] > a[rhs] * b[lhs];
}

int main() {
    freopen("burrito.in", "r", stdin);
    freopen("burrito.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin >> n >> A >> B;
    REP(i, n) cin >> g[i] >> a[i] >> b[i];
    REP(i, n) ord[i] = i;
    sort(ord, ord + n, cmp);
    double ansA = 0, ansB = 0;
    REP(ii, n) {
        int i = ord[ii];
        if (b[i] == 0) {
            ans[i] = g[i];
            ansA += g[i] * a[i];
            continue;
        }
        if (ansB + g[i] * b[i] > B) {
            ans[i] = (B - ansB) / b[i];
            ansA += ans[i] * a[i];
            ansB += ans[i] * b[i];
            break;
        }
        ans[i] = g[i];
        ansA += g[i] * a[i];
        ansB += g[i] * b[i];
    }
    if (ansA + EPS > A) {
        cout << setprecision(12) << fixed << ansA << ' ' << ansB << '\n';
        REP(i, n) cout << setprecision(12) << fixed << ans[i] << ' ';
        cout << endl;
    } else {
        cout << "-1 -1\n";
    }
}
