#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <cstdio>
#include <set>
#include <list>
#include <iomanip>
#include <string>
#include <cstring>
#include <queue>
#include <stack>
#include <sstream>

using namespace std;

#define pb push_back
#define mp make_pair
#define REP(i, n) for(int i = 0; i < (int)(n); ++i)
typedef long long LL;
typedef pair<int, int> PII;

int n, m;
int a[1000], b[1000];
int d[1000];

int main() {
    freopen("knockout.in", "r", stdin);
    freopen("knockout.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin >> n >> m;
    REP(i, n) cin >> a[i] >> b[i];
    REP(i, m) {
        int x, y, t;
        cin >> x >> y >> t;
        REP(j, n) {
            int x0 = t % (2 * (b[j] - a[j]));
            if (x0 <= b[j] - a[j])
                x0 += a[j];
            else
                x0 = b[j] - x0;
            d[j] = x0;
        }
        sort(d, d + n);
        int lo = 0, hi = n, mid;
        while (lo < hi) {
            mid = (lo + hi) >> 1;
            if (d[mid] < x)
                lo = mid + 1;
            else
                hi = mid;
        }
        int from = lo;
        lo = -1, hi = n - 1;
        while (lo < hi) {
            mid = (lo + hi + 1) >> 1;
            if (d[mid] > y)
                hi = mid - 1;
            else
                lo = mid;
        }
        cout << lo - from + 1 << '\n';
    }
}
