#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

typedef long long ll;
typedef long double ld;

const ld eps = 1e-9;
const int N = (int)1e5 + 100;
int perm[N];
int g[N], a[N], b[N];
ld res[N];

bool cmp(int i, int j)
{
	return a[i] * b[j] > a[j] * b[i];
}

bool Eq(ld a, ld b)
{
	return fabs(a - b) < eps;
}

bool GrEq(ld a, ld b)
{
	return a > b || Eq(a, b);
}

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	/*if (sizeof(ld) == sizeof(double))
		throw;   */                                    
	int n;
	ld A, B;
	double AA, AB;
	cin >> n >> A >> B;
	//cout << A << " " << B << endl;
	//scanf("%d%lf%lf", &n, &AA, &AB);       
	//A += AA;
	//B += AB;
	//cout << A << " - " << AA << endl;
	//cout << B << ":" << AB << endl;

	for (int i = 0; i < n; i++)
	{
		perm[i] = i;
		cin >> g[i] >> a[i] >> b[i];
		//scanf("%d%d%d", &g[i], &a[i], &b[i]);
	}

	sort(perm, perm + n, cmp);

	ld curA = 0;
	ld curB = 0;
	//cout << B << "!!!" << endl;
	for (int i = 0; i < n; i++)
	{
		int index = perm[i];
		//cerr << B - curB << ":" << b[index] << endl;
		ld cnt = min((ld)g[index], (B - curB) / b[index]);
		cnt = max(cnt, (ld)0.0);
		curA += cnt * a[index];
		curB += cnt * b[index];
		res[index] = cnt;   
	}
	//cout << curA << ":" << A << endl;

	if (GrEq(curA, A))
	{
		printf("%.10lf %.10lf\n", (double)curA, (double)curB);
		for (int i = 0; i < n; i++)
			printf("%.10lf ", (double)res[i]);
	}
	else
		puts("-1 -1");

	return 0;
}