#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <cmath>
#include <algorithm>
using namespace std;

typedef long long ll;
int cnt[100];

void test()
{
	char buf[10];
	ll res = 0;
	for (int i = 1; i <= 50; i++)
	{
		int len = 0;
		for (int s = 0; s <= 10; s++)
			cnt[s] = 0;
		for (int s = 1; s <= i; s++)
		{
			sprintf(buf, "%d", s);
			len = strlen(buf);
			for (int q = 0; q < len; q++)
				cnt[buf[q] - '0']++;
		}
		ll ans = 1;
		for (int s = 1; s <= 9; s++)
			ans *= cnt[s];
		cout << i << ":" << ans << endl;
		res = max(ans, res);
	}
	cout << res << endl;
}

string str;
int lenStr;

bool used[52];
bool one[52];

bool check(int l, int r)
{
	if ((r - l + 1) %	2 != 0)
		return false;
	for (int i = l; i < r; i += 2)
	{
		int num = (str[i] - '0') * 10 + (str[i + 1] - '0');
		if (used[num])
			return false;
	}
	return true;
}

void setUsed(int l, int r, int value)
{
	for (int i = l; i < r; i += 2)
	{
		int num = (str[i] - '0') * 10 + (str[i + 1] - '0');
		used[num] = value;
	}
}

void printAnswer()
{
	for (int i = 0; i < lenStr;)
	{
		if (one[i])
		{
			cout << str[i] << ' ';
			i++;
		}
		else
		{
			cout << str[i] << str[i + 1] << ' ';
			i += 2;
		}
	}
}

void brute(int pos, int lst, int countOne)
{
	if (countOne == 9)
	{
		if (check(lst + 1, lenStr - 1))
		{
			printAnswer();
			exit(0);
		}
		return;
	}
	if (pos >= lenStr)
		return;

	int val = str[pos] - '0';
	if (val != 0 && !used[val])
	{
		one[pos] = 1;
		used[val] = 1;
		brute(pos + 1, pos, countOne + 1);
		one[pos] = 0;
		used[val] = 0;
	}
	if (pos + 1 >= lenStr)
		return;
	val = (str[pos] - '0') * 10 + (str[pos + 1] - '0');
	if (!used[val])
	{
		used[val] = 1;
		brute(pos + 2, lst, countOne);
		used[val] = 0;
	}
}

int main()
{
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
	cin >> str;
	lenStr = (int)str.length();
	for (int i = 0; i < lenStr; i++)
		cnt[str[i] - '0']++;
	int len = 1;
	bool ok = false;
	for (len = 1; len <= 50; len++)
	{
		char buf[10];
		sprintf(buf, "%d", len);
		for (int s = 0; s < strlen(buf); s++)
			cnt[buf[s] - '0']--;
		ok = true;
		for (int s = 0; s < 10; s++)
			if (cnt[s] != 0)
				ok = false;
		if (ok == true)
			break;
	}
	if (!ok)
		throw;
	
	if (len < 10)
	{
		for (int i = 0; i < lenStr; i++)
			cout << str[i] << ' ';
		return 0;
	}

	brute(0, -1, 0);

	return 0;
}