#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <cmath>
#include <algorithm>
using namespace std;

typedef long long ll;
int cnt[100];

void test()
{
	char buf[10];
	ll res = 0;
	for (int i = 1; i <= 50; i++)
	{
		int len = 0;
		for (int s = 0; s <= 10; s++)
			cnt[s] = 0;
		for (int s = 1; s <= i; s++)
		{
			sprintf(buf, "%d", s);
			len = strlen(buf);
			for (int q = 0; q < len; q++)
				cnt[buf[q] - '0']++;
		}
		ll ans = 1;
		for (int s = 1; s <= 9; s++)
			ans *= cnt[s];
		cout << i << ":" << ans << endl;
		res = max(ans, res);
	}
	cout << res << endl;
}

string str;
int lenStr;

int used[152];
bool one[152];
int perm[150];

int len;

bool check(int l, int r)
{
	if ((r - l + 1) % 2 != 0)
		return false;
	for (int i = l; i < r; i += 2)
	{
		int num = (str[i] - '0') * 10 + (str[i + 1] - '0');
		if (str[i] == '0')
			return false;
		if (used[num] || num > len)
			return false;
		used[num] = 2;
	}
	return true;
}

void printAnswer()
{
	for (int i = 0; i < lenStr;)
	{
		if (one[i])
		{
			cout << str[i] << ' ';
			i++;
		}
		else
		{
			cout << str[i] << str[i + 1] << ' ';
			i += 2;
		}
	}
}


bool brute(int pos, int lst, int countOne)
{
	if (countOne == 9)
	{
		if (check(lst + 1, lenStr - 1))
		{
			printAnswer();
			return true;
		}
		for (int i = 1; i <= len; i++)
			used[i] &= 1;
		return false;
	}
	if (pos >= lenStr)
		return false;

	int val = str[pos] - '0';
	if (val != 0 && used[val] != 1)
	{
		one[pos] = 1;
		used[val] = 1;
		if (brute(pos + 1, pos, countOne + 1))
			return true;
		one[pos] = 0;
		used[val] = 0;
	}
	if (pos + 1 >= lenStr)
		return false;
	val = (str[pos] - '0') * 10 + (str[pos + 1] - '0');
	if (val <= len && used[val] != 1 && str[pos] != '0')
	{
		used[val] = 1;
		if (brute(pos + 2, lst, countOne))
			return true;
		used[val] = 0;
	}
	return false;
}

void gen()
{
	memset(one, 0, sizeof(one));
	memset(used, 0, sizeof(used));
	len = 13;
	for (int i = 1; i <= len; i++)
		perm[i] = i;
	random_shuffle(perm + 1, perm + len + 1);
	int pos = 0;
	char buf[1000];
	for (int i = 1; i <= len; i++)
	{
		int val = perm[i];
		sprintf(buf + pos, "%d", val);
		pos += (val < 10 ? 1 : 2);
	}
	str = (string)buf;
	lenStr = str.length();
}

int main()
{
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
	//str = "74122865139110311";
	cin >> str;
	
	lenStr = (int)str.length();
	for (int i = 0; i < lenStr; i++)
		cnt[str[i] - '0']++;
	len = 1;
	bool ok = false;
	for (len = 1; len <= 50; len++)
	{
		char buf[10];
		sprintf(buf, "%d", len);
		for (int s = 0; s < strlen(buf); s++)
			cnt[buf[s] - '0']--;
		ok = true;
		for (int s = 0; s < 10; s++)
			if (cnt[s] != 0)
				ok = false;
		if (ok == true)
			break;
	}
	if (!ok)
		throw;
	/*
	int t = 1;
	while (true)
	{
		cerr << (t++) << endl;
		gen();
		*/
		
		if (len < 10)
		{
			for (int i = 0; i < lenStr; i++)
				cout << str[i] << ' ';
			return 0;
		}

		if (!brute(0, -1, 0))
		{
			throw;
		}
		/*

	}*/
	return 0;
}