#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <sstream>
#include <map>

using namespace std;
typedef long long ll;

int main(){
	freopen("alter.in", "r", stdin);
	freopen("alter.out", "w", stdout);
	int n, m;
	cin >> n >> m;
	if (n == 1 || m == 1){
		int res = n * m / 2;
		cout << res << "\n";
		for (int i = 0; i < n; i++){
			bool fl = false;
			if (i % 2 == 1)
				fl = true;
			for (int j = 0; j < m; j++){
				if (fl){
					if (j % 2 == 0){
						cout << i + 1 << " " << j + 1 << " " << i + 1 << " " << j + 1 << "\n";
					}
				}
				else{
					if (j % 2 == 1){
						cout << i + 1 << " " << j + 1 << " " << i + 1 << " " << j + 1 << "\n";
					}
				}
			}
		}
		return 0;
	}
	vector<pair<pair<int, int>, pair<int, int> > > res;
	int i = 2, j = 2;
	while (i <= n && j <= m){
		res.push_back(make_pair(make_pair(i, j), make_pair(n, m)));
		i++;
		j++;
	}
	i = 1;
	j = 1;
	while (i != n || j != m){
		res.push_back(make_pair(make_pair(1, 1), make_pair(i, j)));
		if (i < n)
			i++;
		if (j < m)
			j++;
	}
	cout << res.size() << "\n";
	for (int i = 0; i < res.size(); i++){
		cout << res[i].first.first << " " << res[i].first.second << " " << res[i].second.first << " " << res[i].second.second << "\n";
	}
	return 0;
}

/*
5 5 
0 1 
0 2
2 3
3 5
4 5
0 5 0
0 1 2
0 2 1
2 5 2
2 5 3
*/