#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <sstream>
#include <map>
#include <cmath>
#include <cstdio>


using namespace std;
typedef long long ll;

double eps = 1e-8;

int main(){
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	int n;
	cin >> n;
	int a, b;
	cin >> a >> b;
	double osta, ostb;
	osta = 0;
	ostb = b;
	vector<pair<int, int> > v(n);
	vector<int> g(n);
	vector<pair<double, int> > q;
	for (int i = 0; i < n; ++i)
	{
		int a, b, c;
		//cin >> a >> b >> c;
		scanf("%d %d %d", &a, &b, &c);
		v[i] = make_pair(b, c);
		g[i] = a; 
		q.push_back(make_pair(b*1. / (1.*c), i));
	}
	sort(q.rbegin(), q.rend());
	vector<pair<int, double> > ans;
	for (int i = 0; i < n; ++i)
	{
		int ind = q[i].second;
		double cur = ostb / (1.*v[ind].second);
		cur = min(cur, double(g[ind]));
		osta += cur*v[ind].first;
		ostb -= cur*v[ind].second;
		ans.push_back(make_pair(ind, cur));
	}
	double aa = osta, bb = b - ostb;
	sort(ans.begin(), ans.end());
	if (aa < a-eps)
	{
		cout << "-1 -1";
	}
	else
	{
		//cout << aa << ' ' << bb << "\n";
		printf("%.8lf %.8lf\n", aa, bb);
		for (int i = 0; i < n; ++i)
		{
			printf("%.8lf ", ans[i].second);
		}
	}

	return 0;
}

/*
2 5 5
2 2 1
2 2 4

2 5 5
2 2 2
2 2 4


2 0 0
1 1 1
2 2 2


*/