
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <sstream>
#include <map>
#include <set>
#include <cmath>
#include <cstdio>
#include <ctime>


using namespace std;
typedef long long ll;

double eps = 1e-8;
int ptr = 0;
string str;
vector<char> used;
vector<int> st;

void print(){
	for (int i = 0; i < st.size(); i++){
		cout << st[i] << " ";
	}
}

void rec(int i){
	if (i == str.size()){
		print();
		exit(0);
	}
	int numb1 = str[i] - '0';
	if (numb1 > 0){
		if ((numb1-1) < used.size()){
			if (!used[numb1 - 1]){
				st.push_back(numb1);
				used[numb1 - 1] = 1;
				rec(i + 1);
				used[numb1 - 1] = 0;
				st.pop_back();
			}
		}
	}
	if ((i + 1) < str.size()){
		int a = str[i] - '0';
		int b = str[i + 1] - '0';
		int numb2 = a * 10 + b;
		if (numb2 - 1 < used.size()){
			if (!used[numb2 - 1]){
				st.push_back(numb2);
				used[numb2 - 1] = 1;
				rec(i + 2);
				used[numb2 - 1] = 0;
				st.pop_back();
			}
		}
	}
}


int main(){
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
	cin >> str;
	srand(time(0));
	used.assign(50, 0);
	rec(0);
	return 0;
}

/*
4111109876532

2339323529452630434124193712462220404914165623393438448282747155011110421825361348213137417
*/