#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define pbk pop_back
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#define y0 yy0
#define y1 yy1
#define next _next
#define prev  _prev
#define hash _hash
#define link _link
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define LLD "%I64d"

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long double ld;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 1e3 + 100;

int n, m, f;
int64 a[N];
bitset<N> files[N];

int get_char(char c) {
	if ('0' <= c && c <= '9') {
		return c - '0';
	}
	return c - 'a' + 10;
}

bitset<N> cur;

bool cool[N];

int main() {
#define TASK "filter"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	scanf("%d%d", &m, &f);
	for (int i = 0; i < f; i++) {
		scanf(LLD, &a[i]);
	}
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		static char buf[100500];
		scanf("%s", buf);
		for (int j = 0; j < m; j++) {
			int value = get_char(buf[j]);
			files[i].set(j * 4, (value & 1) > 0);
			files[i].set(j * 4 + 1, (value & 2) > 0);
			files[i].set(j * 4 + 2, (value & 4) > 0);
			files[i].set(j * 4 + 3, (value & 8) > 0);
		}
	}
	int q; scanf("%d", &q);
	for (int i = 0; i < q; i++) {
		int64 u; scanf(LLD, &u);
		cur.reset();
		for (int j = 0; j < f; j++) {
			cur.set((a[j] * u) % m, true);
		}
		for (int j = 0; j < n; j++) {
			if ((files[j] & cur) == cur) {
				cool[j] = true;
			}
		}
	}
	int count = 0;
	for (int i = 0; i < n; i++) {
		count += cool[i];
	}
	printf("%d ", count);
	for (int i = 0; i < n; i++)
		if (cool[i])
			printf("%d ", i);
	return 0;
}
