#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define pbk pop_back
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#define y0 yy0
#define y1 yy1
#define next _next
#define prev  _prev
#define hash _hash
#define link _link
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define LLD "%I64d"

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long double ld;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 55;

int n, len;
bool used[N];
int perm[N];
char s[N * 10];

void gen(int x, int y) {
	if (x >= len) {
		if (y != n) {
			return;
		}
		for (int i = 0; i < n; ++i) {
			printf("%d ", perm[i]);
		}
		puts("");
		exit(0);
	}
	int val = 0;
	for (int i = 1; i <= 2; ++i) {
		if (x + i - 1 >= len) {
			break;
		}
		val = val * 10 + s[x + i - 1] - '0';
		if (val >= 1 && val <= n && !used[val]) {
			perm[y] = val;
			used[val] = true;
			gen(x + i, y + 1);
			used[val] = false;
		}
	}
}

inline void gen() {
	freopen("joke2.in", "w", stdout);
	vi perm;
	for (int i = 1; i <= 50; ++i) {
		perm.pb(i);
	}
	//random_shuffle(all(perm));
	for (int i = 0; i < sz(perm); ++i) {
		cout << perm[i];
	}
	cout << endl;
	exit(0);
}

int main() {
	//gen();
#define TASK "joke"
	freopen(TASK "2.in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	gets(s);
	len = strlen(s);
	int sum = 0;
	for (n = 1; ; ++n) {
		if (n < 10) {
			sum += 1;
		}
		else {
			sum += 2;
		}
		if (sum == len) {
			break;
		}
	}
	gen(0, 0);
	return 0;
}
