#include <cstdio>
#include <iostream>
#include <algorithm>
#include <map>
#include <string>
using namespace std;

const int MAXN = 666666;
const double EPS = 1e-9;
#define forn(i,n) for(int i = 0; i < (int)n; ++i)

struct node {
	int a, b;
	int g;
	int num;
};

bool comp(node a, node b) {
	return a.a * b.b > a.b * b.a;
}

node arr[MAXN];
int n, A, B, ptr = 0;
double happies = .0, unhappies = .0;
double ans[MAXN];
int main()
{
#ifdef F0X
	//freopen("input.in", "r", stdin);
#else
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
#endif
	cin >> n >> A >> B;
	//scanf("%d%d%d", &n, &A, &B);
	forn(i, n) {
		int tmp, sa, ss;
		cin >> tmp >> sa >> ss;
		arr[ptr].g = tmp;
		arr[ptr].a = sa;
		arr[ptr].b = ss;
		arr[ptr].num = i;
		ptr++;
	}
	sort(arr, arr + n, comp);
	int pos = 0;

	while (pos < n && unhappies < B + EPS) {
		if (arr[pos].a == 0) {
			ans[arr[pos].num] = .0;
			pos++;
			continue;
		}
		if (arr[pos].b == 0) {
			ans[arr[pos].num] = (double)arr[pos].g;
			happies = ans[arr[pos].num] * arr[pos].a;
			pos++;
			continue;
		}
		double weight = min(arr[pos].g * 1.0, (B - unhappies) * 1.0 / arr[pos].b);
		ans[arr[pos].num] = weight;
		unhappies += weight * arr[pos].b;
		happies += weight * arr[pos].a;
		pos++;
	}

	if (happies + EPS < A || unhappies - EPS > B) printf("%d %d\n", -1, -1);
	else {
		printf("%.16lf %.16lf\n", happies, unhappies);
		forn(i, ptr)
			printf("%.16lf ", ans[i]);
		putchar('\n');
	}

	return 0;
}
