#include <cstdio>
#include <iostream>
#include <algorithm>
#include <map>
#include <string>
using namespace std;

const int MAXN = 666666;
#define forn(i,n) for(int i = 0; i < (int)n; ++i)

bool used[60];

string can(string str, int mx)
{
	for (int t = 0; t < mx; ++t)
	{
		for (int i = mx; i > 0; --i)
		{
			if (used[i])
				continue;

			int cnt = 0, end, last = -1;
			if (i > 9)
			{
				end = str.length() - 1;
				char me = '0' + i / 10;
				char to = '0' + i % 10;

				for (int j = 0; j < end; ++j)
				{
					if (str[j] == me && str[j + 1] == to)
					{
						++cnt;
						last = j;
					}
				}
				if (cnt == 1)
				{
					me = (char)(me - '0' + 1);
					to = (char)(to - '0'  + 1);
					str = str.substr(0, last) + ' ' + me + to + ' ' + str.substr(last + 2, end - last - 1);
					used[i] = true;
				}
			}
			else
			{
				end = str.length();
				char me = '0' + i;

				for (int j = 0; j < end; ++j)
				{
					if (str[j] == me)
					{
						++cnt;
						last = j;
					}
				}
				if (cnt == 1)
				{
					me = (char)(me - '0' + 1);
					str = str.substr(0, last) + ' ' + me + ' ' + str.substr(last + 1, end - last);
					used[i] = true;
				}
			}
		}
	}
	return str;
}

string restore(string str)
{
	int i = 0;
	while (i < str.length())
	{
		if (str[i] != ' ' && !(str[i] >= '0' && str[i] <= '9'))
		{
			str[i] = (char)(str[i] + '0' - 1);
			++i;
		}
		else if (str[i] == ' ' && (i == 0 || str[i - 1] == ' '))
			str = str.substr(0, i) + str.substr(i + 1, str.length() - i);
		else
			++i;
	}
	while (str[str.length() - 1] == ' ')
		str = str.substr(0, str.length() - 1);
	return str;
}

string rt(string str)
{
	int i = 0;
	while (i < str.length())
	{
		if (str[i] == ' ' || !(str[i] >= '0' && str[i] <= '9'))
		{
			++i;
			continue;
		}

		int me = str[i] - '0';
		if (!used[me])
		{
			used[me] = true;
			str = str.substr(0, i + 1) + ' ' + str.substr(i + 1, str.length() - i);
			++i;
			continue;
		}
		me = me * 10 + (str[i + 1] - '0');
		used[me] = true;
		str = str.substr(0, i + 2) + ' ' + str.substr(i + 2, str.length() - i - 1);
		i += 2;
	}
	return str;
}

int main()
{
#ifdef F0X
	freopen("input.in", "r", stdin);
#else
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
#endif

	string in;
	cin >> in;
	int l = in.length();
	int mx = (l <= 9) ? l : 9 + (l - 9) / 2;
	for (int i = 0; i <= mx; ++i)
		used[i] = false;
	string r = can(in, mx);
	r = rt(r);
	cout << restore(r) << endl;


	return 0;
}
//19134121018614177111982316155
//191341220101861417722111116983155