#include <iostream>
#include <cstdio>
#include <iomanip>
#include <algorithm>
using namespace std;
const int MAXN = 100005;
const double eps = 1e-8;

struct myTriplet
{
    int a , b , g , idx;
};

bool compare(myTriplet X , myTriplet Y)
{
  //  return X.a - X.b > Y.a - Y.b;
    return X.a * Y.b > X.b * Y.a;
}

myTriplet p[MAXN];
double full[MAXN];

int main()
{
    freopen("burrito.in" , "r" , stdin);
    freopen("burrito.out" , "w" , stdout);

    int N;
    int A , B;
    cin >> N >> A >> B;

    for ( int i = 1 ; i <= N ; i++ )
    {
        cin >> p[i].g >> p[i].a >> p[i].b;
        p[i].idx = i;
        full[i] = 0;
    }

    sort(p + 1, p + N + 1, compare );

    int takenB = 0;
    double takenA = 0.0;
    for ( int i = 1 ; i <= N ; i++)
    {
        if (p[i].g * p[i].b + takenB <= B )
        {
            takenA += p[i].g * p[i].a;
            takenB += p[i].g * p[i].b;
            full[ p[i].idx ] = p[i].g;
            continue;
        }

        if ( p[i].g * p[i].b + takenB > B && B != takenB )
        {
            full[ p[i].idx ] = ((1.0)*(B - takenB)) / ( 1.0 * p[i].b);
            takenA += full[ p[i].idx ] * p[i].a;
            takenB = B;
        }
    }
    if (takenA < 1.0*A - eps)
    {
        cout << "-1 -1" << endl;
    }
    else
    {
        cout << setprecision(10);
        cout << takenA << " " << takenB << endl;
        for ( int i = 1 ; i <= N ; i++ )
        {
            cout << full[i] << " ";
        }
        cout << endl;
    }

    return 0;
}
