#include <iostream>
#include <vector>
#include <cstdlib>
#include <cstdio>

using namespace std;

struct Car {
    int a, b;
};

int main() {
    freopen("knockout.in", "r", stdin);
    freopen("knockout.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector < Car > cars(n);
    for(int i = 0;i < n;i++) {
        cin >> cars[i].a >> cars[i].b;
    }
    for(int q = 0;q < m;q++) {
        int x, y, t;
        cin >> x >> y >> t;
        int res = 0;
        for(int i = 0;i < n;i++) {
            int dist = abs(cars[i].a - cars[i].b);
            int it = t / dist;
            int cur = 0;
            if(cars[i].a < cars[i].b) {
                if(it % 2 == 0) {
                    cur = cars[i].a + (t % dist);
                } else {
                    cur = cars[i].b - (t % dist);
                }
            } else {
                if(it % 2 == 0) {
                    cur = cars[i].a - (t % dist);
                } else {
                    cur = cars[i].b + (t % dist);
                }
            }
            if(x <= cur && cur <= y) {
                res++;
            }
        }
        cout << res << '\n';
    }
    return 0;
}
