#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <cstdlib>
#include <algorithm>
#include <ctime>

#define name "burrito"

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef double dbl;

struct st {
	pii first;
	int second;
	int index;
};
st nl;
vector<st> v;
int A, B, n;
vector<pll> pr;
vector<dbl> ans;
bool comp(const st &a, const st &b) {
	int a1 = a.first.first, b1 = a.first.second, a2 = b.first.first, b2 = b.first.second;
	if (!b1 && !b2)		return a1 > a2;
	if (!b1)	return true;
	if (!b2)	return false;
	dbl r1 = 1.0 * a1 / (1.0 * b1), r2 = 1.0 * a2 / (1.0 * b2);
	return r1 > r2;
}
int main()
{
	srand(time(NULL));
	freopen(name".in", "r", stdin);
	freopen(name".out", "w", stdout);
	scanf("%d %d %d", &n, &A, &B);
	v.resize(n + 1);
	pr.resize(n + 1);
	ans.resize(n + 1);

	for (int i = 1; i <= n; i++) {
		scanf("%d %d %d", &v[i].second, &v[i].first.first, &v[i].first.second);
		v[i].index = i;
	}
	sort(v.begin() + 1, v.end(), comp);
	v.push_back(nl);
	v[0] = nl;
	for (int i = 1; i <= n; i++) {
		pr[i].first = pr[i - 1].first + v[i].first.first * v[i].second;
		pr[i].second = pr[i - 1].second + v[i].first.second * v[i].second;
	}
	dbl BEST_JOY = 0.0, BEST_MISERY = 0.0;
	int ansL = -1, ansR = -1;
	dbl lst = 0.0;
	bool lst_taken = false;
	for (int i = 1, l, r, mid, ansBS; i <= n; i++) {
		l = i, r = n;
		ansBS = i;
		while (l <= r) {
			mid = (l + r) >> 1;
			if (pr[mid].second - pr[i - 1].second <= B)
				ansBS = mid, l = mid + 1;
			else r = mid - 1;
		}
		int rem = B - pr[ansBS].second + pr[i - 1].second;
		if (!rem)	lst_taken = false;

		dbl add = 0.0;
		bool lp = false;
		if (ansBS < n) {
			lp = true;
			add = (1.0 * rem) / (1.0 * v[ansBS + 1].first.second);
		}
		if (BEST_JOY < add * v[ansBS + 1].first.first + 1.0 * (pr[ansBS].first - pr[i - 1].first)) {
			BEST_JOY = add * v[ansBS + 1].first.first + 1.0 * (pr[ansBS].first - pr[i - 1].first);
			BEST_MISERY = add * v[ansBS + 1].first.second + 1.0 * (pr[ansBS].second - pr[i - 1].second);
			ansL = i;
			ansR = ansBS;
			lst_taken = ansBS < n && rem;
			lst = add;
		}
	}
	if (BEST_JOY < A) 
		return !printf("-1 -1");

	for (int i = ansL; i <= ansR; i++) 
		ans[v[i].index] = 1.0 * v[i].second;
	if (lst_taken)
		ans[v[ansR + 1].index] = 1.0 * lst;
	printf("%.13f %.13f\n", BEST_JOY, BEST_MISERY);
	for (int i = 1; i <= n; i++)
		printf("%.13f ", ans[i]);
	return 0;
}