#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <cstdlib>
#include <algorithm>
#include <ctime>

#define name "improvements"

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef double dbl;

int mas[200005];
int dp[200005];
int ans[200005], ans1[200005];
int n;

int bs(int val)
{
	int l = 0;
	int r = n;
	int a = -1;

	while (l <= r)
	{
		int m = l + r;
		m >>= 1;

		if (dp[m] < val)
		{
			a = m;
			l = m + 1;
		}
		else
		{
			r = m - 1;
		}
	}

	return a;
}

int main()
{
	srand(time(NULL));
	freopen(name".in", "r", stdin);
	freopen(name".out", "w", stdout);
	
	scanf("%d", &n);

    fill(dp, dp + 200005, 1e9);
	dp[0] = -1;

	for (int i = 1, a; i <= n; i++) {
		scanf("%d", &a);
		mas[a] = i;
	}

	for (int i = 1; i <= n; i++)
	{
		int pos = bs(mas[i]);
		dp[pos + 1] = mas[i];
		ans[i] = max(ans[i - 1], pos + 1);
	}
	fill(dp, dp + 200005, 1e9);
	dp[0] = -1; 

	for (int i = n; i > 0; i--)
	{
		int pos = bs(mas[i]);
		dp[pos + 1] = mas[i];
		ans1[i] = max(ans1[i + 1], pos + 1);
	}

	int res = -1;

	for (int i = 0; i <= n; i++)
	{
		res = max(res, ans[i] + ans1[i + 1]);
	}

	cout << res;

	return 0;
}