#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

using namespace std;

struct ingr
{
	int g, a, b, id;
	bool full;
	bool have;
	double grab;
} g[100500];

int main()
{
	//FILE *f;
	//freopen_s(&f, "input.txt", "rt", stdin);
	freopen("burrito.in", "rt", stdin);
	freopen("burrito.out", "wt", stdout);

	int n, A, B;

	scanf("%d %d %d", &n, &A, &B);
	for (int i = 0; i < n; ++i) {
		scanf("%d %d %d", &g[i].g, &g[i].a, &g[i].b);
		g[i].id = i;
		g[i].grab = 0.0;
	}
	sort(g, g + n, [](const ingr &a, const ingr &b) {
		return a.a * b.b > b.a * a.b;
	});

	long long haveA = 0, haveB = 0;
	double plusA = 0.0;
	bool ok = false;

	for (int i = 0; i < n; ++i) {
		long long canB = B - haveB;
		int fullB = g[i].b * g[i].g;
		if (fullB <= canB) {
			haveA += g[i].g * g[i].a;
			haveB += g[i].g * g[i].b;
			g[i].full = true;
			g[i].grab = g[i].g;
			if (haveA >= A)
				ok = true;
		}
		else {
			double grab = canB / double(g[i].b);
			plusA = canB * g[i].a / double(g[i].b);
			haveB = B;
			g[i].have = true;
			g[i].grab = grab;
			ok = ((A - haveA) * (long long)g[i].b <= canB * g[i].a);
			break;
		}
	}
	if (ok == false) {
		cout << "-1 -1" << endl;
	}
	else {
		sort(g, g + n, [](const ingr &a, const ingr &b) {
			return a.id < b.id;
		});
		cout << fixed << setprecision(14) << haveA + plusA << " " << haveB << endl;
		for (int i = 0; i < n; ++i) {
			cout << g[i].grab << " ";
		}
	}

	return 0;
}
