#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

using namespace std;

struct ingr
{
	long long g, a, b, id;
	bool full;
	bool have;
	double grab;
} g[100500];

int main()
{
	//FILE *f;
	//freopen_s(&f, "input.txt", "rt", stdin);
	freopen("burrito.in", "rt", stdin);
	freopen("burrito.out", "wt", stdout);

	long long n, A, B;

	cin >> n >> A >> B;
	for (int i = 0; i < n; ++i) {
		cin >> g[i].g >> g[i].a >> g[i].b;
		g[i].id = i;
		g[i].grab = 0.0;
		g[i].have = false;
		g[i].full = false;
	}
	sort(g, g + n, [](const ingr &a, const ingr &b) {
		//return a.b == 0 || (a.a * b.b > b.a * a.b);
		return (a.a * b.b > b.a * a.b);
	});

	long long haveA = 0, haveB = 0;
	double plusA = 0.0;
	bool ok = false;

	if (A == 0)
		ok = true;

	for (int i = 0; i < n; ++i) {
		if (g[i].a == 0)
			continue;

		long long canB = B - haveB;
		long long fullB = g[i].b * g[i].g;

		if (fullB <= canB) {
			haveA += g[i].g * g[i].a;
			haveB += g[i].g * g[i].b;
			g[i].full = true;
			g[i].grab = g[i].g;
			if (haveA >= A)
				ok = true;
		}
		else {
			double grab = canB / double(g[i].b);
			plusA = canB * g[i].a / double(g[i].b);
			haveB = B;
			g[i].have = true;
			g[i].grab = grab;
			bool ok2 = ok;
			ok = ((A - haveA) * (long long)g[i].b <= canB * g[i].a);
			if (ok2 == true && ok == false)
				for (;;);
			break;
		}
	}
	if (ok == false) {
		cout << "-1 -1" << endl;
	}
	else {
		sort(g, g + n, [](const ingr &a, const ingr &b) {
			return a.id < b.id;
		});
		cout << fixed << setprecision(9) << haveA + plusA << " " << haveB << endl;
		for (int i = 0; i < n; ++i) {
			if (g[i].a == 0) cout << 0 << " ";
			else if (g[i].full) cout << g[i].g << " ";
			else if (g[i].have) cout << fixed << setprecision(9) << g[i].grab << " ";
			else cout << 0 << " ";
		}
	}

	return 0;
}
