import java.io.*;
import java.util.*;

public class Main implements Runnable{

    Scanner sc;
    PrintWriter out;

    public static void main(String[] args) {
        new Main().run();
    }

    @Override
    public void run() {
        try {
            sc =  new Scanner(new File("filter.in"));
            out = new PrintWriter(new File("filter.out"));
        } catch (Exception e) {
            e.printStackTrace();
        }
        solve();
        out.flush();
    }

    int m, f;
    int[] a;
    int cntFiles;
    int[] file;
    int cntPerson;
    //int[] u;
    TreeSet<Integer> isUsedFile = new TreeSet<Integer>();

    private void solve() {
        m = sc.nextInt();
        f = sc.nextInt();
        a = new int[f];
        for (int i = 0; i < f; i++) {
            a[i] = sc.nextInt();
        }

        cntFiles = sc.nextInt();
        file = new int[cntFiles];
        for (int i = 0; i < cntFiles; i++) {
            char[] str = sc.next().toCharArray();
            for(int x = 0, y = str.length - 1; x < y; ++x, --y){
                char ch = str[x];
                str[x] = str[y];
                str[y] = ch;
            }
            file[i] = Integer.parseInt(new String(str), 16);
//            System.err.println(Integer.toBinaryString(file[i]));
        }

        cntPerson = sc.nextInt();
        //u = new int[cntPerson];
        for (int iter = 0; iter < cntPerson; iter++) {
            int uk = sc.nextInt();
            int msk = 0;
            for(int ai : a){
                int j = (uk * ai) % m;
                msk |= 1 << j;
//                System.err.print(" " + j);
            }
//            System.err.println();
            //out.println(Integer.toBinaryString(msk));
            for( int idFile = 0; idFile < cntFiles; ++idFile ){
                if( msk == (file[idFile] & msk) ){
                    isUsedFile.add(idFile);
                }
            }
        }

        out.print(isUsedFile.size());
        for( int v : isUsedFile ) out.print( " " + v );

    }
}
