#include <iostream>
#include <vector>

using namespace std;

int n, m;

struct Car
{
	int a;
	int b;
	int m;
	Car(int a, int b) : a(a), b(b) {
		m = abs(b - a);
	}
	Car() { a = 0, b = 0; }
};

vector<Car> cars;


int main()
{
	//FILE *f;
	//freopen_s(&f, "input.txt", "rt", stdin);
	freopen("knockout.in", "rt", stdin);
	freopen("knockout.out", "wt", stdout);

	cin >> n >> m;
	for (int i = 0; i < n; ++i)
	{
		int a, b;
		cin >> a >> b;
		cars.push_back(Car(a, b));
	}

	for (int i = 0; i < m; ++i)
	{
		int t, a, b, ans = 0;
		cin >> a >> b >> t;
		for (Car &car : cars)
		{
			int tt = t % (2 * car.m);
			long long x;
			if (car.a < car.b)
			{
				x = (long long)car.a + tt;
				if (x > b)
					x = b - (tt - car.m);
			}
			if (car.a > car.b)
			{
				x = (long long)car.a - tt;
				if (x < a)
					x = a + (tt - car.m);
			}

			if (x >= a && x <= b)
				++ans;
		}

		cout << ans << endl;
	}


}