package neercv;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Solution {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok;
	
	void init() throws FileNotFoundException{
		try{
			in = new BufferedReader(new FileReader("inssau2.txt"));
			out = new PrintWriter("outssau2.txt");
		} catch (Exception e) {
			in = new BufferedReader(new FileReader("alter.in"));
			out = new PrintWriter("alter.out");
		}
	}
	
	String readString() throws IOException{
		while (tok == null || !tok.hasMoreTokens()) tok = new StringTokenizer(in.readLine());
		return tok.nextToken();			
	}
	
	int readInt() throws NumberFormatException, IOException{
		return Integer.parseInt(readString());
	}
	
	void solve() throws NumberFormatException, IOException{
		int n = readInt();
		int m = readInt();
		
		int res = n/2+m/2;
		out.println(res);
		for (int i = 2; i<=n; i+=2){
			out.print(i + " 1 ");
			out.print(i + " " + m + "\n");
		}
		for (int i = 2; i<=m; i+=2){
			out.print("1 " + i + " ");
			out.print(n + " " + i + "\n");
		}
		
	}
	
	void run(){
		try{
			init();
			solve();
			out.close();
			in.close();
		} catch(Exception e){
			e.printStackTrace();			
		}
	}
	
	
	public static void main(String[] args) {
		new Solution().run();		
	}

}
