#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;

int n;
int coord[200500];
int d[200500];
int INF = 1 << 29;

int main() {
#ifdef _SSAU2
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("improvements.in", "rt", stdin);
	freopen("improvements.out", "wt", stdout);
#endif
	cin >> n;
	for (int i = 1; i <= n; i++) {
		int x;
		cin >> x;
		coord[i] = x;
	}
	int two = coord[2];
	coord[0] = 0;
	for (int i = 0; i <= 200000; i++) d[i] = INF;
	int ans1 = -1;
	for (int i = 0; i <= n; i++) {
		int l = 0;
		int r = n + 1;
		while (r - l > 1) {
			int mid = (r + l) >> 1;
			if (coord[i] <= d[mid]) {
				r = mid;
			}
			else l = mid;
		}
		d[r] = min(d[r], coord[i]);
		ans1 = max(ans1, r);
	}
	//cout << ans1 << endl;
	
	reverse(coord + 1, coord + 1 + n);
	for (int i = 1; i <= 200000; i++) {
		d[i] = INF;
	}
	int ans2 = ans1;
	ans1 = -1;
	for (int i = 0; i <= n; i++) {
		int l = 0;
		int r = n + 1;
		while (r - l > 1) {
			int mid = (r + l) >> 1;
			if (coord[i] <= d[mid]) {
				r = mid;
			}
			else l = mid;
		}
		d[r] = min(d[r], coord[i]);
		ans1 = max(ans1, r);
	}
	//cout << ans1 << " " << ans2 << endl;
	int ans = n - abs(ans1 - ans2);
	if (two == n) ans++;
	cout << ans;
	return 0;
}