#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <bitset>
#include <string>
#include <cstring>

using namespace std;

struct state
{
    char c;
    map<char, int>to;
    
    state(char x='0', int to1=-1, int to2=-1, int to3=-1)
	{
        c = x;
        if ( to1 != -1 )
            to['R'] = to1;
        if ( to2 != -1 )
            to['P'] = to2;
        if ( to3 != -1 )
            to['S'] = to3;
    }
};
state A[110];
int n;
state my[50100];
int m = 1;

map<char, char>win;
int ind[110][110];
void solve()
{
    win['P'] = 'S';
    win['R'] = 'P';
    win['S'] = 'R';
	cin>>n;
    for (int i=1; i<=n; i++)
	{
        char s[3]; int t1, t2, t3;
        cin>>s>>t1>>t2>>t3;
        A[i] = state(s[0], t1, t2, t3);
    }


    my[1].c = win[ A[1].c ];
    for (int it = 1; it <= n; it++)
	{
      //  cout<<"---"<<endl;
      //  cout<<it<<endl;
        int whA = it;
        int whmy = 1;
        bool was[110];
        memset(was, 0, sizeof(was));
        
        ind[it][1] = 1;
        
        while ( true )
		{
           // cout<<whA<<" "<<whmy<<endl;
            //ind[it][whA] = whmy;
            was[whA] = 1;
            char h = A[ whA ].c;
           // cout<<h<<endl;
            if ( my[whmy].to.find(h) != my[ whmy ].to.end() )
			{
                int gomy = my[whmy].to[h];
                int goA = A[ whA ].to[ my[ whmy ].c ];

                if ( was[goA] == 1 )
				{
                    break;
                }

                whA = goA;
                whmy = gomy;
                continue;
            }
			else
			{
                //cout<<"fff"<<endl;
                int goA = A[ whA ].to[ my[ whmy ].c ];
                //cout<<goA<<endl;
                if ( was[goA] == 1  )
				{
                    if ( whmy != ind[ it ][ goA ] && ind[it][ goA ] != 0 )
                        my[ whmy ].to[ h ] = ind[ it ][ goA ];
					else
					{
                        m++;
                        //my[m].c = win[ h ];
                        my[m].c = win[ A[goA].c ];
                        my[ whmy ].to[h] = m;
                        whA = goA;
                        whmy = m;
                        if ( ind[it][goA] == 0 )
                            ind[it][whA] = whmy;
                        continue;
                    }
                    break;
                }
				else
				{
                   // cout<<"gggg"<<endl;
                    m++;
                    my[m].c = win[ h ];
                    my[ whmy ].to[h] = m;
                    whA = goA;
                    whmy = m;
                    if ( ind[it][goA] == 0 )
                        ind[it][goA] = whmy;
                }
            }
        }
    }

    cout<<m<<endl;
    for (int i=1; i<=m; i++)
	{
        cout<<my[i].c<<" ";
        if ( my[i].to.find('R') == my[i].to.end() )
            cout<<1<<" ";
		else
            cout<<max(my[i].to['R'], 1)<<" ";

	    if ( my[i].to.find('P') == my[i].to.end() )
            cout<<1<<" ";
		else
            cout<<max(1, my[i].to['P'])<<" ";

        if ( my[i].to.find('S') == my[i].to.end() )
            cout<<1<<" ";
		else
            cout<<max(1, my[i].to['S'])<<" ";
        cout<<endl;
    }
}

int main()
{
	freopen("epic.in", "r", stdin);
	freopen("epic.out", "w", stdout);
	time_t start = clock();
	int t = 1;
	for ( int i = 0; i < t; i++ ) solve();
	cerr << fixed << setprecision( 7 ) << "Time: " << 1.0 * ( clock() - start ) / CLOCKS_PER_SEC << "\n";
	return 0;
}