#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <bitset>
#include <string>
#include <cstring>

using namespace std;

int n, m, a[1010], b[1010];

int pos(int A, int B, int t)
{
	if ( A<B )
	{
		int r = t/(B-A);
		if ( r%2 == 0 )
			return A + t%(B-A);
		else
			return B - t%(B-A);
	}
	else
	{
		int r = t/(A-B);
		if ( r%2 == 0 )
			return A - t%(A-B);
		else
			return B + t%(A-B);
	}
}
void solve()
{
	cin>>n>>m;
	for (int i=1; i<=n; i++) cin>>a[i]>>b[i];
	for (int i=1; i<=m; i++)
	{
		int ans = 0, x, y, t;
		cin>>x>>y>>t;
		for (int j=1; j<=n; j++)
		{
			int wh=pos(a[j], b[j], t);
			ans += ( wh>=x && wh<=y );
		}
		cout<<ans<<endl;
	}
}

int main()
{
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);
	time_t start = clock();
	int t = 1;
	for ( int i = 0; i < t; i++ ) solve();
	cerr << fixed << setprecision( 7 ) << "Time: " << 1.0 * ( clock() - start ) / CLOCKS_PER_SEC << "\n";
	return 0;
}