#include <iostream>
#include <algorithm>

using namespace std;

struct str {
	int a;
	int b;
	int g;
	double ab;
	double s;
	int cnt;
};

int comp(const void* a, const void* b) {
	str aa = *((str*)a);
	str bb = *((str*)b);
	return bb.ab - aa.ab;
}

int compBack(const void* a, const void* b) {
	str aa = *((str*)a);
	str bb = *((str*)b);
	return aa.cnt - bb.cnt;
}

int main() {
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	int n;
	int A;
	int B;
	cin >> n; cin >> A; cin >> B;
	str* s = new str[n];
	for (int i = 0; i < n; ++i) {
		cin >> s[i].g; cin >> s[i].a; cin >> s[i].b;
		if (s[i].b != 0)
			s[i].ab = s[i].a / s[i].b;
		else
			s[i].ab = -1;
		s[i].s = 0;
		s[i].cnt = 0;
	}



	qsort(s, n, sizeof(str), comp);

	double tmpA = 0;
	double tmpB = 0;
	int cur = 0;
	while (tmpB + s[cur].b*s[cur].g < B){
		tmpB += s[cur].b*s[cur].g;
		tmpA += s[cur].a*s[cur].g;
		s[cur].s = s[cur].g;
		++cur;
	}
	
	if (tmpB != B){
		int bDiff = B - tmpB;
		s[cur].s = bDiff / (double)s[cur].b;
		tmpA += s[cur].a*s[cur].s;
		tmpB += s[cur].b*s[cur].s; // eq B?
	}
	if (tmpA < A)
	{
		cout << "-1 -1";
	}
	else
	{
		cout <<tmpA<<" "<<tmpB<< "\n";
		qsort(s, n, sizeof(str), comp);
		for (int i = 0; i < n-1; ++i) {
			cout << s[i].s << " ";
		}
		cout << s[n - 1].s;
	}

	return 0;
}