#include <iostream>
#include <algorithm>
#include <cstdio>
#include <fstream>

using namespace std;

struct str {
	int a;
	int b;
	int g;
	double ab;
	double s;
	int cnt;
};

int comp(const void* a, const void* b) {
	str aa = *((str*)a);
	str bb = *((str*)b);
	return bb.ab - aa.ab;
}

int compBack(const void* a, const void* b) {
	str aa = *((str*)a);
	str bb = *((str*)b);
	return aa.cnt - bb.cnt;
}

int main() {
	double tmpA = 0;
	ofstream fout("burrito.out");
	freopen("burrito.in", "r", stdin);
	//freopen("burrito.out", "w", stdout);
	int n;
	int A;
	int B;
	cin >> n; cin >> A; cin >> B;
	str* s = new str[n];
	for (int i = 0; i < n; ++i) {
		s[i].s = 0;
		cin >> s[i].g; cin >> s[i].a; cin >> s[i].b;
		if (s[i].b != 0)
			s[i].ab = (double)s[i].a / s[i].b;
		else
		{
			s[i].ab = -1;
			tmpA += s[i].a*s[i].g;
			s[i].s = s[i].g;
			s[i].g = 0;
		}
		
		s[i].cnt = i;
	}



	qsort(s, n, sizeof(str), comp);

	double tmpB = 0;
	int cur = 0;
	while (tmpB + s[cur].b*s[cur].g < B){
		tmpB += s[cur].b*s[cur].g;
		tmpA += s[cur].a*s[cur].g;
		s[cur].s = s[cur].g;
		++cur;
	}

	if (tmpB != B){
		int bDiff = B - tmpB;
		s[cur].s = bDiff / (double)s[cur].b;
		tmpA += s[cur].a*s[cur].s;
		tmpB += s[cur].b*s[cur].s; // eq B?
	}
	if (tmpA < A)
	{
		fout << "-1 -1";
	}
	else
	{
		fout << tmpA;
		fout << " ";
		fout << tmpB;
		fout << endl;
		qsort(s, n, sizeof(str), compBack);
		for (int i = 0; i < n - 1; ++i) {
			fout << s[i].s << " ";
		}
		fout << s[n - 1].s;
	}
	fout.close();
	return 0;

}