#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <ctime>
using namespace std;

#define fs first
#define sc second

#define mp make_pair
#define pb push_back

vector <int> got;
int n;
string s;

void go(int pos = 0, long long mask = 0)
{
    if(pos == s.length())
    {
        for(int i = 0; i < got.size();)
        {
            int len = got[i];
            cout << s.substr(i, len) << " ";
            i += len;
        }
        cout << endl;
        exit(0);
    }
    for(int j = 1; j <= 2; ++j)
    {
        int cval;
        if(j == 1)
            cval = s[pos] - '0';
        if(j == 2)
        {
            if(pos + 1 < s.length())
            {
                cval = s[pos + 1] - '0' + (s[pos] - '0') * 10;
            }
            else
                continue;
        }
        //cout << pos << " " << j << " " << cval << endl;
        if(cval > n || cval == 0)
            continue;
        if((mask >> cval) & 1)
            continue;
        got[pos] = j;
        go(pos + j, mask | (1LL << cval));
        got[pos] = 0;
    }
}

int main()
{
    freopen("joke.in", "r", stdin);
    freopen("joke.out", "w", stdout);
    cin >> s;
    got.assign(s.length(), 0);
    if(s.length() < 10)
        n = s.length();
    else
        n = 9 + (s.length() - 9) / 2;
    go();
    return 0;
}
