#include <fstream>
#include <vector>
#include <cmath>
#include <iostream>
using namespace std;

void procede(vector<pair<int, int> > &vc, int t)
{
    vector <pair<int, int> > nvc(vc.size());
    for(int i = 0; i < vc.size(); ++i)
    {
        int len = (vc[i].second - vc[i].first);
        int done = abs(len) / t;
        if(len > 0)
        {
            if(done % 2 == 0)
                nvc[i] = make_pair(vc[i].first + t % len, 0);
            else
                nvc[i] = make_pair(vc[i].second - t % len, 0);
        }
        else
        {
            if(done % 2 == 0)
                nvc[i] = make_pair(vc[i].second - t % (int)abs(len), 0);
            else
                nvc[i] = make_pair(vc[i].first + t % (int)abs(len), 0);
        }
    }
    vc = nvc;
}

int main() {
    ifstream cin("knockout.in");
    ofstream cout("knockout.out");
    //ofstream cout("knockout.in");
    int n, m;
    vector <pair<int, int> > all;
    cin >> n >> m;
    all.resize(n);
    for(int i = 0; i < n; ++i)
        cin >> all[i].first >> all[i].second;
    for(int i = 0; i < m; ++i)
    {
        int x, y, t;
        cin >> x >> y >> t;
        vector <pair<int, int > > pos = all;
        procede(pos, t);
        int ans = 0;
        for(int j = 0; j < n; ++j)
            if(pos[j].first >= x && pos[j].first <= y)
                ++ans;
        cout << ans << endl;
    }
    return 0;
}
