#define _CRT_SECURE_NO_WARNINGS 

#include <map>
#include <functional>
#include <iostream>
#include <algorithm>
#include <queue>
#include <cstdio>

using namespace std;

#define FOR(i, n) for (int i = 0; i < n; i++)


int main()
{
#define FILENAME "burrito"
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	/*freopen(FILENAME ".in", "r", stdin);
	freopen(FILENAME ".out", "w", stdout);*/
	
	int n;
	double mina, maxb;

	cin >> n >> mina >> maxb;
	vector<int> a(n);
	vector<int> g(n);
	vector<int> b(n);
	vector<double> c(n), s(n);

	vector<pair<double, int> > sc(n);


	for (int i = 0; i < n; i++)
	{
		cin >> g[i] >> a[i] >> b[i];
		if (b[i] != 0)
			c[i] = a[i] * 1.0 / b[i];
		else
			c[i] = 101;
		sc[i].first = c[i];
		sc[i].second = i;
	}
	sort(sc.begin(), sc.end(), greater<pair<double, int> >());


	double curb = 0, cura = 0;

	for (int i = 0; i < n; i++) {
		int pos = sc[i].second;
		double ss = 1e9;
		if (b[pos] != 0) {
			ss = (maxb - curb) / b[pos];
		}

		ss = min<double>(ss, g[pos]);

		curb += ss * b[pos];
		cura += ss * a[pos];
		s[pos] = ss;

		if (curb >= maxb) {
			break;
		}
	}

	if (cura >= mina) {
		printf("%.10f %.10f \n", cura, curb);
		for (int i = 0; i < n; i++)
			printf("%.10Lf ", s[i]);
	} else {
		cout << -1 << ' ' << -1;
	}
}