
#define _CRT_SECURE_NO_WARNINGS
#define filename 

#include <map>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <queue>
#include <cstdio>
#include <string>
#include <vector>
#include <sstream>

using namespace std;

int main()
{
#define FILENAME "filter"
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
	freopen(FILENAME ".in", "r", stdin);
	freopen(FILENAME ".out", "w", stdout);
	
	int m, f;
	cin >> m >> f;
	vector<int> a(f);
	for (int i = 0; i < f; i++) {
		cin >> a[i];
	}

	int n;
	scanf("%d\n", &n);

	vector<string> s(n);
	for (int i = 0; i < n; i++) {
		getline(cin, s[i]);
	}

	int q;
	cin >> q;
	vector<long long> u(q);
	for (int i = 0; i < u.size(); i++) {
		cin >> u[i];
	}

	vector<vector<long long> > ubits(u.size(), vector<long long> (m)), uzip(u.size());
	for (int i = 0; i < u.size(); i++) {
		for (int j = 0; j < a.size(); j++) {
			ubits[i][(u[i] * a[j]) % m] = true;
		}
	}

	for (int i = 0; i < ubits.size(); i++) {

		for (int j = 0; j < ubits[i].size(); j++) {
			long long num = 0;
			for (int k = 0; k < 64; k++) {
				if (k + j >= ubits[i].size()) {
					break;
				}

				if (ubits[i][j + k]) {
					num |= (1 << k);
				}
			}
			j += 63;
			uzip[i].push_back(num);
		}
	}

	vector<vector<long long> > bits(n), bzip(n);

	for (int i = 0; i < s.size(); i++) {
		for (int j = 0; j < s[i].size(); j++) {
			stringstream ss;
			ss << setbase(16);
			ss << s[i][j];
			int mask;
			ss >> mask;
			for (int k = 0; k < 4; k++) {
				bits[i].push_back((mask & (1 << k)) != 0);
			}
		}
	}

	for (int i = 0; i < bits.size(); i++) {

		for (int j = 0; j < bits[i].size(); j++) {
			long long num = 0;
			for (int k = 0; k < 64; k++) {
				if (k + j >= bits[i].size()) {
					continue;
				}

				if (bits[i][j + k]) {
					num |= (1 << k);
				}
			}
			j += 63;
			bzip[i].push_back(num);
		}
	}

	vector<int> ans;

	
	for (int i = 0; i < bzip.size(); i++) {
		for (int k = 0; k < uzip.size(); k++) {
			bool accept = true;
			for (int j = 0; j < bzip[i].size(); j++) {
				if ((uzip[k][j] & bzip[i][j]) != uzip[k][j]) {
					accept = false;
					break;
				}
			}

			if (accept) {
				ans.push_back(i);
				break;
			}
		}


	}

	cout << ans.size() << " ";
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << " ";
	}
	cout << endl;
}