#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define sz(c) ((int)(c).size())
#define forn(i, n) for (int i = 0; i < (int) n; ++i)
#define pb push_back
#define all(c) (c).begin(), (c).end()
#define fst first
#define snd second
#define fori(i,b,e) for (int i = (b); i < (e); ++i)

typedef vector<int> vi;
typedef long long ll;
typedef long long LL;
typedef long long int64;
typedef pair<int, int> pii;
typedef vector<pii> vii;

inline int getInt() {int x; scanf("%d", &x); return x;}

#define FILE_NAME "epic"

const int N = int(5e4 + 5);

int n, to[N][3], future_edge[N][3], our_to[N][3], mov[N], our_mov[N], from_node[N][3], cnt, start[N];
bool was[N];

int beat(int x) {
    return (x + 1) % 3;
} 

int beaten(int x) {
    x--;
    if (x < 0)
        return 2;
    return x;
} 

char inv(int x) {
    if (!x) return 'R';
    if (x == 1) return 'P';
    return 'S';
}

int add_node(char symb) {
    our_mov[cnt] = symb;
    cnt++;
    return cnt - 1;
}

void add_edge(int a, int b, int c) {
    our_to[a][c] = b;    
}

int trans(char Move) {
    if (Move == 'R') return 0;
    if (Move == 'P') return 1;
    return 2;
}

int main() {
    assert(freopen(FILE_NAME ".in", "rt", stdin));
    assert(freopen(FILE_NAME ".out", "wt", stdout));

    cin >> n;
    for (int i = 0; i < n; i++) {
        int r, p, s;
        char Move;
        cin >> Move >> r >> p >> s;
        mov[i] = trans(Move);
        r--, p--, s--;
        to[i][0] = r, to[i][1] = p, to[i][2] = s;
    }

    for (int i = 0; i < n; i++)
        for (int j = 0; j < 3; j++) 
            future_edge[i][j] = -1;
    
    for (int i = 0; i < n; i++) {
        int now = i, last = -1, nextnow = (i + 1) % n;
        memset(was, 0, sizeof(was));

        while (!was[now]) {
            was[now] = 1;
            int new_node = add_node(beat(mov[now]));
            if (now == i) {
                start[i] = new_node;
            }
            if (last != -1)
                add_edge(last, new_node, beaten(our_mov[last]));
            for (int j = 0; j < 3; j++) {
                if (j != beat(mov[now])) {
                    future_edge[now][j] = to[nextnow][j];
                    from_node[now][j] = new_node;
                }
            }            
            last = new_node;
            now = to[now][beat(mov[now])];
            nextnow = to[nextnow][beat(mov[now])];
        }                            
    }

    for (int i = 0; i < n; i++)
        for (int j = 0; j < 3; j++) {
            if (future_edge[i][j] != -1) {
                add_edge(from_node[i][j], start[future_edge[i][j]], j);                                                                
            }
        }

    cout << cnt << endl;
    for (int i = 0; i < cnt; i++) {
        cout << inv(our_mov[i]) << " " << our_to[i][0] + 1 << " " << our_to[i][1] + 1 << " " << our_to[i][2] + 1 << endl;
    }

    return 0;
}
