#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <memory>
#include <cstdio>
#include <algorithm>
using namespace std;
#define forn(it, from ,to) for(int it = from; it < to; ++it)
#define mems(arr, val) memset(arr, val, sizeof(arr))
#define mp(a, b) make_pair(a, b)
#define all(A) (A).begin(), (A).end()
typedef long long LL;

struct burr{
	int g, a, b, idx;
};

bool comp(burr &a, burr &b)
{
	//if (a.a * b.b == a.b * b.a) return a.idx > b.idx;
	return a.a * b.b > a.b * b.a;
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
	freopen("burrito.in", "r", stdin); freopen("burrito.out", "w", stdout);
#endif
	
	int n;
	LL A, B;
	cin >> n >> A >> B;
	vector<burr> bur(n);
	forn(i, 0, n)
	{
		cin >> bur[i].g >> bur[i].a >> bur[i].b;
		bur[i].idx = i;
	}

	sort(all(bur), comp);

	LL curA = 0, curB = 0;
	vector<double> ans(n, 0.0);
	double ansA = 0, ansB = 0;
	double presA = 0.0, presB = 0.0;
	forn(i, 0, n)
	{
		if (curB + bur[i].b * bur[i].g <= B)
		{
			curB += bur[i].b * bur[i].g;
			ans[bur[i].idx] += bur[i].g;
			curA += bur[i].a * bur[i].g;
		}
		else
		{
			LL need = B - curB;
			double part = (double)need / (double)bur[i].b;
			ans[bur[i].idx] = part;
			//ansA = curA;
			ansA = part * (double)bur[i].a;
			curA += (LL)ansA;
			presA = ansA - (LL)ansA;
			presA = max(presA, 0.0);
			//ansB = curB;
			ansB = part * (double)bur[i].b;
			curB += (LL)ansB;
			presB = ansB - (LL)ansB;
			presB = max(presB, 0.0);
			break;
		}
	}
	if ((double)curA + presA < (double)A)
	{
		cout << "-1 -1";
		return 0;
	}


	char ans2[20];
	sprintf(ans2, "%.15f", presA);
	printf("%I64d", curA);
	for (int i = 1; i < strlen(ans2); ++i)
	{
		printf("%c", ans2[i]);
	}
	sprintf(ans2, "%.15f", presB);
	printf(" %I64d", curB);
	for (int i = 1; i < strlen(ans2); ++i)
	{
		printf("%c", ans2[i]);
	}

	printf("\n");
	forn(i, 0, ans.size())
		printf("%.15f ", ans[i]);
	return 0;
}