#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <memory>
#include <cstdio>
#include <algorithm>
using namespace std;
#define forn(it, from ,to) for(int it = from; it < to; ++it)
#define mems(arr, val) memset(arr, val, sizeof(arr))
#define mp(a, b) make_pair(a, b)
#define all(A) (A).begin(), (A).end()
typedef long long LL;

struct burr{
	int g, a, b, idx;
};

bool comp(burr &a, burr &b)
{
	//if (a.a * b.b == a.b * b.a) return a.idx > b.idx;
	return a.a * b.b > a.b * b.a;
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
	freopen("burrito.in", "r", stdin); freopen("burrito.out", "w", stdout);
#endif

	int n;
	LL A, B;
	cin >> n >> A >> B;
	LL curA = 0, curB = 0;
	vector<burr> bur;
	vector<double> ans(n, 0.0);
	forn(i, 0, n)
	{
		burr curbur;
		cin >> curbur.g >> curbur.a >> curbur.b;
		curbur.idx = i;
		if (curbur.a == 0) continue;
		if (curbur.b == 0)
		{
			curA += curbur.a * curbur.g;
			ans[i] = curbur.g;
		}
		else
		{
			bur.push_back(curbur);
		}
	}

	sort(all(bur), comp);

	
	
	double ansA = 0, ansB = 0;
	forn(i, 0, bur.size())
	{
		if (curB + bur[i].b * bur[i].g <= B)
		{
			curB += bur[i].b * bur[i].g;
			ans[bur[i].idx] += bur[i].g;
			curA += bur[i].a * bur[i].g;
		}
		else
		{
			LL need = B - curB;
			double part = (double)need / (double)bur[i].b;
			ans[bur[i].idx] = part;
			//ansA = curA;
			ansA = part * (double)bur[i].a;	
			//ansB = curB;
			ansB = part * (double)bur[i].b;	
			break;
		}
	}
	ansA += curA;
	ansB += curB;
	if (ansA + 1e-10 < A)
	{
		cout << "-1 -1";
		return 0;
	}


	printf("%.15f %.15f\n", ansA, ansB);

	forn(i, 0, ans.size())
		printf("%.15f ", ans[i]);
	return 0;
}