#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/stack:64000000")

#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <string>
#include <cstring>
#include <set>
#include <algorithm>
#include <queue>
#include <ctime>
#include <cassert>
#include <cstdlib>
#include <cmath>
#include <stack>

using namespace std;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define mp(a, b) make_pair(a,b)
#define ALL(a) a.begin(), a.end()
#define pb(a) push_back(a)
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

vector<int> solve(const vector<int>& a) {
	int n = sz(a);
	vector<int> d(n+1,n+1);
	d[0] = -1;
	vector<int> res(n);
	forn(i, sz(a)) {
		int cur = a[i];
		int pos = lower_bound(ALL(d), cur)-d.begin();
		d[pos] = cur;
		res[i] = pos;
	}
	return res;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);
#endif
	int n; scanf("%d", &n);
	vector<int> a(n);
	forn(i, n) scanf("%d", &a[i]), --a[i];
	vector<int> b(n);
	forn(i, n) b[a[i]] = i;
	vector<int> r1 = solve(b);
	reverse(ALL(b));
	vector<int> r2 = solve(b);
	reverse(ALL(r2));
	int ans = 0;
	forn(i, n) ans = max(ans, r1[i] + r2[i]-1);
	printf("%d\n", ans);
	return 0;
}