#define _CRT_SECURE_NO_WARNINGS
#include<cstdio>
#include<iostream>
#include<algorithm>
#include<cstdlib>
#include<cmath>
using namespace std;
const int MAX_N = 200005;
const double EPS = 1e-8;

struct elem
{
	int g, a, b;
    int num;
	elem() {}
	elem(int g, int a, int b, int num) :g(g), a(a), b(b), num(num) {}
};

inline int less_num(double x, double y)
{
	return (y - x > EPS);
}

inline int more_num(double x, double y)
{
	return (x - y > EPS);
}

inline int equal_num(double x, double y)
{
	return (fabs(x - y) < EPS);
}

bool comp(const elem &x, const elem &y)
{
	int w1 = x.b * y.a;
	int w2 = x.a * y.b;
	return (w1 < w2 || (w1 == w2 && x.b < x.a) || (w1 == w2 && x.b == x.a && x.g < y.g));
}

elem mas[MAX_N];
double ans[MAX_N];

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	int n;
	double total_A, total_B;
	cin >> n >> total_A >> total_B;
	for (int i = 0; i < n; i++)
	{
		scanf("%d%d%d", &mas[i].g, &mas[i].a, &mas[i].b);
		mas[i].num = i;
	}
	sort(mas, mas + n, comp);
	cout.precision(8);

	double sum_A = 0.0, sum_B = 0.0;
	for (int i = 0; i < n; i++)
	{
		if (more_num(sum_B + (double)(mas[i].g * mas[i].b), total_B))
		{
			double kol_g = (total_B - sum_B) / (double)mas[i].b;
			double ans_A = sum_A + kol_g * (double)mas[i].a;
			double ans_B = sum_B + kol_g * (double)mas[i].b;
			ans[mas[i].num] = kol_g;
			if (less_num(ans_A, total_A))
			{
			    cout << "-1 -1\n";
				return 0;
			}

			cout << ans_A << " " << ans_B << "\n";
			for (int j = 0; j < n; j++)
				cout << ans[j] << " ";
			cout << "\n";
			return 0;
		}
		else
		{
			double kol_g = (double)mas[i].g;
			sum_A += kol_g * (double)mas[i].a;
			sum_B += kol_g * (double)mas[i].b;
			ans[mas[i].num] = kol_g;
		}
	}

	if (less_num(sum_A, total_A))
	{
		cout << "-1 -1\n";
		return 0;
	}
	cout << sum_A << " " << sum_B << "\n";
	for (int i = 0; i < n; i++)
		cout << ans[i] << " ";
	cout << "\n";

	return 0;
}