#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>


typedef long long ll;
typedef long double ld;

using namespace std;

struct food
{
	int a;
	int b;
	int g;
	int num;
	double amount;
};

bool foodAB(const food& a1, const food& a2)
{
	long long t1 = 1LL * a1.a * a2.b;
	long long t2 = 1LL * a2.a * a1.b;
	return t1 > t2;
}

bool foodN(const food& a1, const food& a2)
{
	return a1.num < a2.num;
}

int n;
double A, B;
double totA, totB;
food f[100002];
double EPS = 0.0000000001;

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	cout << fixed;
	cout.precision(9);

	totA = totB = 0;
	cin >> n >> A >> B;
	for (int i = 0; i < n; i++)
	{
		cin >> f[i].g >> f[i].a >> f[i].b;
	}

    //zh
	sort(f, f + n, foodAB);

	for (int i = 0; i < n; i++)
	{
		double add = f[i].g;
		if (totB + f[i].b * add > B + EPS)
		{
			add = (B - totB) / f[i].b;
			f[i].amount = add;
			totA += f[i].a * add;
			totB += f[i].b*add;
			break;
		}
		else
		{
			f[i].amount = add;
			totA += f[i].a * add;
			totB += f[i].b*add;
		}
	}

    //num
	sort(f, f + n, foodN);

	if (totA + EPS < A)
	{
		cout << "-1 -1\n";
		return 0;
	}

	cout << totA << " " << totB << endl;
	for (int i = 0; i < n; i++)
	{
		cout << f[i].amount << " ";
	}
	cout << endl;

	return 0;
}