#define _CRT_SECURE_NO_WARNINGS
#include <set>
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>


typedef long long ll;
typedef long double ld;

using namespace std;
struct state
{
	char c;
	int n1;
	int n2;
	int n3;
	int num;
	state(int NUM, char C, int N1, int N2, int N3)
	{
		n1 = N1;
		n2 = N2;
		n3 = N3;
		c = C;
		num = NUM;
	}
	state()
    {
	}
	void out()
	{
		cout << c << ' ' << n1 << ' ' << n2 << ' ' << n3 << endl;
	}

	bool operator<(const state& s) const
	{
		return num < s.num;
	}
};
int cnt = 2;
struct Comparator
{
	bool operator()(pair<vector<state>, bool> const& c1, pair<vector<state>, bool> const& c2)
	{
		if (c1.second != c2.second)
		{
			if (c1.second)
				return true;
			else
				return false;
		}
		else
		{
			return c1.first < c2.first;
		}
	}
};
map<pair<vector<state>, bool>, int, Comparator > My;


vector<state> op;
int stateNum = 4;

vector<state> my;

int recNew(vector<state> const& s)
{
	map<pair<vector<state>, bool>, int, Comparator >::iterator it = My.find(make_pair(s, true));
	if (s.size() == 0)
	{
		return 1;
	}
	if (it != My.end())
	{
		return it->second;
	}

	int Swin =0;
	int Rwin =0;
    int Pwin =0;
	vector<state> vs, vr, vp;
	for (int i = 0; i < s.size(); i++)
	{
		if (s[i].c == 'S')
		{
			Rwin++;
			vr.push_back(s[i]);
		}
		if (s[i].c == 'R')
		{
			Pwin++;
			vp.push_back(s[i]);
		}
		if (s[i].c == 'P')
		{
			vs.push_back(s[i]);
			Swin++;
		}
	}

	char c;
	bool WinFlag = false;
	vector<state> S1;
	vector<state> R1;
	vector<state> P1;

	if (Swin >= Rwin && Swin >= Pwin)
	{
		c = 'S';
		if (Swin == s.size())
		{
			WinFlag = true;
		}
        
		for (int i = 0; i < s.size(); i++)
		{
			if (s[i].c == 'S')
			{
				S1.push_back(op[s[i].n3]);
			}
			if (s[i].c == 'P')
			{
				P1.push_back(op[s[i].n3]);
			}
			if (s[i].c == 'R')
			{
				R1.push_back(op[s[i].n3]);
			}
		}

	}
	else if (Rwin >= Swin && Rwin >= Pwin)
	{
		c = 'R';
		if (Rwin == s.size())
		{
			WinFlag = true;
		}
		for (int i = 0; i < s.size(); i++)
		{
			if (s[i].c == 'S')
			{
				S1.push_back(op[s[i].n1]);
			}
			if (s[i].c == 'P')
			{
				P1.push_back(op[s[i].n1]);
			}
			if (s[i].c == 'R')
			{
				R1.push_back(op[s[i].n1]);
			}
		}
	}
	else if (Pwin >= Swin && Pwin >= Rwin)
	{
		c = 'P';
		if (Pwin == s.size())
		{
			WinFlag = true;
		}
		for (int i = 0; i < s.size(); i++)
		{
			if (s[i].c == 'S')
			{
				S1.push_back(op[s[i].n2]);
			}
			if (s[i].c == 'P')
			{
				P1.push_back(op[s[i].n2]);
			}
			if (s[i].c == 'R')
			{
				R1.push_back(op[s[i].n2]);
			}
		}
	}

	int T = cnt;
	My[make_pair(s, WinFlag)] = T;
	my[T].num = T;
	cnt++;
	sort(vr.begin(), vr.end());
	sort(vp.begin(), vp.end());
	sort(vs.begin(), vs.end());

	int n1 = recNew(R1);
	int n2 = recNew(P1);
	int n3 = recNew(S1);
	
	my[T].n1 = n1;
	my[T].n2 = n2;
	my[T].n3 = n3;
	my[T].c = c;
	return my[T].num;
}

int main()
{
	my.resize(50001);
	freopen("epic.in", "r", stdin);
	freopen("epic.out", "w", stdout);
	int n;
	cin >> n;
	op.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> op[i].c >> op[i].n1 >> op[i].n2 >> op[i].n3;
		op[i].n1--;
		op[i].n2--;
		op[i].n3--;
		op[i].num = i;
	}
    
	sort(op.begin(), op.end());
	int frst = recNew(op);
	my[frst].out();
	for (int i = 2; i < cnt; i++)
	{
		my[i].out();
	}
	return 0;
}