#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

struct ingridient
{
	int a;
	int b;
	int g;
};

bool operator<(const ingridient& a, const ingridient& b)
{
	return a.g < b.g;
}
int n, A, B;
vector<pair<double, ingridient> > v;

const double DOHUYA = 1e300;

int main()
{
	//freopen("i.txt", "rt", stdin);
	freopen("burrito.in", "rt", stdin);
	freopen("burrito.out", "w", stdout);

	cin >> n >> A >> B;
	v.resize(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> v[i].second.g >> v[i].second.a >> v[i].second.b;
		if (v[i].second.b != 0)
			v[i].first = (double)v[i].second.a / (double)v[i].second.b;
		else
			v[i].first = DOHUYA;
	}
	sort(v.rbegin(), v.rend());

	//   

	double cur_a = 0, cur_b = 0;
	vector<double> ans(n, 0);
	for (int i = 0; i < v.size(); i++)
	{
		if (cur_b+v[i].second.b*v[i].second.g <= B)
		{
			cur_b += v[i].second.b*v[i].second.g;
			cur_a += v[i].second.a*v[i].second.g;
			ans[i] = v[i].second.g;
		}
		else
		{
			double k = (v[i].second.b==0)?(v[i].second.g):((double)(B - cur_b) / (double)v[i].second.b);
			if (k <= 0)
				continue;

			ans[i] = k;
			cur_b += k*v[i].second.b;
			cur_a += k*v[i].second.a;
			if (cur_b <= B && cur_a >= A)
				continue;

			ans[i] = 0;
			cur_b -= k*v[i].second.b;
			cur_a -= k*v[i].second.a;
		}
	}

	if (cur_b <= B && cur_a >= A)
	{
		printf("%.9f %.9f\n", cur_a, cur_b);
		for (int i = 0; i < n; i++)
			printf("%.9f ", ans[i]);

	}
	else
	{
		cout << "-1 -1";
	}



}