#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <memory>
#include <deque>
#include <sstream>
#include <set>
#include <cmath>

using namespace std;

#define TASK_NAME "alter"

int calc_k(int n, int m)
{
	if ((n * m) % 2 == 0)
	{
		return (n * m) / 2;
	}
	else
	{
		return (int)((n * m) / 2);
	}
}

void run_calc_k_tests()
{
	cout << (calc_k(2, 2) == 2) << endl;
	cout << (calc_k(3, 3) == 4) << endl;
	cout << (calc_k(1, 1) == 0) << endl;
	cout << (calc_k(2, 3) == 3) << endl;
	cout << (calc_k(3, 2) == 3) << endl;
	cout << (calc_k(1, 3) == 1) << endl;
	cout << (calc_k(3, 1) == 1) << endl;
	cout << (calc_k(1, 4) == 2) << endl;
	cout << (calc_k(1, 5) == 2) << endl;
	cout << (calc_k(5, 1) == 2) << endl;
	cout << (calc_k(1, 6) == 3) << endl;
}

void inv_gen(int n, int m)
{
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= m; j++)
		{
			if ((((i % 2) == 1) && ((j % 2) == 0)) || (((i % 2) == 0) && ((j % 2) == 1)))
			{
				cout << i << " " << j << " " << i << " " << j << endl;
			}
		}
	}
}

int main()
{
#ifndef _DEBUG
	freopen(TASK_NAME ".in", "rt", stdin);
	freopen(TASK_NAME ".out", "wt", stdout);
#endif

#ifdef _DEBUG
	run_calc_k_tests();
#endif

	int n, m;
	cin >> n >> m;

	cout << calc_k(n, m) << endl;
	if ((n != 1) || (m != 1))
	{
		inv_gen(n, m);
	}

#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}
