#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <memory>
#include <deque>
#include <sstream>
#include <set>
#include <cmath>

using namespace std;

#define TASK_NAME "alter"

int calc_k1(int n, int m)
{
	if ((n * m) % 2 == 0)
	{
		return (n * m) / 2;
	}
	else
	{
		return (int)((n * m) / 2);
	}
}

void run_calc_k_tests()
{
	/*cout << (calc_k(2, 2) == 2) << endl;
	cout << (calc_k(3, 3) == 4) << endl;
	cout << (calc_k(1, 1) == 0) << endl;
	cout << (calc_k(2, 3) == 3) << endl;
	cout << (calc_k(3, 2) == 3) << endl;
	cout << (calc_k(1, 3) == 1) << endl;
	cout << (calc_k(3, 1) == 1) << endl;
	cout << (calc_k(1, 4) == 2) << endl;
	cout << (calc_k(1, 5) == 2) << endl;
	cout << (calc_k(5, 1) == 2) << endl;
	cout << (calc_k(1, 6) == 3) << endl;*/
}

void inv_gen1(int n, int m)
{
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= m; j++)
		{
			if ((((i % 2) == 1) && ((j % 2) == 0)) || (((i % 2) == 0) && ((j % 2) == 1)))
			{
				cout << i << " " << j << " " << i << " " << j << endl;
			}
		}
	}
}

int calc_k2(int n, int m)
{
	return (int)(n / 2) + (int)(m / 2);
}

void inv_gen2(int n, int m)
{
	for (int i = 2; i <= n; i+=2)
	{
		cout << i << " " << 1 << " " << i << " " << m << endl;
	}
	for (int i = 2; i <= m; i += 2)
	{
		cout << 1 << " " << i << " " << n << " " << i << endl;
	}
}

int main()
{
#ifndef _DEBUG
	freopen(TASK_NAME ".in", "rt", stdin);
	freopen(TASK_NAME ".out", "wt", stdout);
#endif

#ifdef _DEBUG
	run_calc_k_tests();
#endif

	int n, m;
	cin >> n >> m;

	int k1 = calc_k1(n, m);
	int k2 = calc_k2(n, m);
	if (k1 <= k2)
	{
		cout << k1 << endl;
		inv_gen1(n, m);
	}
	else
	{
		cout << k2 << endl;
		inv_gen2(n, m);
	}

#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}
