#include <iostream>
#include <string>
#include <memory>
#include <deque>
#include <sstream>
#include <set>

using namespace std;

#define TASK_NAME "abc"

bool found[1000] = { false };

#define FOUND(n) found[n + 100]

int N;
deque<int> st;

bool check(const char *v, int l)
{
	//cout << v << endl;
	int offset = 1;
	if (N < 1)
	{
		offset = -1;
	}
	for (int i = 1; (offset > 0) ? (i <= N) : (i >= N); i += offset)
	{
		if (!FOUND(i))
		{
			ostringstream s;
			s << i;
			if (memcmp(v, (void*)s.str().c_str(), s.str().length()) == 0)
			{
				FOUND(i) = true;
				st.push_back(i);
				if (l == 1)
				{
					return true;
				}
				if (check(v + s.str().length(), l - 1))
				{
					return true;
				}
				st.pop_back();
				FOUND(i) = false;
			}
			s.clear();
		}
	}
	return false;
}

int main()
{
#ifndef _DEBUG
	freopen(TASK_NAME ".in", stdin);
	freopen(TASK_NAME "abc.out", stdout);
#endif

	string s;
	cin >> s;

	int minus = false;
	for (int i = 0; i < s.length(); i++)
	{
		if (s[i] == '-')
		{
			minus = true;
			break;
		}
	}
	if (!minus)
	{
		if (s == "10")
		{
			cout << "1 0";
#ifdef _DEBUG
			system("pause");
#endif
			return 0;
		}
		if (s == "01")
		{
			cout << "0 1";
#ifdef _DEBUG
			system("pause");
#endif
			return 0;
		}
		else if (s.length() <= 9)
		{
			N = s.length();
		}
		else
		{
			N = 9 + (s.length() - 9) / 2;
		}
	}
	else
	{
		if (s.length() <= 20)
		{
			N = -(int)(s.length() - 2) / 2;
		}
		else
		{
			N = -(int)(s.length() - 20) / 3 - 9;
		}
	}

	check(s.c_str(), (N >= 1) ? N : (-N + 2));
	cout << *st.begin();
	st.pop_front();
	for each (auto var in st)
	{
		cout << " " << var;
	}

#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}
