#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <memory>
#include <deque>
#include <sstream>
#include <set>
#include <cmath>

using namespace std;

#define TASK_NAME "knockout"

int car_begin[1000] = { 0 };
int car_end[1000] = { 0 };

int main()
{
#ifndef _DEBUG
	freopen(TASK_NAME ".in", "rt", stdin);
	freopen(TASK_NAME ".out", "wt", stdout);
#endif

	int n, m;

	cin >> n >> m;

	for (int i = 0; i < n; i++)
	{
		int a, b;
		cin >> a >> b;
		car_begin[i] = a;
		car_end[i] = b;
	}

	for (int i = 0; i < m; i++)
	{
		int a, b, c;
		cin >> a >> b >> c;
		int count = 0;
		for (int j = 0; j < n; j++)
		{
			int length = abs(car_begin[j] - car_end[j]);
			int offset = c % (length + length);
			int pos;
			if (offset > length)
			{
				offset = length - (offset % (length));
			}
			if (car_begin[j] < car_end[j])
			{
				pos = car_begin[j] + offset;
			}
			if (car_begin[j] > car_end[j])
			{
				pos = car_begin[j] - offset;
			}
			if ((pos >= a) && (pos <= b))
			{
				count++;
			}
		}
		cout << count << endl;
	}

#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}
