#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <list>

#define TASK "burrito"

#define ll long long

using namespace std;

struct ing
{
	ll g, a, b, ind;
};

bool compIng(ing i1, ing i2)
{
	return (i1.a * i2.b >= i2.a * i1.b);
}

bool de(double a, double b)
{
	if (abs(a - b) < 0.00000000001)
		return true;
	else
		return false;
}

bool dg(double a, double b)
{
	if (a > b && !de(a, b))
		return true;
	else
		return false;
}


ing ings[100000];
double ats[100000];

int main() {
	freopen(TASK".in", "rt", stdin);
	freopen(TASK".out", "wt", stdout);

	cin.sync_with_stdio(false);

	int n, A, B;
	cin >> n >> A >> B;

	for (int i = 0; i < n; i++)
	{
		cin >> ings[i].g >> ings[i].a >> ings[i].b;
		ings[i].ind = i;
	}

	sort(ings, ings + n, compIng);

	double curB = 0.0, curA = 0.0;

	for (int i = 0; i < n; i++)
	{
		if (ings[i].b == 0)
		{
			curA += ings[i].a * ings[i].g;
			ats[ings[i].ind] = ings[i].g;
		}
		else
		{
			double liko = (double)B - curB;
			double kiek = liko / double(ings[i].b);

			if (dg(kiek, double(ings[i].g)))
			{
				curA += ings[i].a * ings[i].g;
				ats[ings[i].ind] = ings[i].g;

				curB += ings[i].b * ings[i].g;
			}
			else
			{
				curA += ings[i].a * kiek;
				ats[ings[i].ind] = kiek;

				curB += ings[i].b * kiek;
				break;
			}
		}
	}

	cout.precision(10);
	if (dg(curA, A) || de(curA, A))
	{
		cout << fixed << curA << ' ' << curB << endl;
		for (int i = 0; i < n; i++)
			cout << fixed << ats[i] << ' ';
		cout << endl;
	}
	else
	{
		cout << -1 << ' ' << -1 << endl;
	}


	return 0;
}
