#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <list>

typedef unsigned long long ull;

using namespace std;

#define TASK "filter"

#define MAX_N 1000
#define MAX_F 100
#define MAX_M 1000

#define MAX_LLNUM 16 //15,...

int m;

int f;

int a[MAX_F];

int n;

//vector<int> file[MAX_N];
ull file[MAX_N][MAX_LLNUM];

ull needs[MAX_LLNUM];

//vector<int> needs;


//bool is_needed[MAX_M];

bool in_answer[MAX_N];
vector<int> answer;

/*
bool required(int fnr) {
	int pf = 0, pn = 0;
	while (pf < file[fnr].size() && pn < needs.size()) {
		if (file[fnr][pf] == needs[pn])
			return true;
		else if (file[fnr][pf] < needs[pn])
			pf++;
		else
			pn++;
	}
	return false;
}
*/

int llnum;


void printll(ull a[MAX_LLNUM]) {
	for (int i = 0; i < llnum; ++i) {
		for (int j = 0; j < 64; ++j) {
			printf("%d", (a[i] & ((ull)1 << j)) ? 1 : 0);
		}
	}
	printf("\n");
}


int main() {
	freopen(TASK".in", "rt", stdin);
	freopen(TASK".out", "wt", stdout);//TODO

	scanf("%d %d", &m, &f);
	for (int i = 0; i < f; ++i) {
		scanf("%d", &a[i]);//TODO test 2^31-1
	}
	scanf("%d", &n);
	getchar();
	llnum = m / 64 + (m % 64 ? 1 : 0);
	for (int i = 0; i < n; ++i) {
		int num = (m / 4) + (m % 4 ? 1 : 0);
		ull value = 0;
		for (int j = 0; j < num; ++j) {
			char c = getchar();
			//4*j - 4*(j+1)
			int value = (c >= 'a' && c <= 'f') ? c - 'a' + 10 : c - '0';
			file[i][(4 * j) / 64] ^= (ull)value << ((4 * j) % 64);

		}
		//printf("File %d\n", i);
		//printll(file[i]);
		getchar();
	}


	int q;
	scanf("%d", &q);
	for (int i = 0; i < q; ++i) {
		int u;
		scanf("%d", &u);
		
		for (int j = 0; j < llnum; ++j)
			needs[j] = 0;

		for (int j = 0; j < f; ++j) {
			int v = ((long long)u * (long long)a[j]) % m;
			needs[v / 64] |= (ull)1 << (v % 64);
		}
		//printf("Needs:\n");
		//printll(needs);
		for (int j = 0; j < n; ++j) {
			//printll(needs);
			//printll(file[j]);
			bool found = true;
			for (int block = 0; block < llnum; ++block)
				if ((needs[block] & file[j][block]) != needs[block]) {
					//TODO: improve?
					found = false;
					break;
				}
			if (found) {
				//printf("File %d Contains user %d\n", j, i);
				in_answer[j] = true;
			}
		}
	}

	for (int i = 0; i < n; ++i)
		if (in_answer[i])
			answer.push_back(i);

	printf("%d", answer.size());
	for (int i = 0; i < answer.size(); ++i)
		printf(" %d", answer[i]);
	printf("\n");

	return 0;
}