#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <list>

#define TASK "improvements"
#define MAX_N 200000
#define MAX_SQ 448

using namespace std;


int n;
int x[MAX_N];

int to[MAX_N+1];//TODO: 0 values

int sq;

int mto[MAX_SQ];

bool exist(int a, int b) {
	//cout << a << " - " << b << endl;
	int sbegin = a / sq;
	int send = b / sq;
	//cout << "s " << sbegin << " - " << send << endl;

	//inside segments
	for (int i = sbegin + 1; i < send; ++i) {
		//if (mto[i] > b)
			//return true;
	}

	//head
	//cout << "head" << a + 1 << " --- " << min(b, sq*(sbegin + 1)) << endl;
	for (int i = a+1; i < min(b, sq*(sbegin + 1)); ++i) {
		//cout << "h check" << i << endl;
		if (to[i] > b)
			return true;
	}

	for (int i = max(a+1, sq*send); i < b; ++i) {
		if (to[i] > b)
			return true;
	}
	return false;
}

vector<pair<int, int> > r;

int main() {
	freopen(TASK".in", "rt", stdin);
	freopen(TASK".out", "wt", stdout);

	cin >> n;

	for (sq = 1; sq*sq < n; ++sq);
	for (int i = 0; i < n; ++i)
		cin >> x[i];

	for (int i = 0; i + 1 < n; ++i) {
		int a = min(x[i], x[i + 1]);
		int b = max(x[i], x[i + 1]);
		to[a] = b;
	}

	for (int i = 0; i < n; ++i)
		if (to[i] > mto[i/sq])
			mto[i/sq] = to[i];

	r.push_back(make_pair(0, x[0]));

	for (int i = 0; i <= n - 2; i++)
		r.push_back(make_pair(min(x[i], x[i + 1]), max(x[i], x[i + 1])));

	sort(r.begin(), r.end());

	int kiek = 0;

	for (int i = 0; i < r.size(); i++)
	{
		//cout << r[i].first << " " << r[i].second << ": " << exist(r[i].first, r[i].second) << endl;// exist(r[i].first, r[i].second)
		if (exist(r[i].first, r[i].second))
			kiek++;
	}

	//cout << "answer" << endl;
	cout << n - kiek << endl;
	//cout << n - (kiek/2) << endl;

	//cout << exist(0, 1) << endl;

	return 0;
}
