#include <bits/stdc++.h>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

template <typename T1, typename T2> inline bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> inline bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

struct Item {
	int a, b, c;
	Item () {}
	Item (int a, int b, int c): a(a), b(b), c(c) {
	}
};

struct Input {
	int n, A, B;
	ve<Item> f;
	
	bool read () {
		if (!(cin >> n >> A >> B)) {
			return 0;
		}
		forn (i, n) {
			int a, b, c;
			scanf("%d%d%d", &c, &a, &b);
			f.pb(Item(a, b, c));
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	pa<double, double> val;
	ve<double> ans;
		
	void write () {
		if (val.fs < 0) {
			puts("-1 -1");
		}
		else {
			cout << val.fs << " " << val.sc << "\n";
			forn (i, sz(ans)) {
				if (i != 0) {
					cout << " ";
				}
				cout << ans[i];
			}
			cout << "\n";
		}
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

struct Solution: Data {
	
	void solve () {
		vi idx;
		forn (i, n) {
			idx.pb(i);
		}
		sort(all(idx), [&] (int i, int j) {
			return f[i].a * f[j].b > f[j].a * f[i].b;
		});
		ans.resize(n);
		ll e = 0;
		
		bool full = true;
		bool ok;
		forn (i, n) {
			int x = idx[i];
			if (B < f[x].c * f[x].b) {
//				e + (B / f[x].b) * f[x].a >= A
				ok = (A - e) * f[x].b <= ll(B) * f[x].a;
				ans[x] = double(B) / f[x].b;
				full = false;
				break;
			}
			else {
				B -= f[x].c * f[x].b;
				e += f[x].c * f[x].a;
				ans[x] = f[x].c;
			}
		}
		if (full) {
			ok = (e >= A);
		}
		if (!ok) {
			val.fs = val.sc = -1;
		}
		else {
			val.fs = val.sc = 0;
			forn (i, n) {
				val.fs += f[i].a * ans[i];
				val.sc += f[i].b * ans[i];	
			}
		}
	}
	
	void clear ();
};

#ifdef SG

Solution EMPTY_SOL;

void Solution::clear () {
	*this = EMPTY_SOL;
}
#else

void Solution::clear () {
}
#endif

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("b.in", "r", stdin);
//	freopen(".out", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		printf("\n");
		sol.clear();
	}
#else
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif

	return 0;
}
