#include <bits/stdc++.h>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

template <typename T1, typename T2> inline bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> inline bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

const ld pi = 3.1415926535897932384626433832795l;

struct Input {
	ld d, l, r, t, h;
	
	bool read () {
		return cin >> d >> l >> r >> t >> h;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	ld ans;
	
	void write () {
		cout << double(ans / 1e6) << endl;
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

struct Solution: Data {
	static const int K = 300011;
	
	ld alpha;
	ld s;
	ld x, y;
	
	ld fnd (ld h) {
		if (h > d * sinl(alpha)) {
			return 0;
		}
		ld res = 0;
		if (t > 0.5) {
			ld w = h / sinl(alpha);
			ld phi = acosl((d / 2 - w) / (d / 2));
			res -= (phi - sinl(phi)) * d * d / 4 / cosl(alpha);
		}
		ld r0 = sqrtl(r * r - (y - h) * (y - h));
		ld v = r0 - x - h * cosl(alpha) / sinl(alpha);
		ld xi = acosl((r0 - v) / r0);
		res += (xi - sinl(xi)) * r0 * r0;
		return res;
	}
	
	ld calc (ld h) {
		ld res = 0;
		if (t < 0.5) {
			res = l * 2 * sqrtl(d * d / 4 - (h - d / 2) * (h - d / 2));
		} else {
			res = pi * d * d / 4 / cosl(alpha);
		}
		res += fnd(h);
		res += fnd(l * cosl(alpha) + d * sinl(alpha) - h);
		return res;
	}
	
	void solve () {
		ans = 0;
		alpha = acosl(t / l);
		s = sqrtl(max<ld>(0, r * r - d * d / 4));
		y = s * cosl(alpha) + d / 2 * sinl(alpha);
		x = s * sinl(alpha) - d / 2 * cosl(alpha);
		{
			if (x < 0) {
				ans += (2 * pi * (r - y) * r) * r / 3;
				ld v = sqrtl(r * r - y * y);
				ans -= (pi * v * v) * y / 3;
			}
		}
		forn (i, K) {
			ld r = (i + 0.5l) / K * h;
			ans += calc(r) * h / K;
		}
//		debug((pi * d * d / 4 * l + ((r - sqrtl(r * r - d * d / 4)) * 2 * pi * r * r / 3 - pi * d * d / 4 * sqrtl(r * r - d * d / 4) / 3) * 2) / 1e6);
	}
	
	void clear ();
};

#ifdef SG

Solution EMPTY_SOL;

void Solution::clear () {
	*this = EMPTY_SOL;
}
#else

void Solution::clear () {
}
#endif

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
	cerr.precision(5);
	cerr.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("d.in", "r", stdin);
//	freopen(".out", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	freopen("damage.in", "r", stdin);
	freopen("damage.out", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
