#include <bits/stdc++.h>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

template <typename T1, typename T2> inline bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> inline bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

const int N = 1000;

struct Input {
	int m, f;
	int a[N];
	string b[N];
	int n;
	int q;
	int u[N];
	
	bool read () {
		if (!(cin >> m >> f)) {
			return 0;
		}
		forn (i, f) {
			scanf("%d", &a[i]);
		}
		scanf("%d\n", &n);
		forn (i, n) {
			getline(cin, b[i]);
		}
		scanf("%d", &q);
		forn (i, q) {
			scanf("%d", &u[i]);
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	vi ans;
	
	void write () {
		printf("%d", sz(ans));
		forn (i, sz(ans)) {
			printf(" %d", ans[i]);
		}
		printf("\n");
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

struct Solution: Data {
	bool res[N];
	bool g[N][N];
	
	void process (ll x) {
		forn (i, n) {
			bool ok = 1;
			for (int j = 0; ok && j < f; ++j) {
				ok &= g[i][(x * a[j]) % m];
			}
			res[i] |= ok;
		}
	}
	
	int toNum (char c) {
		if (c >= '0' && c <= '9') {
			return c - '0';
		}
		return c - 'a' + 10;
	}
	
	void solve () {
		memset(res, 0, sizeof(res));
		memset(g, 0, sizeof g);
		
		forn (i, n) {
			forn (j, sz(b[i])) {	
				int x = toNum(b[i][j]);
				forn (k, 4) {
					g[i][j * 4 + k] = (x & (1 << k));
				}
			}
		}
		
		forn (i, q) {
			process(u[i]);
		}
		forn (i, n) {
			if (res[i]) {
				ans.pb(i);
			}
		}
	}
	
	void clear ();
};

#ifdef SG

Solution EMPTY_SOL;

void Solution::clear () {
	*this = EMPTY_SOL;
}
#else

void Solution::clear () {
}
#endif


Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
    freopen("f.in", "r", stdin);
//	freopen(".out", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
