#include <bits/stdc++.h>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

struct Input {
	int n, m;
	ve<pii> a;
	ve<pa<int, pii> > b;
	
	bool read () {
		if (!(cin >> n >> m)) {
			return 0;
		}
		a.resize(n);
		forn (i, n) {
			scanf("%d%d", &a[i].fs, &a[i].sc);
		}
		b.resize(m);
		forn (i, m) {
			scanf("%d%d%d", &b[i].sc.fs, &b[i].sc.sc, &b[i].fs);
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	vi ans;
	
	void write () {
		forn (i, sz(ans)) {
			printf("%d\n", ans[i]);
		}
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

struct Solution: Data {
	
	void solve () {
		forn (i, m) {
			vi c;
			forn (j, n) {
				ll d = abs(a[j].sc - a[j].fs);
				int dx = (a[j].sc > a[j].fs ? 1 : -1);
				ll e = b[i].fs % (2 * d);
				if (e > d) {
					c.pb(a[j].sc - dx * (e - d));
				}
				else {
					c.pb(a[j].fs + dx * e);
				}
			}
			int cnt = 0;
			forn (j, n) {
				if (b[i].sc.fs <= c[j] && c[j] <= b[i].sc.sc) {
					++cnt;
				}
			}
			ans.pb(cnt);
		}
	}
	
	void clear ();
};

#ifdef SG

Solution EMPTY_SOL;

void Solution::clear () {
	*this = EMPTY_SOL;
}
#else

void Solution::clear () {
}
#endif

Solution sol;

int main () {
#ifdef SG
	freopen("k.in", "r", stdin);
//	freopen(".out", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		printf("\n");
		sol.clear();
	}
#else
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
