#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <string>
#include <map>
#include <set>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;


#define pb(a) push_back((a))
#define mp(a, b) make_pair((a), (b))

#define FOR(i, n) for (int i = 0; i < (n); ++i)

struct state {
	char move;
	int next[3];
};

int n;
state opp[50];
state ans[50000];
int cl[50], new_cl[50];
vector<pair<int, int> > find_state;
int last;
vector<int> v[50000];
int has_st = 1, has_cl = 1;

void bfs() {
	queue<int> q;
	q.push(0);
	for (int i = 0; i < 200 && !q.empty(); ++i) {
		int pos = q.front();
		q.pop();
		vector<int> t[3];
		for (int k = 0; k < v[pos].size(); ++k) {
			int cur = v[pos][k];
			t[opp[cur].move - 'P'].push_back(cur);
		}
		if (t[0].size() != v[pos].size() && t[1].size() != v[pos].size() && t[2].size() != v[pos].size()) {
			ans[pos].move = 'P';
			for (int j = 0; j < 3; ++j) {
				if (t[j].size() != 0) {
					for (int k = 0; k < t[j].size(); ++k) {
						v[has_st].push_back(t[j][k]);
						cl[t[j][k]] = has_cl;
					}
					ans[pos].next[j] = has_st;
					++has_st;
					++has_cl;
				}
				else
					ans[pos].next[j] = pos;
			}
		}
		else {
			int j;
			for (j = 0; j < 3; ++j) {
				if (t[j].size() == v[pos].size())
					break;
			}
		}
	}
}

void solve_e() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> opp[i].move;
		cin >> opp[i].next[1] >> opp[i].next[0] >> opp[i].next[2];
		cl[i] = 0;
	}
}



/*void solve_i() {
	int n;
	cin >> n;
	vi v(n);
	for (int i = 0; i < n; ++i) {
		cin >> v[i];
	}

	vi sumin(n), sumax(n);
	int cur_max = 0;
	int cur_min = n + 1;

	for (int i = n - 1; i >= 0; --i) {
		cur_max = max(cur_max, v[i]);
		cur_min = min(cur_min, v[i]);
		sumin[i] = cur_min;
		sumax[i] = cur_max;
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		if (v[i] == sumin[i] || v[i] == sumax[i]) ++ans;
	}
	cout << ans << endl;

}*/
int inf = 1000000;
vi find_dp_1(vi a) {
	a.pb(inf);
	vi dp(a.size(), inf);
	dp[0] = a[0];
	for (int i = 1; i < a.size(); ++i) {
		*(lower_bound(dp.begin(), dp.end(), a[i])) = a[i];
	}
	return dp;
}

vi find_dp_2(vi a) {
	a.pb(-inf);
	vi dp(a.size(), -inf);
	dp[0] = a[0];
	for (int i = 1; i < a.size(); ++i) {
		(*(lower_bound(dp.rbegin(), dp.rend(), a[i]))) = a[i];
	}
	return dp;
}


void solve_i() {
	int n;
	cin >> n;
	vi v(n);
	for (int i = 0; i < n; ++i) {
		cin >> v[i];
	}
	vi dp1 = find_dp_1(v);
	for (int i = 0; i < v.size(); ++i) {
		v[i] *= -1;
	}
	vi dp2 = find_dp_1(v);
	for (int i = 0; i < dp2.size(); ++i) {
		dp2[i] = -dp2[i];
	}
	vi ans1(n + 1, 0), ans2(n + 1, 0);
	for (int i = 0; i < dp1.size(); ++i) {
		if (abs(dp1[i]) <= n) {
			ans1[dp1[i]] = i + 1;
		}
	}

	for (int i = 0; i < dp2.size(); ++i) {
		if (abs(dp2[i]) <= n) {
			ans2[dp2[i]] = i + 1;
		}
	}
	int cur_max_1 = 0, cur_max_2 = 0;

	for (int i = 0; i < n + 1; ++i) {
		cur_max_1 = max(cur_max_1, ans1[i]);
		cur_max_2 = max(cur_max_2, ans2[n - i]);
		ans1[i] = cur_max_1;
		ans2[n - i] = cur_max_2;
	}

	int ans = 0;
	for (int i = 0; i < n + 1; ++i) {
		ans = max(ans, ans1[i] + ans2[i] - 1);
	}

	cout << ans << endl;
}

string taskname = "improvements";

int main() {
#ifdef LOCAL_DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen((taskname + ".in").c_str(), "r", stdin);
	freopen((taskname + ".out").c_str(), "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	solve_i();
	return 0;
}