#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <string>
#include <map>
#include <set>
#include <cstdlib>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;


#define pb(a) push_back((a))
#define mp(a, b) make_pair((a), (b))

#define FOR(i, n) for (int i = 0; i < (n); ++i)

vector<int> c(51);
vector<int> cur;
vector<bool> used;
string s;
int n;

bool brute(int pos) {
	if (cur.size() == n)
		return true;
	if (pos >= s.length())
		return false;
	int dig = s[pos] - '0';
	if (dig > 0 && dig <= n && !used[dig]) {
		used[dig] = true;
		cur.push_back(dig);
		if (brute(pos + 1))
			return true;
		used[dig] = false;
		cur.pop_back();
	}
	if (pos + 1 < s.length()) {
		int numb = 10 * (s[pos] - '0') + s[pos + 1] - '0';
		if (numb >= 10 && numb <= n && !used[numb]) {
			used[numb] = true;
			cur.push_back(numb);
			if (brute(pos + 2))
				return true;
			used[numb] = false;
			cur.pop_back();
		}
	}
	return false;
}

void solve_j() {
	c[0] = 0;
	for (int i = 1; i <= 50; ++i) {
		c[i] = c[i - 1] + 1;
		if (i >= 10)
			++c[i];
	}
	cin >> s;
	n = find(c.begin(), c.end(), s.length()) - c.begin();
	used.assign(n + 1, false);
	brute(0);
	for (int i = 0; i < n; ++i)
		cout << cur[i] << " ";
}

string taskname = "joke";

int main() {
#ifdef LOCAL_DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen((taskname + ".in").c_str(), "r", stdin);
	freopen((taskname + ".out").c_str(), "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	//for (int i = 0; i < 50; ++i)
	//	cout << i + 1;
	solve_j();
	return 0;
}