import java.awt.Point;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class A {

	static BufferedReader in;
	static StringTokenizer st;
	static PrintWriter out;
	static String filename = "alter";

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	public static void main(String[] args) throws IOException {
		in = new BufferedReader(new FileReader(new File(filename + ".in")));
		out = new PrintWriter(new FileWriter(new File(filename) + ".out"));
		int n = nextInt();
		int m = nextInt();
		ArrayList<Point> white = new ArrayList<Point>();
		ArrayList<Point> black = new ArrayList<Point>();
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= m; j++) {
				if ((i + j) % 2 == 0) {
					white.add(new Point(i, j));
				} else {
					black.add(new Point(i, j));
				}
			}
		}
		int min = Math.min(white.size(), black.size());
		out.print(min);
		out.println();
		if (min == white.size()) {
			for (int i = 0; i < min; i++) {
				out.println(white.get(i).x + " " + white.get(i).y + " "
						+ white.get(i).x + " " + white.get(i).y);
			}
		} else {
			for (int i = 0; i < min; i++) {
				out.println(black.get(i).x + " " + black.get(i).y + " "
						+ black.get(i).x + " " + black.get(i).y);
			}
		}
		out.close();
	}
}
