import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.StringTokenizer;

public class F {
	static BufferedReader in;
	static StringTokenizer st;
	static PrintWriter out;
	static String filename = "filter";
	static int tmp[][] = new int[2000][2000];
	static int b[][] = new int[2000][2000];
	static int current[] = new int[2000];
	static boolean xit[] = new boolean[2000];

	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new File(filename + ".in"));
		out = new PrintWriter(new File(filename + ".out"));
		int ID;
		int a[] = new int[2000];
		int m = in.nextInt();
		int f = in.nextInt();
		for (int i = 0; i < f; i++) {
			a[i] = in.nextInt();
			a[i] %= m;
		}
		int n = in.nextInt();
		int mx = 0;
		for (int i = 0; i < n; i++) {
			String s = in.next();
			for (int j = 0; j < s.length(); j++) {
				int x = get(s.charAt(j));
				for (int k = 0; k < 4; k++) {
					tmp[i][j * 4 + k] = (x & 1);
					x >>= 1;
				}
			}
			int id = 0;
			for (int j = 0; j < m; j++) {
				if (j > 0 && j % 31 == 0)
					id++;
				mx = Math.max(mx, id);
				b[i][id] <<= 1;
				b[i][id] |= tmp[i][j];
			}
		}
		mx++;
		int q = in.nextInt();
		while (q-- != 0) {
			ID = in.nextInt();
			ID %= m;
			for (int i = 0; i < m; i++)
				current[i] = 0;
			for (int j = 0; j < f; j++)
				current[(ID * a[j]) % m] = 1;
			for (int i = 0; i < n; i++) {
				if (xit[i])
					continue;
				boolean ok = true;
				for (int j = 0; j < m; j++) {
					if (tmp[i][j] == 0 && current[j] == 1) {
						ok = false;
						break;
					}
				}
				xit[i] = ok;
			}
		}
		int res = 0;
		for (int i = n - 1; i >= 0; i--)
			if (xit[i])
				res++;
		out.print(res + " ");
		for (int i = 0; i < n; i++) {
			if (xit[i])
				out.print(i + " ");
		}
		out.close();
	}

	private static int get(char x) {
		return x >= 48 && x <= 56 ? x - 48 : x - 'a' + 10;
	}
}
