
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <string>
#include <vector>
#include <cstdio>
#include <queue>
#include <stack>
#include <cmath> 
#include <ctime>
#include <map>
#include <set>
 
#define ll long long
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define ppb pop_back
#define fname "burrito"
 
using namespace std;
 
const double pi = acos(-1.0);
const ll maxn = (ll)(1e5 + 1111);
const double eps = (1e-9);
 
ll n, A, B, a[maxn], b[maxn], g[maxn], o[maxn];
pair < pair < double, ll >, pair < ll, pair < ll, ll >  > > c[maxn];
double s[maxn], ta, tb;
 
int comp(double a, double b) {
    if (abs(a - b) < eps)
        return 0;
    if (a < b)
        return -1;
    return 1;
}
 
int main() {
    freopen(fname".in", "r", stdin);
    freopen(fname".out", "w", stdout);
    cin >> n >> A >> B;
    for (int i = 0; i < n; ++i) {
        cin >> c[i].s.f >> c[i].f.s >> c[i].s.s.f;
        c[i].s.s.s = i;
        c[i].f.f = min(1.0 * B/ c[i].s.s.f, c[i].s.f + 0.0) * (c[i].f.s - c[i].s.s.f);
        c[i].f.f *= -1;
        c[i].f.s *= -1;
    }
 
    sort(c, c + n);
 
    for (int i = 0; i < n; ++i) {
        g[i] = c[i].s.f;
        a[i] = -c[i].f.s;
        b[i] = c[i].s.s.f;
        o[i] = c[i].s.s.s;
    }
 
    for (int i = 0; i < n; ++i) {
        double wa = a[i] * g[i];
        double wb = b[i] * g[i];
 
        if (comp(tb + wb, B) <= 0) {
            tb += wb;
            ta += wa;   
            s[o[i]] = g[i];
        } else {
            double L = 0, R = g[i], ans = 0; 
            for (int j = 0; j < 100; ++j) {
                double M = (L + R) / 2.0;
                wa = a[i] * M;
                wb = b[i] * M;
 
                if (comp(tb + wb, B) <= 0) {
                    ans = M;
                    L = M + eps;
                } else {
                    R = M - eps;
                }
            }
            wa = a[i] * ans;
            wb = b[i] * ans;
            ta += wa;
            tb += wb;
            s[o[i]] = ans;
        }
    }
 
    if (comp(ta, A) < 0 || comp(tb, B) > 0) {
        cout << -1 << ' ' << -1;
        return  0;
    }
 
    printf("%.8f %.8f\n", ta, tb);
    for (int i = 0; i < n; ++i)
        printf("%.8f ", s[i]);
 
 
    return 0;
}