#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <string>
#include <vector>
#include <cstdio>
#include <queue>
#include <stack>
#include <cmath> 
#include <ctime>
#include <map>
#include <set>

#define ll long long
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define ppb pop_back
#define fname "filter"

using namespace std;

const double pi = acos(-1.0);
const ll maxn = (ll)(2e3);

ll m, f, a[maxn], n, q, u[maxn], b[1010][101]; 
string d[maxn];
vector < int > c[1010];
vector < int > ans;

vector < int > get(char x) {
	int val = 0;
	if (isdigit(x))
		val = x - '0';
	else
		val = x - 'a' + 10;

	vector < int > res;

	while (val > 0) {
		res.pb(val % 2);
		val /= 2;
	}

	while (res.size() < 4)
		res.pb(0);

	return res;
}                      

int main() {
	freopen(fname".in", "r", stdin);
	freopen(fname".out", "w", stdout);
	cin >> m >> f;
	for (int i = 0; i < f; ++i)	
		cin >> a[i];

	cin >> n;
	
	for (int i = 0; i < n; ++i)
		cin >> d[i];

	cin >> q;

	for (int i = 0; i < q; ++i)
		cin >> u[i];

	for (int i = 0; i < q; ++i) {
		for (int j = 0; j < f; ++j)
			b[i][j] = (u[i] * a[j]) % m;
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < d[i].size(); ++j) {
			vector < int > temp = get(d[i][j]);
			for (int k = 0; k < temp.size(); k++)
				c[i].pb(temp[k]);								
		}
	}
	

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < q; ++j) {
			bool flag = true;
			for (int k = 0; k < f; ++k) {
				int tmp = b[j][k];
				if (c[i][tmp] != true) {
					flag = false;
					break;
				}
			}

			if (flag) {
				ans.pb(i);
				break;
			}
		}
	}

	cout << ans.size() << ' ';
	for (int i = 0; i < ans.size(); ++i)
		cout << ans[i] << ' ';


	return 0;
}





