#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <string>
#include <vector>
#include <cstdio>
#include <queue>
#include <stack>
#include <cmath> 
#include <ctime>
#include <map>
#include <set>

#define ll long long
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define ppb pop_back
#define fname "joke"

using namespace std;

const double pi = acos(-1.0);
const ll maxn = (ll)(1e5);

string s;
int a[1000], len, m;
int ans[1000];
bool used[1000];

bool check() {
	int mx = ans[0];

	for (int i = 1; i < m; ++i)
		mx = max(mx, ans[i]);
	
	if (mx != m)
		return false;

	for (int i = 1; i <= mx; ++i)
		if (!used[i])
			return false;

	return true;
}

void rec(ll pos, ll k) {
	ll x = a[pos];
	if (k == 1)
		x = x * 10 + a[pos + 1];
	if (used[x]) return;

	used[x] = true;
	ans[m++] = x;

	if (pos + k < len - 1) {
		for (int i = 0; i < 2; ++i)
			rec(pos + k + 1, i);
	} else {
		if (check()) {
			for (int i = 0; i < m; ++i)
				cout << ans[i] << ' ';
			exit(0);
		}
	}

	used[x] = false;
	m--;
}

int main() {
	freopen(fname".in", "r", stdin);
	freopen(fname".out", "w", stdout);
	cin >> s;
	len = s.length();

	for (int i = 0; i < len; ++i)
		a[i] = s[i] - '0';

	for (int i = 0; i < 2; ++i)
		rec(0, i);			

	for (int i = 0; i < len; ++i)
		cout << a[i] << ' ';

	return 0;
}
