//#include <iostream>
#include <fstream>
#include <algorithm>

using namespace std;


ifstream cin ("knockout.in");
ofstream cout("knockout.out");


struct Q {
	int x, y, t, ind;
};

struct Car
{
	int x, y;
	int pos, up;

	Car(int x1 = 0, int y1 = 0)
	{
		x = x1, y = y1;
		if (x > y)
			up = false;
		else
			up = true;
		pos = x;
	}

	void move()
	{
		if (up)
		{
			if (pos == y)
			{
				up = false;
				pos = y - 1;
			}
			else
				pos++;
		}
		else
		{
			if (pos == x)
			{
				up = true;
				pos = x + 1;
			}
			else
				pos--;
		}
	}
};

Car cars[1001];
Q qs[1001];
int max_seconds = 0;
int n, m;
int ans[1001];

bool cmp(Q a, Q b)
{
	return a.t < b.t;
}

int main()
{
	cin >> n >> m;
	for (int i = 0; i<n; i++)
	{
		int x1, y1;
		cin >> x1 >> y1;
		cars[i] = Car(x1, y1);
	}

	for (int i = 0; i<n; i++)
	{
		cin >> qs[i].x >> qs[i].y >> qs[i].t;
		qs[i].ind = i;
		if (max_seconds < qs[i].t)
			max_seconds = qs[i].t;
	}

	sort(qs, qs + m, cmp);

	int ind = 0;
	for (int i = 0; i <= max_seconds; i++)
	{
		while (i == qs[ind].t)
		{
			int c = 0;
			for (int j = 0; j < n; j++)
				if (cars[j].pos <= qs[ind].y && cars[j].pos >= qs[ind].x)
				{
					c++;
				}

			ans[qs[ind].ind] = c;
			ind++;
		}

		for (int i = 0; i<n; i++)
			cars[i].move();
	}

	for (int i = 0; i<m; i++)
		cout << ans[i] << endl;

	return 0;
}
