#include <iostream>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <vector>
#include <cstdio>

using namespace std;

struct Ver {

	int index;
	double a, b, g;

	bool operator < (const Ver &A) const {
		if (a * A.b == b * A.a) return (g * b > A.b * A.g);
		return (a / b > A.a / A.b);
	}

} Z[100100];

double c[100100], s[100100];

int main() {
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	int N, A, B;
	cin >> N >> A >> B;
	for (int i = 0; i < N; i++) {
		Z[i].index = i;
		cin >> Z[i].g >> Z[i].a >> Z[i].b;
	}
	sort(Z, Z + N);
	double left = B, sumA = 0, sumB = 0;
	for (int i = 0; i < N; i++) {
//		cout << Z[i].g << " " << Z[i].a << " " << Z[i].b << endl;
		if (left <= Z[i].g * Z[i].b) {
			c[i] = left;
			left = 0;
		} else {
			c[i] = Z[i].g * Z[i].b;
			left -= c[i];
		}
		s[i] = c[i] / Z[i].b;
		sumA += s[i] * Z[i].a;
		sumB += c[i];
	}
	if (sumA < A) {
		cout << "-1 - 1\n";
		return 0;
	}
	printf("%.8f %.8f\n", sumA, sumB);  

	for (int i = 0; i < N; i++) {
		c[Z[i].index] = s[i];
	}
	for (int i = 0; i < N; i++) {
		printf("%.8f ", c[i]);  
	}

	return 0;
}
