#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <vector>
#include <queue>
#include <iostream>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef pair<int,int> pt;
typedef vector<int> vi;

const int inf = 1<<30;
const int N = 1<<17;

int a[111], ok[1111], an[1111], b[1111][1111], pos[111];
int m, f, n, ans,q,x;
string s[1111];
map <char, int > bit[4];

#define Bit(c, i) ((c)&((1)<<(i)))>0

int main() {
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);

	cin >> m >> f;
	for (int i = 0; i < f; i++) {
		cin >> a[i];
	}

	int c = 0;
	for (char ch = '0'; ch <= '9'; ch++) {
		for (int i = 0; i < 4; i++)
			bit[i][ch] = Bit(c, i);
		c++;
	}

	c = 10;
	for (char ch = 'a'; ch <= 'f'; ch++) {
		for (int i = 0; i < 4; i++)
			bit[i][ch] = Bit(c, i);
		c++;
	}

	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> s[i];
		for (int j = 0; j < s[i].length(); j++) {
			b[i][j * 4 + 0] = bit[0][s[i][j]];
			b[i][j * 4 + 1] = bit[1][s[i][j]];
			b[i][j * 4 + 2] = bit[2][s[i][j]];
			b[i][j * 4 + 3] = bit[3][s[i][j]];
		}
	}

	cin >> q;
	for (int Q = 0; Q < q; Q++) {
		cin >> x;
		for (int i = 0; i < f; i++)
			pos[i] = (x * a[i]) % m;
		for (int i = 0; i < n; i++) {
			int cnt = 0;
			for (int j = 0; j < f; j++)
				if (b[i][pos[j]])
					cnt++;
			if (cnt == f)
				ok[i] = 1;
		}
	}

	for (int i = 0; i < n; i++)
		if (ok[i]) {
			an[ans++] = i;
		}

	cout << ans << " ";
	for (int i = 0; i < ans; i++)
		cout << an[i] << " ";

	return 0;
}
