#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <vector>
#include <queue>
#include <iostream>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef pair<int,int> pt;
typedef vector<int> vi;

const int inf = 1<<30;
const int N = 1<<17;

int len[51];
vector<int> pos[51];
int val[N];
int ans[N], n;
string s;

void go(int x) {
	if (x == 0) {
		vi v;
		for (int i = 0; i < sz(s); i++) {
			if (ans[i]) {
				cout << ans[i] << " ";
				v.pb(ans[i]);
			}
		}
		sort(all(v));
		assert(sz(v) == n);
		for (int i = 0; i < n; i++)
			assert(v[i] == i+1);
		exit(0);
	}
	for (int i = 0; i < sz(pos[x]); i++) {
		int j = pos[x][i];
		bool ok = 1;
		for (int k = 0; k < len[x]; k++)
		if (val[j + k] == 1) ok = 0;
		if (ok) {
			for (int k = 0; k < len[x]; k++)
				val[j + k] = 1;
			ans[j] = x;
			go(x-1);
			for (int k = 0; k < len[x]; k++)
				val[j + k] = 0;
			ans[j] = 0;
		}
	}
}

int main() {
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);

	cin >> s;

	for (int i = 1; i <= 9; i++)
		len[i] = 1;

	for (int i = 10; i <= 50; i++)
		len[i] = 2;

	for (int i = 1, sum = 0; i <= 50; i++) {
		sum += len[i];
		if (sum == sz(s)) {
			n = i;
			break;
		}
	}

	char buf[100];
	for (int i = n; i >= 1; i--) {
		sprintf(buf, "%d", i);
		string t = string(buf);
		for (int j = 0; j + sz(t) <= sz(s); j++)
			if (s.substr(j, sz(t)) == t)
				pos[i].pb(j);
	}

/*	for (int i = 1; i <= n; i++, cout << endl)
		for (int j = 0; j < sz(pos[i]); j++)
			cout << pos[i][j] << " ";exit(0);*/

	go(n);

	return 0;
}