#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <ctime>
#include <utility>
#include <cassert>
#include <vector>

#define F first
#define S second
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long LL;
typedef pair <int, int> pii;

const int inf = (int)1e9;
const int mod = (int)1e9 + 7;
const int maxn = (int)1e6;
const double eps = 1e-11;

#define fname "burrito."

struct doner
{
	int a, b, g, p;
} t[maxn];

int n;
long double ans[maxn], ans1[maxn], a1, b1, A, B, a, b, cnt;

bool cmp(doner v, doner u)
{
	return v.a * u.b > u.a * v.b;
}

bool cmp2(doner v, doner u)
{
	return v.a - v.b > u.a - u.b;
}

bool isEqual(double x, double y) {
	if (abs(x - y) < eps)
		return true;
	return false;
}


int main() {
	freopen(fname"in", "r", stdin);
	freopen(fname"out", "w", stdout);

	cin >> n;
	cin >> A >> B;
	for (int i = 1; i <= n; i++)
	{
		cin >> t[i].g >> t[i].a >> t[i].b;
		t[i].p = i;
	}

	sort(t + 1, t + 1 + n, cmp);
	b = B;

	for (int i = 1; i <= n; i++)
	{
		cnt = min(b / (t[i].b + 0.0), (long double)t[i].g);
		b -= cnt * t[i].b;
		a += cnt * t[i].a;
		ans[t[i].p] = cnt;
	}

	sort(t + 1, t + 1 + n, cmp2);
	b1 = B;
	a1 = 0;

	for (int i = 1; i <= n; i++)
	{
		cnt = min(b1 / (t[i].b + 0.0), (long double)t[i].g);
		b1 -= cnt * t[i].b;
		a1 += cnt * t[i].a;
		ans1[t[i].p] = cnt;
	}


	if (a1 > a)
	{
		a = a1;
		b = b1;
		for (int i = 1; i <= n; i++)
			ans[i] = ans1[i];
	}

	if (!isEqual(a, A) && a < A)
	{
		cout << -1 << " " << -1;
		return 0;
	}
	printf("%.11f %.11f\n", (double)a, (double)(B - b));
	for (int i = 1; i <= n; i++)
		printf("%.11f ", (double)ans[i]);
	return 0;
}
