#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <ctime>
#include <utility>
#include <cassert>
#include <vector>

#define F first
#define S second
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long LL;
typedef pair <int, int> pii;

const int inf = (int)1e9;
const int mod = (int)1e9 + 7;
const int maxn = (int)1e6;
const double eps = 1e-9;

#define fname "improvements."

int n, l, r, ans, was[maxn], a[maxn];

int main() {
	freopen(fname"in", "r", stdin);
	freopen(fname"out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	l = 1;
	r = n;
	ans = n;
	for (int i = 1; i <= n; i++)
	{
		cin >> a[i];
		while (was[l])
			l++;
	   	while (was[r])
	   		r--;
		if (a[i] == l)
		{
			l++;
			continue;
		}	
		if (a[i] == r)
		{
			r--;
	   		continue;
	   	}
	   	was[a[i]] = 1;
	   	ans--;
	}

	cout << ans;
	return 0;
}
