#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <ctime>
#include <utility>
#include <cassert>
#include <vector>

#define F first
#define S second
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long LL;
typedef pair <int, int> pii;

const int inf = (int)1e9;
const int mod = (int)1e9 + 7;
const int maxn = (int)1e6;
const double eps = 1e-9;

#define fname "joke."

int c[20], cnt[20], n, len, a[200];
string s;

void calc(int x) {
	while (x) {
		c[x % 10]++;
		x /= 10;
	}
	return;
}

bool check(int v) {
	for (int i = 0; i < 10; ++i)
		c[i] = 0;
	for (int i = 1; i <= v; ++i)
		calc(i);

	for (int i = 0; i < 10; ++i)
		if (cnt[i] != c[i])
			return false;
	return true;
}

int used[200];

void rec(int cur, int v) {
	if (cur == len) {
		for (int i = 1; i <= n; ++i)
			cout << a[i] << ' ';
		exit(0);
	}
	if (!used[s[cur] - '0'] && s[cur] - '0' <= n) {
		used[s[cur] - '0'] = true;
		a[v] = s[cur] - '0';
		rec(cur + 1, v + 1);
		used[s[cur] - '0'] = false;
	}
	if (cur + 1 < len && (s[cur] - '0') * 10 + s[cur + 1] - '0' <= n && !used[(s[cur] - '0') * 10 + s[cur + 1] - '0']) {
		used[(s[cur] - '0') * 10 + s[cur + 1] - '0'] = true;
		a[v] = (s[cur] - '0') * 10 + s[cur + 1] - '0';
		rec(cur + 2, v + 1);
		used[(s[cur] - '0') * 10 + s[cur + 1] - '0'] = false;
	}
	return;
}

int main() {
	freopen(fname"in", "r", stdin);
	freopen(fname"out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> s;
	len = (int)s.length();

	for (int i = 0; i < len; ++i)
		cnt[s[i] - '0']++;

	for (int i = 1; i <= 50; ++i)
		if (check(i)) {
			n = i;
			break;
		}

	rec(0, 1);

	return 0;
}
