#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <bitset>
#include <vector>
#include <string>
#include <cmath>
#include <ctime>
#include <map>
#include <set>

#define sz 2000000
#define pb push_back
#define ll long long
#define mk make_pair
#define sqr(x) (x)*(x)
#define s second
#define fname "filter"
#define vi vector<int>
#define pii pair<int, int>
#define tp(x) typeof(x)
#define all(x) (x).begin(),(x).end()

using namespace std;


int  a[4000], x, n, m;
string s;
int d[4000];
vector <int> v;
int f;
int w[4000];
int cntblocks;
int mask[4100][4000];
int nmask[4000];
int cnt;
int q;
int ans;


int F(char ch) {
 	if (isdigit(ch)) return ch - '0';
 	return ch - 'a' + 10;
} 
void add(string &s) {
	int len;
	if (m % 4 != 0) len = x - 1; else len = x;
 	v.clear();


 	for (int i = 0; i < len; i++) {
 	 	int p = F(s[i]);
 	 	int l = 0;
 	 	while (p) {
 	 	 	d[++l] = p % 2;
 	 	 	p /= 2;
 	 	}
 	 	while (l < 4) d[++l] = 0;
 	 	for (int t = 1; t <= l; t++)
 	 		v.pb(d[t]);
 	}

 	if (m%4 != 0) {
 	   	int p = F(s[len]);
 	 	int l = 0;
 	 	while (p) {
 	 	 	d[++l] = p % 2;
 	 	 	p /= 2;
 	 	}
 	 	while (l < m%4) d[++l] = 0;
 	 	
 	 	for (int t = 1; t <= l; t++)
 	 		v.pb(d[t]);
 	}	
 	cnt++;
 	memset(mask[cnt], 0, sizeof mask[cnt]);
 	for (int i = 0; i < v.size(); i++)
	{
		//cout << v[i]<<" ";
		//	if (i > 9) cout << " ";
		int block = i / 30;
		if (v[i]) mask[cnt][block] |= (1 << (i % 30)); 
    }
}
void upd(){
 	for (int i = 0; i <= m/30 +4; i++)
 	nmask[i] = 0;
}
void fadd(int x)  {
     int block = x / 30;
     nmask[block] |= (1 << (x % 30));
}	
void out(int x) {
 	
 	for (int i = 0; i < 30; i++)
 		if (x & (1 << i)) cerr << 1; else cerr << 0;
}
bool check(int x) {
 	for (int i = 0; i <= cntblocks; i++)
 		if ((mask[x][i] | nmask[i])!=mask[x][i]) return 0;
 	return 1;
}
int main() {
	freopen(fname".in", "r", stdin);
	freopen(fname".out", "w", stdout);
	cin >> m >> f;
	for (int i = 0; i < f; i++)	
		cin >> a[i];

	cntblocks = m / 30 + 4;

	x = (m + 3) / 4;
    cin >> n;
    for (int i = 1; i <= n; i++){
    	cin >> s;
    	add(s);
	}	
	cin >> q;


	for (int T = 1; T <= q; T++) {
	 	cin >> x;
	 	upd();
	 	for (int i = 0; i < f; i++) {
	 	 	int j = (x * 1ll * a[i]) % m;
	 //	    cerr << j <<" " ;
	 		fadd(j);
	 	}
	 for (int i = 1; i <= n; i++)
	 		if (!w[i] && check(i)) { w[i] = 1; }//cerr << i << " "<< x << endl;}
	}                                                         

	for (int i = 1; i <= n; i++)
		if (w[i]) ans++;
	cout << ans << endl;;
	
	for (int i = 1; i <= n; i++)	
		if (w[i])
			cout << i - 1 << " ";
	return 0;
}
