import java.io.*;
import java.util.*;

public class a {
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	public String next() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (Exception e) {
				// TODO: handle exception
			}
		}
		return st.nextToken();
	}

	public int nextInt() {
		return Integer.parseInt(next());
	}

	public long nextLong() {
		return Long.parseLong(next());
	}

	String bin(char c) {
		int x=0;
		if ('0'<= c && c <='9') {
			x = c - '0'; 
		} else {
			x = c -'a' + 10; 
		}
		
		String r = ""; 
		for (int i=0; i<4; i++) {
			if (x % 2 == 1) r =  r + "1"; else r =  r + "0";  
			x/=2; 
		}
		return r; 
	}
	
	public void run() throws Exception {
		in = new BufferedReader(new FileReader("filter.in"));
		out = new PrintWriter(new FileWriter("filter.out"));
			int m = nextInt(); 
			int f = nextInt();
			int[] a = new int[f];
			for (int i=0; i<f; i++) a[i] = nextInt();
			
			int n = nextInt();
			
			
			boolean[][] g = new boolean[n][m+10];
			for (int i=0; i<n; i++) {
				String s = next();
				int t=0; 
				for (int j=0; j<s.length(); j++) {
					String st = bin(s.charAt(j));
//					System.err.println(st + " " + s.charAt(j) );
					for (int p=0; p<4; p++) {
						g[i][t]=(st.charAt(p)=='1'); 
						t++;
					}
				}
			}
			
			int q = nextInt();
			
			TreeSet<Integer> ans = new TreeSet<Integer>(); 
			
			for (int i=0; i<q; i++) {
				int u = nextInt();
				for (int j=0; j<n; j++) {
					boolean ok = true; 
					for (int k=0; k<f; k++) {
						int r = (u * a[k]) % m;
						ok &= (g[j][r]);  
					}
					
					if (ok) ans.add(j);
				}
			}
			out.print(ans.size()+" ");
			
			for (Integer p : ans) {
				out.print(p + " "); 
			}
		out.close();
	}

	public static void main(String[] args) throws Exception {
		new a().run();
	}
}
