import static java.lang.Math.*;
import java.io.*;
import java.util.*;

public class a {
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	boolean debug = false;

	public String next() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (Exception e) {
				// TODO: handle exception
			}
		}
		return st.nextToken();
	}

	public int nextInt() {
		return Integer.parseInt(next());
	}

	public long nextLong() {
		return Long.parseLong(next());
	}

	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader("improvements.in"));
		out = new PrintWriter(new FileWriter("improvements.out"));

		int n = nextInt();
		int[] a = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextInt() - 1;
		}

		int l = 0, r = n - 1;
		boolean[] skip = new boolean[n];
		for (int i = 0; i < n; i++) {
			if (skip[i]) {
				continue;
			}
			while (skip[l]) {
				l++;
			}
			while (skip[r]) {
				r--;
			}
			if (a[i] != l && a[i] != r) {
				int c = 1;
				int x = a[i] - l;
				int y = r - a[i];
				int z = min(x, y);
				while (a[i + c] != l && a[i + c] != r) {
					if (c > z) {
						break;
					}
					c++;
				}

				if (c <= z) {
					c = 0;
					while (a[i + c] != l && a[i + c] != r) {
						skip[a[i + c]] = true;
						c++;
					}
				} else {
					if (x > y) {
						for (int j = a[i] + 1; j <= r; j++) {
							skip[j] = true;
						}
					} else {
						for (int j = l; j < a[i]; j++) {
							skip[j] = true;
						}
					}
				}
			} else {
				if (a[i] == l) {
					l++;
				} else {
					r--;
				}

			}
		}

		int ans = n;
		for (int i = 0; i < n; i++) {
			if (skip[i]) {
				ans--;
			}
		}
		out.println(ans);

		out.close();
	}

	public static void main(String[] args) throws Exception {
		new a().run();
	}
}
