import java.io.*;
import java.util.*;

public class a {
	BufferedReader in; 
	PrintWriter out;
	StringTokenizer st; 
	
	public String next() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine()); 
			} catch (Exception e) {
				// TODO: handle exception
			}
		}
		return st.nextToken(); 
	}
	
	public int nextInt() {
		return Integer.parseInt(next()); 
	}
	
	public long nextLong() {
		return Long.parseLong(next()); 
	}
	
	public void run() throws Exception{
		in = new BufferedReader(new FileReader("knockout.in")); 
		out = new PrintWriter(new FileWriter("knockout.out"));
		int n = nextInt(); 
		int m = nextInt(); 
		
		int[] a = new int[n]; 
		int[] b = new int[n]; 
		for (int i=0; i<n; i++) {
			a[i] = nextInt(); 
			b[i] = nextInt(); 
		}
		
		for (int i=0; i<m; i++) {
			int x = nextInt(); 
			int y = nextInt();
			int t = nextInt();
			
			int ans=0; 
			for (int j=0; j<n; j++) {
				int len = b[j] - a[j]; 
				int f = (t/len) % 2;
				int h = t % len;
				int cur = -1; 
				if (f == 1) {
					cur = b[j] - h; 
				} else cur = a[j] + h;
				if (x <= cur && cur <= y) ans++; 
			}
			System.err.println(ans);
			out.println(ans);
		} 
		
		out.close(); 
	}
	
	public static void main(String[] args) throws Exception {
		new a().run(); 
	}
}
