#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <utility>
#include <queue>
#include <stack>

using namespace std;

#define filename "burrito"

const int N = (int)1e5 + 100;
const double eps = 1e-12;

int n, A, B;
struct point {
	int x, y;
	int g, ind;

};

bool cmp(const point& u, const point& v) {
	return u.x * v.y > u.y * v.x;
}

point p[N];
double s[N];

int main() { 
	assert(freopen(filename ".in", "r", stdin));
	assert(freopen(filename ".out", "w", stdout));
	scanf("%d%d%d", &n, &A, &B);
	for (int i = 1 ; i <= n ; i++) {
		scanf("%d%d%d", &p[i].g, &p[i].x, &p[i].y);
		p[i].ind = i;
	}
	sort(p + 1, p + n + 1, cmp);                

	double curA = 0.0 , curB = 0.0;
	for (int i = 1 ; i <= n ; i ++) {
		double lo = 0.0, hi = p[i].g, mid;
		for (int it = 0; it < 50 ; it ++) {
			mid = (hi + lo) / 2;
			// TODO
			if (curB + mid * p[i].y <= B)
				lo = mid;
			else
				hi = mid;
		}
		curB += mid * p[i].y;
		curA += mid * p[i].x;
		s[p[i].ind] = mid;
	}           
	// TODO
	if (curA + eps < A) {
		puts("-1 -1");
	} else {
		printf("%.9f %.9f\n", curA, curB);
		for (int i = 1 ; i <= n ; i++) {
			printf("%.9f ", s[i]);
		}
	}





	return 0;
}
