import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;


public class Solution {
	
	private static BufferedReader in;
	private static StringTokenizer st;
	private static PrintWriter out;

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
//		standart();
		file("alter");
		int n = nextInt();
		int m = nextInt();
		int ans = (n * m)/ 2;
		out.println(ans);
		for (int i = 1; i <=n; i++) {
			for (int j = 2 - ((i+1) % 2); j <=m; j+=2) {
				out.println(i+" "+j+" "+i+" "+j);
			}
		}
		out.close();
	}

	private static long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(next());
	}

	private static double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(next());
	}

	private static int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(next());
	}

	private static String next() throws IOException {
		while(!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	private static void file(String file) throws IOException {
		in = new BufferedReader(new FileReader(new File(file+".in")));
		st = new StringTokenizer("");
		out=  new PrintWriter(new BufferedWriter(new FileWriter(file+".out")));
	}

	private static void standart() {
		in = new BufferedReader(new InputStreamReader(System.in));
		st = new StringTokenizer("");
		out = new PrintWriter(new OutputStreamWriter(System.out));
	}
}
