#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#pragma warning (disable:4996)

#define file "burrito"
typedef vector<int> vi;

const int MAXN = 1e5 + 5;
const double EPS = 1e-9;

struct ing{
	int g;
	int a, b, id;
};

bool getS(const ing &a, const ing &b){
	int ds = a.a * b.b - a.b * b.a;	
	if (ds != 0) return ds > 0;
	return a.a > b.a || a.a == b.a && a.b < b.b;
	//return (a.a - a.b) * b.g > (b.a - b.b) * a.g;
}

ing p[MAXN];
double res[MAXN];

void solve(){
	int n, A, B;
	scanf("%d%d%d", &n, &A, &B);
	int a, b,g;
	for (int i = 0; i < n; i++){
		scanf("%d%d%d", &g, &a, &b);
		p[i].a = a;
		p[i].b = b;
		p[i].g = g;
		p[i].id = i;
	}
	sort(p, p + n, getS);
	double ansa = 0, ansb = 0;
	for (int i = 0; i < n; i++){
		double s1 = p[i].g * p[i].b;
		if (ansb + s1 < B - EPS){
			res[p[i].id] = p[i].g;
			ansb += s1;
			ansa += p[i].g * p[i].a;
		}
		else{
			double dt = (B - ansb) / p[i].b;
			res[p[i].id] = dt;
			ansb = B;
			ansa += dt * p[i].a;
		}
	}
	if (A < ansa - EPS){
		printf("%.8lf %.8lf\n", ansa, ansb);
		for (int i = 0; i < n; i++){
			printf("%.8lf ", res[i]);
		}
	}
	else{
		printf("-1 -1");
	}
}

int main() {
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen(file ".in", "r", stdin); freopen(file".out", "w", stdout);
	solve();
}