#include <cstdio>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

#pragma warning (disable:4996)

#define file "filter"
typedef vector<int> vi;
typedef long long ll;

const int MAXN = 1e3 + 5;
const int MAXN2 = 100;
const int MAXN3 = 1e4;

ll a[MAXN];
string s[MAXN];
ll u[MAXN];
char b[MAXN3];
char cur[MAXN3];
ll bs[MAXN][MAXN2];
ll bf[MAXN2];

void solve(){
	int f;
	ll m;
	scanf("%I64d%d", &m, &f);
	for (int i = 0; i < f; i++){
		scanf("%I64d", &a[i]);
	}
	int n, q;
	scanf("%d", &n);
	for (int i = 0; i < n; i++){
		cin >> s[i];
	}
	scanf("%d", &q);
	for (int i = 0; i < q; i++){
		scanf("%I64d", &u[i]);
	}
	int top = 0;
	int k = ceil(1. * m / 64);
	for (int i = 0; i < q; i++){
		for (int j = 0; j < m; j++) b[j] = 0;
		for (int j = 0; j < f; j++){
			ll pos = (a[j] * u[i]) % m;
			b[pos] = 1;
		}
		top = 0;
		for (int j = 0; j < k; j++){
			bs[i][j] = 0;
			int beg = top;
			for (int h = 0; h < 64 && top < m; h++){
				if (b[top] == 1){
					bs[i][j] |= (1ll << (top - beg));
				}
				top++;
			}
		}
	}
	/*for (int i = 0; i < q; i++){
		for (int j = 0; j < k; j++){
			ll cc = bs[i][j];
			int len = 64;
			while (len){
				len--;
				printf("%d", cc % 2);
				cc /= 2;
			}
		}
		printf("\n");
	}*/
	int c;
	vi res;
	for (int i = 0; i < n; i++){
		top = 0;
		int len = s[i].length();
		for (int j = 0; j < len; j++){
			c = 0;
			if (isdigit(s[i][j])){
				c = s[i][j] - '0';
			}
			else{
				c = s[i][j] - 'a' + 10;
			}
			int cnt = 4;
			while (cnt && top < m){
				cnt--;
				cur[top++] = c & 1;
				c >>= 1;
			}
		}
		top = 0;
		for (int j = 0; j < k; j++){
			bf[j] = 0;
			int beg = top;
			for (int h = 0; h < 64 && top < m; h++){
				if (cur[top] == 1){
					bf[j] |= (1ll << (top - beg));
				}
				top++;
			}
		}
		/*
			for (int j = 0; j < k; j++){
				ll cc = bf[j];
				int len = 64;
				while (len){
					len--;
					printf("%d", cc % 2);
					cc /= 2;
				}
			}
			printf("\n");*/
		
		int fl = 0;
		for (int ui = 0; ui < q; ui++){
			int bad = 0;
			for (int j = 0; j < k; j++){
				if ((bf[j] | bs[ui][j]) != bf[j]){
					bad = 1; break;
				}
			}
			if (!bad){
				fl = 1; break;
			}
		}
		if (fl){
			res.push_back(i);
		}
	}
	int sz = res.size();
	printf("%d ", sz);
	for (int i = 0; i < sz; i++){
		printf("%d ", res[i]);
	}
}

int main() {
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	freopen(file ".in", "r", stdin); freopen(file".out", "w", stdout);
	solve();
}