#include <iostream>
#include <cstdio>
#include <fstream>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <utility>
#include <algorithm>
#include <ctime>
#include <stdio.h>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define sqr(x) ((x)*(x))
#define pii pair<int, int>
#define vi vector<int>
#define ll long long
#define ull unsigned long long
#define sz(a) (int)a.size()
#define file "joke"

const int inf = (int)1e9;
const int mod = (int)1e9 + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

string s;
int n;
int ans[2000], _ans[2000];
vi v[20];
int pos[20];
map <ll, int> dp[200];

int f(int n) {
	if(n <= 9) return n;
	return 9 + 2 * (n - 9);
}

string toString(int x) {
	if(x == 0) return "0";
	string ans = "";
	while(x) {
		ans = (char)(x % 10 + 48) + ans;
		x /= 10;
	}
	return ans;
}

void print() {
	cout << ans[0];
	for(int i = 1; i < sz(s); i++) {
		if(ans[i] != ans[i-1]) cout << " " << ans[i];
	}
	cout << endl;
}

bool ok() {
	for(int i = 0; i < sz(s); i++) _ans[i] = ans[i];
	for(int i = 1; i < 10; i++) ans[pos[i]] = i;
	for(int i = 0, j; i < sz(s);) {
		if(ans[i]) i++;
		else {
			if(i+1 == sz(s) || ans[i+1]) {
				for(int i = 0; i < sz(s); i++) ans[i] = _ans[i];
				return false;
			}
			ans[i] = ans[i+1] = 10 * (s[i] - '0') + s[i+1] - '0';
			i += 2;
		}
	}
	vi t;
	for(int i = 0; i < sz(s); i++) {
		if(i && ans[i] == ans[i-1]) continue;
		t.pb(ans[i]);
	}
	vi used(n+1, 0);
	for(int i = 0; i < sz(t); i++) used[t[i]]++;
	for(int i = 1; i <= n; i++)
		if(used[i] != 1) {
			for(int i = 0; i < sz(s); i++) ans[i] = _ans[i];
			return false;
		}
	return true;
}

void go(int ind) {
	if(ind == 10) {
		if(ok()) print();
		return;
	}
	for(int i = 0; i < sz(v[ind]); i++) {
		pos[ind] = v[ind][i];
		go(ind+1);
	}
}

int calc(int ind, ll mask) {
	if(ind == sz(s)) return (mask==((1ll<<n)-1));
	if(dp[ind].count(mask)) return dp[ind][mask];
	int &res = dp[ind][mask];
	res = 0;
	int x = s[ind] - '0';
	if(ans[ind] == x) return res = calc(ind+1, (mask^(1ll<<(x-1))));
	if(ind < sz(s) - 1) {
		int xx = 10 * x + s[ind+1] - '0';
		if(ans[ind] == xx && ans[ind+1] == x) return res = calc(ind+2, (mask^(1ll<<(xx-1))));
	}
	if(x >= 1 && x <= n && (mask&(1ll<<(x-1)))==0) {
		res |= calc(ind+1, (mask^(1ll<<(x-1))));
	}
	if(ind < sz(s)-1) {
		x = 10 * x + s[ind+1] - '0';
		if(x >= 1 && x <= n && ((mask&(1ll<<(x-1)))==0))
			res |= calc(ind+2, (mask^(1ll<<(x-1))));
	}
	return res;
}

void rec(int ind, ll mask) {
	if(ind == sz(s)) return;
	int x = s[ind] - '0';
	if(ans[ind] == x) {
		ans[ind] = x;
		rec(ind + 1, mask^(1ll<<(x-1)));
		return;
	}
	if(ind + 1 < sz(s) && ans[ind] == 10 * x + s[ind+1] - '0' && ans[ind+1] == 10 * x + s[ind+1] - '0') {
		ans[ind] = ans[ind+1] = 10 * x + s[ind+1] - '0';
		x = 10 * x + s[ind+1] - '0';
		rec(ind + 2, mask^(1ll<<(x-1)));
		return;
	}
	if(x >= 1 && x <= n && ((1ll<<(x-1))&mask) == 0 && calc(ind+1, (mask^(1ll<<(x-1))))) {
		ans[ind] = x;
		rec(ind+1, mask^(1ll<<(x-1)));
	} else {
		x = 10 * x + s[ind+1] - '0';
		ans[ind] = ans[ind+1] = x;
		rec(ind+2, mask^(1ll<<(x-1)));
	}
}

int main () {

	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);

	cin >> s;

	for(n = 1; f(n) != sz(s); n++);

	/*
	for(int i = 0; i < sz(s); i++) {
		if(s[i] == '0') {
			ans[i-1] = ans[i] = 10 * (s[i-1] - '0');
		}
	}

	for(int i = 0; i < sz(s); i++) {
		if(!ans[i]) {
			v[s[i]-'0'].pb(i);
		}
	}

	memset(pos, -1, sizeof pos);

	go(1);
	*/

	vi used(n+1, 0);
	for(int iter = 0; iter < n; iter++) 
	{
		vi cnt(n+1, 0);
		for(int i = 1; i <= n; i++) {
			if(used[i]) continue;
			string temp = toString(i);
			for(int j = 0; j <= sz(s) - sz(temp); j++) {
				bool ok = 1;
				if(s.substr(j, sz(temp)) != temp) continue;
				for(int t = j; t < j + sz(temp); t++)
					if(ans[t]) {
						ok = 0;
						break;
					}
				if(!ok) continue;
				cnt[i]++;
			}
		}
		int x = -1;
		for(int i = 1; i <= n; i++) {
			if(!used[i] && cnt[i] == 1) {
				x = i;
				break;
			}
		}
		if(x == -1) break;
		used[x] = 1;
		string temp = toString(x);
   		for(int j = 0; j <= sz(s) - sz(temp); j++) {
			if(s.substr(j, sz(temp)) != temp) continue;
   			bool ok = 1;
   			for(int t = j; t < j + sz(temp); t++)
   				if(ans[t]) {
   					ok = 0;
   					break;
   				}
   			if(!ok) continue;
   			for(int t = j; t < j + sz(temp); t++)
   				ans[t] = x;
			break;
   		}
	}

	rec(0, 0);

	print();

	return 0;
}