#include <iostream>
#include <fstream>
#include <cstdio>
#include <iomanip>
#include <cassert>
#include <cmath>
#include <math.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <ctime>
#include <string>
#include <cstdlib>

using namespace std;

#define sz(x) ((int)((x).size()))

int getCode(char x) {
	if ('0' <= x && x <= '9')
		return x - '0';
	else
		return x - 'a' + 10;
}

int m, f, a[105];
int n;
int bts[1050][1050], q, ids, b[1050][1050];
int cur[1050];
char str[1050];
bool good[1050];

int main() {
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);

	scanf("%d%d", &m, &f);
	for (int i = 0; i < f; i++) {
		scanf("%d", &a[i]);
		a[i] %= m;
	}
	scanf("%d", &n);
	int mx = 0;
	for (int i = 0; i < n; i++) {
		scanf("%s", str);
		int cnt = ((string)(str)).length();
		for (int j = 0; j < cnt; j++) {
			int x = getCode(str[j]);
			for (int k = 0; k < 4; k++) {
				bts[i][j * 4 + k] = (x & 1);
				x >>= 1;
			}
		}
		int id = 0;
		for (int j = 0; j < m; j++) {
			if (j > 0 && j % 31 == 0)
				id++;
			mx = max(mx, id);
			b[i][id] <<= 1;
			b[i][id] |= bts[i][j];
		}
	}
	mx++;
	scanf("%d", &q);
	while (q-- > 0) {
		scanf("%d", &ids);
		ids %= m;
		for (int i = 0; i < m; i++) {
			cur[i] = 0;
		}
		for (int j = 0; j < f; j++) {
			int x = (ids * a[j]) % m;
			cur[x] = 1;
			//cur[x / 31] |= (1 << (x % 31));
		}
		for (int i = 0; i < n; i++) {
			if (good[i])
				continue;
			bool ok = true;
			for (int j = 0; j < m; j++) {
				if (bts[i][j] == 0 && cur[j] == 1) {
					ok = false;
					break;
				}
			}
			good[i] = ok;
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		if (good[i])
			ans++;
	}
	printf("%d", ans);
	for (int i = 0; i < n; i++) {
		if (good[i]) {
			printf(" %d", i);
		}
	}
	puts("");


	return 0;
}
