import java.io.*;
import java.util.StringTokenizer;


public class Main {
	
	public void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();
		
		long a[] = new long[n];
		long b[] = new long[n];
		
		for (int i = 0; i < n; ++i) {
			a[i] = nextLong();
			b[i] = nextLong();
		}
		
		for (int i = 0; i < m; ++i) {
			long x = nextLong(), y = nextLong(), t = nextLong();
			int cnt = 0;
			
			for (int j = 0; j < n; ++j) {
				long len = b[j] - a[j];
				
				long tm = t / len;
				
				long pos = 0;
				
				if (tm % 2 == 0) {
					pos = a[j] + t % len;
				} else {
					pos = b[j] - (t % len);
				}
				if (pos >= x && pos <= y) {
					cnt++;
				}
			}
			
			out.println(cnt);
			
		}
	}
	
	public static void main(String[] args) throws IOException {
		new Main().run();
	}
	
	final String fileIn = "knockout.in";
	final String fileOut = "knockout.out";
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st = new StringTokenizer("");
	
	private void run() throws IOException {
		in = new BufferedReader(new FileReader(fileIn));
//		in = new BufferedReader(new InputStreamReader(System.in));
		
		out = new PrintWriter(new FileWriter(fileOut));
//		out = new PrintWriter(System.out);
		
		solve();
		
		in.close();
		out.close();
	}
	
	String nextToken() throws IOException {
		while (!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}
	
	Integer nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	Double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	Long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}
	
	String nextString() throws IOException {
		st = new StringTokenizer("");
		return in.readLine();
	}
	
	boolean EOF() throws IOException {
		while (!st.hasMoreTokens()) {
			String s = in.readLine();
			if (s == null)
				return true;
			st = new StringTokenizer(s);
		}
		return false;
	}
}
