#define _CRT_SECURE_NO_WARNINGS 1

#include <stdio.h>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <stack>

using namespace std;



string s;

class cJoke
{
private:
	vector<int> mask = vector<int>(100);
	int from, is_valid = 1;
public:
	cJoke(vector<int> m, int f)
	{
		this->mask = m;
		this->from = f;
		for (int i = from; i > 0; i--)
		{
			stack<vector<int>> st;
			int offset = 0;
			do{
				vector<int> curMask = this->mask;
				offset = this->find(i, curMask, offset);
				if (offset != -1) st.push(curMask);
				if (offset == -1) break;
				offset++;
			} while (true);
			if (st.size() == 0)
			{
				this->is_valid = 0;
				break;
			}
			else if (st.size() == 1)
			{
				this->mask = st.top();
			}
			else
			{
				int isnowvalid = 0;
				while (st.size() > 0)
				{
					cJoke curJoke = cJoke(st.top(), i - 1);
					if (curJoke.isvalid())
					{
						this->mask = curJoke.getMask();
						isnowvalid = 1;
					}
					st.pop();
				}
				if (!isnowvalid) { this->is_valid = 0; break; }
			}
		}
	}

	int isvalid()
	{
		return this->is_valid;
	}

	vector<int> getMask()
	{
		return this->mask;
	}

	static int find(int k, vector<int> &mask, int startOffset)
	{
		int offset = startOffset;
		offset = s.find(to_string(k), offset);
		if (offset == -1) return -1;
		while (mask[offset] != 0 && ((k > 9) ? mask[offset + 1] != 0 : 1))
		{
			offset = s.find(to_string(k), offset + 1);
			if (offset == -1) return -1;
		}
		mask[offset] = k;
		if (k > 9) mask[offset + 1] = -1;
		return offset;
	}
};

int main()
{
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);

	cin >> s;

	int cnt = s.length();
	cnt = cnt > 9 ? (cnt - 9) / 2 + 9 : cnt;

	cJoke *joke = new cJoke(vector<int>(100), cnt);

	vector<int> prosto_vivedi_otvet = joke->getMask();

	for (int i = 0; prosto_vivedi_otvet[i] != 0; i++)
	{
		if (prosto_vivedi_otvet[i] != 0 && prosto_vivedi_otvet[i] != -1)
			cout << prosto_vivedi_otvet[i] << " ";
	}


	fclose(stdin);
	fclose(stdout);
	return 0;
}