
#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include <stdio.h>
#include <string.h>
#include <cstdio>
#include <iomanip>

using namespace std;
#define all(v) v.begin(),v.end()
typedef long long ll;
typedef long double db;

class T{
public:
	int id;
	db a, b, k, g, gr;
};
bool operator <(const T &a, const T &b){
	return a.k > b.k;
}
bool cmp(const T &a, const T &b){
	return a.id < b.id;
}
int n;
db A, B;
vector < T > w;

int main(){
	ios::sync_with_stdio(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	freopen("burrito.in", "r", stdin); freopen("burrito.out", "w", stdout);
	cin >> n >> A >> B;
	w.resize(n);

	for (int i = 0; i < n; i++){
		cin >> w[i].g >> w[i].a >> w[i].b;
		w[i].k = w[i].a / w[i].b;
		w[i].id = i;
	}

	sort(all(w));
	db q = 0, ans = 0;
	for (int i = 0; i < n; i++){
		w[i].gr = min((db)w[i].g, (B - q) / w[i].b);
		q += w[i].gr*w[i].b;
		ans += w[i].gr*w[i].a;
	}
	sort(all(w), cmp);

	if (ans + (1e-9) < A){ puts("-1 -1"); return 0; }
	cout << fixed << setprecision(8);
	cout << (double)ans << ' ' << (double)q << '\n';
	for (int i = 0; i < n; i++){
		cout << (double)w[i].gr << ' ';
	}
	return 0;
}
/*
2 5 5
2 2 1
2 2 4
*/