#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <sstream>
#include <algorithm>
#include <cstdio>
#include<iomanip>

using namespace std;
#define all(v) v.begin(),v.end()
typedef long long ll;
typedef long double db;

int n;
ll A, B;
vector<int > id;
vector<db > a, b, g;
vector<db > k, gr;

bool cmp(int i, int j){
	return k[i] > k[j];
}

int main(){
	  ios::sync_with_stdio(0);
	freopen("burrito.in", "r", stdin); freopen("burrito.out", "w", stdout);
	cin >> n >> A >> B;

	a.resize(n);
	b.resize(n);
	g.resize(n);
	k.resize(n);
	id.resize(n);
	gr.resize(n);

	for (int i = 0; i < n; i++){
		cin >> g[i] >> a[i] >> b[i];
		k[i] = a[i] / (b[i] + 0.0);
		id[i] = i;
	}

	sort(all(id));
	db q = 0, ans = 0;
	for (int i = 0; i < n; i++){
		gr[id[i]] = min((db)g[id[i]], (B - q) / b[id[i]]);
		q += gr[id[i]] * b[id[i]];
		ans += gr[id[i]] * a[id[i]];
	}
	if (ans + (1e-9) < A){ puts("-1 -1"); return 0; }
	cout << fixed << setprecision(8);
	cout << (double)ans << ' ' << (double)q << '\n';
	for (int i = 0; i < n; i++){
		cout << (double)gr[i] << ' ';
	}
	return 0;
}
/*
2 5 5
2 2 1
2 2 4
*/