#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int a[1000];
int b[1000];

typedef struct
{
	int g, a, b;
	double k;
	int ind;
} Ing;
Ing ing[100000];

int cc(const void* i1, const void* i2)
{
	if ((*(Ing*)i1).b == 0 && (*(Ing*)i2).b == 0)
		return (*(Ing*)i1).a - (*(Ing*)i2).a;
	else if ((*(Ing*)i1).a == 0)
		return 1;
	else if ((*(Ing*)i2).a == 0)
		return -1;
	else
		return (*(Ing*)i1).b / (*(Ing*)i1).a - (*(Ing*)i2).b / (*(Ing*)i2).a;
}

int ci(const void* i1, const void* i2)
{
	return (*(Ing*)i1).ind - (*(Ing*)i2).ind;
}

int main(int argc, char* argv[])
{
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);
	int n;
	double A, B;
	scanf("%d%lf%lf", &n, &A, &B);
	double Amax = 0, Bmin = B;
	int i, j;
	for (i = 0; i < n; i++)
	{
		scanf("%d%d%d", &ing[i].g, &ing[i].a, &ing[i].b);
		ing[i].k = 0;
		ing[i].ind = i;
	}
	qsort(ing, n, sizeof(Ing), cc);

	for (i = 0; i < n; i++)
	{
		if (ing[i].a == 0)
			break;
		double g, k;
		g = double(ing[i].g);
		if (ing[i].b == 0)
			k = g;
		else
			k = Bmin / ing[i].b;

		if (g <= k)
		{
			Amax += ing[i].a * g;
			Bmin -= ing[i].b * g;
		}
		else
		{
			Amax += ing[i].a * k;
			Bmin -= ing[i].b * k;
		}

		if (g < k)
			ing[i].k = g;
		else
			ing[i].k = k;
	}
	qsort(ing, n, sizeof(Ing), ci);
	if (Amax < A)
		printf("-1 -1");
	else
	{
		printf("%.9lf %.9lf\n", Amax, B-Bmin);
		for (j = 0; j < n; j++)
		{
			printf("%.9lf ", ing[j].k);
		}
	}
	return 0;
}