#include <iostream>
#include <stdio.h>
#include <cmath>
#include <algorithm>
#include <string>
#include <string.h>
#include <vector>
#include <set>
#include <map>
#include <time.h>
#include <stdlib.h>
#include <memory.h>

typedef long long ll;

const int N = 1e5+3;
const int inf = 1e9;

using namespace std;

char s[N];

int cc(int x){
    int c = 0;
    while(x) ++c,x/=10;
    return c;
}

map<ll,int> p[N];

bool solve()
{
    gets(s);
    int l = strlen(s);
    int n = 1;
    int len = 1;
    while(len!=l){
        ++n;
        len+=cc(n);
    }

    p[0][0] = -1;
    for(int i=1;i<=len;++i){
        int x = s[i-1]-'0';
        if(x>0 && x<=n){
            for(map<ll,int>::iterator it = p[i-1].begin(); it!=p[i-1].end();it++){
                ll ms = it->first;
                if(ms>>x&1) continue;
                p[i][ms|(1LL<<x)] = 1;
            }
        }
        if(i>1 && s[i-2]!='0'){
            x = x+(s[i-2]-'0')*10;
            if(x>0 && x<=n){
                for(map<ll,int>::iterator it = p[i-2].begin(); it!=p[i-2].end();it++){
                    ll ms = it->first;
                    if(ms>>x&1) continue;
                    p[i][ms|(1LL<<x)] = 2;
                }
            }
        }
    }
    ll MS = (1LL<<n)-1;
    MS = MS*2;
    if(p[len].count(MS)){
        vector<int> v;
        int i = len;
        while(MS){
            int tp = p[i][MS];
            if(tp==1){
                int x = s[i-1]-'0';
                v.push_back(x);
                --i;
                MS^=(1LL<<x);
            }else
            if(tp==2){
                int x = s[i-1]-'0';
                x = x + (s[i-2]-'0')*10;
                v.push_back(x);
                i-=2;
                MS^=(1LL<<x);
            }
        }
        for(int i=0;i<n;++i) cout<<v[n-i-1]<<' '; cout<<endl;
    }

    return 0;
}

int main()
{/*
    if(01){
        FILE *f = fopen("input.txt","w");
        int n = 50;
        srand(time(0));
        vector<int> a;
        for(int i=0;i<n;++i) a.push_back(i+1);
        random_shuffle(a.begin(), a.end());
        for(int i=0;i<n;++i) fprintf(f,"%d",a[i]);
        fclose(f);
    }*/
    freopen("joke.in","r",stdin);
    //freopen("input.txt","r",stdin);
    freopen("joke.out","w",stdout);
    while (solve());
    return 0;
}
