#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

struct myIngrid{
	int g, a, b, i;
	float r, amount;
};

bool cmp(myIngrid &x, myIngrid &y){
		return (x.r > y.r);
}

bool secCmp(myIngrid &x, myIngrid &y){
		return (x.i < y.i);
}

int main(){
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	vector <myIngrid> arr;
	//myIngrid arr[100005];
	int n, a, b;
	cin >> n >> a >> b;
	arr.resize(n);
	for (int i = 0; i < n; ++i){
		arr[i].i = i;
		cin >> arr[i].g >> arr[i].a >> arr[i].b;
		if (arr[i].b)
			arr[i].r = (arr[i].a * 1.0) / arr[i].b;
		else
			arr[i].r = arr[i].a + 101;
	}

	sort(arr.begin(), arr.end(), cmp);
	
	double joy = 0, unhap = 0;
	for (int i = 0; i < n; ++i){
		if (arr[i].b * arr[i].g + unhap <= b){
			
			arr[i].amount = arr[i].g;
			
			unhap += arr[i].b * arr[i].g;
			joy += arr[i].a * arr[i].g;
		}
		else {
			double t = (b - unhap) / arr[i].b;
			arr[i].amount = t;
			unhap += arr[i].b * t;
			joy += arr[i].a * t;
			break;
		}
	}
	if (joy < a) cout << "-1 -1"; else {
		cout << joy << ' ' << unhap << endl;
		sort(arr.begin(), arr.end(), secCmp);
		for (int i = 0; i < n; ++i)
			cout << arr[i].amount << ' ';
	}
	return 0;
}