#include <iostream>
#include <string>
#include <stdio.h>
#include <sstream>

using namespace std;

string int_to_str(int n) {
	string res;
	while (n) {
		char a = '0' + (char)(n % 10);
		res = a + res;
		n /= 10;
	}
	return res;
}
string mask(string n) {
	int len = n.length();
	for (int i = 0; i < len; i++) {
		n[i] = n[i] + 10;
	}
	return n;
}

string unmask(string n) {
	int len = n.length();
	for (int i = 0; i < len; i++) {
		n[i] = n[i] - 10;
	}
	return n;
}

int str_to_int(string n) {
	int res = 0;
	if (n[0] > '9') n = unmask(n);
	int len = n.length();
	for (int i = 0; i < len; i++) {
		res = res * 10 + n[i] - '0';
	}
	return res;
}



bool flag[55];
string rec(string str, int n) {
	while (flag[n] && n> 0) n--;
	if (n == 0) return str;
	string a = int_to_str(n);
	int pos = str.find(a);
	if (pos != string::npos) {
		//found
		str = str.substr(0, pos) + ' ' + mask(a) + ' ' + str.substr(pos + a.length(), str.length());
	}
	return rec(str, n - 1);
	//cout << str;
}


int main(){
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
	string str;
	cin >> str;
	int len = str.length();
	int n;
	if (len <= 9) n = len; else n = (len - 9) / 2 + 9;

	//big nums;
	for (int i = 0; i < n; i++) flag[i] = false;

	for (int i = 0; i < str.length() - 1; i++) {
		string a = str.substr(i, 2);
		//cout << a << endl;
		if (str_to_int(a) > n) {
			str = str.substr(0, i + 1) + ' ' + str.substr(i + 1, str.length()); i++;
			//cout << str << endl;
		}
	}



	//10 20 30 40 50
	for (int i = 10; i <= n; i += 10) {
		string a = int_to_str(i);
		int pos = str.find(a);
		if (pos != string::npos) {
			//found
			str = str.substr(0, pos) + ' ' + mask(a) + ' ' + str.substr(pos + 2, str.length());
		}
		//cout << str;
	}
	stringstream ss(str);
	string s;
	while (ss >> s) {
		int a = str_to_int(s);
		if (a <= n) flag[a] = true;
	}
	//cout << str <<endl;
	string res = rec(str,n);
	stringstream ress(res);
	while (ress >> s) {
		cout << str_to_int(s) << ' ';
	}
	return 0;
}