import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {

    public static void main(String[] args) {
        Reader in = null;
        PrintWriter out = null;
        try {
            in = new Reader(new FileInputStream("alter.in"));
            out = new PrintWriter(new FileOutputStream("alter.out"));
        } catch (FileNotFoundException e) {
            throw new RuntimeException();
        }
        long n = in.nextLong();
        long m = in.nextLong();
        long c = n*m/2;
        out.println(c);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if ((i+j)%2==1){
                    out.println(String.format("%d %d %d %d", i+1, j+1, i+1, j+1));
                }
            }
        }
        out.close();
    }
}

class Reader{
    StringTokenizer st;
    BufferedReader is;

    public Reader(InputStream pis){
        Locale.setDefault(Locale.US);
        is = new BufferedReader(new InputStreamReader(pis));
        st = new StringTokenizer("");
    }

    public String nextLine(){
        st = new StringTokenizer("");
        try {
            return is.readLine();
        } catch (IOException e) {
            throw new RuntimeException();
        }
    }

    public String next(){
        while (!st.hasMoreTokens())st = new StringTokenizer(nextLine());
        return st.nextToken();
    }

    public long nextLong(){
        return Long.parseLong(next());
    }
}