// isit sfu 1 - comp. 6 ---- cab 301
import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {

    public static void main(String[] args) {
        Reader in = null;
        PrintWriter out = null;
        try {
            in = new Reader(new FileInputStream("burrito.in"));
            out = new PrintWriter(new FileOutputStream("burrito.out"));
        } catch (FileNotFoundException e) {
            throw new RuntimeException();
        }

        int n = in.nextInt();
        int A = in.nextInt();
        int B = in.nextInt();
        Ingr [] l = new Ingr[n];
        for (int i = 0; i <n; i++) {
            l[i] = new Ingr();
            l[i].index = i;
            l[i].amount = in.nextInt();
            l[i].a = in.nextInt();
            l[i].b = in.nextInt();
        }
        Arrays.sort(l);

        double at=0, bt=B;
        double [] ans = new double[n];

        for (int i = 0; (i < n) && bt>0; i++) {
            double can = l[i].amount;
            double can2 = bt/l[i].b;
            if (!Double.isInfinite(can2)) can = Math.min(can, can2);
            at+= can*l[i].a;
            bt-= can*l[i].b;
            ans[l[i].index] = can;
        }

        if ((at-A)>-0.0000001d){
            out.println(String.format("%f %f", at, B-bt));
            for (int i = 0; i < n; i++) {
                out.print(String.format("%f ", ans[i]));
            }
            out.println();
        }
        else{
            out.println("-1 -1");
        }
       out.close();
    }
}

class Ingr implements Comparable<Ingr>{
    public int index;
    public double amount;
    public double a;
    public double b;

    @Override
    public int compareTo(Ingr o) {
        if (Double.isInfinite(a/b) && Double.isInfinite(o.a/o.b)) return -Double.compare(a, o.a);
        if (Double.isInfinite(a/b)) return -1;
        if (Double.isInfinite(o.a/o.b)) return 1;
        return -Double.compare(a/b, o.a/o.b);
    }
}

class Reader{
    StringTokenizer st;
    BufferedReader is;

    public Reader(InputStream pis){
        Locale.setDefault(Locale.US);
        is = new BufferedReader(new InputStreamReader(pis));
        st = new StringTokenizer("");
    }

    public String nextLine(){
        st = new StringTokenizer("");
        try {
            return is.readLine();
        } catch (IOException e) {
            throw new RuntimeException();
        }
    }

    public String next(){
        while (!st.hasMoreTokens())st = new StringTokenizer(nextLine());
        return st.nextToken();
    }

    public long nextLong(){
        return Long.parseLong(next());
    }
    public int nextInt(){
        return Integer.parseInt(next());
    }
}