import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {

    public static void main(String[] args) {
        Reader in = null;
        PrintWriter out = null;
        try {
            in = new Reader(new FileInputStream("knockout.in"));
            out = new PrintWriter(new FileOutputStream("knockout.out"));
        } catch (FileNotFoundException e) {
            throw new RuntimeException();
        }

        int n = in.nextInt();
        int m = in.nextInt();
        int [] a = new int[n];
        int [] b = new int[n];
        for (int i = 0; i <n; i++) {
            a[i] = in.nextInt();
            b[i] = in.nextInt();
        }

        int [] x = new int[m];
        int [] y = new int[m];
        int [] t = new int[m];
        for (int i = 0; i < m; i++) {
            x[i] = in.nextInt();
            y[i] = in.nextInt();
            t[i] = in.nextInt();
        }

        for (int i = 0; i < m; i++) {
            int c = 0;
            for (int j = 0; j < n; j++) {
                int l = Math.abs(b[j]-a[j]);
                int pos;
                if ((t[i]/l)%2==0) {
                    if (b[j]>a[j]){
                        pos = a[j]+t[i]%l;
                    }
                    else{
                        pos = a[j]-t[i]%l;
                    }
                }
                else{
                    if (b[j]>a[j]){
                        pos = b[j]-t[i]%l;
                    }
                    else{
                        pos = b[j]+t[i]%l;
                    }
                }
                if (pos>=x[i]&&pos<=y[i]) ++c;
            }
            out.println(c);
        }

        out.close();
    }
}

class Reader{
    StringTokenizer st;
    BufferedReader is;

    public Reader(InputStream pis){
        Locale.setDefault(Locale.US);
        is = new BufferedReader(new InputStreamReader(pis));
        st = new StringTokenizer("");
    }

    public String nextLine(){
        st = new StringTokenizer("");
        try {
            return is.readLine();
        } catch (IOException e) {
            throw new RuntimeException();
        }
    }

    public String next(){
        while (!st.hasMoreTokens())st = new StringTokenizer(nextLine());
        return st.nextToken();
    }

    public long nextLong(){
        return Long.parseLong(next());
    }
    public int nextInt(){
        return Integer.parseInt(next());
    }
}