import com.sun.org.apache.xpath.internal.SourceTree;

import java.io.*;
import java.util.*;

public class Main {


    public static StringTokenizer tokenizer;
    public static BufferedReader reader;
    public static PrintWriter writer;

    public static void init() {
        try {
            reader = new BufferedReader(new InputStreamReader(new FileInputStream("burrito.in")));
            writer = new PrintWriter(new FileOutputStream("burrito.out"));
        } catch (IOException e) {
            System.out.println(e);
            System.exit(1);
        }
    }

    public static String nextToken() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                System.out.println(e);
                System.exit(1);
            }
        }
        return tokenizer.nextToken();
    }

    public static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    public static Long nextLong() {
        return Long.parseLong(nextToken());
    }

    public static Byte nextByte() {
        return Byte.parseByte(nextToken());
    }

    public static Double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    public static Short nextShort() {
        return Short.parseShort(nextToken());
    }

    public static Float nextFloat() {
        return Float.parseFloat(nextToken());
    }

    public static void close() {
        try {
            reader.close();
            writer.flush();
            writer.close();
        } catch (IOException e) {
            System.out.println(e);
            System.exit(1);
        }
    }

    public static void solve() {

        int n = nextInt();
        int[][] arr = new int[n][3];
        int minA = nextInt();
        int maxB = nextInt();

        for (int i = 0; i < n; i++) {
            arr[i][0] = nextInt();
            arr[i][1] = nextInt();
            arr[i][2] = nextInt();
        }

        double a = 0, b = 0;
        double[] arr2 = new double[100001];
        Arrays.fill(arr2, 0);

        for (int d = 100; d >= -102; d--) {
            for (int i = 0; i < n; i++)

                if (arr[i][1] - arr[i][2] == d)
                    if (maxB > b) {

                        if ((maxB - b) > arr[i][0] * arr[i][2]) {
//                            System.out.println(1);
                            a += arr[i][0] * arr[i][1];
                            b += arr[i][0] * arr[i][2];
                            arr2[i] = arr[i][0];
                            //System.out.println(a+" "+b);
                        } else {
                            //System.out.println("123");
//                            System.out.println(2);
                            double g = (maxB - b) / arr[i][2];
                            a += g * arr[i][1];
                            b += g * arr[i][2];
                            arr2[i] = g;

                            //System.out.println(a+" "+b);
                        }
                    }
        }


        if ((minA > a) || (maxB < b)) writer.print("-1 -1");
        else {
            writer.println(a + " " + b);

            for (int i = 0; i < n; i++) {
                if (i == n - 1) writer.print(arr2[i]);
                else
                    writer.print(arr2[i] + " ");
            }

        }
    }

    public static void main(String[] args) {
        init();
        solve();
        close();
    }
}
