import com.sun.org.apache.xpath.internal.SourceTree;

import java.io.*;
import java.util.*;
import java.util.function.IntToDoubleFunction;

public class Main {
    public static int[][] arr;

    public static StringTokenizer tokenizer;
    public static BufferedReader reader;
    public static PrintWriter writer;

    public static void init() {
        try {
            reader = new BufferedReader(new InputStreamReader(new FileInputStream("burrito.in")));
            writer = new PrintWriter(new FileOutputStream("burrito.out"));
        } catch (IOException e) {
            System.out.println(e);
            System.exit(1);
        }
    }

    public static String nextToken() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                System.out.println(e);
                System.exit(1);
            }
        }
        return tokenizer.nextToken();
    }

    public static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    public static Long nextLong() {
        return Long.parseLong(nextToken());
    }

    public static Byte nextByte() {
        return Byte.parseByte(nextToken());
    }

    public static Double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    public static Short nextShort() {
        return Short.parseShort(nextToken());
    }

    public static Float nextFloat() {
        return Float.parseFloat(nextToken());
    }

    public static void close() {
        try {
            reader.close();
            writer.flush();
            writer.close();
        } catch (IOException e) {
            System.out.println(e);
            System.exit(1);
        }
    }

    public static void qsort(int left, int right){

     //   for (int i = 0; i <= 10-1; i++)
//            System.out.println(arr[i][0]+" "+arr[i][1]+" "+arr[i][2]);

        int mid = (left+right)/2;
        //System.out.println(left+" "+right+);

        int i = left;
        int j = right;


        //System.out.println((x1+0.0)/(x2+0.0));


        while ((arr[i][1]+0.0)+(arr[i][2]+0.0) < (arr[mid][1]+0.0)+(arr[mid][2]+0.0)) i++;
        while ((arr[j][1]+0.0)+(arr[j][2]+0.0) > (arr[mid][1]+0.0)+(arr[mid][2]+0.0)) j--;

        while (i <= j){


            if ((arr[i][1]+0.0)+(arr[i][2]+0.0) > (arr[j][1]+0.0)+(arr[j][2]+0.0)){



                int x = arr[i][0];
                arr[i][0] = arr[j][0];
                arr[j][0] = x;

                x = arr[i][1];
                arr[i][1] = arr[j][1];
                arr[j][1] = x;

                x = arr[i][2];
                arr[i][2] = arr[j][2];
                arr[j][2] = x;


            }

            i++;
            j--;


        }

        if (left < j) qsort(left, j);
        if (right > i) qsort(i, right);





    }

    public static void solve() {




        int n = nextInt();
        arr = new int[n][4];
        String[] strs = new String[n];


        int minA = nextInt();
        int maxB = nextInt();

        for (int i = 0; i < n; i++) {
            arr[i][0] = nextInt();
            arr[i][1] = nextInt();
            arr[i][2] = nextInt();
            strs[i] = (arr[i][1]+0.0)/(+arr[i][2]+0.0)+";"+arr[i][0]+";"+arr[i][1]+";"+arr[i][2]+";"+i;
        }

        Arrays.sort(strs, Collections.reverseOrder());



        double a = 0, b = 0;
        double[] arr2 = new double[100001];
        Arrays.fill(arr2, 0);

        //for (int d = 100; d >= -102; d--) {
            for (int i = 0; i < n; i++) {
                String[] temp;
                temp = strs[i].split(";");
                int g1 = Integer.parseInt(temp[1]);
                int a1 = Integer.parseInt(temp[2]);
                int b1 = Integer.parseInt(temp[3]);
                int num = Integer.parseInt(temp[4]);
//               System.out.println(g1+" "+a1+" "+b1+" "+num);

             //   if (arr[i][1] - arr[i][2] == d)
                    if (maxB > b) {

                        if ((maxB - b) > g1 * b1) {
//                            System.out.println(1);
                            a += g1 * a1;
                            b += g1 * b1;
                            arr2[num] = g1;
                            //System.out.println(a+" "+b);
                        } else {
                            //System.out.println("123");
//                            System.out.println(2);
                            double g = (maxB - b) / b1;
                            a += g * a1;
                            b += g * b1;
                            arr2[num] = g;

                            //System.out.println(a+" "+b);
                        }
                    }
            }
        //}


        if ((minA > a) || (maxB < b)) writer.print("-1 -1");
        else {
            writer.println(a + " " + b);

            for (int i = 0; i < n; i++) {
                if (i == n - 1) writer.print(arr2[i]);
                else
                    writer.print(arr2[i] + " ");
            }

        }
    }

    public static void main(String[] args) {
        init();
        solve();
        close();
    }
}
