


import java.awt.Container;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.MathContext;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {

	static ArrayList<Double> res = new ArrayList<Double>();

	public static void main(String[] args) throws Exception {
		BufferedReader in=new BufferedReader(new FileReader("burrito.in"));
		StringTokenizer input = new StringTokenizer(in.readLine());
		FileWriter out = new FileWriter("burrito.out");
        double sum=0;
        double sum2=0;
		int n = Integer.parseInt(input.nextToken());
		double A= Double.parseDouble(input.nextToken());
		double B=Double.parseDouble(input.nextToken());
		ArrayList<Elem> mas = new ArrayList<Elem>();
		for (int i = 0; i < n; i++) {
			input = new StringTokenizer(in.readLine());
			Elem el = new Elem();
			el.num=i;
			el.g=Double.parseDouble(input.nextToken());
			el.a=Double.parseDouble(input.nextToken());
			el.b=Double.parseDouble(input.nextToken());
			if (el.b==0){el.otn=Double.MAX_VALUE;}
			else{
			 el.otn=el.a/el.b;
			}
			mas.add(el);
			res.add(0.0);
			
		}
	    Collections.sort(mas, new Comparator<Elem>() {

			@Override
			public int compare(Elem o1, Elem o2) {
				if (o1.otn<o2.otn){
					return 1;
				}
				if (o1.otn>o2.otn){
					return -1;
				}
				return 0;
			}
		});
	    for (Elem el : mas) {
		   if((B-el.b*el.g)>=0){
			   sum+=el.a*el.g;
			   B-=el.b*el.g;
			   sum2+=el.b*el.g;
			   res.set(el.num, el.g);
		   }else{
			   sum+=B/el.b*el.a;
			   sum2+=B;
			   res.set(el.num,B/el.b);
			   
			   B=0;
			  
		   }	
		}
	    if (sum>=A){
	    	out.write(new BigDecimal(sum, new MathContext(9))+" "+new BigDecimal(sum2, new MathContext(9))+"\n");
	    	for (Double r : res) {
		    	 out.write(new BigDecimal(r, new MathContext(9))+" ");
			}
	    }else{
	    out.write("-1 "+"-1");
	    }
	   
	    out.close();
   
	}	
	public static class Elem{
		double g;
		double a;
		double b;
		double otn;
		int num;
		
		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			long temp;
			temp = Double.doubleToLongBits(otn);
			result = prime * result + (int) (temp ^ (temp >>> 32));
			return result;
		}
		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			Elem other = (Elem) obj;
			if (Double.doubleToLongBits(otn) != Double
					.doubleToLongBits(other.otn))
				return false;
			return true;
		}
		
		
		
	}

}

