#include <cstdio>
#include <vector>

#define INF 1e10

class burrito {
public:
    float max_g;
    float h_v;
    float u_v;
    float mod;
    float gramm;
};

using namespace std;

vector<burrito> burritos;
vector<int> indexes;
vector<burrito> burritos_answer(100005);

float a, b;

int n;

int main(int argc, char **argv) {
    FILE *f = fopen("burrito.in", "r");
    fscanf(f, "%i %f %f", &n, &a, &b);
    for (int i = 0; i < n; ++i) {
        float h, u, g;
        fscanf(f, "%f %f %f", &g, &h, &u);
        burrito b;
        b.max_g = g, b.h_v = h, b.u_v = u;
        if (b.u_v == 0)
            b.mod = INF;
        else if (b.h_v == 0)
            b.mod = -INF;
        else
            b.mod = b.h_v - b.u_v;
        burritos.push_back(b);
    }
    fclose(f);

    for (int i = 0; i < n; ++i) {
        float max_mode_value = burritos[i].mod;
        int max_index = i;
        for (int j = i + 1; j < n; ++j) {
            if (burritos[j].mod > max_mode_value) {
                max_mode_value = burritos[j].mod;
                max_index = j;
            }
        }

        burrito tmp = burritos[max_index];
        burritos[max_index] = burritos[i];
        burritos[i] = tmp;

        indexes.push_back(max_index);
    }

    float current_a(0), current_b(0);
    int i = 0;
    while (current_b <= b && i < n) {
        float b_n = b - current_b;
        float g_n = b_n / burritos[i].u_v;
        if (burritos[i].u_v == 0)
            g_n = INF;
        g_n = (g_n > burritos[i].max_g) ? burritos[i].max_g : g_n;

        current_a += burritos[i].h_v * g_n;
        current_b += burritos[i].u_v * g_n;

        burritos[i].gramm = g_n;
        i++;
    }

    f = fopen("burrito.out", "w");

    if (current_a < a || current_b > b)
        fprintf(f, "-1 -1");
    else {
        for (int i = 0; i < n; ++i) {
            burritos_answer[indexes[i]] = burritos[i];
        }
        fprintf(f, "%.4f %f.4\n", current_a, current_b);
        for (int i = 0; i != n; ++i) {
            fprintf(f,"%f.4 ", burritos_answer[i].gramm);
        }
    }
    fclose(f);
    return 0;
}
