#include <cstdio>
#include <algorithm>
#include <cmath>

using namespace std;

long a[1005], b[1005];
long x[1005], y[1005], t[1005];
bool broken_car[1005];

int main(int argc, char **argv) {
	int n, m;
	FILE *f = fopen("knockout.in", "r");
	fscanf(f, "%i %i", &n, &m);

	for (int i = 0; i < n; ++i)
        fscanf(f, "%ld %ld", a + i, b + i);
	for (int i = 0; i < m; ++i)
        fscanf(f, "%ld %ld %ld", x + i, y + i, t + i);

	fclose(f);

	f = fopen("knockout.out", "w");

	for (int i = 0; i < m; ++i) {
        int answer = 0;
        for (int j = n - 1; j >= 0; j--) {
            if (broken_car[j])
                continue;
            int vj = (b[j] > a[j]) ? 1 : -1;

            long sj = abs(a[j] - b[j]);
            long tj = 2 * sj;

            long tj_from_a = t[i] % tj;
            long cjt = 0;

            if (tj_from_a > sj) {
                cjt = b[j] - (vj * (tj_from_a - sj));
            }
            else {
                cjt = a[j] + vj * tj_from_a;
            }

            if (cjt <= y[i] && cjt >= x[i]) {
                answer = j + 1;
                broken_car[j] = true;
                break;
            }
        }

        if (answer) {
            fprintf(f, "%i\n", answer);
        }
	}

	fclose(f);
	return 0;
}
