#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#include <vector>
#include <bitset>

using namespace std;

__int64 m;
int f;
__int64 a[109], userId[1009];
int n;
char str[1009];
bitset<1009> files[1009];
int q;

void ReadData()
{
	scanf("%I64d %d", &m, &f);
	for (int i = 0; i < f; i++)
	{
		scanf("%I64d", &a[i]);
	}
	scanf("%d%*c", &n);
	int cnt = m / 4 + (m % 4 == 0 ? 0 : 1);
	for (int i = 0; i < n; i++)
	{
		scanf("%s%*c", str);
		int idx = 0;
		for (int j = 0; j < cnt; j++)
		{
			int val = str[j] >= '0' && str[j] <= '9' ? str[j] - '0' : str[j] - 'a' + 10;
			for (int k = 0; k < 4; k++)
			{
				if (val & 1)
				{
					files[i].set(idx);
				}
				idx++;
				val >>= 1;
			}
		}
	}
	scanf("%d", &q);
	for (int i = 0; i < q; i++)
	{
		scanf("%I64d", &userId[i]);
	}
}

vector<int> answer;

void Solve()
{
	for (int fileId = 0; fileId < n; fileId++)//1000
	{
		for (int currentUser = 0; currentUser < q; currentUser++)//1000
		{
			bool internalFlag = true;
			for (int hashId = 0; hashId < f; hashId++)//100
			{
				int j = (userId[currentUser] * a[hashId]) % m;
				if (files[fileId].at(j) == false)
				{
					internalFlag = false;
					break;
				}
			}
			if (internalFlag)
			{
				answer.push_back(fileId);
				break;
			}
		}
	}
}

void WriteData()
{
	printf("%d ", answer.size());
	for (vector<int>::iterator it = answer.begin(); it != answer.end(); ++it)
	{
		printf("%d ", *it);
	}
}

int main()
{
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
	ReadData();
	Solve();
	WriteData();
	return 0;
}