#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
using namespace std;
int main() {
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	double A, B;
    int n;
    cin >> n >> A >> B;
	vector<double> g(n), a(n), b(n), ans(n);
	vector<pair<double, int>> pr(n);
    for (int i = 0; i < n; i++) {
		cin >> g[i] >> a[i] >> b[i];
		pr[i] = make_pair(a[i] - b[i], i);
    }
	sort(pr.rbegin(), pr.rend());
	double t;
	int it;
	double myA = 0;
	double myB = 0;
    for (int i = 0; i < n; i++) {
		it = pr[i].second;
		t = min(B / b[it], g[it]);
		B -= t * b[it];
		myA += t * a[it];
		myB += t * b[it];
		ans[it] = t;
    }
	if (myA <= A - 1e-9) {
		cout << "-1 -1";
		return 0;
	} 
	printf("%0.9lf %0.9lf\n", myA, myB);
	for (int i = 0; i < n; i++) {
		printf("%0.9lf ", ans[i]);
	}
	return 0;
}