#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
using namespace std;
int main() {
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	double A, B;
    int n;
    cin >> n >> A >> B;
	vector<int> g(n), a(n), b(n);
    vector<double> ans(n);
	vector<pair<double, int>> pr(n);
    for (int i = 0; i < n; i++) {
		cin >> g[i] >> a[i] >> b[i];
		if (a[i] == 0)
			pr[i] = make_pair(1e9 + 345.0, i);
		else
            pr[i] = make_pair((double)b[i] / a[i], i);
        
    }
	sort(pr.begin(), pr.end());
	double t;
	int it;
	double myA = 0;
	double myB = 0;
    for (int i = 0; i < n; i++) {
		it = pr[i].second;
        
		if (b[it] == 0)
			t = g[it];
		else
		    t = min(B / b[it], (double)g[it]);
		if (a[it] == 0) {
			t = 0.0;
        }
		B -= t * b[it];
		myA += t * a[it];
		myB += t * b[it];
		ans[it] = t;
    }
	if (myA < A && fabs(myA - A) > 1e-10 ) {
		cout << "-1 -1";
		return 0;
	} 
	printf("%0.11lf %0.11lf\n", myA, myB);
	for (int i = 0; i < n; i++) {
		printf("%0.11lf ", ans[i]);
	}
	return 0;
}