#include <stdlib.h>
#include <fstream>
#include <iostream>
#include <string>

using namespace std;

long place(long x, long y, long t) {
	long distance = abs(x - y);
	long t1 = t - t / (2 * distance);
	if (t1 < distance) {
		if (x < y) return x + t1;
		else return x - t1;
	}
	else {
		t1 -= distance;
		if (x < y) return y - t1;
		else return y + t1;
	}
}

int main(int argc, char *argv[]) {
	ifstream input; input.open("knockout.in");
	ofstream output; output.open("knockout.out");
	int n = 0, m = 0; long xCoords[1000], yCoords[1000]; long X = 0, Y = 0, T = 0, count = 0;
	input >> n >> m;
	for (int i = 0; i < n; i++) {
		input >> xCoords[i] >> yCoords[i];
	}
	for (int i = 0; i < m; i++) {
		input >> X >> Y >> T; count = 0;
		for (int j = 0; j < n; j++) {
			long temp = place(xCoords[j], yCoords[j], T);
			if (temp >= X && temp <= Y) count++;
		}
		output << count << endl;
	}
	return 0;
}