#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>

using namespace std;

int main(){
	ifstream in("knockout.in");
	ofstream out("knockout.out");
//#ifdef _DEBUG
	cin.set_rdbuf(in.rdbuf());
	cout.set_rdbuf(out.rdbuf());
//#endif

	long long N, M;
	cin >> N >> M;
	vector<long long> a(N);
	vector<long long> b(N);
	//vector<long long> t(M);
	//vector<long long> x(M);
	//vector<long long> y(M);
	vector<long long> counts(M, 0);
	for (int i = 0; i < N; i++){
		cin >> a[i] >> b[i];
	}
	for (int i = 0; i < M; i++){
		long long t;
		long long x;
		long long y;
		cin >> x >> y >> t;
		for (int j = 0; j < N; j++){
			int sign = b[j] - a[j] > 0 ? 1 : -1;
			long long len = abs(b[j] - a[j]);
			long long dist = len * 2;
			long long tj = t%dist;
			long long coord;
			if (tj>len) coord = sign * ((dist - tj)) + a[j];
			else coord = sign * (tj)+a[j];
			if (coord <= max(x,y) && coord >= min (x,y)) counts[i] ++;
		}
	}

	for (int i = 0; i < M; i++){
		cout << counts[i] << endl;
	}


	return 0;
}
