#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <deque>
#include <ctime>
#include <set>
#include <map>
#include <cstdint>
#include <fstream>

using namespace std;

ifstream in("burrito.in");
ofstream out("burrito.out");
#define EPS (1e-16)
struct Ingr
{
	double max, a, b;
	int index;
};
bool order(Ingr& a, Ingr& b)
{
	double result = a.a / a.b - b.a / b.b;
	return result > 0;
}

int main()
{
	int64_t n, a, b;
	in >> n >> a >> b;
	vector<Ingr> v(n);
	vector<double> vresult(n, 0);
	double aresult = 0, bresult = 0;

	for (int i = 0; i < n; ++i)
	{
		in >> v[i].max >> v[i].a >> v[i].b;
		v[i].index = i;
	}
	sort(v.begin(), v.end(), order);

	for (int i = 0; i < n; ++i)
	{
		if (v[i].max * v[i].b < b - bresult)
		{
			bresult += v[i].max*v[i].b;
			aresult += v[i].max*v[i].a;
			vresult[v[i].index] = v[i].max;
		}
		else
		{
			float mn = b - bresult;
			if (abs(mn) < EPS)
				break;
			mn = mn / (v[i].b);
			bresult += mn* v[i].b;
			aresult += mn * v[i].a;
			vresult[v[i].index] = mn;
			break;
		}
	}

	if (aresult < a) out << "-1 -1" << endl;

	else
	{
		out << aresult << ' ' << bresult << endl;
		for (auto vi : vresult) out << vi << ' ';
	}

}
/*
int hex(char c)
{
if (c <= '9'&&c >= '0')
return c - '0';
return c - 'a'+10;
}
vector<bool> parse(string &hash, int m)
{
vector<bool> res(m);
int imax = (m % 4 == 0 ? hash.length() : (hash.length() - 1));
for (int i = 0; i < imax; i++)
{
int hexa = hex(hash[i]);
res[i*4] = (hexa) & 8;
res[i*4+1] = (hexa) & 4;
res[i*4+2] = (hexa) & 2;
res[i*4+3] = (hexa) & 1;
}
if (m % 4 != 0)
{
int hexa = hex(hash[m / 4]);
for (int i = 0; i < m % 4; i++)
{

res[i+m-m%4]=(hexa)&(8 >> i);
}
}
return res;
}
int main()
{
int m, f;
in >> m >> f;
vector<int> a(f);
for (int i = 0; i < f; i++)
{
in >> a[i];
}
int n;
in >> n;
string str;
vector<vector<bool>> hashes(n);
for (int i = 0; i < n; i++)
{
in >> str;
hashes[i] = parse(str, m);
}
int q;
in >> q;
vector<int> u(q);
for (int i = 0; i < q; i++)
{
in >> u[i];
}
vector<bool> participate(n, 0);
int count = 0;
for (int i = 0; i < q; i++)
{
for (int j = 0; j < n; j++)
{
bool ok = 1;
for (int k = 0; k < f&&ok; k++)
{
int needed = (u[i] * a[k]) % m;
ok &= hashes[j][needed];
}
if (ok)
{
if (!participate[j])
{
count++;
participate[j] = 1;
}
}
}
}
out << count << ' ';
for (int i = 0; i < n; i++)
{
if (participate[i])
out << i << ' ';
}
}*/