#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <deque>
#include <ctime>
#include <set>
#include <map>
#include <cstdint>
#include <fstream>

using namespace std;

ifstream in("burrito.in");
ofstream out("burrito.out");
#define EPS (1e-15)
struct Ingr
{
	long double max, a, b;
	int index;
};
bool order(Ingr& a, Ingr& b)
{
	return a.a / a.b > b.a / b.b;
}

int main()
{
	int64_t n;
	long double a, b;
	in >> n >> a >> b;
	vector<Ingr> v(n);
	vector<long double> vresult(n, 0);
	long double aresult = 0, bresult = 0;

	for (int i = 0; i < n; ++i)
	{
		in >> v[i].max >> v[i].a >> v[i].b;
		v[i].index = i;
	}
	sort(v.begin(), v.end(), order);

	for (int i = 0; i < n; ++i)
	{
		if (v[i].max * v[i].b < b - bresult + EPS)
		{
			bresult += v[i].max * v[i].b;
			aresult += v[i].max * v[i].a;
			vresult[v[i].index] = v[i].max;
		}
		else
		{
			long double mn = b - bresult;
			if (mn < EPS && mn > -EPS)
				break;
			mn = mn / (v[i].b);
			bresult += mn* v[i].b;
			aresult += mn * v[i].a;
			vresult[v[i].index] = mn;
			break;
		}
	}

	if (aresult < a) out << "-1 -1" << endl;

	else
	{
		out << aresult << ' ' << bresult << endl;
		for (auto vi : vresult) out << vi << ' ';
	}

}

