#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <deque>
#include <ctime>
#include <set>
#include <map>
#include <cstdint>
#include <fstream>

using namespace std;

ifstream in("knockout.in");
ofstream out("knockout.out");

int main()
{
	long long n, m;
	in >> n >> m;
	vector<long long> a(n), b(n),delta(n);
	vector<long long> x(m), y(m), t(m);
	for (long long i = 0; i < n; i++)
	{
		in >> a[i] >> b[i];
		delta[i] = 2 * (b[i] - a[i]);
	}
	for (long long i = 0; i < m; i++)
	{
		in >> x[i] >> y[i] >> t[i];
		long long count = 0;
		for (long long j = 0; j < n; j++)
		{
			long long v = t[i] % delta[j] + a[j];
			if (v >= x[i] && v <= y[i])
				count++;
		}
		out << count << endl;
	}
}
/*int main()
{
	int n, m;
	in >> n >> m;
	out << n / 2 + m / 2<<endl;
	for (int i = 2; i <= n; i+=2)
	{
		out << i << ' ' << 1 << ' ' << i << ' ' << m<<endl;
	}
	for (int i = 2; i <= m; i += 2)
	{
		out << 1 << ' ' << i << ' ' << n << ' ' << i << endl;
	}
	return 0;
}*/
//
//int main()
//{
//	int64_t count;
//	string str;
//	deque<int> st;
//	in >> str;
//
//	size_t size = str.size();
//	if (size > 9)
//	{
//		count = (size - 9) / 2 + 9;
//		
//
//	}
//	else for (auto a : str) out << a << ' ';
//		
//
//
//	return 0;
//}