#include <vector>
#include <string>
#include <fstream>
using namespace std;

int N;
vector<int> nums;
vector<int> res;

bool search(string::iterator start, string::iterator end, int nn)
{
	if (start == end)
		return true;

	int k = (*start - '0') * 10;
	if (k == 0)
		return false;
	
	start++;
	if (start != end)
	{
		k += *start - '0';

		if (k <= N)
			if (nums[k] == 0)
			{
			nums[k]++;
			res[nn] = k;
			bool ok = search(++start, end, nn + 1);
			if (ok) return true;
			nums[k]--;
			--start;
			}

		k -= (*start - '0');
	}
	k /= 10;
	if (nums[k] == 0)
	{
		nums[k]++;
		res[nn] = k;
		bool ok = search(start, end, nn + 1);
		if (ok) return true;
		nums[k]--;
	}

	return false;
}

int main()
{
	ifstream in("joke.in");
	ofstream out("joke.out");

	string s;
	in >> s;
	if (s.size() < 10)
	{
		for (int i = 0; i < s.size(); i++)
			out << s[i] << " ";
		return 0;
	}

	int size = s.size() - 9;
	size = size / 2;
	N = size + 9;

	nums.resize(N+1);
	res.resize(N);

	search(s.begin(), s.end(), 0);

	for (int i = 0; i < N; i++)
		out << res[i] << " ";

	return 0;
}