#include <iostream>
#include <string>
#include <vector>
#include <time.h>
#include <algorithm>
#include <iomanip>


using namespace std;
typedef long long int i64;
typedef pair<int, int> pint;
typedef pair<i64, i64> pi64;

#define forn(i,n) for (int i = 0; i < n; ++i)
#define down(i,n) for (int i = n-1; i >= 0; --i)
#define ALL(x) x.begin(), x.end()

i64 my_abs(i64 x)
{
	return x >= 0 ? x : (-x);
}
i64 my_sign(i64 x)
{
	return x >= 0 ? 1 : (-1);
}

#define CONTEST "burrito"

struct St
{
	i64 n;
	int i;
	i64 a, b;
	long double c;
	double g;

};



bool cmp1(const St & a, const St & b)
{
	if (a.b == 0 && b.b == 0)
	{

		return a.i < b.i;
	}
	if (a.b == 0)
	{
		return true;
	}
	if (b.b == 0)
	{
		return false;
	}
	return a.c > b.c;

}

bool cmp2(const St & a, const St & b)
{
	return a.i < b.i;


}

int main()
{


	ios_base::sync_with_stdio(false);
#ifdef FI
	freopen("file.in", "r", stdin);
	freopen("file.out", "w", stdout);
#else
	freopen(CONTEST ".in", "r", stdin);
	freopen(CONTEST ".out", "w", stdout);
#endif
	int n;
	double a, b;
	cin >> n >> a >> b;
	cout << fixed << setprecision(10);
	double a0 = a, b0 = b;
	vector<St> arr(n);
	forn(i, n)
	{
		cin >> arr[i].n >> arr[i].a >> arr[i].b;
		if (arr[i].b != 0)
			arr[i].c = (arr[i].a *1.0)  / arr[i].b;
		arr[i].i = i;
	}
	sort(arr.begin(), arr.end(), cmp1);
	forn(i, n)
	{
		double can = arr[i].n;
		double m = 10000;
		if (arr[i].b != 0)
		{
			m = b / arr[i].b;
		}
		can = min(m, can);
		arr[i].g = can;
		a -= can * arr[i].a;
		b -= can * arr[i].b;
	}


	sort(arr.begin(), arr.end(), cmp2);
	double ansA = a0 - a;
	double ansB = b0 - b;
	if (ansA >= a0)
	{
		cout << ansA << " " << ansB << "\n";
		forn(i, n)
		{
			cout << arr[i].g << " ";
		}
	}
	else
	{
		cout << "-1 -1";
	}

	return 0;
}