#include <iostream>
#include <string>
#include <vector>
#include <time.h>
#include <algorithm>



using namespace std;
typedef long long int i64;
typedef pair<int, int> pint;
typedef pair<i64, i64> pi64;

#define forn(i,n) for (int i = 0; i < n; ++i)

i64 my_abs(i64 x)
{
	return x >= 0 ? x : (-x);
}
i64 my_sign(i64 x)
{
	return x >= 0 ? 1 : (-1);
}

pi64 arr[1001];

#define CONTEST "knockout"

int main()
{
#ifdef FI
	freopen("file.in", "r", stdin);
	freopen("file.out", "w", stdout);
#else
	freopen(CONTEST ".in", "r", stdin);
	freopen(CONTEST ".out", "w", stdout);
#endif
	int n, m;
	cin >> n >> m;
	forn(i, n)
	{
		cin >> arr[i].first >> arr[i].second;
	}
	forn(i, m)
	{
		i64 x, y, t;
		cin >> x >> y >> t;
		i64 cnt = 0;
		forn(j, n) {
			i64 a = arr[j].first;
			i64 b = arr[j].second;
			i64 len = my_abs(a - b);
			i64 t2 = t % (2 * len);
			i64 pos;
			//
			if (t2 <= len)
			{
				pos = a + t2*my_sign(b - a);
			}
			else
			{
				pos = b + (t2 - len)*my_sign(a - b);
			}
			if (x <= pos && pos <= y)
			{
				++cnt;
			}
		}
		cout << cnt << endl;
	}

	return 0;
}