#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <list>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))

typedef long long ll;
typedef pair<int, int> pii;

#define TASK "joke"

string s;

void print(vector<char>& spaces)
{
	for (int i = 0; i < s.length(); i++)
	{
		cout << (char)(s[i] + '0');
		if (spaces[i] >= 1)
			cout << ' ';
	}
}

int len = 0;

void f(int i, ll mask, vector<char>& spaces)
{
	if (i > s.length()) return;
	if (i == s.length())
	{
		print(spaces);
		exit(0);
	}
	if (s[i] == 0) return;
	spaces[i]++;

	if (!(mask & (1LL << s[i])))
	{
		if (s[i] <= len)
			f(i + 1, mask | (1LL << s[i]), spaces);
	}

	spaces[i]--;

	if (s[i] * 10 + s[i + 1] <= len)
	{
		if (!(mask & (1LL << (s[i] * 10 + s[i + 1]))))
		{
			if (i + 1 < s.length())
			{
				if (s[i] == 8 && s[i + 1] == 7)
				{
					printf("");
				}
				spaces[i + 1]++;
				f(i + 2, mask | (1LL << (s[i] * 10 + s[i + 1])), spaces);
				spaces[i + 1]--;
			}
		}
	}
}

int main()
{
#ifdef XXX
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#elif defined(TASK)
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#endif

	cin >> s;
	for (int i = 0; i < s.length(); i++)
		s[i] -= '0';

	int res = 0;

	for (int i = 1; i < 60; i++)
	{
		res = i;
		len++;
		if (i >= 10) len++;
		if (len == s.length()) break;
	}

	len = res;

	/*vector<char> used(s.length(), 0);
	vector<char> spaces(s.length(), 0);

	for (int i = 0; i < s.length(); i++)
	{
	if (s[i] == 0)
	{
	spaces[i] = 1;
	used[i] = 1;
	used[i - 1] = 1;
	if (i - 2 >= 0)
	spaces[i - 2] = 1;
	}
	}*/

	//print(spaces);

	vector<char> spaces(s.length());

	f(0, 0LL, spaces);

	return 0;
}