#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <list>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))

typedef long long ll;
typedef pair<int, int> pii;

#define TASK "knockout"

const int N = 1010;
ll a[N], b[N];

int main()
{
#ifdef XXX
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#elif defined(TASK)
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#endif

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i] >> b[i];
	}

	for (int q = 0; q < m; q++)
	{
		ll x, y, t;
		cin >> x >> y >> t;
		int res = 0;
		for (int i = 0; i < n; i++)
		{
			ll cur_t = t;
			ll pos = a[i];
			cur_t %= (b[i] - a[i]) * 2LL;
			if (cur_t <= b[i] - a[i])
			{
				pos = a[i] + cur_t;
			}
			else
			{
				cur_t -= b[i] - a[i];
				pos = b[i] - cur_t;
			}
			if (pos >= x && pos <= y) res++;
		}
		cout << res << endl;
	}

	return 0;
}