#include <cstdio>
#include <iostream>
#include <set>
#include <vector>
#include <cstdlib>
#include <map>
#include <algorithm>
#include <cmath>
#include <climits>
#include <string>
#include <cstring>
#include <cctype>
#include <ctime>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

typedef long long ll;

#define TASK "filter"


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	int m, f;
	scanf("%d%d", &m, &f);
	vector <int> a(f);
	for (int i = 0; i < f; i++)
		scanf("%d", &a[i]);
	int n;
	scanf("%d", &n);
	getchar();
	vector <vector <int> > files (n);
	for (int i = 0; i < n; i++) {
		string temp;
		getline(cin, temp);
		for (int j = 0; j < sz(temp); j++) {
			int c;
			if (isalpha(temp[j]))
				c = temp[j] - 'a' + 10;
			else
				c = temp[j] - '0';
			files[i].pb((c >> 0) & 1);
			files[i].pb((c >> 1) & 1);
			files[i].pb((c >> 2) & 1);
			files[i].pb((c >> 3) & 1);
		}
	}
	int q;
	scanf("%d", &q);
	vector <int> users(q);
	for (int i = 0; i < q; i++)
		scanf("%d", &users[i]);

	vector <vector <int> > vusers(q);
	for (int i = 0; i < q; i++) {
		for (int j = 0; j < f; j++) {
			int h = ((users[i] % m) * (a[j] % m)) % m;
			vusers[i].pb(h);
		}
	}
	vector <int> good_files;
	for (int i = 0; i < n; i++) {
		int cur = 0;
		for (int j = 0; j < q; j++) {
			bool bad = false;
			for (int k = 0; k < sz(vusers[j]); k++) {
				if (files[i][vusers[j][k]] == 0) {
					bad = true;
					break;
				}
			}
			if (!bad)
				cur++;
		}
		if (cur > 0)
			good_files.pb(i);
	}
	printf("%d ", sz(good_files));
	for (int i = 0; i < sz(good_files); i++)
		printf("%d ", good_files[i]);
	return 0;
}