#include <cstdio>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <climits>
#include <cctype>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

typedef long long ll;

#define TASK "knockout"

const int maxn = 1111;
ll x[maxn], y[maxn];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif

	/*int n, m;
	scanf("%d%d", &n, &m);
	printf("%d\n", n / 2 + m / 2);
	for (int i = 0; i < n / 2; i++) {
		printf("%d %d %d %d\n", 2 + 2 * i, 1, 2 + 2 * i, m);
	}
	for (int i = 0; i < m / 2; i++) {
		printf("%d %d %d %d\n", 1, 2 + 2*i, n, 2 + 2*i);
	}*/
	int n, m;
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; i++) {
		scanf("%lld%lld", &x[i], &y[i]);
	}

	for (int i = 0; i < m; i++) {
		ll cx, cy, t;
		scanf("%lld%lld%lld", &cx, &cy, &t);
		int cnt = 0;
		for (int j = 0; j < n; j++) {
			ll tt = (ll)(y[j] - x[j]);
			ll cur = (ll)t % (2LL * tt);
			if (cur > tt) {
				cur = tt - cur;
			}
			cur += x[j];
			if (cx <= cur && cur <= cy)
				cnt++;
		}
		printf("%d\n", cnt);
	}

	return 0;
}