#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define TASK "burrito"

int n, A, B;
struct bur{
	int id;
	int g;
	int a;
	int b;
};
 
bool const operator<(bur A, bur B){
	return A.a*B.b < A.b*B.a;
}

vector<bur> bs;

int ids[(int)1e5];

int main()
{
#ifdef MYCOMP
	freopen("input.txt", "r", stdin);
#else
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#endif

	cin >> n >> A >> B;
	
	
	int b=0, a=0;
	for (int i = 0; i < n; i++)
	{
		bur t;
		cin >> t.g >> t.a >> t.b;
		t.id = i;
		bs.push_back(t);
	}
	sort(bs.begin(), bs.end());
	int j;
	for (j = bs.size()-1; j >= 0; j--)
	{
		bur t = bs[j];
		if (b + t.b*t.g > B)
			break;

		ids[t.id] = t.g;
		b += t.g*t.b;
		a += t.g*t.a;
	}

	double AS, BS;
	AS = a;
	BS = b;
	double w = 0;
	if (j >= 0)
	{
		bur t = bs[j];
		j = t.id;
		w = 1. * (B - b) / t.b;
		AS += w * t.a;
		BS = B;
	}

	cout.precision(20);
	if (AS < A - 1e-12) cout << "-1 -1";
	else
	{
		cout << AS << " " << BS << endl;
		for (int i = 0; i < n; i++)
			cout << (i == j ? w : ids[i]) << " ";
	}

	return 0;
}