#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define TASK "burrito"

struct bur
{
	int id;
	int g;
	int a;
	int b;
};

bool operator<(bur A, bur B)
{
	return A.a*B.b < A.b*B.a;
}

vector<bur> bs;

int ids[(int)1e6];

int main()
{
#ifdef MYCOMP
	freopen("input.txt", "r", stdin);
#else
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#endif

	int n, A, B;
	cin >> n >> A >> B;

	int a = 0, b = 0;
	for (int i = 0; i < n; i++)
	{
		bur t;
		cin >> t.g >> t.a >> t.b;
		t.id = i;
		bs.push_back(t);
	}
	sort(bs.begin(), bs.end());
	int j;
	for (j = n - 1; j >= 0; j--)
	{
		bur t = bs[j];
		if (b + t.b*t.g > B)
			break;

		ids[t.id] = t.g;
		a += t.g*t.a;
		b += t.g*t.b;
	}

	if (j >= 0)
	{
		bur t = bs[j];
		j = t.id;
		double w = 1. * (B - b) / t.b;
		double AS = a + w * t.a;

		if (1ll * (B - b) * t.a < 1ll * (A - a) * t.b)
		{
			cout << "-1 -1";
			return 0;
		}

		cout.precision(16);
		cout << AS << " " << B << endl;
		for (int i = 0; i < n; i++)
		{
			if (i == j)
				cout << w;
			else
				cout << ids[i];
			cout << " ";
		}
	}
	else
	{
		if (a < A)
		{
			cout << "-1 -1";
			return 0;
		}

		cout << a << " " << b << endl;
		for (int i = 0; i < n; i++)
			cout << ids[i] << " ";
	}

	return 0;
}