#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <set>
#include <cstring>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <climits>
//#include <cstring>

using namespace std;

#define CPPINP
#define CPPOUTP
//#define STDINP
//#define STDOUTP

int main()
{
	char inpfname[100] = "joke.in";
	char outpfname[100] = "joke.out";
#ifdef CPPINP
#ifdef STDINP
#define inp cin
#else
	ifstream inp(inpfname);
#endif
#else
#ifndef STDINP
	freopen(inpfname, "r", stdin);
#endif
#endif

#ifdef CPPOUTP
#ifdef STDOUTP
#define outp cout
#else
	ofstream outp(outpfname);
#endif
#else
#ifndef STDOUTP
	freopen(outpfname, "w", stdout);
#endif
#endif
	

	int fix[51];
	for (int i = 0; i < 51; ++i)
		fix[i] = 0;

	char *line = new char[120];
	inp >> (line + 1);
	int len = strlen(line + 1);
	line[0] = '0' + 10;
	line[len + 1] = '0' + 10;
	line[len + 2] = 0;

	int n = 0;
	if (len > 9)
		n = 9 + (len - 9) / 2;
	else
		n = len;

	char numstr[5] = "00";

	//   
	for (int i = 1; i <= len; ++i)
	{
		if (line[i] == '0')
		{
			numstr[0] = line[i - 1];
			numstr[1] = line[i];
			line[i] += 10;
			line[i - 1] += 10;
			fix[atoi(numstr)] = i - 1;
		}
	}

	/*
	for (int i = 1; i <= 100; ++i)
	{
	for (int j = 1; j <= n; ++j)
	{
	if (fix[j] == i)
	{
	outp << j << ' ';
	}
	}
	}
	outp << endl;
	outp << line << endl;
	*/

	//   99  max(n+1, 11)
	for (int i = 99; i >= max(n + 1, 11); --i)
	{
		sprintf(numstr, "%d", i);
		for (int j = 1; j <= len - 1; ++j)
		{
			if ((line[j] == numstr[0]) && (line[j + 1] == numstr[1]))
			{
				char numstr2[5] = "0";
				if (line[j - 1] > '9')
				{
					numstr2[0] = line[j];
					numstr2[1] = 0;
					line[j] += 10;
					fix[atoi(numstr2)] = j;
				}
				else
				{
					numstr2[0] = line[j - 1];
					numstr2[1] = line[j];
					numstr2[2] = 0;
					if (atoi(numstr2) > n)
					{
						numstr2[0] = line[j];
						numstr2[1] = 0;
						line[j] += 10;
						fix[atoi(numstr2)] = j;
					}
				}

				if (line[j + 2] > '9')
				{
					numstr2[0] = line[j + 1];
					numstr2[1] = 0;
					line[j + 1] += 10;
					fix[atoi(numstr2)] = j + 1;
				}
				else
				{
					numstr2[0] = line[j + 1];
					numstr2[1] = line[j + 2];
					numstr2[2] = 0;
					if (atoi(numstr2) > n)
					{
						numstr2[0] = line[j + 1];
						numstr2[1] = 0;
						line[j + 1] += 10;
						fix[atoi(numstr2)] = j + 1;
					}
				}
			}
		}
	}

	
	/*
	for (int i = 1; i <= 100; ++i)
	{
	for (int j = 1; j <= n; ++j)
	{
	if (fix[j] == i)
	{
	outp << j << ' ';
	}
	}
	}
	outp << endl;
	outp << line << endl;
	*/
	




	for (;;)
	{
		int changed = 0;

		for (int i = n; i >= 11; --i)
		{
			if (fix[i])
				continue;

			int found_first = 0, found_count = 0;
			sprintf(numstr, "%d", i);

			for (int j = 1; j <= len - 1; ++j)
			{
				if ((line[j] == numstr[0]) && (line[j + 1] == numstr[1]))
				{
					if (!found_count)
						found_first = j;
					++found_count;

					if (found_count > 1)
					{
						break;
					}
				}
			}

			if (found_count == 1)
			{
				changed = 1;

				fix[atoi(numstr)] = found_first;
				line[found_first] += 10;
				line[found_first + 1] += 10;
			}
		}


		int compl = 1;
		for (int i = n; i >= 11; --i)
		{
			if (!fix[i])
			{
				compl = 0;
				break;
			}
		}
		if (compl)
			break;

		changed = 0;
		for (int i = n; (i >= 11) && (!changed) ; --i)
		{
			if (!fix[i])
			{
				sprintf(numstr, "%d", i);
				for (int j = len - 1; j >= 1; --j)
				{
					if ((line[j] == numstr[0]) && (line[j + 1] == numstr[1]))
					{
						fix[atoi(numstr)] = j;
						line[j] += 10;
						line[j + 1] += 10;
						changed = 1;
						break;
					}
				}
			}
		}
	}

	
	/*
	for (int i = 1; i <= 100; ++i)
	{
	for (int j = 1; j <= n; ++j)
	{
	if (fix[j] == i)
	{
	outp << j << ' ';
	}
	}
	}
	outp << endl;
	outp << line << endl;
	*/
	

	numstr[1] = 0;
	for (int j = 1; j <= len; ++j)
	{
		if (line[j] <= '9')
		{
			numstr[0] = line[j];
			fix[atoi(numstr)] = j;
			line[j] += 10;
		}
	}


	for (int i = 1; i <= 100; ++i)
	{
		for (int j = 1; j <= n; ++j)
		{
			if (fix[j] == i)
			{
				outp << j << ' ';
			}
		}
	}
	outp << endl;

	//outp << line << endl;

	delete[] line;
	return 0;
}
