#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
using namespace std;
#define double long double

typedef long long int LL;

struct sweet {
	int order;
	double a;
	double b;
	double g;
};

const double INF = 1e18;

double fun (double a, double b) {
	if (!b) return INF;
	return a / b;
}

bool comp(const sweet &a, const sweet &b) {
	return (fun(a.a, a.b) > fun(b.a, b.b));
}

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	int n;
	double A, B;
	cin >> n >> A >> B;
	vector < sweet > input(n);
	for (int i = 0; i < n; ++i) {
		cin >> input[i].g >> input[i].a >> input[i].b;
		input[i].order = i;
	}
	sort(input.begin(), input.end(), comp);
	vector <double> answer(n);
	double good = 0.0, bad = 0.0;
	for (int i = 0; i < n; ++i) {
		if (!input[i].b) {
			good += input[i].a * input[i].g;
			answer[input[i].order] = input[i].g;
		}
		else {
			double add = min((B - bad) / input[i].b, input[i].g);
			good += input[i].a * add;
			bad += input[i].b * add;
			answer[input[i].order] = add;
		}
	}
	cout.precision(12);
	if (good < A) {
		cout << "-1 -1";
	}
	else {
		cout << fixed << good << " " << bad << endl;
		for (int i = 0; i < n; ++i) {
			cout << fixed << answer[i] << " ";
		}
	}
	return 0;
}