#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <cmath>

using namespace std;
#define double long double

typedef long long int LL;

int a[1000001];
const int inf = 1000000;

int tr[1000001];


void Set(int v, int x, int val, int L, int R)
{
	if (L == R)
		tr[v] = val;
	else
	{
		int m = (L + R) >> 1;
		if (x <= m)
			Set(v << 1, x, val, L, m);
		else
			Set(v << 1 | 1, x, val, m+1, R);
		
		tr[v] = tr[v << 1] + tr[v << 1 | 1];
	}
}

int Get(int v, int l, int r, int L, int R)
{
	if (l > r)
		return 0;
	if (L == l && r==R)
		return tr[v];
	else
	{
		int m = (L + R) >> 1;
		int A = Get(v << 1, l, min(m, r), L, m);
		int B = Get(v << 1 | 1, max(l, m + 1), r, m + 1, R);

		return A + B;
	}
}

int ans[1000001];

int main()
{
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);

	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
		Set(1, a[i], 1, 0, n);
	}
	Set(1, a[1], 0, 0, n);
	Set(1, a[2], 0, 0, n);
	bool more = true;
	vector<int> nums;
	//set<int> SUM;
	nums.push_back(1);
	nums.push_back(2);
	more = a[1] < a[2];

	int SUM = 0;
	int Max = 0;

	for (int i = 3; i <= n; ++i)
	{
		Set(1, a[i], 0, 0, n);
		if (a[i] > a[i - 1])
		{
			if (more)
			{
				nums.push_back(i);
			}
			else
			{
				more = true;

				//SOLVE();
				int A = a[nums[0]];
				int B = a[nums.back()];
				int Less = Get(1, 0, B - 1, 0, n);
				int Moar = Get(1, A + 1, n, 0, n);
				 
				if (Less)
					ans[nums.back()] = 1;
				if (Moar)
					ans[nums[0]] = 1;

				SUM += nums.size() - 2;
				Max = max(Max, (int)nums.size() - 2);

				nums.clear();
				nums.push_back(i - 1);
				nums.push_back(i);
			}
		}
		else 
		{
			if (more)
			{
				more = false;

				int A = a[nums[0]];
				int B = a[nums.back()];
				int Less = Get(1, 0, A - 1, 0, n);
				int Moar = Get(1, B + 1, n, 0, n);

				if (Moar)
					ans[nums.back()] = 1;

				if (Less)
					ans[nums[0]] = 1;

				SUM += nums.size() - 2;
				Max = max(Max, (int)nums.size() - 2);

				nums.clear();
				nums.push_back(i-1);
				nums.push_back(i);
			}
			else
			{
				nums.push_back(i);
			}
		}
	}

	SUM += nums.size() - 2;
	Max = max(Max, (int)nums.size() - 2);
	//cout << SUM << ' ' << Max << endl;
	int cnt = 0;
	
	for (int i = 1; i <= n; ++i)
	{
		cnt += ans[i];
		//cout << ans[i] << endl;
	}

	cout << n - cnt - SUM + Max;

	return 0;
}