#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
using namespace std;

int dp[101][50];
typedef long long ll;
ll mask;
vector<int> ans;
string s;

bool dfs(int i)
{
	if (i == s.length())
		return (mask == ((1ll << ans.size()) - 1));

	int num = s[i] - '0';
	if (num == 0)return false;

	if (!(mask >> (num - 1) & 1))
	{
		mask |= (1ll << (num - 1));
		ans.push_back(num);
		if(dfs(i + 1))return true;
		ans.pop_back();
		mask -= (1ll << (num - 1));
	}
	if (i + 1 < s.length())
	{
		int num2 = num * 10 + s[i + 1] - '0';
		if (!(mask >> (num2 - 1) & 1))
		{
			mask |= (1ll << (num2 - 1));
			ans.push_back(num2);
			if (dfs(i + 2))return true;
			ans.pop_back();
			mask -= (1ll << (num2 - 1));
		}
	}
	return false;
}
int main()
{
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);

	cin >> s;

	if (s.length() <= 10)
	{
		for (int i = 0; i < s.length(); ++i)
			cout << s[i] << ' ';
	}
	else
	{
		dfs(0);
		for (int i = 0; i < ans.size(); ++i)
			cout << ans[i] << ' ';
	}
	return 0;
}