
#define _CRT_SECURE_NO_DEPRECATE
#include <iostream>
#include <cstdio>
#include <map>
#include <string>
#include <cstdlib>
#include <utility>
#include <vector>
#include <algorithm>
using namespace std;
typedef pair<int, int> pii;
#define TASK "filter"
#define hex huipizda
#define sz(C) (int) (C).size()
#define all(C) (C).begin(), (C).end()
int m, f, q, n;
int hv[200];
bool bloom[1100][1100];
char buff[1100];
int queries[1100];
bool ans[1100];
int hex_to_dec (char h)
{
    if (h >= '0' && h <= '9')
        return h - '0';
    if (h >= 'a' && h <= 'f')
        return h - 'a' + 10;
}
 
bool check (int id, int ind)
{
    for (int i = 0; i < f; ++i)
    {
        int j = (id * 1ll * hv[i]) % m;
        if (!bloom[ind][j])
            return false;
    }
    return true;
}
int main()
{
    freopen(TASK ".in", "r", stdin);
    freopen(TASK ".out", "w", stdout);
    scanf ("%d %d", &m, &f);
    for (int i = 0; i < f; ++i)
        scanf ("%d", &hv[i]);
    scanf ("%d\n", &n);
    for (int i = 0; i < n; ++i)
    {
        gets (buff);
        int l = strlen (buff);
        int ind = 0;
        for (int j = 0; j < l; ++j)
        {
            int dec = hex_to_dec (buff[j]);
            for (int k = 0; k < 4; ++k)
            {
                bloom[i][ind++] = ((1 << k) & dec) != 0;
            }
        }
    }
 
    scanf ("%d", &q);
 
    for (int i = 0; i < q; ++i)
    {
        int cur_q;
        scanf ("%d", &cur_q);
        for (int j = 0; j < n; ++j)
        {
            ans[j] = check (cur_q, j);
        }
    }
 
    int res = 0;
    vector <int> full_ans;
    for (int i = 0; i < n; ++i)
    {
        if (ans[i])
        {
            ++res;
            full_ans.push_back(i);
        }
    }
 
    sort (all (full_ans) );
    printf ("%d ", res);
 
    for (int i = 0; i < sz(full_ans); ++i)
    {
        printf ("%d ", full_ans[i]);
    }
 
    return 0;
}