//#pragma comment(linker, "/STACK:1000000000")
#define _CRT_SECURE_NO_DEPRECATE
#define _USE_MATH_DEFINES
#include <cstdio>
#include <iostream>
#include <cmath>
#include <cstdlib>
#include <algorithm>
#include <memory.h>
#include <utility>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <string>
#include <queue>
using namespace std;

#define forn(i, n) for (int i = 0; i < (n); ++i)
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define mod 1000000007
#define inf 2000000000
typedef long long ll;
typedef unsigned long long ull;

bool d[1024][1024];
long long h[1010];
int n, f;
long long m;
const char conv[] = { "0123456789abcdef" };
bool u[1024];
bool ok[1024];
string s;

void solve(long long uk)
{
	//memset(u, 0, sizeof u);
	memset(ok, 1, sizeof ok);
	long long cur;
	for (int i = 0; i < f; i++)
	{
		cur = (uk * h[i]) % m;
		//cout << uk << " + " << h[i] << " => " << cur << endl;
		for (int j = 0; j < n; j++)
			if (!d[j][cur])
				ok[j] = false;
	}
	for (int i = 0; i < n; i++)
	{
		if (ok[i])
			u[i] = 1;
	}
}

int main()
{
	ios_base::sync_with_stdio(false); cin.tie(0);
	//freopen("input.txt", "rt", stdin); freopen("output.txt", "wt", stdout);
	freopen("filter.in", "rt", stdin); freopen("filter.out", "wt", stdout);
	cin >> m >> f;
	for (int i = 0; i < f; i++)
		cin >> h[i];
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> s;
		for (int j = 0; j < s.size(); j++)
		{
			int val;
			for (int k = 0; k < 16; k++)
				if (conv[k] == s[j])
					val = k;
			for (int k = 0; k < 4; k++)
			{
				d[i][j * 4 + k] = (val & 1);
				val >>= 1;
			}
		}
		/*for (int j = 0; j < m; j++)
		{
		cout << d[i][j];
		}
		cout << endl;*/
	}
	int q, uk;
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		cin >> uk;
		solve(uk);
	}

	int ans = 0;
	for (int i = 0; i < n; i++)
		ans += u[i];
	cout << ans << " ";
	for (int i = 0; i < n; i++)
		if (u[i])
			cout << i << " ";

	return 0;
}