#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
const double eps = 1e-9;


int ton(char a) {
	if (a >= '0' && a <= '9')
		return a - '0';
	else {
		return 10 + (a - 'a');
	}
}

int main(){
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);

	int ht[16][4] = {
			{ 0, 0, 0, 0 },
			{ 0, 0, 0, 1 },
			{ 0, 0, 1, 0 },
			{ 0, 0, 1, 1 },
			{ 0, 1, 0, 0 },
			{ 0, 1, 0, 1 },
			{ 0, 1, 1, 0 },
			{ 0, 1, 1, 1 },
			{ 1, 0, 0, 0 },
			{ 1, 0, 0, 1 },
			{ 1, 0, 1, 0 },
			{ 1, 0, 1, 1 },
			{ 1, 1, 0, 0 },
			{ 1, 1, 0, 1 },
			{ 1, 1, 1, 0 },
			{ 1, 1, 1, 1 }
	};


	int m, f;
	vector <long> aa;
	long a;
	cin >> m >> f;
	vector <string> hashes;
	vector <int> used, ans;
	for (int i = 0; i < f; i++) {
		cin >> a;
		aa.push_back(a);
	}
	int n;
	cin >> n;
	string hsh;
	for (int i = 0; i < n; i++) {
		cin >> hsh;
		hashes.push_back(hsh);
		used.push_back(0);
	}
	int q;
	cin >> q;
	long u;

	vector <int> hm;
	long valid;
	for (int i = 0; i < q; i++) {
		cin >> u;
		hm.erase(hm.begin(), hm.end());
		for (int k = 0; k < aa.size(); k++) {
			hm.push_back((aa[k] * u) % m);
		}
		for (int j = 0; j < n; j++) {
			if (!used[j]) {
				valid = 0;
				for (int cnt = 0; cnt < hm.size(); cnt++) {
					int in = (hm[cnt] / 4);
					int in_num = hm[cnt] % 4;
					char c = hashes[j][in];

					int hmm = ton(c);
					if (ht[hmm][3 - in_num] == 1) {
						valid++;
					}
					else {
						break;
					}
				}
				if (valid == hm.size()) {
					ans.push_back(j);
					used[j] = 1;
				}
			}
		}
	}

	sort(ans.begin(), ans.end());
	cout << ans.size() << " ";
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << " ";
	}

	return 0;
}
