#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;

inline int tn(char a) {
	return a - '0';
}

int parse(vector<int> &u, vector<int> &a, string &l, int ptr, int maxc) {
	if (ptr >= l.size()) {
		return 1;
	}
	if (ptr == l.size() - 1) {
		if (u[l[ptr] - '0'] == 1) {
			return -1;
		}
		else {
			a.push_back(l[ptr] - '0');
			return 1;
		}
	}
	if (tn(l[ptr]) == 0) {
		return -1;
	}
	//one num
	{
		if (!u[tn(l[ptr])])
		{
			u[tn(l[ptr])] = 1;
			a.push_back(tn(l[ptr]));
			int r = parse(u, a, l, ptr + 1, maxc);
			if (r == 1) {
				return 1;
			}
			a.pop_back();
			u[tn(l[ptr])] = 0;
		}
	}
	//two num
	int cn = tn(l[ptr]) * 10 + tn(l[ptr + 1]);
	if (cn <= maxc && !u[cn]) {
		u[cn] = 1;
		a.push_back(cn);
		int r = parse(u, a, l, ptr + 2, maxc);
		if (r == 1) {
			return r;
		}
		else {
			u[cn] = 0;
			a.pop_back();
			return -1;
		}
	}
	else {
		return -1;
	}
}

int main(){
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
	string line;
	cin >> line;
	vector <int> used, ans;
	int n = line.size();
	if (n < 10) {
		for (int i = 0; i < line.size(); i++) {
			cout << line[i] << " ";
		}
		return 0;
	}
	else {
		int maxc = (int)((n - 9) / 2 + 9);
		for (int i = 0; i <= maxc; i++) {
			used.push_back(0);
		}
		int r = parse(used, ans, line, 0, maxc);
		if (r) {
			for (int i = 0; i < ans.size(); i++) {
				cout << ans[i] << " ";
			}
		}
		else {
			cout << "error" << endl;
		}
	}


	return 0;
}

