#include <cstdlib>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <functional>
#include <cctype>
#include <string>
#include <stack>
#include <queue>
#include <ctime>
#include <iostream>

#define MIN(A, B) ((A) < (B) ? (A) : (B))
#define MAX(A, B) ((A) > (B) ? (A) : (B))
#define ABS(A, B) ((A) < 0 ? -1 * (A) : (A))

using namespace std;

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	vector<int> g, a, b;

	int n, A, B;
	cin >> n >> A >> B;

	g.resize(n, 0);
	a.resize(n, 0);
	b.resize(n, 0);

	for (int i = 0; i < n; i++)
		cin >> g[i] >> a[i] >> b[i];

	vector<pair<double, int>> k;
	for (int i = 0; i < n; i++)
	{
		k.push_back(make_pair((double)a[i] / b[i], i));
		sort(k.begin(), k.end());
	}

	double aR = 0, bR = 0;
	vector<double> result;
	result.resize(n, 0);
	for (int i = n - 1; i >= 0; i--)
	{
		int ind = k[i].second;
		result[ind] = MIN(g[ind], ((double)B - bR) / b[ind]);
		bR += result[ind] * b[ind];
		aR += result[ind] * a[ind];
	}

	if (aR > A)
	{
		cout << aR << " " << bR << endl;
		for (int i = 0; i < n; i++)
			cout << result[i] << " ";
		cout << endl;
	}
	else
	{
		cout << "-1 -1" << endl;
	}

	return 0;
}
