#include <cstdlib>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <functional>
#include <cctype>
#include <string>
#include <stack>
#include <queue>
#include <ctime>
#include <iostream>

#define MIN(A, B) ((A) < (B) ? (A) : (B))
#define MAX(A, B) ((A) > (B) ? (A) : (B))
#define ABS(A, B) ((A) < 0 ? -1 * (A) : (A))

using namespace std;

int main()
{
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);

	int m, f, a[100];

	cin >> m >> f;
	for (int i = 0; i < f; i++)
		scanf("%d", &a[i]);

	int n;
	cin >> n;

	vector <bool> filt[1000];

	for (int i = 0; i < n; i++)
	{
		string s;
		cin >> s;

		filt[i].resize(m + 4, 0);
		for (int j = 0; j < s.length(); j++)
		{
			int x;
			if ('0' <= s[j] && s[j] <= '9')
				x = s[j] - '0';
			else
				x = s[j] - 'a' + 10;
			filt[i][4 * j + 0] = x & 1;
			filt[i][4 * j + 1] = x & 2;
			filt[i][4 * j + 2] = x & 4;
			filt[i][4 * j + 3] = x & 8;
		}
	}

	int q;
	int u[1000];
	cin >> q;
	for (int i = 0; i < q; i++)
		scanf("%d", &u[i]);

	vector <int> mask[1000];
	for (int i = 0; i < q; i++)
	{
		mask[i].resize(m, 0);
		for (int j = 0; j < f; j++)
		{
			int x = ((long long unsigned)u[i] * a[j]) % m;
			mask[i][x] = 1;
		}
	}

	vector <int> files;

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < q; j++)
		{
			bool f = true;
			for (int k = 0; k < m; k++)
				//if (filt[i][k] & mask[j][k] != mask[j][k])
				if (mask[j][k] && !filt[i][k])
					f = false;
			if (f)
			{
				files.push_back(i);
				break;
			}
		}
	}

	cout << files.size();
	for (int i = 0; i < files.size(); i++)
		printf(" %d", files[i]);

	printf("\n");

	return 0;
}
