#include <stdio.h>
#include <cstdio>
#include <cmath>
#include <vector>
#include <map>
#include <queue>
#include <algorithm>
#include <iostream>
#include <string>

using namespace std;

#define int64 long long
#define FOR(i, n) for (int i =0; i < n ; i++)

#define TASK "filter"

vector<int64> base[1005];
vector<int64> users[1005];

char mm[] = { '0', '8', '4', 'c', '2', 'a', '6', 'e', '1', '9', '5', 'd', '3', 'b', '7', 'f'};

int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);

	int m, f;

	cin >> m >> f;

	vector<int> hashes(f);
	FOR(i, f)
		scanf("%d", &hashes[i]);

	int n;
	cin >> n;
	FOR(i, n)
	{
		string s;
		cin >> s;
		int64 cur = 0;
		int nm = 0;
		FOR(j, s.length())
		{
			if (isdigit(s[j]))
				s[j] = mm[s[j] - '0'];
			else
				s[j] = mm[s[j] - 'a' + 10];
		}
		FOR(j, s.length())
		{
			cur = cur * 16;
			if (isdigit(s[j]))
				cur += s[j] - '0';
			else
				cur += s[j] - 'a' + 10;
			nm++;
			if (nm >= 8)
			{
				cur = 0;
				nm = 0;
				base[i].push_back(cur);
			}
		}
		if (nm != 0)
			base[i].push_back(cur);
	}
	int q;
	cin >> q;
	int blocks = (int)ceil((double)m / 32.0);//todo check
	FOR(i, q)
	{
		int u;
		scanf("%d", &u);
		users[i].resize(blocks);
		FOR(j, f)
		{
			int curCheck = (u * hashes[j]) % m;
			int inPos = curCheck / 32;
			if (inPos == blocks - 1)
				users[i][inPos] |= 1 << (31 - curCheck % 32 - (32 - m % 32 -1 ));
			else
				users[i][inPos] |= 1 << (31 - curCheck % 32);
			//users[i][inPos] |= 1 << (curCheck % 32);
		}
	}
	vector<int> res;
	FOR(i, n)
	{
		bool good = false;
		FOR(j, q)
		{
			bool goodUser = true;
			FOR(k, blocks)
			{
				if ((base[i][k] & users[j][k]) != users[j][k])
				{
					goodUser = false;
					break;
				}
			}
			good |= goodUser;
			if (good)
				break;
		}
		if (good)
			res.push_back(i);
	}
	cout << res.size();
	FOR(i, res.size())
		printf(" %d", res[i]);
	return 0;
}