#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <bitset>
#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <sstream>
#include <cstring>
#include <deque>
#include <queue>
#include <cmath>
using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef long double ldouble;
typedef long long llong;
typedef unsigned long long ullong;

#define forn(i,n) for(int i=0; i<(n); i++)
#define sz(x) int((x).size())
#define pb push_back
#define mp make_pair
#define inf int(1e9)
#define linf llong(4e18)

#define TASK "filter"

vector<vector<int>> userBits;
bool result[1000];

bool IsGood(const vector<char>& h) {
	for (const auto& bits : userBits) {
		for (int bit : bits)
			if (!h[bit])
				goto no;
		return true;
	no:
		;
	}
	return false;
}

int main() {
	freopen(TASK ".in", "r", stdin);
#ifndef LOCAL_PROJECT
	freopen(TASK ".out", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int i, j, m, f, n, q;
	string s;
	while (cin >> m >> f) {
		vector<int> a(f);
		for (auto& x : a) {
			cin >> x;
			x %= m;
		}
		cin >> n;
		vector<vector<char>> hashes(n);
		for (auto& h : hashes) {
			cin >> s;
			h.reserve(m);
			for (char c : s) {
				int x;
				if (isdigit(c))
					x = c - '0';
				else
					x = c - 'a' + 10;
				h.push_back(x & 0x1);
				h.push_back(x & 0x2);
				h.push_back(x & 0x4);
				h.push_back(x & 0x8);
			}
		}
		cin >> q;
		vector<int> userIds(q);
		for (int& x : userIds)
			cin >> x;
		userBits.clear();
		userBits.resize(q);
		for (i = 0; i < q; i++)
			for (j = 0; j < f; j++)
				userBits[i].push_back(((userIds[i] % m) * a[j]) % m);
		int resultCount = 0;
		memset(result, 0x00, sizeof result);
		/*
		for (const auto& h : hashes) {
			for (i = 0; i < (int)h.size(); i++) {
				if (!(i % 4))
					cerr << ' ';
				cerr << h[i];
			}
			cerr << '\n';
		}
		for (const auto& bits : userBits) {
			for (int x : bits)
				cerr << x << ' ';
			cerr << '\n';
		}
		*/
		for (i = 0; i < n; i++)
			if (IsGood(hashes[i])) {
				result[i] = true;
				resultCount++;
			}
		cout << resultCount << ' ';
		for (i = 0; i < n; i++)
			if (result[i])
				cout << i << ' ';
		cout << '\n';
	}
	return 0;
}
