#define USE_MATH_DEFINES
#include <iostream>
#include <cmath>
#include <cstdlib>
#include <cstdio>
#include <fstream>
#include <vector>
#include <string>
#include <set>
#include <iomanip>
#include <stack>
#include <map>
#include <queue>
#include <memory>
#include <algorithm>

#define pb push_back
#define vi vector<int>
#define ll long long
#define vii vector<pair< int, int> >
#define f first
#define s second
#define mp make_pair
using namespace std;
//___________________________

int A[1000];
int B[1000];
int coeff_win[1000];

int main(){
	ifstream cin("knockout.txt");
	ofstream cout("knockout.txt");

	int m, n;
	cin >> m >> n;

	for (int i = 0; i < n; i++)
	{
		cin >> A[i] >> B[i];
		coeff_win[i] = B[i] > A[i] ? 1 : -1;
	}

	for (int i = 0; i < m; i++)
	{
		int a, b, t;
		int count = 0; 
		cin >> a >> b >> t;

		for (int j = 0; j < n; j++)
		{
			int dist = abs(B[j] - A[j]);
			int offset = t % (2 * dist);
			
			int coord;

			if (offset < dist)
				coord = A[j] + coeff_win[j] * offset;
			else
				coord = B[j] - coeff_win[j] * (offset - dist);
			if (coord <= b && coord >= a) count++;
		}

		cout << count << endl;

	}

	return 0;
}