#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <queue>
using namespace std;

const double EPS = 1e-8;

class ingredient
{
public:
	long id;
	long happy, sad;
	long quantity;

	double used;

	ingredient(){ used = 0;	quantity = happy = sad = 0; id = -1; }
	
	ingredient(long q, long h, long s, long i)
	{
		used = 0;
		quantity = q; happy = h; sad = s; id = i; 
	}

	double getOptimality()
	{
		double h = happy;
		double s = sad;

		if (sad == 0)
			return 101;
		return h / s;
	}
};

bool operator<(const ingredient a, const ingredient b)
{
	//TODO: check
	return a.happy*b.sad > a.sad*b.happy;

	//return a.getOptimality() > b.getOptimality();
}



int main()
{
	if ( true )
	{
		freopen("burrito.in", "r", stdin);
		freopen("burrito.out", "w", stdout);
	}

	long A, B, n, i, g ,a,b;

	long tempA = 0, tempB = 0;
	
	cin >> n >> A >> B;

	vector <ingredient> mas(n);
	vector <double> answer(n,0.0);

	for (i = 0; i < n; i++)
	{
		cin >> g >> a >> b;
		//TODO CHECK
		mas[i] = ingredient(g, a, b, i+1);

	}
	
	sort(mas.begin(), mas.end());

	double H, S;
	H = S = 0.0;

	for (i = 0; i < n; i++)
	{

		long long SS = B;

		SS -= tempB;
		SS -= mas[i].quantity*mas[i].sad;

		if (0<=SS)
		{
			tempA += mas[i].quantity*mas[i].happy;

			tempB += mas[i].quantity*mas[i].sad;
			

			answer[mas[i].id - 1] = mas[i].quantity;

			H = tempA;
			S = tempB;
		}
		else
		{
			double newQ = B - tempB;
			double sd = mas[i].sad;

			

			newQ /= sd;

			answer[mas[i].id-1] = newQ;

			H = tempA; H += newQ*(double)mas[i].happy;
			S = tempB; S += newQ*(double)mas[i].sad;

		}
	}

	if (H - (double)A > 0 || fabs(H-(double)A)<EPS )
	{
		printf("%.9lf %.9lf\n", H, S);
		for (int j = 0; j < n; j++)
			printf("%.9lf ", answer[j]);
	}
	else
		cout << "-1 -1" << endl;

	return 0;
}