#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <queue>
using namespace std;

const double EPS = 1e-8;

class ingredient
{
public:
	long id;
	long happy, sad;
	long quantity;

	double used;

	ingredient(){ used = 0;	quantity = happy = sad = 0; id = -1; }
	
	ingredient(long q, long h, long s, long i)
	{
		used = 0;
		quantity = q; happy = h; sad = s; id = i; 
	}

	double getOptimality()
	{
		double h = happy;
		double s = sad;

		if (sad == 0)
			return 101;
		return h / s;
	}
};

bool operator<(const ingredient a, const ingredient b)
{
	//TODO: check

	if (a.happy*b.sad == a.sad*b.happy)
		return a.quantity > b.quantity;

	return a.happy*b.sad > a.sad*b.happy;

	//return a.getOptimality() > b.getOptimality();
}


const long long BASE = 100000000;

void p(long long a)
{
	cout << a / BASE << "." << a%BASE;
}

int main()
{
	if ( true )
	{
		freopen("burrito.in", "r", stdin);
		freopen("burrito.out", "w", stdout);
	}

	long A, B, n, i, g ,a,b;

	long tempA = 0, tempB = 0;
	
	cin >> n >> A >> B;

	vector <ingredient> mas(n);
	vector <double> answer(n,0.0);
	vector <long long> lanswer(n, 0);


	for (i = 0; i < n; i++)
	{
		cin >> g >> a >> b;
		//TODO CHECK
		mas[i] = ingredient(g, a, b, i+1);

	}
	
	sort(mas.begin(), mas.end());

	double H, S;
	H = S = 0.0;

	long long lH = 0, lS = 0;
	long long ltempA = 0, ltempB = 0;

	int I;
	bool prepareBAD = false;

	for (i = 0; i < n; i++)
	{

		long long SS = B;

		SS -= tempB;
		SS -= mas[i].quantity*mas[i].sad;



		if (0<=SS)
		{
			ltempA += mas[i].quantity*mas[i].happy;

			ltempB += mas[i].quantity*mas[i].sad;
			

			lanswer[mas[i].id - 1] = BASE * mas[i].quantity;
		}
		else
		{
			I = i;
			prepareBAD = true;
			break;
		}
	}

	ltempA *= BASE;
	ltempB *= BASE;

	if (prepareBAD)
	{
		i = I;

		long long Q = (BASE*B - ltempB)/mas[i].sad;


		lanswer[mas[i].id - 1] = Q;

		ltempA += Q*(long long)mas[i].happy;
		ltempB += Q*(long long)mas[i].sad;

	}
	cerr << ltempA << " ";

	if (ltempA - A*BASE >= 0)
	{
		p(ltempA);
		cout << " ";
		p(ltempB);
		cout << endl;
		for (int j = 0; j < n; j++)
		{
			p(lanswer[j]);
			cout << " ";
		}
	}
	else
		cout << "-1 -1" << endl;

	return 0;
}