#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <functional>
#include <utility>

using namespace std;

struct burrito
{
	int g, a, b,i;
	double s;
	bool operator <(const burrito& br)
	{
		return (a / b) > (br.a / br.b);
	}

	
};

struct comparator
{
	bool operator()(const burrito& b1, const burrito& b2)const
	{
		return b1.i < b2.i;
	}
};


int main()
{
	freopen("burrito.in","r",stdin);
	freopen("burrito.out", "w", stdout);
	
	int n, A, B;
	cin >> n >> A >> B;
	vector<burrito> brs(n);
	vector<double> g(n);
	for (int j = 0; j < n; j++)
	{
		cin >> brs[j].g >> brs[j].a >> brs[j].b;
		brs[j].i = j;
	}

	sort(brs.begin(), brs.end());

	int a0 = 0, b0 = 0;
	int i = 0;
	while (b0 <= B && i < n)
	{
		b0 += brs[i].b * brs[i].g;
		a0 += brs[i].a * brs[i].g;
		brs[i].s = brs[i].g;
		i++;
	}
	i--;
	double b01 = b0, a01 = a0;

	if (i < n)
	{
		b0 -= brs[i].b * brs[i].g;
		a0 -= brs[i].a * brs[i].g;
		b01 = b0;
		a01 = a0;

		if (b0 != B)
		{
			brs[i].s = (double)(B - b0) / (double)brs[i].b;
		}
		else
			brs[i].s = 0;

		b01 += brs[i].s * brs[i].b;
		a01 += brs[i].s * brs[i].a;
	}
	else
	{
		i--;
	}

	int k = (g[i] == 0) ? i  : i + 1;
	if (a01 < A){
		cout << -1 << " " << -1 << endl;
		//system("pause");
		return 0;
	}
	
	sort(brs.begin(), brs.end(), comparator());
	cout << a01 << " " << b01 << endl;
	for (int j = 0; j < n; j++)
	{
		cout << brs[j].s << " ";
	}

	//system("pause");
	return 0;
}


