#include <iostream> 
#include <fstream> 
#include <string> 
#include <stdlib.h> 
#include <stdio.h> 
#include <string>
#include <vector>
#include <stack>


using namespace std;

bool used[51];

int n;
bool printed = false;

ifstream fin;
ofstream fout;

void print(stack<int> s){
	vector<int> v;

	while (!s.empty()){
		v.push_back(s.top());
		s.pop();
	}

	reverse(v.begin(), v.end());

	for (int i = 0; i < v.size(); i++){
		fout << v[i] << " ";
	}
}

void rec(string st, int indx,stack<int> s){
	if (printed) return;
	if (indx == st.size()){
		print(s);
		printed = true;
		return;
	}
	int num = st[indx] - '0';
	
	if (indx == st.size() - 1){
		if (!used[num]){
			s.push(num);
			rec(st, indx + 1, s);
		}
		return;
	}

	if (num > n / 10 && !used[num]){
		s.push(num);
		used[num] = true;
		rec(st, indx + 1, s);
		used[num] = false;
		s.pop();
		return;
	}
	
	num = num * 10 + st[indx + 1] - '0';

	if (num <= n && !used[num]){
		s.push(num);
		used[num] = true;
		rec(st, indx + 2, s);
		used[num] = false;
		s.pop();
	}

	if (num / 10 <= n / 10 && !used[num / 10]){
		s.push(num / 10);
		used[num / 10] = true;
		rec(st, indx + 1, s);
		s.pop();
		used[num / 10] = false;
	}

}

int main(){

	 

	//fin.open("input.txt"); 
	//fout.open("output.txt"); 

	fin.open("joke.in");
	fout.open("joke.out");
 
	string st;
	fin >> st;

	if (st.size() > 9){
		n = 9 + ( st.size() - 9 ) / 2;
	}
	else n = st.size();
	stack<int> s;

	rec(st,0,s);


	fin.close();
	fout.close();

	return 0;
}