#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cstdlib>
#include <sstream>

using namespace std;

string IntToStr(int x)
{
    stringstream ss;
    ss << x;
    return ss.str();
}

int GetX(int a, int b, int t)
{
    int tmp = t % (2 * (b - a));
    if (tmp <= b - a) return a + tmp;
    return a + tmp - (b - a);
}

int main()
{
   freopen("knockout.in", "r", stdin);
    freopen("knockout.out", "w", stdout);

    int n, m, a, b, t;
    scanf("%d %d", &n, &m);
    vector<pair<int, int> >cars(n);
    for (int i = 0; i < n; i++)
    {
        scanf("%d %d", &a, &b);
        if (a <= b)
            cars[i] = make_pair(a, b);
        else
            cars[i] = make_pair(b, a);
    }
    for (int i = 0; i < m; i++)
    {
        scanf("%d %d %d", &a, &b, &t);
        int cnt = 0;
        for (int j = 0; j < n; j++)
        {
            int L = max(a, cars[j].first);
            int R = min(b, cars[j].second);
            if (L > R) continue;
            int c = GetX(cars[j].first, cars[j].second, t);
            cnt += L <= c && R >= c;
            //printf("%d\n", c);
        }
        //printf("\n");
        printf("%d\n", cnt);
    }

    return 0;
}
