#include <iostream>
#include <fstream>
#include <cstdio>
#include <string>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

int toint (string s) {
    if ( s.size() == 1 ) {
        return (int)(s[0] - '0');
    }


    int a = 0;

    a +=  (int)(s[1] - '0');
    a += 10 * (int)(s[0] - '0');

    return a;

}

bool cmp( pair<int, int> a, pair<int, int> b ){
    return a.second <= b.second;
}

int main()
{
    freopen("alter.in", "r", stdin);
    freopen("alter.out", "w", stdout);

    string x;

    cin>>x;

    int n = x.size();

    int interval;

    if ( n <= 9 ) {
        interval = n;
    }
    else
    {
        interval = 9 + ( (n - 9) >> 1 );
    }

    //vector<string> vs;

    vector< pair< int, int > > numbers;

    bool *used  = new bool[n + 1];

    for (int i = 0; i < n + 1; i++) {
        used[i] = false;
    }

    used[n] = true;

    int bs = 0;

    for (int i = 1; i < n; i++) {
        if ( x[i] == '0' ) {
            string xs = x.substr(i-1, 2);

            numbers.push_back( make_pair(  toint(xs), i - 1 ) );



            bs = i + 1;

            used[i - 1] = used[i] = true;
        }
    }

    multiset<int> ms;

    for ( int i = 0; i < n; i++ ) {
        if ( used[i] == true ) continue;

        if ( used[i+1] == true ) { numbers.push_back( make_pair( toint("" + x[i]), i ) ); continue; }

        string xs = x.substr(i, 2);

        numbers.push_back( make_pair( toint(xs), i ) );
        used[i+1] = true;
    }

    sort(numbers.begin(), numbers.end(), cmp);

    for ( int i = 0; i < numbers.size(); i++) {
        cout << numbers[i].first << ' ';
    }

    cout << endl;


    return 0;
}
