#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <algorithm>
#include <vector>

using namespace std;

struct ts {
    long long x, y, z, id;
};

bool cmp(ts a, ts b) {
    double x1 = a.y, x2 = b.y, y1 = a.z, y2 = b.z;
    if (y1 == 0 && y2 == 0) return true;
    if (y2 == 0) return false;
    if (y1 == 0) return true;
    return (x1/y1 > x2/y2);
}

int main() {
    freopen("burrito.in", "r", stdin);
    freopen("burrito.out", "w", stdout);
    long long n, m, k;
    cin >> n >> m >> k;
    vector <ts> v;
    for (int i=0; i<n; i++) {
        long long x, y, z;
        cin >> x >> y >> z;
        ts newOne;
        newOne.x = x;
        newOne.y = y;
        newOne.z = z;
        newOne.id = i;
        v.push_back(newOne);
    }
    sort(v.begin(), v.end(), cmp);
    vector <double> ans(n+1, 0);
    double a=0, b=0;
    for (int i=0; i<v.size(); i++) {
        if (v[i].x * v[i].z + b <= k) {
            b+=v[i].x * v[i].z;
            a+=v[i].x * v[i].y;
            ans[v[i].id] = v[i].x;
        } else {
            double kk = (k - b)/(double) v[i].z;
            b+=kk*v[i].z;
            a+=kk*v[i].y;
            ans[v[i].id] = kk;
            break;
        }
    }
    if (a < m) {
        cout << -1 << " " << -1 << endl;
        return 0;
    }
    printf("%.8f %.8f\n", a, b);
    for (int i=0; i<n; i++)
        printf("%.8f ", ans[i]);
}
