#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <algorithm>
#include <vector>

using namespace std;

struct ts {
    int x, y, z, id;
};

bool cmp(ts a, ts b) {
    double x1 = a.x, x2 = b.x, y1 = a.y, y2 = b.y;
    return x1/y1 < x2/y2;
}

int main() {
    freopen("burrito.in", "r", stdin);
    freopen("burrito.out", "w", stdout);
    int n, m, k;
    cin >> n >> m >> k;
    vector <ts> v;
    for (int i=0; i<n; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        ts newOne;
        newOne.x = x;
        newOne.y = y;
        newOne.z = z;
        newOne.id = i;
        v.push_back(newOne);
    }
    sort(v.begin(), v.end(), cmp);
    vector <double> ans(n, 0);
    double a=0, b=0;
    for (int i=0; i<v.size(); i++) {
        if (v[i].x * v[i].z + b <= k) {
            b+=v[i].x * v[i].z;
            a+=v[i].x * v[i].y;
            ans[v[i].id] = v[i].x;
        } else {
            double kk = (k - b)/v[i].z;
            b+=kk*v[i].z;
            a+=kk*v[i].y;
            ans[v[i].id] = kk;
            break;
        }
    }
    if (a < m) {
        cout << -1 << " " << -1 << endl;
        return 0;
    }
    cout << a << " " << b << endl;
    for (int i=0; i<n; i++)
        cout << ans[i] << " ";
}
