#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define fi first
#define se second
#define sz(x) ((int) (x).size())

const int INF = 1000000101;
const ll INFL = 2000000000000000101;

#define NAME "epic"

int conv[300];
char conv2[3] = {'R', 'P', 'S'};

int sym[200];
int a[200][3];

int g[50002][3];
int s[50002];
int n;

void check()
{
    for (int i = 0; i < n; ++i)
    {
        int u = i;
        int v = 0;
        for (int iter = 0; iter < 100000; ++iter)
        {
            int want = (sym[u] + 1) % 3;
            if (s[v] != want)
                cerr << "fail\n";
            int S = s[v];
            int SYM = sym[u];
            u = a[u][S];
            v = g[v][SYM];
        }
    }
}

int main()
{
    cout.precision(10);
    cout.setf(ios::fixed);
    srand(420);
    assert(freopen(NAME ".in", "r", stdin));
    #ifndef LOCAL
    assert(freopen(NAME ".out", "w", stdout));
    #endif
    conv[(int) 'R'] = 0;
    conv[(int) 'P'] = 1;
    conv[(int) 'S'] = 2;
    
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        char tmp[3];
        int a1, a2, a3;
        scanf("%s%d%d%d", tmp, &a1, &a2, &a3);
        --a1, --a2, --a3;
        sym[i] = conv[(int) tmp[0]];
        a[i][0] = a1;
        a[i][1] = a2;
        a[i][2] = a3;
    }
    
    const int MAGIC = 50000;
    int cnt = MAGIC / n;
    for (int i = 0; i < n; ++i)
    {
        for (int level = 0; level < cnt; ++level)
        {
            int id = i + level * n;
            int level2 = (level + 1) % cnt;
            for (int j = 0; j < 3; ++j)
                g[id][j] = level2 * n + rand() % n;
            s[id] = (sym[i] + 1) % 3;
            g[id][sym[i]] = level * n + a[i][s[id]];
        }
    }
//    check();
    cout << n * cnt << '\n';
    for (int i = 0; i < n * cnt; ++i)
    {
        cout << conv2[s[i]] << ' ';
        for (int j = 0; j < 3; ++j)
            cout << g[i][j] + 1 << ' ';
        cout << '\n';
    }
}
