#include <iostream>
#include <vector>
#include <cstdio>
#include <cmath>
#include <memory.h>

typedef long long LL;
using namespace std;

struct tp {
	int mark;
	int go[3];
} au[111], out[55555];
int unterm[55555];
int ch2id[255], id2ch[255], anti[255];
int vn = 0, term[111];

int dfs(const vector<int>& a) {	
	int v = ++vn;

	out[v].mark = -1;
	for (int ch = 0; ch < 3; ++ch) {
		vector<int> go[3];
		int ne = 0;
		for (size_t j = 0; j < a.size(); ++j) {
			if (go[au[a[j]].mark].size() == 0) ++ne;
			go[ au[a[j]].mark ].push_back(au[a[j]].go[ch]);
		}
		if (ne != 1) {
			out[v].mark = ch;
			for (int j = 0; j < 3; ++j) if (go[j].size()) {
				out[v].go[j] = dfs(go[j]);
			} else
				out[v].go[j] = v;
			return v;
		}
	}
	for (size_t i = 0; i < a.size(); ++i) {
		term[ a[i] ] = v;
	}
	unterm[v] = a[0];

	return v;
}


int main() {
	freopen("epic.in", "r", stdin);
	freopen("epic.out", "w", stdout);

	ch2id['R'] = 0;
	ch2id['P'] = 1;
	ch2id['S'] = 2;
	id2ch[0] = 'R';
	id2ch[1] = 'P';
	id2ch[2] = 'S';

	anti[0] = 1;
	anti[1] = 2;
	anti[2] = 0;

	int n;
	scanf("%d\n", &n);
	for (int i = 1; i <= n; ++i) {
		char ch;
		scanf("%c %d %d %d\n", &ch, &au[i].go[0], &au[i].go[1], &au[i].go[2]);
		au[i].mark = ch2id[(int)ch];
	}

	vector<int> a;
	for (int i= 0; i < n; ++i) {
		a.push_back(i + 1);
	}

	dfs(a);
	for (int i = 1; i <= n; ++i) if (!term[i]) {
		term[i] = ++vn;
		unterm[vn] = i;
		out[vn].mark = -1;
	}

	for (int i = 1; i <= vn; ++i) if (out[i].mark == -1) {
		int x = unterm[i];
		out[i].mark = anti[au[x].mark];
		out[i].go[0] =
		out[i].go[1] =
		out[i].go[2] = 
			term[ au[x].go[out[i].mark] ];
	}

	printf("%d\n", vn);
	for (int i = 1; i <= vn; ++i) {
		printf("%c %d %d %d\n", id2ch[out[i].mark], out[i].go[0], out[i].go[1], out[i].go[2]);
	}

	return 0;
}