#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cstring>
#include <queue>
#include <ctime>
#include <cassert>
using namespace std;

const int N = 150;

int n;
int len;
char str[N];
int arr[N];
bool used[N];
int par[N];

vector<int> to_vec(int a)
{
	vector<int> res;
	while (a > 0)
	{
		res.push_back(a % 10);
		a /= 10;
	}
	reverse(res.begin(), res.end());
	return res;
}

void rec(int pos)
{
	if (pos == len)
	{
		vector<int> res;
		for (int i = len; i > 0; i -= par[i])
		{
			if (par[i] == 1)
				res.push_back(arr[i - 1]);
			else
				res.push_back(arr[i - 2] * 10 + arr[i - 1]);
		}

		reverse(res.begin(), res.end());
		for (int i = 0; i < (int)res.size(); i++)
			printf("%d ", res[i]);

		exit(0);
	}

	int single = arr[pos];
	if (!used[single])
	{
		used[single] = true;
		par[pos + 1] = 1;
		rec(pos + 1);
		used[single] = false;
	}

	if (pos + 1 >= len)
		return;

	int two = arr[pos] * 10 + arr[pos + 1];
	if (!used[two])
	{
		used[two] = true;
		par[pos + 2] = 2;
		rec(pos + 2);
		used[two] = false;
	}
}

void solve()
{
	scanf("%s", str);
	len = strlen(str);
	for (int i = 0; i < len; i++)
		arr[i] = (int)(str[i] - '0');

	int cur_sum = 0;
	for (int i = 1; i <= 50; i++)
	{
		cur_sum += (int)to_vec(i).size();
		n++;
		if (cur_sum == len)
			break;
	}

	rec(0);

	/*
	map<int, int> cnt;
	for (int i = 1; i <= 50; i++)
	{
		vector<int> a = to_vec(i);
		for (int x : a)
			cnt[x]++;
	}

	for (auto p : cnt)
		cout << p.first << " " << p.second << endl;
	*/
}

void gen()
{
	vector<int> a;
	for (int i = 1; i <= 50; i++)
		a.push_back(i);

	random_shuffle(a.begin(), a.end());

	for (int x : a)
		printf("%d", x);
}

int main()
{
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);

	//gen();
	solve();

	return 0;
}