#pragma comment(linker, "/STACK:100000000")
#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <cctype>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <deque>
#include <queue>
#include <string>
using namespace std;
#define int64 long long
#define ldb long double
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const double pi = acos(-1.0);
#define taskname "burrito"
const double eps = 1e-10;
const int N = (int) 1e5 + 10;
int a[N], b[N], g[N], n, A, B;
double ans[N];

int main() {
	assert(freopen(taskname".in", "r", stdin));
	assert(freopen(taskname".out", "w", stdout));
	scanf("%d%d%d", &n, &A, &B);
	vector<int> p;
	for (int i = 0; i < n; ++i) {
		scanf("%d%d%d", &g[i], &a[i], &b[i]);
		if (b == 0)
			ans[i] = g[i];
		else
			p.pb(i);
	}
	sort(p.begin(), p.end(), [](int i, int j) { return (a[i] * (int64)b[j] > a[j] * (int64)b[i]); });
	for (int pi = 0; pi < sz(p); ++pi) {
		int i = p[pi];
		if (B >= g[i] * (int64)b[i]) {
			ans[i] = g[i];
			B -= g[i] * (int64)b[i];
		} else {
			ans[i] = B * 1.0 / b[i];
			break;
		}
	}
	double total_A = 0, total_B = 0;
	for (int i = 0; i < n; ++i) {
		total_A += a[i] * ans[i];
		total_B += b[i] * ans[i];
	}
	if (total_A < A - eps) {
		printf("-1 -1\n");
		return 0;
	}
	printf("%.10lf %.10lf\n", total_A, total_B);
	for (int i = 0; i < n; ++i)
		printf("%.10lf%c", ans[i], " \n"[i == n - 1]);
	return 0;
}