#pragma comment(linker, "/STACK:100000000")
#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <cctype>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <deque>
#include <queue>
#include <string>
using namespace std;
#define int64 long long
#define ldb long double
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const double pi = acos(-1.0);
#define taskname "epic"

const int size = 100 * 1000;
const int magic = 50 * 1000;

int getval(char c) {
	if (c == 'R')
		return 0;
	if (c == 'P')
		return 1;
	if (c == 'S')
		return 2;
}

int getwin(int c) {
	return (c + 1) % 3;
}

char smb[256];
int n;

int myt[size];
int way[size][3];
vector <int> starts;
int ans[size][3];
int cur = 0;

int main() {
	smb[0] = 'R';
	smb[1] = 'P';
	smb[2] = 'S';

	assert(freopen(taskname".in", "r", stdin));
	assert(freopen(taskname".out", "w", stdout));

	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		char tp;
		scanf(" %c%d%d%d", &tp, &way[i][0], &way[i][1], &way[i][2]);
		way[i][0]--;
		way[i][1]--;
		way[i][2]--;
		myt[i] = getval(tp);
	}

	int tot = magic / n;
	
	printf("%d\n", tot * n);
    
    for (int i = 0; i < tot; i++) {
		for (int j = 0; j < n; j++) {
			printf("%c", smb[getwin(myt[j])]);
			for (int p = 0; p < 3; p++) {
				if (p == myt[j])
					printf(" %d", i * n + way[j][getwin(myt[j])] + 1);
				else
					printf(" %d", ((i + 1) % tot) * n + rand() % n + 1);
			}
			printf("\n");
		}
	}

	return 0;
}