#define FILENAME "joke"

#ifdef SU1
#define _GLIBCXX_DEBUG
#include <windows.h>
#endif

#include <iostream>
#include <iomanip>

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <climits>
#include <ctime>

#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forl(i, n) for (int i = 1; i <= int(n); i++)
#define fore(i, l, r) for (int i = int(l); i <= int(r); i++)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define ft first
#define sc second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X sqr(const X &a) { return a * a; }
template<typename X> inline X abs(const X &a) { return a < 0 ? -a : a; }

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9, PI = acosl(ld(-1));

const int N = 50 + 3;

string s;
int n;
int used[N];
int ans[N], szans;

inline bool read()
{
	return getline(cin, s);
	
	vector<int> perm;
	int k = 50;
	forn(i, k) perm.pb(i + 1);
	random_shuffle(all(perm));
	forn(i, sz(perm))
	{
		if (perm[i] < 10)
			s.pb(perm[i] + '0');
		else
		{
			s.pb(perm[i] / 10 + '0');
			s.pb(perm[i] % 10 + '0');
		}
	}
	return true;
}

void go (int idx)
{
	if (idx == sz(s))
	{
		forn(i, szans)
		{
			if (i) putchar(' ');
			printf("%d", ans[i]);
		}
		puts("");
		exit(0);
	}
	
	if (!used[s[idx] - '0'])
	{
		ans[szans++] = s[idx] - '0';
		used[s[idx] - '0'] = true;
		go(idx + 1);
		used[s[idx] - '0'] = false;
		szans--;
	}
	
	if (idx + 1 < sz(s) && !used[(s[idx] - '0') * 10 + s[idx + 1] - '0'])
	{
		ans[szans++] = (s[idx] - '0') * 10 + s[idx + 1] - '0';
		used[(s[idx] - '0') * 10 + s[idx + 1] - '0'] = true;
		go(idx + 2);
		used[(s[idx] - '0') * 10 + s[idx + 1] - '0'] = false;
		szans--;
	}
}

inline void solve()
{
	n = 0;
	int curlen = 0;
	while (curlen < sz(s))
	{
		n++;
		if (n >= 10) curlen += 2;
		else curlen += 1;
	}
	go(0);
}

int main()
{
#ifdef SU1
	freopen("input.txt", "rt", stdin);
	//freopen("output.txt", "wt", stdout);
	srand(GetTickCount());
#else
	freopen(FILENAME ".in", "rt", stdin);	
	freopen(FILENAME ".out", "wt", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(5) << fixed;
	
	assert(read());
	solve();

	return 0;
}