#include <stdio.h>
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
using namespace std;

typedef long long LL;
typedef long long ll;
typedef pair<int, int> pii;

const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

#ifdef LOCAL
#include <windows.h>
#endif

#define PROBLEM "burrito"

vector<double> g, a, b;

bool comp(int x, int y) {
  return b[x] < b[y];
}

int main() {
  std::ios_base::sync_with_stdio(false);
  cin.tie(NULL);
#ifdef LOCAL
  freopen("input.txt", "rt", stdin);
  freopen("output.txt", "wt", stdout);
  int _tt = GetTickCount();
#else
  freopen(PROBLEM ".in", "rt", stdin);
  freopen(PROBLEM ".out", "wt", stdout);
#endif
  int n;
  double A, B;
  cin >> n >> A >> B;
  g.resize(n); a.resize(n); b.resize(n);
  FOR(i, 0, n) cin >> g[i] >> a[i] >> b[i];

  vector<double> ans(n, 0);
  vector<int> coords(n);
  FOR(i, 0, n) coords[i] = i;
  sort(coords.begin(), coords.end(), comp);
  double cura = 0, curb = 0;
  for (int i : coords) {
    double to = min(B - curb, g[i] * b[i]) / b[i];
    ans[i] = to;
    cura += to * a[i];
    curb += to * b[i];
    if (curb >= B - 1e-10) break;
  }

  if (cura < A - 1e-10) {
    cout << "-1 -1";
    return 0;
  }

  cout.precision(10);
  cout << fixed << cura << " " << curb << "\n";
  FOR(i, 0, n) cout << fixed << ans[i] << " ";

#ifdef LOCAL
  cerr << double(GetTickCount() - _tt) * 0.001 << endl;
#endif
  return 0;
}
