#include <stdio.h>
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
using namespace std;

typedef long long LL;
typedef long long ll;
typedef pair<int, int> pii;

const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

#ifdef LOCAL
#include <windows.h>
#endif

#define PROBLEM "filter"

int files[1024][32];
int filter[32];
int ai[128];
bool good[1024];

bool check(int f) {
  FOR(i, 0, 32) if (filter[i] & (~files[f][i])) return false;
  return true;
}

string bitv(int x) {
  string s;
  FOR(i, 0, 32) {
    s += char('0' + (x & 1));
    x >>= 1;
  }
  return s;
}

int main() {
  std::ios_base::sync_with_stdio(false);
  cin.tie(NULL);
#ifdef LOCAL
  freopen("input.txt", "rt", stdin);
  freopen("output.txt", "wt", stdout);
  int _tt = GetTickCount();
#else
  freopen(PROBLEM ".in", "rt", stdin);
  freopen(PROBLEM ".out", "wt", stdout);
#endif

  int n, m, f;
  cin >> m >> f;
  FOR(i, 0, f) cin >> ai[i];
  cin >> n;
  FOR(i, 0, n) {
    int c = (m + 3) / 4;
    string str;
    cin >> str;
    FOR(j, 0, c) {
      int x = str[j] - '0';
      if (str[j] >= 'a' && str[j] <= 'f') x = str[j] - 'a' + 10;
      files[i][j / 8] |= (x << (j % 8) * 4);
    }
//    cout << bitv(files[i][0]) << endl;
  }

  int q;
  cin >> q;
  FOR(i, 0, q) {
    int u; cin >> u;
    FOR(z, 0, 32) filter[z] = 0;
    FOR(j, 0, f) {
      int b = (u * 1LL * ai[j]) % m;
      filter[b / 32] |= (1 << (b % 32));
    }
//    cout << bitv(filter[0]) << endl;
    FOR(j, 0, n) if (check(j)) good[j] = true;
  }

  int cnt = 0;
  FOR(j, 0, n) cnt += good[j];
  cout << cnt;
  FOR(j, 0, n) if (good[j]) cout << " " << j;

#ifdef LOCAL
  cerr << double(GetTickCount() - _tt) * 0.001 << endl;
#endif
  return 0;
}
