#include <stdio.h>
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
using namespace std;

typedef long long LL;
typedef long long ll;
typedef pair<int, int> pii;

const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

#ifdef LOCAL
#include <windows.h>
#endif

#define PROBLEM "improvements"

int main() {
  std::ios_base::sync_with_stdio(false);
  cin.tie(NULL);
#ifdef LOCAL
  freopen("input.txt", "rt", stdin);
  freopen("output.txt", "wt", stdout);
  int _tt = GetTickCount();
#else
  freopen(PROBLEM ".in", "rt", stdin);
  freopen(PROBLEM ".out", "wt", stdout);
#endif

  int n;
  cin >> n;
  vector<int> seq(n);
  for (int& i : seq) cin >> i;

  vector<int> mins(n), maxs(n);
  mins[n - 1] = maxs[n - 1] = seq[n - 1];
  ROF(i, 0, n - 1) mins[i] = min(mins[i + 1], seq[i]), maxs[i] = max(maxs[i + 1], seq[i]);

  int cnt = 0;
  FOR(i, 0, n) {
    if (maxs[i] <= seq[i] || mins[i] >= seq[i]) cnt++; 
  }
  cout << cnt;

#ifdef LOCAL
  cerr << double(GetTickCount() - _tt) * 0.001 << endl;
#endif
  return 0;
}
