#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
using namespace std;

typedef long long LL;
typedef long long ll;
typedef pair<int, int> pii;

const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

#ifdef LOCAL
#include <windows.h>
#endif

#define PROBLEM "joke"

string str;
vector <vector <int> > poses(5);
vector <bool> used;
vector <bool> found(51, false);
int len, amount;

void generate(int n) {
  if (n == 5) {
    found.assign(51, false);

    for (int i = 0; i != len;) {
      if (used[i]) {
        ++i;
        continue;
      }
      if (str[i] == '0') { return; }

      if (str[i] < '6') {
        if (i + 1 == len || used[i + 1]) {
          return;
        }
        int curr = (str[i] - '0') * 10 + (str[i + 1] - '0');
        if (found[curr]) return;
        found[curr] = true;
        i += 2;
      } else {
        int curr = (str[i] - '0');
        if (found[curr]) return;
        found[curr] = true;
        ++i;
      }
    }

    for (int i = 6; i <= amount; ++i) {
      if (!found[i]) return;
    }

    for (int i = 0; i != len;) {
      if (used[i]) { cout << str[i] << ' '; ++i; continue; }
      if (str[i] < '6') {
        int curr = (str[i] - '0') * 10 + (str[i + 1] - '0');
        cout << curr << ' ';
        i += 2;
      } else {
        int curr = (str[i] - '0');
        cout << curr << ' ';
        ++i;
      }
    }

    exit(0);
  }

  for (int i = 0; i != poses[n].size(); ++i) {
    used[poses[n][i]] = true;
    generate(n + 1);
    used[poses[n][i]] = false;
  }
}

int main() {
#ifdef LOCAL
  freopen("input.txt", "rt", stdin);
  freopen("output.txt", "wt", stdout);
  int _tt = GetTickCount();
#else
  freopen(PROBLEM ".in", "rt", stdin);
  freopen(PROBLEM ".out", "wt", stdout);
#endif
  cin >> str;
  len = str.length();  

  if (len < 10) {
    for (int i = 0; i != len; ++i) {
      cout << str[i] << ' ';
    }
    return 0;
  }

  used.resize(len, false);
  amount = (len - 9) / 2 + 9;
  
  for (int i = 0; i != len; ++i) {
    if (str[i] != '0' && str[i] < '6') {
      poses[str[i] - '1'].push_back(i);
    }
  }

  generate(0);

#ifdef LOCAL
  cerr << double(GetTickCount() - _tt) * 0.001 << endl;
#endif
  return 0;
}
