#include <cstdio>
#include <algorithm>

using namespace std;

const int N = 200010;

int na[N], nb[N], g[N];
double ans[N];
int id[N];

bool cmp(int i, int j) {
  return (na[i] * nb[j] > na[j] * nb[i]);
}

int main() {
  freopen("burrito.in", "r", stdin);
  freopen("burrito.out", "w", stdout);
  int n, A, B;
  scanf("%d %d %d", &n, &A, &B);
  for (int i = 0; i < n; i++) {
    scanf("%d %d %d", g + i, na + i, nb + i);
    id[i] = i;
    ans[i] = 0.0;
  }
  sort(id, id + n, cmp);
  int ha = 0, hb = 0;
  double res_a = -1;
  double res_b = -1;
  for (int pos = 0; pos < n; pos++) {
    int i = id[pos];
    if (hb + g[i] * nb[i] <= B) {
      ha += g[i] * na[i];
      hb += g[i] * nb[i];
      ans[i] = g[i];
    } else {
      double max_g = (B - hb) * 1.0 / nb[i];
      if (ha * 1LL * nb[i] + (B - hb) * 1LL * na[i] < A * 1LL * nb[i]) {
        puts("-1 -1");
        return 0;
      }
      res_a = ha + max_g * na[i];
      res_b = B;
      ans[i] = max_g;
      break;
    }
  }
  if (res_a < 0) {
    res_a = ha;
  }
  if (res_b < 0) {
    res_b = hb;
  }
  printf("%.17f %.17f\n", res_a, res_b);
  for (int i = 0; i < n - 1; i++) printf("%.17f ", ans[i]);
  printf("%.17f\n", ans[n - 1]);
  return 0;
}
