#pragma comment(linker, "/STACK:666000666")
#define _CRT_SECURE_NO_WARNINGS

#include<cstdio>
#include<iostream>
#include<string.h>
#include<cstring>
#include<string>
#include<vector>
#include<algorithm>
#include<set>
#include<map>

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;

#define fill(a, v) memset(a, v, sizeof(a))
#define all(a) a.begin(), a.end()
#define mp(a,b) make_pair(a,b)

int *ass;
void ML(bool v)
{
	if (v)
		return;
	for (;;)
	{
		ass = new int[100500];
		for (int i = 0; i < 100500; i++)
			ass[i] = rand();
	}
}

string s;
char tmp[111];

bool load()
{
	if (1 != scanf("%s", tmp))
		return false;
	s = tmp;;
	return true;
}

int toint(char c)
{
	return c - '0';
}

int toint(char c1, char c2)
{
	return toint(c1) * 10 + toint(c2);
}

string tostr(int a)
{
	if (a < 10)
	{
		string s;
		s.push_back('0' + a);
		return s;
	}
	else
	{
		string s;
		s.push_back('0' + a / 10);
		s.push_back('0' + a % 10);
		return s;
	}
}

bool was[111];
bool used[111];
int can1[111];
int can2[111];
int cnt[111];
int ans[111];

void solve()
{
	fill(was, false);
	fill(used, false);
	fill(can1, -1);
	fill(can2, -1);
	fill(cnt, 0);
	fill(ans, -1);
	string tt;
	int mx = 1;

	while (tt.size() < s.size())
	{
		tt += tostr(mx);
		mx++;
	}
	mx--;
	
	for (int i = 0; i < (int)s.size(); i++)
	{
		if (i != (int)s.size() - 1 && s[i + 1] == '0')
		{
			int r2 = toint(s[i], s[i + 1]);
			ML(!was[r2] && r2 >= 10);
			was[r2] = true;
			used[i] = true;
			used[i + 1] = true;
			ans[i] = r2;
			i++;
		}
	}	
	
	for (int i = (int)s.size() - 1; i >= 0; i--) if (!used[i])
	{		
		if (i > 0 && s[i - 1] != '0' && !used[i - 1])
		{
			int r2 = toint(s[i - 1], s[i]);
			if (r2 <= mx && !was[r2])
				can2[i - 1] =r2;
		}
		int r1 = toint(s[i]);
		if (!was[r1] && r1 > 0)
			can1[i] = r1;
	}
	for (int i = 0; i < (int)s.size(); i++)
	{
		if (can2[i] > 0)
			cnt[can2[i]]++;
		if (can1[i] > 0)
			cnt[can1[i]]++;
	}
	set<pair<int, int>> w;
	for (int i = 1; i <= mx; i++)
		if (cnt[i] > 0)
			w.insert(mp(cnt[i],i));

	while (!w.empty())
	{
		int v = w.begin()->second;
		bool bad = w.begin()->first <= 0;
		w.erase(w.begin());
		if (was[v] || bad)
			continue;
		was[v] = true;
		if (v < 10)
		{
			for (int i = 0; i < (int)s.size(); i++) if (!used[i])
			{
				if (toint(s[i]) == v)
				{
					used[i] = true;
					ans[i] = v;
					can2[i] = can1[i] = -1;
					if (i != (int)s.size() - 1)
					{
						int dd = toint(s[i], s[i + 1]);
						cnt[dd]--;
						if (cnt[dd] > 0)
							w.insert(mp(cnt[dd], dd));
					}
					if (i > 0)
					{
						can2[i - 1] = -1;
						int dd = toint(s[i - 1], s[i]);
						cnt[dd]--;
						if (cnt[dd] > 0)
							w.insert(mp(cnt[dd], dd));
					}
					break;
				}
			}
		}
		else
		{
			for (int i = 0; i < (int)s.size() - 1; i++) if (!used[i] && !used[i + 1])
			{
				if (toint(s[i], s[i + 1]) == v)
				{
					used[i] = true;
					used[i + 1] = true;
					ans[i] = v;
					can2[i] = can1[i] = -1;
					if (i > 0)
					{
						can2[i - 1] = -1;
						int dd = toint(s[i - 1], s[i]);
						cnt[dd]--;
						if (cnt[dd] > 0)
							w.insert(mp(cnt[dd], dd));
					}
					break;
				}
			}
		}
	}
	for (int i = 1; i <= mx; i++)
		ML(was[i]);
	for (int i = 0; i < (int)s.size(); i++)
		if (-1 != ans[i])
			printf("%d ", ans[i]);
	puts("");
}

#define FILES "joke"

void gen()
{
	vi a;
	int n = 47;
	for (int i = 1; i <= n; i++)
		a.push_back(i);
	random_shuffle(all(a));
	for (int i = 0; i < n; i++)
		printf("%d", a[i]);
	exit(0);
}

int main()
{
	freopen(FILES".in", "r", stdin);
	freopen(FILES".out", "w", stdout);
	//gen();
#ifdef SCHULLZ
	while (load())
	{
		if ("exit" == s)
			break;
		solve();
	}
#else
	load();
	solve();
#endif

	return 0;
}