#define _CRT_SECURE_NO_WARNINGS

#include<cstdio>
#include<iostream>
#include<string.h>
#include<cstring>
#include<string>
#include<vector>

using namespace std;

typedef vector<int> vi;
typedef long long LL;

#define fill(a, v) memset(a, v, sizeof(a))

int n, m;
LL st[1010], fin[1010];

bool load()
{
	if (2 != scanf("%d%d", &n, &m))
		return false;
	for (int i = 0; i < n; i++)
		scanf("%I64d%I64d", &st[i], &fin[i]);
	return true;
}

void solve()
{
	LL lt, rt, t0;
	for (int i = 0; i < m; i++)
	{
		scanf("%I64d%I64d%I64d", &lt, &rt, &t0);
		if (lt > rt)
			swap(lt, rt);
		int res = 0;
		for (int j = 0; j < n; j++)
		{
			LL T = (fin[j] - st[j]) * 2;
			LL pos;
			if (0 != T)
			{
				LL t = t0 % T;
				if (t > fin[j] - st[j])
				{
					pos = fin[j] - (t - (fin[j] - st[j]));
				}
				else
				{
					pos = st[j] + t;
				}
			}
			else
				pos = st[j];

			if (lt <= pos && pos <= rt)
				res++;
		}
		printf("%d\n", res);
	}
}

#define FILES "knockout"

int main()
{
	freopen(FILES".in", "r", stdin);
	freopen(FILES".out", "w", stdout);
#ifdef SCHULLZ
	while (load())
	{ 
		solve();
		puts("");
	}
#else
	load();
	solve();
#endif

	return 0;
}