#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) ((int)(x).size())
#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#define TASK "burrito"

int n, A, B;
ld ans[1000000];
const ld eps = 1e-9;
bool cmp(pair<pair<int, int>, pair<int, int> > a, pair<pair<int, int>, pair<int, int> > b) {
	ll res = (ll)a.x.x * b.x.y - (ll)b.x.x * a.x.y;
	if (res != 0) {
		return res > 0;
	}
	return a.y.y < b.y.y;
}
int solve() {
	if (scanf("%d %d %d", &n, &A, &B) != 3)
		return 0;
	vector<pair<pair<int, int>, pair<int, int> > > ls;
	for (int i = 0; i < n; i++) {
		int x, y, z;
		scanf("%d %d %d", &x, &y, &z);
		if (y == 0) continue;
		ls.pb(mp(mp(y, z), mp(x, i)));
	}
	for (int i = 0; i < n; i++) {
		ans[i] = 0;
	}
	sort(all(ls), cmp);
	ld curA = 0;
	ld curB = 0;
	for (int i = 0; i < sz(ls); i++) {
		if (ls[i].x.y == 0) {
			ans[ls[i].y.y] = ls[i].y.x;
			curA += ls[i].x.x * ans[ls[i].y.y];
			continue;
		}
		ld mn = min((ld)ls[i].y.x, (B - curB) / (ld)ls[i].x.y);
		ans[ls[i].y.y] = mn;
		curA += ls[i].x.x * ans[ls[i].y.y];
		curB += ls[i].x.y * ans[ls[i].y.y];
	}
	if (curA < A - eps || curB > B + eps) {
		printf("-1 -1\n");
		return 1;
	}
	printf("%.18f %.18f\n", (double)curA, (double)curB);
	for (int i = 0; i < n; i++) {
		printf("%.18f%c", (double)ans[i], " \n"[i + 1 == n]);
	}
	return 1;	
}

int main() {
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);

	while (1) {
		if (!solve())
			break;
		#ifdef DEBUG
		eprintf("%.f\n", (double)clock() / CLOCKS_PER_SEC);
		#endif
	}

	return 0;
}
