#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef double ld;

#define mp make_pair
#define pb push_back
#define sz(x) ((int)(x).size())
#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#define TASK "damage"
const ld inf = 1e18;
struct pnt {
	ld x, y;
	pnt() {
	}
	pnt(ld x, ld y):x(x),y(y) {		
	}
};
pnt operator - (pnt a, pnt b) {
	return pnt(a.x - b.x, a.y - b.y);
}
pnt operator + (pnt a, pnt b) {
	return pnt(a.x + b.x, a.y + b.y);
}
pnt operator * (pnt a, ld c) {
	return pnt(a.x * c, a.y * c);
}
pnt operator / (pnt a, ld c) {
	return pnt(a.x / c, a.y / c);
}
ld sp(pnt a, pnt b) {
	return a.x * b.x + a.y * b.y;
}
ld vp(pnt a, pnt b) {
	return a.x * b.y - a.y * b.x;
}

ld dst(pnt a, pnt b) {
	return sqrt(sp(a - b, a - b));
}
ld d, l, r, t, h;
int solve() {
	if (scanf("%lf %lf %lf %lf %lf", &d, &l, &r, &t, &h) != 5)
		return 0;
	pnt p1 = pnt(0, 0);
	ld alp = asin(t / l);
	pnt p2 = pnt(l * cos(alp), t);
	pnt v1 = (p2 - p1) / dst(p1, p2);
	pnt v2 = pnt(-v1.y, v1.x);
	pnt o1 = p1 + v2 * d / 2;
	pnt o2 = p2 + v2 * d / 2;
	pnt c1 = o1 + v1 * sqrt(r * r - d / 2 * d / 2);
	pnt c2 = o2 - v1 * sqrt(r * r - d / 2 * d / 2);
  ld leftx = c1.x - r;
  ld rightx = c2.x + r;
  ld downy = c1.y - r;
  ld upy = h;
  int N = 8000;
  ld dx = (rightx - leftx) / N;
  ld dy = (upy - downy) / N;
  ld ans = 0;
	for (int j = 0; j < N; j++) {
		ld sum = 0;
	  for (int i = 0; i < N; i++) {
  		pnt p0 = pnt(leftx + dx * (i + 0.5), downy + dy * (j + 0.5));
  		ld dst_o = fabs(vp(p0 - o1, v1));
  		ld dst2 = dst(p0, c2);
  		ld dst1 = dst(p0, c1);
  		if (dst_o <= d / 2 && 
  		    (sp(v1, p0 - o2) < 0 || dst2 <= r) && 
     		  (sp(v1 * (-1), p0 - o1) < 0 || dst1 <= r)) {
  			ld z = min(2 * sqrt(d / 2 * d / 2 - dst_o * dst_o), 
  			       min(sp(v1, p0 - o2) < 0 ? inf : 2 * sqrt(r * r - dst2 * dst2),
  			           sp(v1 * (-1), p0 - o1) < 0 ? inf : 2 * sqrt(r * r - dst1 * dst1)));
  			ans += dx * dy * z;
  			sum += dx * dy * z;
  		}
  	}
  }
  printf("%.18f\n", (double)(ans / 1e6));
	return 1;	
}

int main() {
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);

	while (1) {
		if (!solve())
			break;
		#ifdef DEBUG
		eprintf("%.10f\n", (double)clock() / CLOCKS_PER_SEC);
		#endif
	}

	return 0;
}
