#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef double ld;

#define mp make_pair
#define pb push_back
#define sz(x) ((int)(x).size())
#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#define TASK "damage"
const ld inf = 1e18;
const ld eps = 1e-9;

struct pnt {
	ld x, y;
	pnt() {
	}
	pnt(ld x, ld y):x(x),y(y) {		
	}
};
pnt operator - (pnt a, pnt b) {
	return pnt(a.x - b.x, a.y - b.y);
}
pnt operator + (pnt a, pnt b) {
	return pnt(a.x + b.x, a.y + b.y);
}
pnt operator * (pnt a, ld c) {
	return pnt(a.x * c, a.y * c);
}
pnt operator / (pnt a, ld c) {
	return pnt(a.x / c, a.y / c);
}
ld sp(pnt a, pnt b) {
	return a.x * b.x + a.y * b.y;
}
ld vp(pnt a, pnt b) {
	return a.x * b.y - a.y * b.x;
}

ld dst(pnt a, pnt b) {
	return sqrt(sp(a - b, a - b));
}
ld d, l, r, t, h;
ld shap(ld R, ld C) {
	ld alp = acos(min((ld)1, C / R));
	return alp * R * R - C * sqrt(max((ld)0, R * R - C * C));
}
int solve() {
	if (scanf("%lf %lf %lf %lf %lf", &d, &l, &r, &t, &h) != 5)
		return 0;
	d /= 1e2;
	l /= 1e2;
	r /= 1e2;
	t /= 1e2;
	h /= 1e2;
	pnt p1 = pnt(0, 0);
	ld alp = asin(t / l);
	pnt p2 = pnt(l * cos(alp), t);
	pnt v1 = (p2 - p1) / dst(p1, p2);
	pnt v2 = pnt(-v1.y, v1.x);
	pnt o1 = p1 + v2 * d / 2;
  ld leftx = -d / 2;
  ld rightx = d / 2;
  int N = 100000;
  int M = 2 * N;
  ld dx = (rightx - leftx) / M;
  ld ans = 0;
  ld C = sqrt(r * r - d / 2 * d / 2);
 	for (int i = 0; i < M; i++) {
 		ld X0 = leftx + (i + 0.5) * dx;
	 	ld dd0 = X0 * X0;
		if (fabs(t) <= eps && X0 > h - d / 2) continue;
		pnt pp0 = o1 + v2 * X0;
		ld go = (h - pp0.y) / v1.y;
		if (fabs(t) <= eps) go = inf;
		ld D1 = sqrt(max((ld)0, d / 2 * d / 2 - X0 * X0));
		ld R1 = sqrt(max((ld)0, r * r - X0 * X0));
		ld C1 = C;
		ld L1 = l;
		ld UP = min(go, L1 + R1 - C1);
		if (UP < -(R1 - C1)) continue;
		if (UP <= 0) {
			ans += (shap(R1, C1 - UP));
			continue;
		}
		if (UP <= L1) {
			ans += (UP * 2 * D1 + shap(R1, C1));
			continue;
		}
		ans += (L1 * 2 * D1 + shap(R1, C1) + shap(R1, C1) - shap(R1, UP - L1 + C1));
  }
  printf("%.18f\n", (double)(ans * dx));
	return 1;	
}

int main() {
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);

	while (1) {
		if (!solve())
			break;
		#ifdef DEBUG
		eprintf("%.10f\n", (double)clock() / CLOCKS_PER_SEC);
		#endif
	}

	return 0;
}
