#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) ((int)(x).size())
#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#define TASK "epic"

int n;

const char chars[3] = {'R', 'P', 'S'};

struct Vertex {
	int go[3];
	int t;

	int read() {
		char ch;
		if (scanf("%c%d%d%d", &ch, &go[0], &go[1], &go[2]) != 4)
			return 0;
		--go[0], --go[1], --go[2];
		t = find(chars, chars + 3, ch) - chars;
		return t;	
	}
};

const int maxn = 100 + 10;
Vertex vs[maxn];

const int len = 240;

int where[maxn][len + 1];
int wheres[maxn][maxn + 1];

int s[len];
int solve() {
	if (scanf("%d", &n) != 1)
		return 0;
	for (int i = 0; i < n; ++i) {
		vs[i].read();	
	}

	for (int i = 0; i < len; ++i)
		s[i] = rand() % 3;
	for (int i = 0; i < n; ++i) {
		where[i][0] = i;
		for (int j = 0; j < len; ++j)
			where[i][j + 1] = vs[where[i][j]].go[s[j]];
	}

	for (int i = 0; i < n; ++i) {
		wheres[i][0] = i;
		for (int j = 1; j <= n; ++j)
			wheres[i][j] = where[wheres[i][j - 1]][len];
	}

	vector<Vertex> res(n * len * 2 + n);

	int cnt = 0;
	for (int iter = 0; iter < n; ++iter) {
		for (int i = 0; i < len; ++i) {
			int v = where[wheres[iter][iter]][i];
			//eprintf("iter = %d, i = %d, v = %d\n", iter, i, v);
			for (int it = 0; it < 3; ++it) {
				if (i < len - 1)
					res[cnt + i].go[it] = cnt + i + len + 1;
				else
					res[cnt + i].go[it] = cnt + 2 * len;
			}
			if (i < len - 1)
				res[cnt + i].go[vs[v].t] = cnt + i + 1;
			else
				res[cnt + i].go[vs[v].t] = n * len * 2 + where[wheres[iter][iter]][i + 1];
			res[cnt + i].t = s[i];
			
			for (int it = 0; it < 3; ++it) {
				if (i < len - 1)
					res[cnt + len + i].go[it] = cnt + i + len + 1;
				else
					res[cnt + len + i].go[it] = cnt + 2 * len;
			}
			res[cnt + len + i].t = s[i];
		}
		cnt += 2 * len;
	}

	for (int i = 0; i < n; ++i) {
		res[cnt + i].t = (vs[i].t + 1) % 3;
		for (int it = 0; it < 3; ++it)
			res[cnt + i].go[it] = cnt + vs[i].go[res[cnt + i].t];
	}

	//for (int i = 0; i < len; ++i)
	//	printf("%d%c", s[i], " \n"[i == n - 1]);
	printf("%d\n", sz(res));
	for (int i = 0; i < sz(res); ++i) {
		printf("%c %d %d %d\n", chars[res[i].t], res[i].go[0] + 1, res[i].go[1] + 1, res[i].go[2] + 1);
	}
	return 1;	
}

int main() {
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);

	while (1) {
		if (!solve())
			break;
		#ifdef DEBUG
		eprintf("%.6f\n", (double)clock() / CLOCKS_PER_SEC);
		#endif
	}

	return 0;
}
