#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
using namespace std;
#define TASK "filter"

const int F = 100;
const int N = 1000;
const int M = 1000;
int m, f;
int a[F];
int n;
bool bit[N][M];
bool can[N];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	scanf("%d%d", &m, &f);
	for (int i = 0; i < f; i++)
	{
		scanf("%d", &a[i]);
	}
	scanf("%d\n", &n);
	for (int i = 0; i < n; i++)
	{
		string s; getline(cin, s);
		for (int j = 0; j < m; j++)
		{
			char c = s[j / 4];
			int x = (c >= '0' && c <= '9') ? c - '0' : c - 'a' + 10;
			bit[i][j] = (x >> (j % 4)) & 1;
		}
	}
	int q; scanf("%d", &q);
	while (q--)
	{
		int u; scanf("%d", &u);
		for (int i = 0; i < n; i++)
		{
			bool flag = true;
			for (int j = 0; j < f; j++)
			{
				flag &= bit[i][(1ll * u * a[j]) % m];
			}
			can[i] |= flag;
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) ans += can[i];
	printf("%d ", ans);
	for (int i = 0; i < n; i++)
	{
		if (can[i]) printf("%d ", i);
	}
	return 0;
}