#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <string>
using namespace std;

#define lli long long int

const int N = (int)(1e6);

struct info {
	int index, g, a, b;

	info(int ip, int gp, int ap, int bp) : index(ip), g(gp), a(ap), b(bp) {}

	bool operator < (const info & t) const {
		return a * t.b < b * t.a;
	}
};

double ans[N];

int main() {
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	lli A, B, n;
	vector<info> v;
	scanf("%lld%lld%lld", &n, &A, &B);
	for (int i = 0; i < n; ++i) {
		int g, a, b;
		scanf("%d%d%d", &g, &a, &b);
		v.push_back(info(i, g, a, b));
	}

	sort(v.begin(), v.end());
	reverse(v.begin(), v.end());

	lli sumA = 0, sumB = 0;
	double resultA = 0.0;

	for (int i = 0; i < n; ++i) {
		if (sumB + v[i].b * v[i].g <= B) { //ok
			sumB += v[i].b * v[i].g;
			sumA += v[i].a * v[i].g;
			ans[v[i].index] = v[i].g;

			resultA = sumA;
		}
		else {
			lli restB = B - sumB;

			double g = (restB + 0.0) / v[i].b;

			ans[v[i].index] = g;
			sumB = B;
			resultA = sumA + g * v[i].a;
			break;
		}
	}

	if (resultA < A) {
		printf("-1 -1");
	}
	else {
		printf("%.12lf %lld\n", resultA, sumB);
		for (int i = 0; i < n; ++i) printf("%.12lf ", ans[i]);
	}
}