#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <string>
using namespace std;

int bitN, fooN, a[110];
int filesN;
char files[1010][1010];
int idsN, ids[1010];

struct Mask {
	__int64 n[16];
	Mask() {
		for (int i = 0; i < 16; i++)
			n[i] = 0;
	}
	Mask(char *s, int k) {
		for (int i = 0; i < 16; i++)
			n[i] = 0;
		int hexD = k / 4, lastD = k % 4, offset = 0;
		for (int i = 0; i < hexD; i++) {
			int digit;
			if (isdigit(s[i]))
				digit = s[i] - '0';
			else
				digit = s[i] - 'a' + 10;

			for (int j = 0; j < 4; j++) {
				if (digit & 1)
					set(offset);
				offset++;
				digit >>= 1;
			}
			
		}

		int digit;
		if (isdigit(s[hexD]))
			digit = s[hexD] - '0';
		else
			digit = s[hexD] - 'a' + 10;

		for (int j = 0; j < lastD; j++) {
			if (digit & 1)
				set(offset);
			offset++;
			digit >>= 1;
		}
		
	}
	void set(int cell, int cellOffset) {
		n[cell] |= (1LL << cellOffset);
	}
	void set(int offset) {
		set(offset / 64, offset % 64);
	}
	bool andEq(const Mask &m) const {
		for (int i = 0; i < 16; i++)
			if ((n[i] & m.n[i]) != n[i])
				return 0;
		return 1;
	}
} masks[1010];

set<int> res;

int main() {
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);

	scanf("%d%d", &bitN, &fooN);
	for (int i = 0; i < fooN; i++)
		scanf("%d", &a[i]);

	scanf("%d", &filesN);
	for (int i = 0; i < filesN; i++) {
		scanf(" %s", files[i]);
		masks[i] = Mask(files[i], bitN);
	}
	
	scanf("%d", &idsN);
	for (int i = 0; i < idsN; i++) {
		scanf("%d", &ids[i]);
		Mask curMask;
		for (int j = 0; j < fooN; j++)
			curMask.set(((__int64)ids[i] * (__int64)a[j]) % bitN);
		for (int j = 0; j < filesN; j++)
			if (curMask.andEq(masks[j]))
				res.insert(j);
	}

	printf("%d ", res.size());
	for (set<int>::iterator i = res.begin(); i != res.end(); i++)
		printf("%d ", *i);

}