#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cctype>
#include <cassert>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <sstream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <queue>
#include <functional>

using namespace std;

#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <class T> inline T sqr(const T& a) { return a * a; }
template <class T> inline void updMin(T& a, const T& b) { if (b < a) a = b; }
template <class T> inline void updMax(T& a, const T& b) { if (a < b) a = b; }

int n; 
int a[1000000]; 
int b[1000000]; 
int g[1000000]; 
int p[1000000]; 
double anss[1000000]; 
bool isg[1000000]; 
double lastb = 0; 
bool nisn[1000000];
int A, B;

double greed(int * p) {
	double asum = 0; 
	double bsum = 0; 
	for (int ii = 0; ii < n; ii++) {
		int i = p[ii]; 
		nisn[i] = 1;
		if (bsum + b[i] * g[i] > B) {
			double x = (B - bsum) * 1.0 / b[i]; 
			asum += x * a[i]; 
			bsum = B; 
			anss[i] = x; 
			break; 
		}
		else {
			asum += g[i] * a[i]; 
			bsum += g[i] * b[i]; 
			anss[i] = g[i];
			isg[i] = 1; 
		}
	}
	lastb = bsum; 
	return asum; 
}

bool cmp(int x, int y) {
	return a[x] * b[y] > a[y] * b[x]; 
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#define TASKNAME "burrito"
	freopen(TASKNAME ".in", "r", stdin); freopen(TASKNAME ".out", "w", stdout);

	//ios::sync_with_stdio(false);

	scanf("%d %d %d", &n, &A, &B); 
	for (int i = 0; i < n; i++) {  
		scanf("%d %d %d", &g[i], &a[i], &b[i]); 
		p[i] = i; 
	}

	sort(p, p + n, cmp); 

	double ans = greed(p); 

	if (ans >= A - 1e-9) {
		printf("%.8f %.8f\n", ans, lastb); 
		for (int i = 0; i < n; i++) {
			if (!nisn[i]) {
				printf("0 "); 
			}
            else if (isg[i]) 
            {
				printf("%d ", g[i]); 
			}
			else {
				printf("%.8f ", anss[i]); 
			}
		}
		puts(""); 
	}
	else {
		puts("-1 -1"); 
	}

	return 0;
}


