#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cctype>
#include <cassert>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <sstream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <queue>
#include <functional>

using namespace std;

#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <class T> inline T sqr(const T& a) { return a * a; }
template <class T> inline void updMin(T& a, const T& b) { if (b < a) a = b; }
template <class T> inline void updMax(T& a, const T& b) { if (a < b) a = b; }

const int MAXN = 300000;

int d[MAXN][2];
int arr[MAXN];
int l[MAXN], r[MAXN];
int rev[MAXN];


int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#define TASKNAME "improvements"
	freopen(TASKNAME ".in", "r", stdin); freopen(TASKNAME ".out", "w", stdout);

	ios::sync_with_stdio(false);

	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> rev[i];
		arr[rev[i]] = i;
	}
	int lPos = n + 1, rPos = -1;
	for (int i = n; i >= 1; --i) {
		lPos = min(lPos, rev[i]);
		rPos = max(rPos, rev[i]);
		l[i] = lPos;
		r[i] = rPos;
	}

	d[n][0] = d[n][1] = 0;
	for (int i = n - 1; i >= 0; --i) {
		for (int bit = 0; bit < 2; ++bit) {
			int cl = l[i + 1], cr = r[i + 1];
			if (bit) {
				swap(cl, cr);
			}
			cl = arr[cl], cr = arr[cr];
            // the same direction
			d[i][bit] = 2 * n;
			d[i][bit] = min(d[i][bit], d[i + 1][bit] + (cl != i + 1));
			d[i][bit] = min(d[i][bit], d[i + 1][bit ^ 1] + (cr != i + 1));
		}
	}

	cout << n - d[0][0] << '\n';

	return 0;
}


