#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cctype>
#include <cassert>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <sstream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <queue>
#include <functional>

using namespace std;

#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <class T> inline T sqr(const T& a) { return a * a; }
template <class T> inline void updMin(T& a, const T& b) { if (b < a) a = b; }
template <class T> inline void updMax(T& a, const T& b) { if (a < b) a = b; }

const int maxn = 1000 + 100;

int a[maxn];
int b[maxn];

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#define TASKNAME "knockout"
	freopen(TASKNAME ".in", "r", stdin); freopen(TASKNAME ".out", "w", stdout);

	ios::sync_with_stdio(false);

	int n, m;
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d%d", &a[i], &b[i]);
	}

	for (int j = 0; j < m; ++j)
	{
		int x, y, t;
		scanf("%d%d%d", &x, &y, &t);
		int ans = 0;
		for (int i = 0; i < n; ++i)
		{
			int xI = 0;
			int d = abs(a[i] - b[i]);
			int tt = t % (2 * d);
			if (tt == 0)
				xI = a[i];
			else if (tt == d)
				xI = b[i];
			else if (tt < d)
			{
				if (b[i] < a[i])
					xI = a[i] - tt;
				else
					xI = a[i] + tt;
			}
			else
			{
				tt -= d;
				if (b[i] < a[i])
					xI = b[i] + tt;
				else
					xI = b[i] - tt;
			}
			if (xI >= x && xI <= y)
				++ans;
		}
		printf("%d\n", ans);
	}

	return 0;
}


