#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <algorithm>

using namespace std;

struct ingr
{
	long double g;
	long double a;
	long double b;
	long double sat;
	int ord;
} mas[100001];

int n;
long double a, b;
long double sa, sb; //    

int cmp(const void *a, const void *b)
{
	if ((*(ingr*)a).sat > (*(ingr*)b).sat)
		return 1;
	if ((*(ingr*)a).sat == (*(ingr*)b).sat)
		return 0;
	return -1;
}

int cmpord(const void *a, const void *b)
{
	return (*(ingr*)a).ord - (*(ingr*)b).ord;
}

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	scanf("%d %lf %lf", &n, &a, &b);
	for (int i = 0; i < n; i++)
	{
		scanf("%lf %lf %lf", &mas[i].g, &mas[i].a, &mas[i].b);
		if (mas[i].b == 0)
			mas[i].sat = 1000;
		else
		    mas[i].sat = mas[i].a / mas[i].b;
		mas[i].ord = i; //  
	}
	qsort(mas, n, sizeof(ingr), cmp);
	for (int i = 0; i < n; i++)
	{
		sa += mas[i].a*mas[i].g;
		sb += mas[i].b*mas[i].g;
	}
	int pos = 0;
	while (sb>b)
	{
		if (sb - mas[pos].b*mas[pos].g < b)
		{
			long double dif = sb - b;
			long double g = dif / mas[pos].b;
			sb -= dif; //   
			sa -= g*mas[pos].a;
			mas[pos].g = mas[pos].g - g;
		}
		else
		{
			sa -= mas[pos].a*mas[pos].g;
			sb -= mas[pos].b*mas[pos].g;
			mas[pos].g = 0;
			pos++;
		}
	}
	if (sa >= a-1e-9 && sb <= b+1e-9 && !mas[n-1].g<1e-9)
	{
		//  
		qsort(mas, n, sizeof(ingr), cmpord);
		printf("%.9lf %.9lf\n", sa, sb);
		for (int i = 0; i < n; i++)
			printf("%.9lf ", mas[i].g);
	}
	else
		printf("-1 -1");
	//for (;;);
	return 0;
}

