#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <vector>

using namespace std;

pair<int, int> cars[1000];

inline int getd(int delt, int t) {
	t %= (2 * delt);
	if (t < delt) {
		return t;
	}
	else {
		return (delt - (t - delt));
	}
}

int main() {
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);
	int n, m;
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; i++) {
		int x, y;
		scanf("%d%d", &x, &y);
		cars[i] = make_pair(x, y);
	}
	for (int i = 0; i < m; i++) {
		int x1, x2, t;
		scanf("%d%d%d", &x1, &x2, &t);
		int res = 0;
		for (int i = 0; i < n; i++) {
			int x = cars[i].first + getd(cars[i].second - cars[i].first, t);
			if (x >= x1 && x <= x2) {
				res++;
			}
		}
		printf("%d\n", res);
	}
	return 0;
}
