#include <iostream>
#include <cstdio>

#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>

#include <math.h>
#include <string>

#include <memory.h>
#include <time.h>
#include <cassert>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define fornd(i, n) for(int i = (int)(n - 1); i >= 0; i--)
#define forab(i, a, b) for(int i = (int)(a); i <= (int)(b); i++)
#define forabd(i, b, a) for(int i = (int)(b); i >= (int)(a); i--)
#define pb push_back
#define make_pair mp
#define sz(a) (int)(a).size()
#define _(a, val) memset(a, val, sizeof(a))
#define all(a) (a).begin(), (a).end()

#ifdef MY_DEBUG
#define dbgx(x) {  cerr << #x << " = " << x << endl; }
#define dbg(...){ fprintf(stderr, __VA_ARGS__); fflush(stderr); }
#else
#define dbgx(x) {}
#define dbg(...){}
#endif

typedef long long lint;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef double ld;

const int INF = 1000 * 1000 * 1000;
const lint LINF = (lint)INF*(lint)INF;
const ld eps = 1e-9;

void prepare(string s)
{
#ifdef MY_DEBUG
	freopen("input.txt", "r", stdin);
#else
	freopen((s + ".in").c_str(), "r", stdin);
	freopen((s + ".out").c_str(), "w", stdout);
#endif
}

int n, m;

void read()
{
	scanf("%d %d", &n, &m);
}

void solve()
{
	int cnt = 0;
	forn(i, n)
	{
		forn(j, m)
		{
			if ((i + j) & 1)
				cnt ++;
		}
	}
	printf("%d\n", cnt);
	forn(i, n)
	{
		forn(j, m)
		{
			if ((i + j) & 1)
			{
				printf("%d %d %d %d\n", i + 1, j + 1, i + 1, j + 1);
			}
		}
	}
}

int main()
{
	prepare("alter");

	read();
	solve();

	return 0;
}