#include <iostream>
#include <cstdio>

#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>

#include <math.h>
#include <string>

#include <memory.h>
#include <time.h>
#include <cassert>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define fornd(i, n) for(int i = (int)(n - 1); i >= 0; i--)
#define forab(i, a, b) for(int i = (int)(a); i <= (int)(b); i++)
#define forabd(i, b, a) for(int i = (int)(b); i >= (int)(a); i--)
#define pb push_back
#define make_pair mp
#define sz(a) (int)(a).size()
#define _(a, val) memset(a, val, sizeof(a))
#define all(a) (a).begin(), (a).end()

#ifdef MY_DEBUG
#define dbgx(x) {  cerr << #x << " = " << x << endl; }
#define dbg(...){ fprintf(stderr, __VA_ARGS__); fflush(stderr); }
#else
#define dbgx(x) {}
#define dbg(...){}
#endif

typedef long long lint;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef double ld;

const int INF = 1000 * 1000 * 1000;
const lint LINF = (lint)INF*(lint)INF;
const ld eps = 1e-9;

void prepare(string s)
{
#ifdef MY_DEBUG
	freopen("input.txt", "r", stdin);
#else
	freopen((s + ".in").c_str(), "r", stdin);
	freopen((s + ".out").c_str(), "w", stdout);
#endif
}

const int NMAX = 1005;

int n, m;
int a[NMAX][2];
int q[NMAX][3];

void read()
{
	scanf("%d %d", &n, &m);
	forn(i, n)
	{
		scanf("%d %d", &a[i][0], &a[i][1]);
	}

	forn(i, m)
	{
		scanf("%d %d %d", &q[i][0], &q[i][1], &q[i][2]);
	}
}

int get(int id, int tm)
{
	if (tm == 0)
		return a[id][0];

	int k = tm / abs(a[id][0] - a[id][1]);
	int q = tm % abs(a[id][0] - a[id][1]);

	if (k & 1)
	{
		if (a[id][0] < a[id][1])
		{
			return a[id][1] - q;
		}
		else
		{
			return a[id][1] + q;
		}
	}
	else
	{
		if (a[id][0] < a[id][1])
		{
			return a[id][0] + q;
		}
		else
		{
			return a[id][0] - q;
		}
	}
}

void solve()
{
	forn(i, m)
	{
		int cnt = 0;
		forn(j, n)
		{
			int t = get(j, q[i][2]);
			if (q[i][0] <= t && t <= q[i][1])
				cnt ++;
		}
		printf("%d\n", cnt);
	}
}

int main()
{
	prepare("knockout");

	read();
	solve();

	return 0;
}