#include <iostream>
#include <cstdio>
#include <vector>
#include <cstring>
#include <algorithm>

using namespace std;
const int N = 2e5 + 10;
const int INF = 1e9;

int a[N];
int h[N];
int res[N];
int n;

vector < int > solve(int * h) {
	memset(res, 63, sizeof(res));	
	vector < int > answer(n + 1);
	res[0] = -1;
	int cur = 0;
	answer[0] = 0;
	for (int i = 0; i < n; i++) {
		int pos = lower_bound(res, res + n, h[i]) - res;	
		res[pos] = min(res[pos], h[i]);	
		cur = max(pos, cur);		
		answer[i + 1] = cur;
	}
	return answer;
}


int main() {
#ifdef DEBUG
	freopen("in", "r", stdin);
#else
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);
#endif
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%d", &a[i]);
		a[i]--;
	}
	for (int i = 0; i < n; i++)
		h[a[i]] = i;
			
	auto r1 = solve(h);
	reverse(h, h + n);
	auto r2 = solve(h);	
	reverse(r2.begin(), r2.end());
	/*for (auto x: r1)
		cerr << x << " ";
	cerr << endl;
	for (auto x: r2)
		cerr << x << " ";
	cerr << endl;*/

	int ans = 0;
	for (int i = 0; i < n + 1; i++)
		ans = max(ans, r1[i] + r2[i]);
	printf("%d\n", ans);



	return 0;
}





