#pragma comment(linker, "/STACK:64000000")

#include <iostream>
#include <cassert>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <ctime>
#include <sstream>
#include <string>
#include <cstring>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef double ld;

const int N = 500500;
int g[N];
int a[N];
int b[N];
ld ans[N];

struct cmp {
    bool operator()(int i, int j)const {
        return a[i] * b[j] < b[i] * a[j];
    }
};

void solve() {
    int n;
    cin >> n;
    i64 A, B;
    cin >> A >> B;
    forn(i, n) cin >> g[i] >> a[i] >> b[i];
    vi order(n);
    forn(i, n) order[i] = i;
    sort(all(order), cmp());
    reverse(all(order));
    i64 mB = 0, mA = 0;
    forn(_t, n) {
        int i = order[_t];
        if (g[i] * b[i] <= B - mB) {
            ans[i] = g[i];
            mA += g[i] * a[i];
            mB += g[i] * b[i];
        }
        else {
            assert(b[i] != 0);
            ans[i] = (ld)(B - mB) / b[i];
            if (mA < A && (B - mB) * a[i] < (A - mA) * b[i]) {
                cout << "-1 -1\n";
            }
            else {
                mB = B;
                cout << mA + ans[i] * a[i] << ' ' << mB << '\n';
                forn(i, n) cout << ans[i] << " \n"[i + 1 == n];
            }
            return;
        }
    }
    if (mA < A) {
        cout << "-1 -1\n";
    }
    else {
        cout << mA << ' ' << mB << '\n';
        forn(i, n) cout << ans[i] << " \n"[i + 1 == n];
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(15);
    cout << fixed;
#define TASK "burrito"
#ifdef HOME
    freopen("input.txt", "rt", stdin);
#else 
    freopen(TASK".in", "rt", stdin);
    freopen(TASK".out", "wt", stdout);
#endif
    solve();
#ifdef HOME
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " sec.\n";
#endif
    return 0;
}
