#pragma comment(linker, "/STACK:64000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <ctime>
#include <sstream>
#include <string>
#include <cstring>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef double ld;

const int N = 1050;
int a[N], b[N];

void solve()
{
	int n, m;
	cin >> n >> m;
	forn(i, n)
		cin >> a[i] >> b[i];
	forn(tt, m)
	{
		int x, y, _t;
		cin >> x >> y >> _t;
		int ans = 0;
		forn(i, n)
		{
			int t = _t;
			int len = abs(b[i] - a[i]);
			t %= (2*len);
			int p;
			if (a < b)
			{
				if (t > len)
					p = b[i] - (t - len);
				else
					p = t + a[i];
			}
			else
			{
				if (t > len)
					p = a[i] + (t - len);
				else
					p = b[i] - t;
			}
			ans += (x <= p && p <= y);
		}
		cout << ans << "\n";
	}
}

#define TASK "knockout"

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(15);
    cout << fixed;
#ifdef HOME
    freopen("input.txt", "rt", stdin);
#else 
    freopen(TASK".in", "rt", stdin);
    freopen(TASK".out", "wt", stdout);
#endif
	solve();
#ifdef HOME
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " sec.\n";
#endif
    return 0;
}
