#include<stdio.h>
#include<vector>
#include<algorithm>
using namespace std;

struct Ingr
{
	void init()
	{
		if (r == 0)
			srt = 2000000000;
		else
			srt = p / (double)r;
	}

	int w, r, p;
	double srt, ans;
};


int n, min_r, max_p;
vector<Ingr> ingrs;
vector<int> ingrs_ind;

bool cmp(const int& a, const int& b)
{
	return ingrs[a].srt < ingrs[b].srt;
}

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	scanf("%d %d %d", &n, &min_r, &max_p);
	ingrs.resize(n);
	ingrs_ind.resize(n);
	for (int i = 0; i < n; i++)
	{
		int w, r, p;
		scanf("%d %d %d", &ingrs[i].w, &ingrs[i].r, &ingrs[i].p);

		ingrs[i].init();
		ingrs_ind[i] = i;
	}

	sort(ingrs_ind.begin(), ingrs_ind.end(), cmp);

	double sum_r = 0;
	double sum_p = 0;

	for (int i = 0; i < n && sum_p < max_p; i++)
	{
		Ingr& cur_ingr = ingrs[ingrs_ind[i]];

		double grab_w = min((double)cur_ingr.w, (max_p - sum_p) / cur_ingr.p);
		cur_ingr.ans = grab_w;

		sum_r += cur_ingr.r * grab_w;
		sum_p += cur_ingr.p * grab_w;
	}

	if (sum_r < min_r)
	{
		printf("-1 -1");
		return 0;
	}

	printf("%.9lf %.9lf\n", sum_r, sum_p);
	for (int i = 0; i < n; i++)
	{
		printf("%.9lf ", ingrs[i].ans);
	}


	return 0;
}