// Main.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <fstream>
#include <cstddef>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>
#include <utility>
#include <unordered_map>
#include <iomanip>

#ifdef _DEBUG

auto& in = std::cin;
auto& out = std::cout;

#else

std::ifstream in("joke.in");
std::ofstream out("joke.out");

#endif

std::string get_preplacement(std::string s)
{
	for (auto& x : s)
	{
		x = 'a' + (x - '0');
	}
	
	return " " + s + " ";
}

std::pair<bool, std::string> ans_rec(const std::string& str, std::size_t i)
{
	if (i == 0)
	{
		return{ true, str };
	}

	auto i_str = std::to_string(i);
	auto rep = get_preplacement(i_str);

	for (auto it = str.find(i_str); it != std::string::npos; it = str.find(i_str, it + 1))
	{
		std::string splitted = str;
		splitted.replace(splitted.begin() + it, splitted.begin() + it + i_str.length(), rep);

		//std::cout << splitted << std::endl;
		//std::cin.get();

		auto ans = ans_rec(splitted, i - 1);

		if (ans.first)
		{
			return ans;
		}
	}

	return{ false, "" };
}

std::string decode(std::string str)
{
	std::string ans;

	bool has_space = true;
	for (const auto& x : str)
	{
		if (x == ' ')
		{
			if (!has_space)
			{
				ans.push_back(' ');
				has_space = true;
			}
		}
		else
		{
			ans.push_back((x - 'a') + '0');
			has_space = false;
		}
	}

	return ans;
}

int main()
{
	//std::vector<std::size_t> v(50);
	//for (std::size_t i = 0; i < v.size(); ++i)
	//{
	//	v.at(i) = i + 1;
	//}

	//std::random_shuffle(v.begin(), v.end());

	std::string str;
	//for (const auto& x : v)
	//{
	//	str += std::to_string(x);
	//}

	in >> str;

	auto n = std::min(static_cast<int>(str.length()), 
					  9 + std::max(0, static_cast<int>(str.length() - 9) / 2));

	out << decode(ans_rec(str, n).second) << std::endl;

}

