#include <iostream>
#include <sstream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <algorithm>
#include <iomanip>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); i++)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; i--)
#define fore(i,l,r) for (int i = int(l); i <= int(r); i++)
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ft first
#define sc second
#define x first
#define y second

template<typename X> inline X abs(const X& a) { return a < 0 ? -a : a; }
template<typename X> inline X sqr(const X& a) { return a * a; }

typedef pair<int, int> pt;
typedef long double ld;
typedef long long li;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld PI = 3.1415926535897932384626433832795L;
const ld EPS = 1e-9;

const int N = 1000 + 113;
int m, f, n;
int a[N];
char buf[N];
int d[N][N];

inline int getDig (char c)
{
	if (c >= '0' && c <= '9')
		return int(c - '0');
		
	if (c >= 'a' && c <= 'f')
		return int(10 + (c - 'a'));

	throw;
}

inline string toStr (int n)
{
	if (n == 0)
		return "0";
		
	string ans = "";
	while (n)
	{
		ans.pb(char('0' + (n & 1)));
		n >>= 1;
	}
	
	//reverse(all(ans));
	
	return ans;
}

inline bool read()
{
	if (scanf ("%d%d", &m, &f) != 2)
		return false;
		
	forn (i, f)
		assert(scanf ("%d", &a[i]) == 1);
		
	assert(scanf ("%d", &n) == 1);
		
	forn (i, n)
	{
		assert(scanf ("%s", buf) == 1);
		
		int len = strlen(buf);
		
		int pos = 0;
		
		forn (j, len)
		{
			int dd = getDig(buf[j]);
			string cur = toStr(dd);
			
			int curLen = min(m - j * 4, 4);
			while (sz(cur) < curLen)
			{
				cur.pb('0');
				//d[i][pos++] = 0;
				//curLen--;
			}	
			
			forn (j, sz(cur))
				d[i][pos++] = cur[j] - '0';
		}
		
		//forn (j, m)
	//		printf ("%d", d[i][j]);
//		puts("");
	}
		
	return true;
}

int used[N];
int ans[N], szans;
int cnt[N];

inline void solve()
{
	int q;
	assert(scanf ("%d", &q) == 1);
	
	forn (i, q)
	{
		int u;
		assert(scanf ("%d", &u) == 1);
		
		memset(cnt, 0, sizeof cnt);
		
		forn (it, f)
		{
			int pos = int((u * 1ll * a[it]) % m);
			
			forn (j, n)
				if (d[j][pos])
					cnt[j]++;
		}
		
		forn (j, n)
			if (cnt[j] == f)
				used[j] = 1;
	}
	
	forn (i, n)
		if (used[i])
			ans[szans++] = i;
			
	cout << szans;
	forn (i, szans)
		printf (" %d", ans[i]);
	puts("");
}

int main()
{
#ifdef SU2_PROJ
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("filter.in", "rt", stdin);
	freopen("filter.out", "wt", stdout);
#endif	

	cerr << setprecision(10) << fixed;
	cout << setprecision(15) << fixed;
	
	srand(time(NULL));
	
	assert(read());
	solve();
	
#ifdef SU2_PROJ
	cerr << "TIME: " << clock() << endl;
#endif	
	
	return 0;
}