#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cassert>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cstdlib>
#include <cmath>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()

using namespace std;

int main() {
  assert(freopen("alter.in", "r", stdin));
  assert(freopen("alter.out", "w", stdout));
  int n, m;
  scanf("%d %d", &n, &m);  
  vector< pair<int, int> > blacks;
  vector< pair<int, int> > whites;
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      if ((i + j) % 2 == 0) {
        blacks.push_back(make_pair(i, j));
      } else {
        whites.push_back(make_pair(i, j));
      }
    }
  }
  vector< pair<int, int> > ans;
  if (whites.size() < blacks.size()) {
    ans = whites;
  } else {
    ans = blacks;
  }
  printf("%d\n", ans.size());
  for (int i = 0; i < (int)ans.size(); ++i) {
    printf("%d %d %d %d\n", ans[i].first + 1, ans[i].second + 1, ans[i].first + 1, ans[i].second + 1);
  }
}
