#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cassert>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cstdlib>
#include <cmath>


#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()

using namespace std;

const int maxn = 1 << 20;

int a[maxn], b[maxn];
int g[maxn];
double s[maxn];
int p[maxn];

int cmpw(int x, int y) {
	if (b[x] == 0 && b[y] != 0) return 1;
	if (b[x] != 0 && b[y] == 0) return 0;
	if (b[x] == 0 && b[y] == 0) return a[x] > a[y];
	return a[x] * b[y] > a[y] * b[x];
}


int main() {
	freopen("burrito.in", "rt", stdin);
	freopen("burrito.out", "wt", stdout);
	int n, A, B;
	scanf("%d%d%d", &n, &A, &B);
	for (int i = 0; i < n; i++) {
		scanf("%d%d%d", &g[i], &a[i], &b[i]);	
		p[i] = i;
	}
	sort(p, p + n, cmpw);
	double tA = 0;
	double tB = 0;
	for (int i = 0; i < n; i++) {
		if (b[p[i]] == 0) {
			tA += a[p[i]] * g[p[i]];
			s[p[i]] = g[p[i]];
		} else {
			if (tB + b[p[i]] * g[p[i]] <= B) {
				tA += a[p[i]] * g[p[i]];
				tB += b[p[i]] * g[p[i]];
				s[p[i]] = g[p[i]];
			} else {
				double ss = (B - tB) / b[p[i]];
				s[p[i]] = ss;
				tA += a[p[i]] * ss;
				tB += b[p[i]] * ss;
				break;
			}
		}
	}
	if (tA < A) {
		printf("-1 -1\n");
	} else {
		printf("%.20f %.20f\n", tA, tB);
		for (int i = 0; i < n; i++) {
			printf("%.20f%c", s[i], " \n"[i + 1 == n]);
		}
 }
}