#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cassert>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cstdlib>
#include <cmath>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()

using namespace std;

const int maxn = 1 << 10;

int a[maxn], b[maxn];


int sign(int x) {
	if (x < 0) return -1;
	if (x > 0) return 1;
	return 0;
}

int main() {
	freopen("knockout.in", "rt", stdin);
	freopen("knockout.out", "wt", stdout);
	int n, m;
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; i++) scanf("%d%d", &a[i], &b[i]);
	for (int j = 0; j < m; j++) {
		int x, y, t;
		scanf("%d%d%d", &x, &y, &t);
		int res = 0;
		for (int i = 0; i < n; i++) {
			int tt = t / (abs(a[i] - b[i]));
			int trem = t % abs(a[i] - b[i]);
			int curx = 0;
			if (tt % 2 == 0) {
				curx = a[i] + sign(b[i]-a[i]) * trem;
			} else {
				curx = b[i] + sign(a[i] - b[i]) * trem;
			}
			if (x <= curx && curx <= y) res++;
		}
		printf("%d\n", res);
	}
}