#define _CRT_SECURE_NO_WARNINGS

#include <iostream>

using namespace std;

const int MAXF = 110;
const int MAXBITS = 40;
const int MAXN = 1010;

int m, f, a[MAXF];
int n, q;
int bitsCnt, bufLen;

char buffer[1000];
bool good[MAXN];

struct myhash{
	int bits[MAXBITS];

	void setBit(int id){
		int bin = id / 32;
		id %= 32;
		bits[bin] |= (1 << id);
	}

	bool contains(const myhash &h) const{
		for (int i = 0; i < bitsCnt; ++i){
			if ((bits[i] & h.bits[i]) != h.bits[i]) 
            return false;
		}
		return true;        
	}
} files[MAXN], users[MAXN];


void scan(int idx){
    
	gets(buffer);
	//printf("\n%d : ", idx);
	for (int i = 0; i < bufLen; ++i){
		char x = buffer[i];
		if (x <= '9')
			x -= '0';
		else
			x -= 'a' - 10;
		x -= (x <= '9') ? '0' : 'a';
		for (int j = 0; j < 4; j++){
			//printf("%d", (x & (1 << j)) != 0 ? 1 : 0);
			if ((x & (1 << j)) != 0){
				files[idx].setBit(i * 4 + j);
				//printf("%d ", i * 4 + j);
			}
		}
		//printf(" ");

	}
}

int main(){
	freopen("filter.in", "rt", stdin);
	freopen("filter.out", "wt", stdout);
    
	scanf("%d%d", &m, &f);
	bitsCnt = (m + 31) / 32;
	bufLen = (m + 3) / 4;
	for (int i = 0; i < f; ++i){
		scanf("%d", &a[i]);
	}
	scanf("%d\n", &n);
	for (int i = 0; i < n; ++i){
		scan(i);
	}
	scanf("%d", &q);
	int cnt = 0;
	for (int i = 0; i < q; ++i){
		int u;
		scanf("%d", &u);
		//printf("\n%d -> ", i);
		for (int j = 0; j < f; ++j){
			users[i].setBit((u * a[j]) % m);
			//printf("%d ", (u*a[j]) % m);
		}
		for (int j = 0; j < n; ++j){
			if (!good[j] && files[j].contains(users[i])){
				good[j] = true;
				cnt++;
			}
		}
	}

	printf("%d ", cnt);
	for (int i = 0; i < n; ++i){
		if (good[i])
			printf("%d ", i);
	}

	return 0;
}