#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <map>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <iterator>

using namespace std;

typedef long long ll;

int get_num2 (const string &s, int j)
{
    return 10*(s[j] - '0') + s[j+1] - '0';
}

int get_num1 (const string &s, int j)
{
    return s[j] - '0';
}

bool set(const ll mask, int pos)
{
    return (((1LL << pos) & mask) != 0);
}

vector<int> out;
bool ok = false;

void go(const string& s, int pos, vector<int>& v, ll mask)
{
    //cout << pos << " " << mask << endl;
    if( ok ) return;
    if ( pos == s.size() )
    {
        int sz = v.size();
        if ( (mask | 1) == ((1LL << (sz + 1)) - 1))
        {
            out = v;
            ok = true;
        }
        return;
    }

    if( pos > s.size() )
        return;

    if( pos < s.size() - 1 )
    {
        int num = get_num2(s, pos);
      //  cout << "num2: " << num << endl;
        if( !set(mask, num) )
        {
            vector<int> new_v(v);
            new_v.push_back(num);
            go(s, pos + 2, new_v, (mask | (1LL << (num))));
        }
    }

    int num = get_num1(s, pos);
    //cout << "num1:" <<  num << endl;
    if( !set(mask, num) )
    {
        vector<int> new_v(v);
        new_v.push_back(num);
        go(s, pos + 1, new_v, (mask | (1LL << (num))));
    }

    return;
}

int main()
{
    freopen ("joke.in", "rt", stdin);
    freopen ("joke.out", "wt", stdout);
    string s;

    cin >> s;

    vector<int> tmp;
    go(s, 0, tmp, 0LL);

    if( ok )
    {
        copy(out.begin(), out.end(), ostream_iterator<int>(cout, " "));
        cout << endl;
    }
    else
    {
        cout << "FAIL" << endl;
    }

    return 0;
}
