#if 1
#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cstdlib>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#define MAXN 100100
#define mp make_pair
using namespace std;

struct node{
	int g, a, b, id;
};
   
int n;
double a, b;
node c[MAXN];
double resx, resy;
double res[MAXN];

typedef long long LL;

bool cmp(node u, node v){

	if (mp(mp(u.a, u.b), u.g) == mp(mp(v.a, v.b), v.g))
		return u.id < v.id;

	if (u.b == 0){
		if (v.b == 0)
            return u.a > v.a;
		return true;
	}

	return  LL(v.b) * LL(u.a) > LL(v.a) * (u.b) ||
		    LL(v.b) * LL(u.a) == LL(v.a) * (u.b) && u.g > v.g;
}

void solve()
{
	
	cin >> n >> a >> b;
	for (int i = 1; i <= n; i++){
		cin >> c[i].g >> c[i].a >> c[i].b;
		c[i].id = i;
	}
    
	//n = 100000; a = 1000000000; b = 1000000000;
	//for (int i = 1; i <= n; i++){
	//	c[i].g = 100; c[i].a = 10000; c[i].b = 0;
	//	c[i].id = i;
	//}
	sort(c + 1, c + n + 1, cmp);
	
	resx = 0; resy = 0;

	for (int i = 1; i <= n; i++){
		res[c[i].id] = 0;
		if (c[i].g == 0) continue;
		if (c[i].b == 0){
			res[c[i].id] = c[i].g;
			resx += c[i].a * c[i].g;
		}
		else{
			if (c[i].g * c[i].b + resy > b){
				res[c[i].id] = (b - resy) / c[i].b;
				resx += res[c[i].id] * c[i].a;
				resy += res[c[i].id] * c[i].b;
			}
			else{
				res[c[i].id] = c[i].g;
				resx += res[c[i].id] * c[i].a;
				resy += res[c[i].id] * c[i].b;
			}
		}
	}

	cout.setf(ios::fixed);
	cout.precision(9);
	if (resx < a) cout << "-1 -1" << endl;
	else{
		cout << resx << " " << resy << endl;
		for (int i = 1; i <= n; i++) cout << res[i] << " ";
		cout << endl;
	}
}

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	ios_base::sync_with_stdio(false);
	solve();

	return 0;
}
#endif