#if 1
#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cstdlib>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
using namespace std;

const int maxn = 1e4;

typedef long long LL;

LL getx(LL a, LL b, LL t)
{
	LL d = abs(b - a);
	LL ost = t % (2 * d);
	if (a < b)
		return ost <= d ? a + ost : b - (ost - d);
	else
		return ost <= d ? a - ost : b + (ost - d);
}

void solve()
{
	int n, m;
	cin >> n >> m;
	vector<int> a(n), b(n);

	for (int i = 0; i < n; ++i)
		cin >> a[i] >> b[i];

	while (m--)
	{
		int res = 0;

		int x, y, t; cin >> x >> y >> t;
		for (int i = 0; i < n; ++i)
		{
			LL xx = getx(a[i], b[i], t);
			res += x <= xx && xx <= y;
		}

		cout << res << endl;
	}
}

int main()
{
	//freopen("input.txt", "r", stdin);
	freopen("knockout.in", "r", stdin); freopen("knockout.out", "w", stdout);

	ios_base::sync_with_stdio(false);
	solve();

	return 0;
}
#endif