#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

struct st
{
	int g, a, b, i;
	st(int g, int a, int b, int i) : g(g), a(a), b(b), i(i)
	{
	}
	st() {}
};

int n, a, b;

st v[110000];
double res[110000];

bool Comp(const st & a, const st & b)
{
	double x = a.a / (a.b + 0.0);
	double y = b.a / (b.b + 0.0);
	return x < y;
}
int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	scanf("%d%d%d", &n, &a, &b);
	for (int i = 0; i < n; i++)
	{
		int g1, a1, b1;
		scanf("%d%d%df", &g1, &a1, &b1);
		v[i] = st(g1, a1, b1, i);
	}
	sort(v, v + n, Comp);
	double cura = 0, curb = 0;
	int cur = n - 1;
	while (curb < b && cur >= 0)
	{
		double curg = min((double) v[cur].g, (b - curb) / v[cur].b);
		res[v[cur].i] = curg;
		cura += curg * v[cur].a;
		curb += curg * v[cur].b;
		cur--;
	}
	if (cura + 1e-9 < a)
	{
		printf("-1 -1\n");
		return 0;
	}
	printf("%.9lf %.9lf\n", cura, curb);
	for (int i = 0; i < n; i++)
	{
		printf("%.9lf ", res[i]);
	}
	printf("\n");
	return 0;
}