#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

struct st
{
	int g, a, b, i;
	st(int g, int a, int b, int i) : g(g), a(a), b(b), i(i)
	{
	}
	st() {}
};

int n, a, b;

st v[110000];
double res[110000];

bool Comp(const st & a, const st & b)
{
	return a.a * b.b < a.b * b.a;
}

bool eq(double a, double b)
{
	return fabs(a - b) < 1e-9;
}

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	scanf("%d%d%d", &n, &a, &b);
	for (int i = 0; i < n; i++)
	{
		int g1, a1, b1;
		scanf("%d%d%d", &g1, &a1, &b1);
		v[i] = st(g1, a1, b1, i);
	}
	sort(v, v + n, Comp);
	double cura = 0, curb = 0;
	int cur = n - 1;
	while (curb < b && cur >= 0)
	{
		double curg = min((double) v[cur].g, (double) (b - curb) / v[cur].b);
		res[v[cur].i] = curg;
		cura += curg * v[cur].a;
		curb += curg * v[cur].b;
		cur--;
	}
	if (eq(cura, a))
		cura = a;
	if (eq(curb, b))
		curb = b;
	if (cura < a)
	{
		printf("-1 -1\n");
		return 0;
	}
	printf("%.8lf %.8lf\n", (double) cura, (double) curb);
	for (int i = 0; i < n; i++)
	{
		printf("%.8lf ", (double) res[i]);
	}
	printf("\n");
	return 0;
}