#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;
#define LL long long

struct st
{
	int g, a, b, i;
	st(int g, int a, int b, int i) : g(g), a(a), b(b), i(i)
	{
	}
	st() {}
};

int n, a, b;

st v[110000];
double res[110000];

bool Comp(const st & a, const st & b)
{
	return a.a * b.b < a.b * b.a;
}

bool eq(double a, double b)
{
	return fabs(a - b) < 1e-9;
}

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	scanf("%d%d%d", &n, &a, &b);
	for (int i = 0; i < n; i++)
	{
		int g1, a1, b1;
		scanf("%d%d%d", &g1, &a1, &b1);
		v[i] = st(g1, a1, b1, i);
	}
	sort(v, v + n, Comp);
	LL cura = 0, curb = 0;
	int cur = n - 1;
	int last = -1;
	while (curb < b && cur >= 0)
	{
		if (b - curb < v[cur].g * v[cur].b)
		{
			last = cur;
			res[v[cur].i] = (b - curb) / (v[last].b + 0.0);
			break;
		}
		LL curg = v[cur].g;
		res[v[cur].i] = curg;
		cura += curg * v[cur].a;
		curb += curg * v[cur].b;
		cur--;
	}
	double dcura = (double)cura + (last == -1 ? 0 : (v[last].a * (b - curb)) / (v[last].b + 0.0));
	double dcurb = (double)curb + (last == -1 ? 0 : ((b - curb)));
	if (eq(dcura, a))
		dcura = a;
	if (eq(dcurb, b))
		dcurb = b;
	if (dcura < a)
	{
		printf("-1 -1\n");
		return 0;
	}
	printf("%.8lf %.8lf\n", (double) dcura, (double) dcurb);
	for (int i = 0; i < n; i++)
	{
		printf("%.8lf ", (double) res[i]);
	}
	printf("\n");
	return 0;
}