#include<iostream>
#include<fstream>
#include<algorithm>
#include<iomanip>
#include<cmath>
#define f first
#define s second
#define mp make_pair
#define MAX_ERROR 0.0000000001
using namespace std;


bool dlt(double l, double r) {
	if (abs(l - r) < MAX_ERROR)
		return false;

	return l < r;
}

pair< pair < pair<double, double>, pair<double, double> >, int>  inc[100000];

int n, A, B;
double happy, unhappy, chosen[100000];

int main() {
	ifstream in("burrito.in");

	in >> n >> A >> B;

	for (int i = 0; i < n; i++) {
		in >> inc[i].f.f.s >> inc[i].f.s.f >> inc[i].f.s.s, inc[i].f.f.f = inc[i].f.s.f / inc[i].f.s.s, inc[i].s = i;
	}

	sort(inc, inc + n);
	reverse(inc, inc + n);

	for (int i = 0; i < n; i++) {
		double add = inc[i].f.f.s;

		if (dlt(0.0, inc[i].f.s.s))
			add = min(add, (B - unhappy) / inc[i].f.s.s);
			

		happy += inc[i].f.s.f * add;
		unhappy += add * inc[i].f.s.s;

		chosen[inc[i].s] += add;
	}

	ofstream out("burrito.out");

	if(dlt(happy, (double)A) )
		out << "-1 -1\n";
	else {
		out << fixed << setprecision(9) << happy << ' ' << unhappy << '\n';

		for (int i = 0; i < n; i++)
			out << fixed << setprecision(9) << chosen[i] << ' ';

		out << '\n';
	}

	return 0;
}