#include<iostream>
#include<fstream>
#include<string>
#include<vector>
using namespace std;

int m, f, a[100], q, u, n;
unsigned int mask[1000][33];
unsigned int usrmask[1000][33];

string hexstr = "0123456789abcdef";

unsigned int hexint(char c) {
	return hexstr.find(c);
}

int main() {
	ifstream in("filter.in");

	in >> m >> f;

	for (int i = 0; i < f; i++) {
		in >> a[i];
	}

	string line;
	in >> n;

	for (int i = 0; i < n; i++) {
		in >> line;

		for (unsigned int j = 0; j < line.size(); j++) {
			
			unsigned int add = (1 << 4 * (j % 8)) * hexint(line[j]);

			mask[i][j / 8] += add;
		}
	}

	//Next we deal with the users

	in >> q;

	for (int i = 0; i < q; i++) {
		in >> u;

		for (int k = 0; k < f; k++)
			for (int j = 0; j < m; j++)
				if (j == (1LL * u * a[k]) % m)
					usrmask[i][j / 32] |= 1 << (j % 32);
	}


	//Finally we do the comparisons

	vector<int> sated;

	for (int i = 0; i < n; i++) {
		int found = false;

		for (int j = 0; j < q; j++) {
			bool curvalid = true;

			for (int k = 0; k < 33; k++)
				if ((usrmask[j][k] & mask[i][k]) != usrmask[j][k])
					curvalid = false;

			if (curvalid) {
				found = true;
				break;
			}
		}

		if (found)
			sated.push_back(i);
	}

	ofstream out("filter.out");

	out << sated.size();

	for (int i = 0; i < sated.size(); i++)
		out << ' ' << sated[i];

	out << '\n';
	return 0;
}