#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <deque>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>

using namespace std;

#define _USE_MATH_DEFINES
#include <math.h>

#define LL long long
#define forn(i,n) for (LL i=0;i<n;i++)
#define rforn(i,n) for (LL i=n-1;i>=0;i--)
#define mp make_pair

void smain();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);
#endif

	smain();

	return 0;
}

#define N 200000

int tup[4 * N], tdw[4 * N];
int x[N];

void add_t(int *t, int v, int l, int r, int pos, int val){
	if (l == r)return void(t[v] = val);
	int m = (l + r) / 2;
	if (pos <= m) add_t(t, 2 * v, l, m, pos, val);
	else add_t(t, 2 * v + 1, m + 1, r, pos, val);
	t[v] = max(t[2 * v], t[2 * v + 1]);
}

int query(int *t, int v, int l, int r, int ql, int qr){
	if (l == ql && r == qr) return t[v];
	int m = (l + r) / 2;
	int r1 = 0, r2 = 0;
	if (ql <= m) r1 = query(t, 2 * v, l, m, ql, min(qr, m));
	if (qr > m) r2 = query(t, 2 * v + 1, m + 1, r, max(ql, m + 1), qr);
	return max(r1, r2);
}

void smain() {
	int n;
	cin >> n;

	forn(i, n) {
		cin >> x[i];
		x[i] -= 1;
	}

	int res = 0;
	forn(i, n){
		int v1 = query(tup, 1, 0, n - 1, 0, x[i]);
		int v2 = query(tdw, 1, 0, n - 1, x[i], n - 1);
		add_t(tup, 1, 0, n - 1, x[i], v1 + 1);
		add_t(tdw, 1, 0, n - 1, x[i], v2 + 1);
		int cur = v1 + v2 + 1;
		res = max(res, cur);
	}

	cout << res;
}