import java.io.*;
import java.util.StringTokenizer;

public class TaskK extends PrintWriter {
    BufferedReader in;
    StringTokenizer stok;

    static String FILENAME = "knockout";

    void solve() throws IOException {
        int n = nextInt(), m = nextInt();
        long[] a = new long[n];
        long[] b = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
            b[i] = nextInt();
        }
        for (int i = 0; i < m; ++i) {
            long x = nextInt(), y = nextInt(), t = nextInt();
            int res = 0;
            for (int j = 0; j < n; ++j) {
                long len = Math.abs(a[j] - b[j]);
                long cnt = t / len;
                long tcur = t % len;
                long f = a[j], s = b[j];
                if (cnt % 2 == 1)
                {
                    long tmp = f;
                    f = s;
                    s = tmp;
                }
                long cur = f;
                if (s > f)
                    cur += tcur;
                else
                    cur -= tcur;
                if (cur >= x && cur <= y)
                    res++;
            }
            println(res);
        }
    }

    void run() {
        try {
            solve();
            close();
        } catch (Exception e) {
            System.exit(1);
        }
    }

    TaskK() throws IOException {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    TaskK(String s) throws IOException {
        super(s + ".out");
        in = new BufferedReader(new FileReader(s + ".in"));
    }

    public static void main(String[] args) throws IOException {
        if (FILENAME == null) {
            new TaskK().run();
        } else {
            new TaskK(FILENAME).run();
        }
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }
}