#include <iostream>
#include <cstdio>
#include <climits>
#include <memory.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <numeric>

using namespace std;

int main()
{
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("knockout.in", "rt", stdin);
	freopen("knockout.out", "wt", stdout);
#endif
	int n, m;
	cin >> n >> m;
	vector < pair<int, int> > a;
	a.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i].first >> a[i].second;
	}
	for (int i = 0; i < m; i++)
	{
		int x, y, t;
		cin >> x >> y >> t;
		int cnt = 0;
		for (int j = 0; j < n; j++)
		{
			int pos;
			if (a[j].first > a[j].second )
			{
				pos = t % (a[j].first - a[j].second);
				if ((t / (a[j].first - a[j].second)) % 2 == 0)
					pos = a[j].first - pos;
				else
					pos = a[j].second + pos;
			}
			else if (a[j].first < a[j].second)
			{
				pos = t % (a[j].second - a[j].first);
				if ((t / (a[j].second - a[j].first)) % 2 == 0)
					pos = a[j].first + pos;
				else
					pos = a[j].second - pos;
			}
			else
				pos = a[j].first;
			if (pos >= x && pos <= y)
				cnt++;
		}
		cout << cnt << endl;
	}
	return 0;
}