#include <iostream>
#include <cstdio>
#include <string>
#include <cassert>
#include <vector>
#include <cstdlib>
#include <sstream>
#include <algorithm>
#include <ctime>

using namespace std;

#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define forn(i, n) forab(i, 0, n)
#define forba(i, b, a) for(int i = int(b) - 1; i >= int(a); --i)

typedef long long ll;
typedef long double ldb;

const int MAXN = 100010;

const ldb EPS = 1e-12;

struct ingr {
    int a, b, g;
    int num;

    bool operator <(const ingr & i) const {
        return a * i.b > i.a * b;
    }

};


int n, A, B;
ingr x[MAXN];

ldb ans[MAXN];


int main()
{
    freopen("burrito.in", "r", stdin);
    freopen("burrito.out", "w", stdout);

    scanf("%d%d%d", &n, &A, &B);
    forn(i, n) {
        scanf("%d%d%d", &x[i].g, &x[i].a, &x[i].b);
        x[i].num = i;
    }

    sort(x, x + n);

    ldb cA = 0.0L, cB = 0.0L;

    forn(i, n) {
        if (B - cB < EPS)
            break;

        ans[x[i].num] = x[i].g;
        if (x[i].b > 0)
            ans[x[i].num] = min(ans[x[i].num], (B - cB) / x[i].b);

        cB += ans[x[i].num] * x[i].b;
        cA += ans[x[i].num] * x[i].a;
    }

    if (A - cA > EPS) {
        printf("-1 -1\n");
        return 0;
    }

    printf("%.10f %.10f\n", (double)cA, (double)cB);
    forn(i, n)
        printf("%.10f ", (double)ans[i]);
    printf("\n");




    return 0;
}

