#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <vector>
#include <cstring>

#define FOR(a, b) for (int a = 0; a < (b); ++a)
#define clr(a) memset(a, 0, sizeof(a))

using namespace std;

typedef long long ll;

const int MAXN = 1100;
const int MAXL = 200;

int a[MAXN];
ll t[MAXN][MAXL];
char s[MAXN];
bool tb[MAXN];
ll tl[MAXL];
bool good[MAXN];

int getCode(char c) {
	if (c >= '0' && c <= '9')
		return c - '0';
	return c -'a' + 10;
}
int nl;
int m;

void getLong() {
	clr(tl);
	FOR(i, m) {
		tl[i / 64] |= ((ll)(tb[i] ? 1 : 0))<<(i % 64);
	}
}

int main() {
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
	int f;
	scanf("%d%d", &m, &f);
	FOR(i, f) {
		scanf("%d", &a[i]);
		a[i] = a[i] % m;
	}
	int n;
	scanf("%d", &n);
	nl = (m + 63) / 64;
	FOR(i, n) {
		scanf("%s", &s);
		int len = strlen(s);
		int cnt = 0;
		clr(tb);
		FOR(j, len) {
			FOR(k, 4)
				tb[cnt++] = ((getCode(s[j]) & (1 << k)) != 0);
		}
		getLong();
		FOR(j, nl)
			t[i][j] = tl[j];
		/*
		FOR(j, m)
			cerr << (int)tb[j];
		cerr << '\n';
		cerr << tl[0] << '\n';*/
	}
	clr(good);
	int q;
	scanf("%d", &q);
//	cerr << '\n';
	FOR(i, q) {
		int u;
		scanf("%d", &u);
		u = u % m;
		clr(tb);
		FOR(j, f) {
			int val = (u * a[j]) % m;
			tb[val] = true;
		}
		/*
		FOR(j, m)
			cerr << (int)tb[j];
		cerr << '\n';*/
		getLong();
//		cerr << tl[0] << '\n';
		FOR(j, n) {
			bool flag = true;
			FOR(k, nl) {
				if ((t[j][k] & tl[k]) != tl[k]) {
					flag = false;
					break;
				}
			}
			if (flag)
				good[j] = true;
		}
	}
	vector<int> ans;
	FOR(i, n) {
		if (good[i])
			ans.push_back(i);
	}
	printf("%d ", ans.size());
	FOR(i, ans.size()) {
		printf("%d ", ans[i]);
	}

	return 0;

}

