#include <iostream>
#include <cstdio>
#include <string>
#include <cassert>
#include <vector>
#include <cstdlib>
#include <sstream>
#include <algorithm>
#include <ctime>
#include <set>

using namespace std;

#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define forn(i, n) forab(i, 0, n)
#define forba(i, b, a) for(int i = int(b) - 1; i >= int(a); --i)

typedef long long ll;
typedef long double ldb;

const int MAXN = 200010;

int n;
int x[MAXN];

set<int> q;
set<int> q2;

int main()
{
    freopen("improvements.in", "r", stdin);
    freopen("improvements.out", "w", stdout);

    scanf("%d", &n);
    q.clear();
    forn(i, n) {
        scanf("%d", &x[i]);
        q.insert(x[i]);
    }

    q2.clear();

    int ans = n;
    forn(i, n) {
        if (!q2.count(x[i]) && x[i] != (*q.begin()) && x[i] != (*q.rbegin())) {
            auto it = q.begin();
            auto rit = q.rbegin();
            ++it;
            --rit;
            if (x[i] == (*it)) {
                q2.insert((*q.begin()));
                q.erase(q.begin());
            } else if (x[i] == (*rit)) {
                q2.insert((*q.rbegin()));
                q.erase((*q.rbegin()));
            }
            ans--;
        }
        q.erase(x[i]);
    }

    cout << ans << '\n';

    return 0;
}

