#include <iostream>
#include <cstdio>
#include <string>
#include <cassert>
#include <vector>
#include <cstdlib>
#include <sstream>
#include <algorithm>
#include <ctime>
#include <set>

using namespace std;

#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define forn(i, n) forab(i, 0, n)
#define forba(i, b, a) for(int i = int(b) - 1; i >= int(a); --i)

typedef long long ll;
typedef long double ldb;

const int MAXN = 200010;
const int INF = int(1e9);

int n;
int x[MAXN];

int mn[MAXN];
int mx[MAXN];

int ans = 0;

int main()
{
    freopen("improvements.in", "r", stdin);
    freopen("improvements.out", "w", stdout);

    scanf("%d", &n);
    forn(i, n)
        scanf("%d", &x[i]);

    forn(i, n + 1) {
        mn[i] = INF;
        mx[i] = -INF;
    }
    mn[0] = -INF;
    mx[0] = INF;

    ans = 1;
    mn[1] = mx[1] = x[0];


    forab(i, 1, n) {
        int Lmn = 0, Rmn = i + 1, Mmn;
        while (Rmn - Lmn > 1) {
            Mmn = (Lmn + Rmn) / 2;
            if (mn[Mmn] < x[i])
                Lmn = Mmn;
            else
                Rmn = Mmn;
        }

        int Lmx = 0, Rmx = i + 1, Mmx;
        while (Rmx - Lmx > 1) {
            Mmx = (Lmx + Rmx) / 2;
            if (mx[Mmx] > x[i])
                Lmx = Mmx;
            else
                Rmx = Mmx;
        }

        //cout << i << ' ' << Lmn << ' ' << Lmx << '\n';

        ans = max(ans, Lmn + Lmx + 1);
        mn[Lmn + 1] = min(mn[Lmn + 1], x[i]);
        mx[Lmx + 1] = max(mx[Lmx + 1], x[i]);
    }

    cout << ans << '\n';

    return 0;
}

