#include <iostream>
#include <cstdio>
#include <string>
#include <cassert>
#include <vector>
#include <cstdlib>
#include <sstream>
#include <algorithm>
#include <ctime>

using namespace std;

string s;
int n = -1;
vector<bool> used;
vector<int> p;

void gen(int i, int pos) {
    //cerr << i << ' ' << pos << endl;
    if (pos == n) {
        for (int j = 0; j < n; ++j) {
            printf("%d ", p[j]);
        }
        printf("\n");
        exit(0);
        return;
    }
    int cur1 = s[i] - '0';
    if (cur1 <= n && !used[cur1]) {
        used[cur1] = true;
        p[pos] = cur1;
        gen(i + 1, pos + 1);
        used[cur1] = false;
    }
    if (i + 1 < s.size()) {
        int cur2 = 10 * (s[i] - '0') + (s[i + 1] - '0');
        if (cur2 <= n && !used[cur2]) {
            used[cur2] = true;
            p[pos] = cur2;
            gen(i + 2, pos + 1);
            used[cur2] = false;
        }
    }
}

int main()
{
    freopen("joke.in", "r", stdin);
    freopen("joke.out", "w", stdout);
    cin >> s;
    /*&\srand(time(NULL));
    vector<int> rp(50);
    for (int i = 0; i < 50; ++i) {
        rp[i] = i + 1;
    }
    random_shuffle(rp.begin(), rp.end());
    stringstream ss;
    for (int i = 0; i < 50; ++i) {
        ss << rp[i];
        cerr << rp[i] << ' ';
    }
    cerr << endl;
    s = ss.str();
    cerr << s << endl;*/
    int sz = 0;
    for (int i = 1; i <= 50; ++i) {
        if (i < 10) {
            sz += 1;
        } else {
            sz += 2;
        }
        if (sz == s.size()) {
            n = i;
            break;
        }
    }
    assert(n != -1);
    used.assign(n + 1, false);
    p.resize(n);
    used[0] = true;
    //cerr << n << " gen\n";
    gen(0, 0);
    return 0;
}
