#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>

#define all(v) v.begin(), v.end()
typedef long long ll;

using namespace std;

int main()
{
	ios_base::sync_with_stdio(false);
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);
	int n, m;
	cin >> n >> m;
	vector<pair<int, int> > vc;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		vc.push_back(make_pair(x, y));
	}

	for (int i = 0; i < m; ++i)	{
		int x, y, t;
		cin >> x >> y >> t;
		int ans = 0;
		for (int j = 0; j < n; ++j) {
			int a = vc[j].first;
			int b = vc[j].second;
			int c = abs(a - b);
			int o = t % (2 * c);
			if (o > c)
				o = 2 * c - o;
		
			if (a > b) {
				int coo = a - o;
				if (coo >= x && coo <= y) {
					++ans;
				}
			} else {
				int coo = a + o;
				if (coo >= x && coo <= y) {
					++ans;
				}
			}
		}
		cout << ans << endl;
	}
	return 0;
}