#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <list>
#include <vector>
#include <string>
#include <cstring>
#include <cmath>
#include <ctime>
#include <cassert>
#include <bitset>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)((a).size())
#define mp make_pair
#define X first
#define Y second
#define y1 __y1
#define sqr(x) ((x) * (x))
#define endl '\n'

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld eps = 1e-9;
const ld pi = ld(3.1415926535897932384626433832795);

inline int myrand()
{
	return rand() ^ (rand() << 15);
}

const int N = 200009;

map <pt, int> m;
int n, a[N];

void rec(int l, int r){
	if (l == r){
		m[mp(l, r)] = 0;
		if (!a[n] == l)
			++m[mp(l, r)];
		return;
	}

	int pos = n - (r - l);
	if (m.find(mp(l, r)) != m.end())
		return;
	rec(l + 1, r), rec(l, r - 1);
	m[mp(l, r)] = min(m[mp(l + 1, r)] + 1 - (a[pos] == l), m[mp(l, r - 1)] + 1 - (a[pos] == r));
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

#ifndef _DEBUG
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(10) << fixed;

	cin >> n;
	forn(i, n)
		cin >> a[i + 1];

	rec(1, n);

	cout << n - m[mp(1, n)];
	cerr << "TIME == " << ld(clock()) / CLOCKS_PER_SEC << endl;
	return 0;
}