#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
using namespace std;

int g[100005], a[100005], b[100005];
int srt[100005];
double ans[100005];
int n, A, B;

bool cmp (int d1, int d2) {
	return a[d1] * b[d2] > a[d2] * b[d1];
}

bool doubleEqual (double val1, double val2) {
	return fabs(val1 - val2) < 1e-9;
}

bool doubleLess (double val1, double val2) {
	return val1 < val2 && !doubleEqual(val1, val2);
}

int main () {
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	scanf("%d%d%d", &n, &A, &B);
	for (int i = 0; i < n; i++) {
		scanf("%d%d%d", &g[i], &a[i], &b[i] );
	}

	for (int i = 0; i < n; i++)
		srt[i] = i;
	sort(srt, srt + n, cmp);

	int aSum = 0, bSum = 0;
	for (int i = 0; i < n; i++) {
		int cur = srt[i];

		if (bSum + g[cur] * b[cur] <= B) {
			ans[cur] = g[cur];
			bSum += b[cur] * g[cur];
		} else {
			ans[cur] = (B - bSum) / (b[cur] * 1.);
			break;
		}
	}

	double aRes = 0, bRes = 0;
	for (int i = 0; i < n; i++) {
		aRes += a[i] * ans[i];
		bRes += b[i] * ans[i];
	}

	if (doubleLess(aRes, A) ) {
		printf("-1 -1\n");
		return 0;
	}

	printf("%.12lf %.12lf\n", aRes, bRes);
	for (int i = 0; i < n; i++) {
		printf("%.12lf ", ans[i] );
	}

	return 0;
}