#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct ing {
	double g;
	double a;
	double b;
	double taken;
};

ing M[100000];

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("burrito.in", "rt", stdin);
	freopen("burrito.out", "wt", stdout);
#endif
	int n;
	double A, B;
	cin >> n >> A >> B;
	vector <pair <double, int> > val;
	double joy = 0;
	double unh = 0;
	for (int i = 0; i < n; ++i) {
		cin >> M[i].g >> M[i].a >> M[i].b;
		M[i].taken = 0;
		if (M[i].b == 0) {
			joy += M[i].a * M[i].g;
			M[i].taken = M[i].g;
		}
		else {
			val.push_back(make_pair(M[i].a / M[i].b, i));
		}
	}
	sort(val.begin(), val.end());
	reverse(val.begin(), val.end());
	int i = 0;
	while ((unh < B) && (i < val.size())) {
		int p = val[i].second;
		if (unh + M[p].b * M[p].g <= B) {
			joy += M[p].a * M[p].g;
			unh += M[p].b * M[p].g;
			M[p].taken = M[p].g;
			++i;
		}
		else {
			double yet = B - unh;
			yet /= M[p].b;
			unh = B;
			joy += M[p].a * yet;
			M[p].taken = yet;
		}
	}
	if (joy < A) {
		cout << "-1 -1" << endl;
		return 0;
	}
	else {
		printf("%.8lf %.8lf\n", joy, unh);
		for (int i = 0; i < n; ++i) {
			printf("%.8lf ", M[i].taken);
		}
	}
	return 0;
}