
#pragma comment(linker,"/STACK:256000000")

#include <iostream>
#include <iomanip>

#include <cstdlib>
#include <cstring>
#include <cmath>

#include <algorithm>

#include <string>

using namespace std;

int n;
long double A, B;

bool used[100007];

long long a[100007], b[100007], c[100007];
int id[100007];

long double ans[100007];

bool cmp(int id1, int id2)
{
	if (used[id1]) return false;
	if (used[id2]) return true;
	return a[id1] * b[id2] > a[id2] * b[id1];
}

int main()
{
	#ifdef CRABEN
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#else
	#define FILE_NAME "burrito"
	freopen(FILE_NAME".in", "r", stdin);
	freopen(FILE_NAME".out", "w", stdout);
	#endif

	cin >> n >> A >> B;
	for (int i = 0; i < n; i++)
		cin >> c[i] >> a[i] >> b[i];

	long double ansA = 0, ansB = 0;
	
	for (int i = 0; i < n; i++)
	{
		if (a[i] == 0) used[i] = true;
		if (b[i] == 0 && a[i] != 0)
		{
			used[i] = true;
			ans[i] = c[i] + .0;
			ansA += a[i] * c[i];
		}
	}
	
	for (int i = 0; i < n; i++)
		id[i] = i;

	sort(id, id + n, cmp);

	for (int i = 0; i < n; i++)
	{
		int Ind = id[i];

		if (used[Ind]) continue;

		long double need = c[Ind] + .0;
		need = min(need, (B - ansB) / b[Ind]);

		ans[Ind] += need;
		ansA += need * a[Ind];
		ansB += need * b[Ind];
	}

	if (ansA < A - 1e-9)
	{
		cout << -1 << " " << -1;
		return 0;
	}

	cout << setprecision(10) << fixed;
	cout << ansA << " " << ansB << endl;
	for (int i = 0; i < n; i++)
		cout << ans[i] << " ";

	return 0;
}