#pragma comment(linker,"/STACK:256000000")

#include <iostream>
#include <iomanip>

#include <cstdlib>
#include <cstring>
#include <cmath>

#include <algorithm>

#include <vector>
#include <string>

using namespace std;

int n;
int a[200007];

bool intersec(int x1, int x2, int x3, int x4)
{
	if ((x1 < x3 && x3 < x2 && x2 < x4) ||
		((x3 < x1 && x1 < x4 && x4 < x2))) return true;
	else return false;
}

int main()
{
	#ifdef CRABEN
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#else
	#define FILE_NAME "improvements"
	freopen(FILE_NAME".in", "r", stdin);
	freopen(FILE_NAME".out", "w", stdout);
	#endif

	cin >> n;
	a[0] = 0;
	for (int i = 1; i <= n; i++)
		cin >> a[i];
	int Amax, Amin;
	Amax = a[n]; Amin = a[n];
	int res = 0;
	for (int i = n - 1; i >= 1; i--)
	{
		int Max = max(a[i], a[i - 1]);
		int Min = min(a[i], a[i - 1]);
		if (intersec(Min, Max, Amin, Amax)) res++;
		else {
			if (Max > Amax) Amax = Max;
			if (Min < Amin) Amin = Min;
		}
	}
	cout << n-res;
	return 0;
}