#pragma comment(linker,"/STACK:256000000")

#include <iostream>
#include <iomanip>

#include <cstdlib>
#include <cstring>
#include <cmath>

#include <algorithm>

#include <string>

using namespace std;

int ans[207];
bool used[207];

int num[207][3];

string s;

int getLength(int x)
{
	if (x < 10) return 1;
	return 2;
}

void write()
{
	int ind = 0;
	while (ind < (int)s.size())
	{
		int len = ans[ind];
		cout << num[ind][len] << " ";
		ind += len;
	}

	exit(0);
}

void solve(int n)
{
	if (n == 0) write();	

	int len = getLength(n);
	for (int i = 0; i < (int)s.size(); i++)
	{
		if (num[i][len] != n) continue;

		bool f = true;
		for (int j = 0; j < len; j++)
			if (used[i + j]) f = false;

		if (!f) continue;

		for (int j = 0; j < len; j++)
			used[i + j] = true;

		ans[i] = len;

		solve(n - 1);

		for (int j = 0; j < len; j++)
			used[i + j] = false;
	}
}

int main()
{
	#ifdef CRABEN
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#else
	#define FILE_NAME "joke"
	freopen(FILE_NAME".in", "r", stdin);
	freopen(FILE_NAME".out", "w", stdout);
	#endif

	cin >> s;

	memset(num, -1, sizeof(num));
	for (int i = 0; i < (int)s.size(); i++)
	{
		if (s[i] == '0') continue;
		num[i][1] = s[i] - '0';
		if (i < (int)s.size() - 1 && num[i][1] != 0)
			num[i][2] = num[i][1] * 10 + s[i + 1] - '0';
	}

	int n = 0, length = 0;
	while (length < (int)s.size())
		length += getLength(++n);

	solve(n);
	/*
	for (int i = 0; i < 50; i++)
		ans[i] = i + 1;

	random_shuffle(ans, ans + 50);

	for (int i = 0; i < 50; i++)
		cout << ans[i];
	*/
	return 0;
}