#pragma comment(linker,"/STACK:256000000")

#include <iostream>

#include <algorithm>

using namespace std;

int n, m;
long long a[1007], b[1007];

int main()
{
	#ifdef CRABEN
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#else
	#define FILE_NAME "knockout"
	freopen(FILE_NAME".in", "r", stdin);
	freopen(FILE_NAME".out", "w", stdout);
	#endif

	cin >> n >> m;
	for (int i = 0; i < n; i++)
		cin >> a[i] >> b[i];

	for (int i = 0; i < m; i++)
	{
		long long x, y, t; 
		cin >> x >> y >> t;

		int ans = 0;
		for (int j = 0; j < n; j++)
		{
			long long time = b[j] - a[j];
			long long timer = t % (2 * time);

			long long p = a[j];
			p += min(timer, time);
			timer -= min(timer, time);
			p -= timer;

			if (x <= p && p <= y) ans++;
		}

		cout << ans << endl;
	}
	
	return 0;
}