#pragma comment(linker,"/STACK:1000000000")
#include<iostream>
#include<algorithm>
#include<vector>
#include<string>
#include<set>

using namespace std;

int a[100 * 1000], b[100 * 1000], g[100 * 1000];

double ex = 1e-10;

vector<pair<double, int> > koef;
double kol[100 * 1000];
int main() {
	string filename = "burrito";
#ifdef _DEBUG
	freopen("in.in", "r", stdin);
	freopen("out.out", "w", stdout);
#else
	freopen((filename + ".in").c_str(), "r", stdin);
	freopen((filename + ".out").c_str(), "w", stdout);
#endif
	int n, A, B;
	cin >> n >> A >> B;
	for (int i = 0; i < n; i++) {
		cin >> g[i] >> a[i] >> b[i];
		koef.push_back(make_pair(b[i] * 1.0 / a[i], i));
	}

	sort(koef.begin(), koef.end());
	
	double curA = 0, curB = 0;

	for (int i = 0; i < n; i++) {
		int index = koef[i].second;
		if (curB + g[index] * b[index] - ex < B) {
			kol[index] = g[index];
			curB += g[index] * b[index];
			curA += g[index] * a[index];
		}
		else {
			double neededB = B - curB;
			double g0 = neededB / b[index];
			kol[index] = g0;
			curB = B;
			curA += g0 * a[index];
		}
	}
	if (curA < A) {
		cout << "-1 -1";
	}
	else {
		cout << curA << " " << curB << endl;
		for (int i = 0; i < n; i++) {
			if (i != 0) cout << " ";
			cout << kol[i];
		}
	}

	return 0;
}