#pragma comment(linker,"/STACK:1000000000")
#include<iostream>
#include<algorithm>
#include<vector>
#include<string>
#include<set>

using namespace std;

string const filename = "knockout";

int main()
{
#ifdef _DEBUG
	freopen("in.in", "r", stdin);
	freopen("out.out", "w", stdout);
#else
	freopen((filename + ".in").c_str(), "r", stdin);
	freopen((filename + ".out").c_str(), "w", stdout);
#endif

	int n, m;
	vector<pair<long long, long long> > cars;
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
	{
		long long from, to;
		cin >> from >> to;
		cars.push_back(make_pair(from, to));
	}

	for (int i = 0; i < m; ++i)
	{
		long long from, to, tim, cnt;
		cin >> from >> to >> tim;
		cnt = 0;
		for (int j = 0; j < n; ++j)
		{
			long long coord;
			long long even = tim / abs(cars[j].first - cars[j].second);
			if (even % 2 == 0)
				even = 0;
			else
				even = 1;
			long long dist = tim % abs(cars[j].first - cars[j].second);
			if (cars[j].first > cars[j].second)
			{
				if (even == 0)
				{
					coord = cars[j].first - dist;
				}
				else
				{
					coord = cars[j].second + dist;
				}
			}
			else
			{
				if (even == 0)
				{
					coord = cars[j].first + dist;
				}
				else
				{
					coord = cars[j].second - dist;
				}
			}
			if (coord >= from && coord <= to)
				++cnt;
		}
		cout << cnt << endl;
	}

	return 0;
}
