#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <set>
#include <map>
#include <functional>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cctype>
#include <cassert>

using namespace std;

#define forn(i,n) for(int i = 0; i < (int)(n); ++i)
#define forit(it, x) for(it = (x).begin(); it != (x).end(); ++it)
#define all(x) (x).begin(), (x).end()
#define mp make_pair


typedef long long int64;
typedef vector<int> vint;
typedef vector<bool> vbool;
typedef vector<int64> vint64;
typedef pair<int, int> pii;
typedef pair<int, int> pint;



const int MAXN = 1000;
const int MAXF = 100;

bool files[MAXN][MAXN];
int users[MAXN][MAXN];

int res_cnt = 0;
int res[MAXN];
int F[MAXF];
char buf[MAXN];

int char_to_int(char c)
{
	if (isalpha(c))
	{
		return c - 'a' + 10;
	}
	return c - '0';
}



//#define __SFEDU__KRAVTSUN
#define TASK_NAME "filter"
int main()
{
#ifdef __SFEDU__KRAVTSUN
	freopen("readme.txt", "r", stdin);
#else
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

	int m, f;
	scanf("%d %d\n", &m, &f);
	
	forn(i, f)
	{
		scanf("%d", &F[i]);
	}
	scanf("\n");


	int n;
	scanf("%d", &n);

	gets(buf);
	int bit_len = (m + 3) / 4;
	int num;
	forn(i, n)
	{
		gets(buf);
		forn(j, bit_len) 
		{
			num = char_to_int(buf[j]);
			forn(k, 4)
			{
				files[i][(j << 2) + k] = num & (1 << k);
			}
		}
		
	}

	int q;
	scanf("%d", &q);
	int u;
	int64 buf;
	forn(i, q)
	{
		scanf("%d", &u);
		forn(j, f)
		{
			buf = F[j];
			buf = (buf*u)%m;
			users[i][j] = buf;
		}
	}

	vint answer;
	int fl = 1;
	int isUser = 0;
	forn(i, n)
	{
		isUser = 0;
		forn(j, q)
		{
			fl = 1;
			forn(k, f)
			{
				if (!files[i][users[j][k]]) 
				{
					fl = 0;
					break;
				}
			}

			if (fl) 
			{
				isUser = 1; 
				break;
			}
		}
		if (isUser) {
			answer.push_back(i);
		}
	}

	cout << answer.size();
	forn(i, answer.size())
	{
		cout << " " << answer[i];
	}

	return 0;
}