#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>
#include <string>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define TASK "filter"

const int N = 1024;

int n, f, m, a[N], q, u[N], ans;
bool c[N][N], good[N];
char s[N];

int digit(char ch)
{
	if ('0' <= ch && ch <= '9')
		return ch - '0';
	return 10 + (ch - 'a');
}

int main()
{
#ifdef __HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	cin >> m >> f;
	for (int i = 0; i < f; ++i)
		cin >> a[i];
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		scanf("%s", s);
		for (int j = 0; j < m;)
		{
			int dig = digit(s[j / 4]);
			for (int k = 0; k < 4; ++k, ++j)
				c[i][j] = dig & (1 << k);
		}
	}
	cin >> q;
	for (int i = 0; i < q; ++i)
		cin >> u[i];

	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; !good[i] && j < q; ++j)
		{
			bool flag = true;
			for (int k = 0; flag && k < f; ++k)
			{
				int h = 1LL * u[j] * a[k] % m;
				if (!c[i][h])
					flag = false;
			}
			if (flag)
				good[i] = true;
		}
		if (good[i])
			++ans;
	}

	cout << ans;
	for (int i = 0; i < n; ++i)
		if (good[i])
			cout << " " << i;

	return 0;
}