
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>
#include <string>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define TASK "improvements"

const int N = 200500;

int n, x[N];
int a[N], m;
pair<int, int> dp[N], dp2[N];
int hui[N], pizda[N], A, B;
int aa[N], q;

pair<int, int> get_min(int i)
{
	pair<int, int> res = make_pair(0, 0);
	for (; i >= 0; i = (i & (i + 1)) - 1)
		res = max(res, dp[i]);
	return res;
}

void set_val(int i, pair<int, int> val)
{
	dp2[i] = val;
	dp[i] = val;
	for (; i < N; i |= (i + 1))
		dp[i] = max(val, dp[i]);
}

void seq()
{
	fill(dp, dp + N, 0);
	pair<int, int> ret = make_pair(0, 0);
	for (int i = 0; i < m; ++i)
	{
		pair<int, int> newval = get_min(a[i] - 1);
		newval.first += 1;
		newval.second = i;
		set_val(a[i], newval);
		ret = max(ret, newval);
	}
	q = ret.first;	
	for (int i = 0, j = ret.second; i < q; ++i, j = dp2[j].second)
		aa[i] = j;
}

int solve()
{
	m = 0;
	for (int i = 0; i < n; ++i)
			a[m++] = x[i];
	seq();
	A = q;
	copy(aa, aa + q, hui);
	m = 0;
	for (int i = 0; i < n; ++i)
			a[m++] = n - x[i] + 1;
	copy(aa, aa + q, pizda);
	B = q;
	for (int i = 0; i < q; ++i)
		pizda[i] = n - x[i] + 1;
	int ans = 0;
	for (int i = 1, u = 0, v = 0; i <= n; ++i)
	{
		while (u < A && hui[u] <= i)
			++u;
		while (v < B && pizda[v] > i)
			++v;
		ans = max(ans, u + v);
	}
	return ans;
}

int main()
{
#ifdef __HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
		scanf("%d", x + i);
	printf("%d\n", solve());
	return 0;
}