#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>
#include <string>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define TASK "joke"

const int N = 100;

int n, num[N];
string s;
bool used[N], found[N];

bool starts_at(int num, size_t i)
{
	if (num >= 10 && i == s.length() - 1)
		return false;
	if (used[i])
		return false;
	if (num >= 10 && used[i + 1])
		return false;
	if (num < 10 && s[i] - '0' == num)
		return true;
	if (num >= 10 && 10 * (s[i] - '0') + (s[i + 1] - '0') == num)
		return true;
	return false;
}

void use(int x, size_t i)
{
	used[i] = true;
	if (x >= 10)
		used[i + 1] == true;
	num[i] = x;
	found[x] = true;
}

void unuse(int x, size_t i)
{
	used[i] = false;
	if (x >= 10)
		used[i + 1] == false;
	num[i] = 0;
	found[x] = false;
}

void rec(int cur)
{
	if (!cur)
	{
		for (size_t i = 0; i < s.length(); ++i)
			if (num[i])
				cout << num[i] << " ";
		exit(0);
	}
	if (found[cur])
	{
		rec(cur - 1);
		return;
	}
	for (size_t i = 0; i < s.length(); ++i)
		if (starts_at(cur, i))
		{
			use(cur, i);
			rec(cur - 1);
			unuse(cur, i);
		}
	assert(false);
}

int main()
{
#ifdef __HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	//int a[51];
	//for (int i = 1; i <= 50; ++i)
	//	a[i] = i;
	//random_shuffle(a + 1, a + 50 + 1);
	//for (int i = 1; i <= 50; ++i)
	//	cout << a[i];
	//return 0;
	cin >> s;
	int cnt = 0;
	for (int i = 1; i <= 9 && cnt < s.length(); ++i, ++cnt)
		++n;
	for (int i = 10; i <= 50 && cnt < s.length(); ++i, cnt += 2)
		++n;
	for (int i = 1; i <= n; ++i)
	{
		int cnt = 0;
		for (size_t j = 0; j < s.length(); ++j)
			if (starts_at(i, j))
				++cnt;
		if (cnt == 1)
			for (size_t j = 0; j < s.length(); ++j)
				if (starts_at(i, j))
					use(i, j);
	}
	rec(n);
	return 0;
}