#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>
#include <string>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define TASK "knockout"

const int N = 1024;

int n, m, a[N], b[N];

int pos(int i, int t)
{
	int d = abs(a[i] - b[i]);
	t %= 2 * d;
	int res = a[i];
	if (t >= d)
	{
		res = b[i];
		t -= d;
	}
	res += (b[i] > a[i] ? 1 : -1) * t;
	return res;
}

int main()
{
#ifdef __HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
		cin >> a[i] >> b[i];

	for (int i = 0; i < m; ++i)
	{
		int x, y, t, ans = 0;
		cin >> x >> y >> t;
		for (int j = 0; j < n; ++j)
		{
			int p = pos(j, t);
			if (x <= p && p <= y)
				++ans;
		}
		cout << ans << endl;
	}
	return 0;
}