#pragma warning(disable:4996)
#pragma comment(linker,"/STACK:67108864")


#include<iostream>
#include<stdio.h>
#include<string.h>
#include<string>
#include<algorithm>
using namespace std;
const long double eps = 0.000000001;

const int SIZE = 1000 * 1000;

int a[SIZE], b[SIZE],g[SIZE];
int m[SIZE];
int N; 
int A, B;
long double G[SIZE];


bool cmp(int i, int j)
{
	if (a[i] * b[j] == a[j] * b[i])
	{
		return b[i] > b[j];
	}
	return a[i] * b[j] > a[j] * b[i];
}



int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	scanf("%d%d%d", &N, &A, &B);
	int i, j;
	for (i = 0; i < N; i++)
	{
		scanf("%d%d%d", &g[i], &a[i], &b[i]);
		m[i] = i;
	}
	sort(m, m + N, cmp);
	long double AA, BB;
	AA = 0;
	BB = B;
	for (i = 0; i < N; i++)
	{
		//if (BB < eps) BB = 0;
		j = m[i];
		G[j] = g[j];
		if (b[j] != 0)
		{
			G[j] = min(G[j], BB / b[j]);
		}
		//if (G[j] < eps) G[j] = 0;
		if (G[j] * a[j] < eps)
		{
			G[j] = 0;
			continue;
		}
		AA += G[j]*a[j];
		BB -= G[j]*b[j];
	}
	if (AA < A)
	{
		printf("-1 -1");
		return 0;
	}
	if (B - BB < eps) BB = 0;
	printf("%.9lf %.9lf\n", (double)AA, (double)(B-BB));
	for (i = 0; i < N; i++) printf("%.9lf ", (double)G[i]);
	return 0; 
}