#include <cstdio>
#include <iostream>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (int)2e2;

#define file "joke"

string s;
int p[N];
int n, l;
bool g[N][N];
int ans[N];
int sz[N], pa[N];
bool busy[N];

bool ok(int x, int id)
{
  string t = "";
  while (x > 0)
  {
    t += (x % 10) + '0';
    x /= 10;
  }
  for (int i = 0; i < (int)t.size() / 2; i++)
    swap(t[i], t[t.size() - i - 1]);
  if (id + t.size() > l)
    return false;
  for (int i = id; i < id + t.size(); i++)
    if (s[i] != t[i - id] || busy[i])
      return false;
  
  return true;
}

int len(int x)
{
  int cnt = 0;
  while (x > 0)
  {
    x /= 10;
    cnt++;
  }
  return cnt;
}

bool brut()
{
  for (int i = 1; i <= n; i++)
  {
    if (pa[i] == -1 && sz[i] == 0)
      return false;
    if (pa[i] != -1)
      continue;
    int id = -1;
    for (int j = 0; j < l; j++)
    {
      if (g[i][j])
      {
        id = j;
        ans[j] = i;
        ans[id] = i;
        pa[i] = id;
        vector<int> save;
        for (int j = 1; j <= n; j++)
          if (g[j][id])
          {
            save.push_back(j);
            g[j][id] = false;
            sz[j]--;
          }
        vector<int> save1;
        if (id > 0)
        {
          for (int j = 10; j <= n; j++)
          if (g[j][id - 1])
          {
            save.push_back(j);
            g[j][id - 1] = false;
            sz[j]--;
          }
        }
        if (!brut())
        {
          ans[id] = 0;
          pa[i] = -1;
          for (int j = 0; j < (int)save.size(); j++)
          {
            if (save[j] != i)
            {
              g[save[j]][id] = true;
              sz[save[j]]++;
            }
          }
          for (int j = 0; j < (int)save1.size(); j++)
          {
            g[save1[j]][id - 1] = true;
            sz[save1[j]]++;
          }

        
        }
        else
          return true;
      }
    }
    return false;
  }

  return true;
}

int main()
{
  freopen(file".in", "r", stdin);
  freopen(file".out", "w", stdout);

  cin >> s;
  l = s.size();
  if (l < 10)
    n = l;
  else
    n = 9 + (l - 9) / 2;
  for (int i = 0; i <= n; i++)
    pa[i] = -1;

  for (int i = 1; i <= n; i++)
    for (int j = 0; j < l; j++)
      if (ok(i, j))
      {
        g[i][j] = true;
        sz[i]++;
      }

  for (int t = 0; t < 100; t++)
  {
    for (int i = n; i >= 1; i--)
    {
      if (sz[i] > 1)
        continue;
      int id = -1;
      for (int j = 0; j < l; j++)
        if (g[i][j])
        {
          id = j;
          ans[j] = i;
          pa[i] = j;
          for (int k = j; k < j + len(i); k++)
            busy[k] = true;
          break;
        }
      for (int j = 1; j <= n; j++)
        if (g[j][id])
        {
          g[j][id] = false;
          sz[j]--;
        }
    }
    for (int i = 1; i <= n; i++)
    {
      sz[i] = 0;
      for (int j = 0; j < l; j++)
        if (ok(i, j))
          g[i][j] = true, sz[i]++;
        else
          g[i][j] = false;
    }
  }

  brut();
  int id = 0;
  while (id < l)
  {
    for (int i = id; i < id + len(ans[id]); i++)
      cout << s[i];
    cout << ' ' ;
    id += len(ans[id]);
  }

  return 0;
}
