import java.io.*;
import java.util.*;

public class Main {

    public static BufferedReader in;
    public static PrintWriter out;
    public static StringTokenizer tok = null;

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static String nextToken() throws IOException {
        if (tok == null || !tok.hasMoreTokens()) {
            tok = new StringTokenizer(in.readLine());
        }

        return tok.nextToken();
    }

    public static char nextChar() throws IOException {
        return (char) in.read();
    }

    public static boolean[] sym;
    public static int[] index;
    public static String s;

    public static boolean check() {
        Set<Integer> set = new HashSet<Integer>();
        int i = 0;
        while (i < s.length()) {
            if (sym[i]) {
                i++;
            }
            else if (i + 1 == s.length() || sym[i + 1]) {
                return false;
            }
            else {
                int x = Integer.parseInt(s.substring(i, i + 2));
                if (set.contains(x)) {
                    return false;
                }
                else {
                    set.add(x);
                }
                i += 2;
            }
        }
        i = 0;
        while (i < s.length()) {
            if (sym[i]) {
                i++;
            }
            else {
                index[i] = 2;
                i += 2;
            }
        }
        return true;
    }

    public static boolean recurs(char p) {
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) == p && !sym[i]) {
                sym[i] = true;
                index[i] = 1;
                if (p == '1' && check()) {

                    return true;
                }
                else if (recurs((char)((int)p - 1))) {

                    return true;
                }
                sym[i] = false;
                index[i] = 0;
            }
        }
        return false;
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        in = new BufferedReader(new InputStreamReader(new FileInputStream("joke.in")));
        out = new PrintWriter(new BufferedOutputStream(new FileOutputStream("joke.out")));

        s = nextToken();
        int l = s.length();
        int n;
        if (l <= 9) {
            n = l;
        }
        else {
            n = 9 + (l - 9) / 2;
        }

        sym = new boolean[l];
        for (int i = 0; i < l; i++) {
            sym[i] = false;
        }

        index = new int[l];
        for (int i = 0; i < index.length; i++) {
            index[i] = 0;
        }

        for (int i = 0; i < l; i++) {
            if (s.charAt(i) == '0') {
                sym[i - 1] = sym[i] = true;
                index[i - 1] = 2;
                //int x = Integer.parseInt(s.substring(i - 1, i + 1));
                //num[x] = true;
            }
        }

        for (char number = '9'; number >= '5'; number--) {
            Set<Character> set = new HashSet<Character>();
            char pov = 'a';
            for (int i = 0; i < l; i++) {
                if (s.charAt(i) == number && i > 0) {
                    if (set.contains(s.charAt(i - 1))) {
                        pov = s.charAt(i - 1);
                    }
                    set.add(s.charAt(i - 1));
                }
            }
            for (int i = 0; i < l; i++) {
                if (!sym[i] && s.charAt(i) == number && i > 0 && s.charAt(i - 1) != pov && s.charAt(i - 1) <= '4' && s.charAt(i - 1) >= '1') {
                    sym[i] = sym[i - 1] = true;
                    index[i - 1] = 2;
//                    if (i == 0) {
//                        int x = Integer.parseInt(s.substring(i, i + 1));
//                        num[x] = true;
//                    }
//                    if (i > 0) {
//                        int x = Integer.parseInt(s.substring(i - 1, i + 1));
//                        num[x] = true;
//                        sym[i - 1] = true;
//                    }
                }
            }

            recurs((char)((char)Math.min(9, n) + '0'));


        }

        for (int i = 0; i < s.length(); i++) {
            if (index[i] > 0) {
                out.print(s.substring(i, i + index[i]));
                out.print(" ");
            }
        }

        out.flush();
    }
}
