#include <bits/stdc++.h>

using namespace std;

#define FILE "burrito"

typedef long double ld;

typedef double dbl;
#define double ld

struct point{
    int g, a, b;

    bool operator <(const point& x) const {
        return (1ll * a * x.b > 1ll * b * x.a);
    }
};

int main()
{
    #ifndef LOCAL
        freopen(FILE".in", "r", stdin);
        freopen(FILE".out", "w", stdout);
    #else
        freopen("input.txt", "r", stdin);
    #endif

    int n;
    cin >> n;
    long long A, B;
    cin >> A >> B;
    vector<pair<point, int> > a;
    vector<double> ans(n);
    int cnt = 0;
    double x = 0, y = 0;
    for (int i = 0; i < n; i++){
        point x;
        cin >> x.g >> x.a >> x.b;
        if (x.a == 0){
            ans[i] = 0;
        } else
        if (x.b == 0){
            ans[i] = x.g;
            y += x.g * x.a;
        } else
        if (x.g > 0){
            a.push_back(make_pair(x, i));
            cnt++;
        }
    }
    stable_sort(a.begin(), a.end());
    for (int i = 0; i < cnt; i++){
        if (x + 1.0 * a[i].first.b * a[i].first.g > B){
            double k = (B - x) / a[i].first.b;
            ans[a[i].second] = k;
            x += k * a[i].first.b;
            y += k * a[i].first.a;
        } else {
            x += 1.0 * a[i].first.g * a[i].first.b;
            y += 1.0 * a[i].first.g * a[i].first.a;
            ans[a[i].second] = a[i].first.g;
        }
    }
    if (y < A - 1e-9){
        cout << "-1 -1\n";
    } else {
        cout << setprecision(10) << fixed;
        cout << (dbl)y << " " << (dbl)x << "\n";
        for (int i = 0; i < n; i++) cout << (dbl)ans[i] << " ";
        cout << "\n";
    }

    return 0;
}
