#include <cstdio>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;
#define REP(i,n) for(int i=0;i<(n);i++)

#define FILENAME "knockout"
struct FileOpener
{
	FileOpener()
	{
		FILE* f = fopen(FILENAME".in", "r");
		if (f)
		{
			fclose(f);
			freopen(FILENAME".in", "r", stdin);
			freopen(FILENAME".out", "w", stdout);
		}
	}
} fileopener;

int main()
{
	int n, m;
	scanf("%d%d", &n, &m);
	vector<pair<int, int> > v;
	REP(i, n)
	{
		int a, b;
		scanf("%d%d", &a, &b);
		v.push_back(make_pair(a, b));
	}
	REP(i, m)
	{
		int x, y, t;
		scanf("%d%d%d", &x, &y, &t);
		int res = 0;
		REP(j, n)
		{
			int a = v[j].first;
			int b = v[j].second;
			int k = t / abs(b - a);
			if (k % 2 == 1)
				swap(a, b);
			int val = t%abs(b - a);
			if (a < b)
				val = a + val;
			else
				val = a - val;
			if (x <= val && val <= y)
				res++;
		}
		printf("%d\n", res);
	}
}