#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <cstdio>
#include <set>
#include <list>
#include <iomanip>
#include <string>
#include <cstring>
#include <queue>
#include <stack>
#include <sstream>

using namespace std;

#define pb push_back
#define mp make_pair
#define REP(i, n) for(int i = 0; i < (int)(n); ++i)
typedef long long LL;
typedef pair<int, int> PII;

int n;
int g[100000], a[100000], b[100000], A, B;
int ord[100000];
double ans[100000] = {};
const double EPS = 1e-9;

bool cmp(const int &lhs, const int &rhs) {
    if (b[lhs] == 0) return b[rhs] != 0;
    if (b[rhs] == 0) return false;
    return a[lhs] * b[rhs] > a[rhs] * b[lhs];
}

int main() {
    freopen("burrito.in", "r", stdin);
    freopen("burrito.out", "w", stdout);
    scanf("%d%d%d", &n, &A, &B);
    REP(i, n) scanf("%d%d%d", g + i, a + i, b + i);
    REP(i, n) ord[i] = i;
    sort(ord, ord + n, cmp);
    double dansA = 0, dansB = 0;
    int ansA = 0, ansB = 0;
    bool flag = false;
    REP(ii, n) {
        int i = ord[ii];
        if (a[i] == 0) break;
        if (b[i] == 0) {
            ans[i] = g[i];
            ansA += g[i] * a[i];
            dansA = ansA;
            continue;
        }
        if (ansB + g[i] * b[i] >= B) {
            ans[i] = (B - (double)ansB) / b[i];
            if ((B - ansB) * (LL)a[i] < (A - ansA) * (LL)b[i]) {
                printf("-1 -1\n");
                return 0;
            }
            flag = true;
            dansA = ansA + ans[i] * a[i];
            dansB = ansB + ans[i] * b[i];
            break;
        }
        ans[i] = g[i];
        ansA += g[i] * a[i];
        ansB += g[i] * b[i];
        dansA = ansA;
        dansB = ansB;
    }
    if (ansA >= A) flag = true;
    if (flag) {
        printf("%.12lf %.12lf\n", dansA, dansB);
        REP(i, n) printf("%.12lf ", ans[i]);
        printf("\n");
    } else {
        printf("-1 -1\n");
    }
}
