
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <sstream>
#include <map>
#include <set>
#include <cmath>
#include <cstdio>
#include <ctime>


using namespace std;
typedef long long ll;

double eps = 1e-8;

int get(char ch){
	if (ch >= '0' && ch <= '9')
		return (ch - '0');
	else{
		int numb = ch - 'a';
		return (10 + numb);
	}
}

int main(){
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
	ll n, m, f;
	cin >> m >> f;
	vector<ll> arr(f);
	for (int i = 0; i < f; i++){
		cin >> arr[i];
	}
	cin >> n;
	vector<vector<char> > data(n, vector<char>(m+5, 0));
	for (int i = 0; i < n; i++){
		string str;
		cin >> str;
		int ptr = 0;
		for (int j = 0; j < str.size(); j++){
			int numb = get(str[j]);
			for (int k = 0; k < 4; k++){
				if (numb & (1 << k)){
					data[i][ptr] = 1;
				}
				ptr++;
			}	
		}
		//reverse(data[i].begin(), data[i].end());
	}
	int q;
	cin >> q;
	vector<ll> g(q);
	for (int i = 0; i < q; i++){
		cin >> g[i];
	}
	vector<int> ans;
	for (int i = 0; i < data.size(); ++i)
	{
		for (int j = 0; j < q; ++j)
		{
			bool good = true;
			for (int k = 0; k < f; ++k)
			{
				ll tmp = (g[j] * arr[k]) % m;
				if (!data[i][tmp])
				{
					good = false;
					break;
				}
			}
			if (good)
			{
				ans.push_back(i);
				break;
			}

		}		

	}
	cout << ans.size() <<' ';
	for (int i = 0; i < ans.size(); ++i)
	{
		printf("%d ", ans[i]);
	}

	return 0;
}

/*
23 4 3 5 7 11
3 
effde7
c07902
0800c1
3 2 4 6
*/