#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <sstream>
#include <map>

using namespace std;
typedef long long ll;

int main(){
	int n, m;
	cin >> n >> m;
	vector<pair<int, int> > arr(n);
	for (int i = 0; i < n; i++){
		int a, b;
		cin >> a >> b;
		arr[i] = make_pair(a, b);
	}
	for (int i = 0; i < m; i++){
		int l, r, t;
		cin >> l >> r >> t;
		int res = 0;
		for (int j = 0; j < n; j++){
			int dist = arr[j].second - arr[j].first;
			int tt = t % (2 * dist);
			int x = arr[j].first;
			if (tt > dist){
				x = arr[j].second;
				x -= (tt - dist);
			}
			else{
				x = arr[j].first;
				x += tt;
			}
			if (x >= l && x <= r)
				res++;
		}
		cout << res << "\n";
	}
	return 0;
}

/*
5 5 
0 1 
0 2
2 3
3 5
4 5
0 5 0
0 1 2
0 2 1
2 5 2
2 5 3
*/