#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define pbk pop_back
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#define y0 yy0
#define y1 yy1
#define next _next
#define prev  _prev
#define hash _hash
#define link _link
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define LLD "%I64d"

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long double ld;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

const int N = 105;
int show[N];
int to[N][3];

int M[256];
char iM[4];
int n;

const int MAX = 50000;

struct chain
{
	vector<int> we_show;
	vector<int> he_show;
	int start;
	int per;
	chain(int s)
	{
		start = s;
		vector<int> pos(n, -1);
		while (true)
		{
			pos[s] = we_show.size();
			int ws = ((show[s] + 1) % 3);
			we_show.push_back(ws);
			he_show.push_back(show[s]);
			int ns = to[s][ws];
			if (pos[ns] != -1)
			{
				per = pos[ns];
				break;
			}
			else
				s = ns;
		}
	}
};

int main() {
#define TASK "epic"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	M['R'] = 0;
	M['P'] = 1;
	M['S'] = 2;
	iM[0] = 'R';
	iM[1] = 'P';
	iM[2] = 'S';
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		char c;
		scanf(" %c ", &c);
		show[i] = M[c];
		for (int j = 0; j < 3; j++)
			scanf("%d", &to[i][j]), --to[i][j];
	}
	vector<chain> C;
	int sum_sz = 0;
	while (sum_sz + n + 2 < MAX)
	{
		C.push_back(chain(rand() % n));
		sum_sz += C.back().we_show.size();
	}
	printf("%d\n", sum_sz);
	int cur = 1;
	for (int i = 0; i < C.size(); i++)
	{
		//printf("=== new chain from %d === \n", C[i].start);
		int nxt_l = cur + C[i].we_show.size();
		if (i + 1 == C.size())
			nxt_l = 1;
		for (int j = 0; j < C[i].we_show.size(); j++)
		{
			printf("%c", iM[C[i].we_show[j]]);
			int nxt_s = (j + 1 == C[i].we_show.size()) ? cur + C[i].per : cur + j + 1;
			for (int t = 0; t < 3; t++)
			{
				if (t == C[i].he_show[j])
					printf(" %d", nxt_s);
				else
					printf(" %d", nxt_l);
			}
			printf("\n");
		}
		cur += C[i].we_show.size();
	}
	return 0;
}
