#include <cstdio>
#include <iostream>
#include <algorithm>
#include <map>
#include <string>
using namespace std;

const int MAXN = 666666;
const double EPS = 1e-12;
#define forn(i,n) for(int i = 0; i < (int)n; ++i)


int getint(char ch) {
	if ('0' <= ch && ch <= '9') return ch -= '0';
	return ch - 'a' + 10;
}

int m, f, n, u, T, ans = 0;
int a[MAXN];
string s;
int v[1005][1005];
bool used[MAXN];

int main()
{
#ifdef F0X
	freopen("input.in", "r", stdin);
#else
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
#endif
	cin >> m >> f;
	//scanf("%d%d", &m, &f);
	forn(i, f) cin >> a[i]; //scanf("%d", &a[i]);
	cin >> n;
	//scanf("%d\n", &n);

	forn(j, n) {
		used[j] = false;
		cin >> s;
		int ptr = 0;
		forn(i, s.length()) {
			int yy = getint(s[i]);
			 v[j][ptr] = yy & 1;
			 v[j][ptr + 1] = yy & 2;
			 v[j][ptr + 2] = yy & 4;
			 v[j][ptr + 3] = yy & 8;
			ptr += 4;
		}

	}

	cin >> T;
	//scanf("%d", &T);
	while (T--) {
		cin >> u;
		//scanf("%d", &u);
		forn(word, n) {
			if (used[word]) continue;
			bool flag = true;
			forn(i, f) {
				int place = u * 1LL * a[i] % m;
				if (v[word][place]) continue;
				flag = false;
				break;
			}
			if (flag) {
				used[word] = true;
				ans++;
			}
		}
	}

	printf("%d ", ans);
	forn(i, n) if (used[i]) printf("%d ", i);


	return 0;
}
