#include <iostream>
#include <cstdio>

using namespace std;

int a[55][55];

int solve1(int n, int m, bool need_out) {
    int zeroes = 0, ones = 0;

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            if (a[i][j] == 0) ++zeroes;
            else ++ones;

    if (zeroes < ones) {
        if (!need_out) return zeroes;
        cout << zeroes << "\n";
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < m; ++j)
                if (a[i][j] == 0)
                    cout << i + 1 << " " << j + 1 << " " << i + 1 << " " << j + 1 << "\n";
    } else {
        if (!need_out) return ones;
        cout << ones << "\n";
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < m; ++j)
                if (a[i][j] == 1)
                    cout << i + 1 << " " << j + 1 << " " << i + 1 << " " << j + 1 << "\n";
    }
}

int solve2(int n, int m, bool need_out) {
    if (!need_out) {
        return (n / 2 + m / 2);
    } else {
        cout << n / 2 + m / 2 << "\n";

        for (int i = 1; i < n; i += 2)
            cout << i + 1 << " " << 1 << " " << i + 1 << " " << m << "\n";

        for (int j = 1; j < m; j += 2)
            cout << 1 << " " << j + 1 << " " << n << " " << j + 1 << "\n";
    }
}

int main()
{
    freopen("alter.in","r",stdin);
    freopen("alter.out","w",stdout);
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j) {
            if (i % 2 == 0)
                a[i][j] = j % 2;
            else a[i][j] = 1 - j % 2;
        }

    int ans1 = solve1(n, m, 0);
    int ans2 = solve2(n, m, 0);

    if (ans1 < ans2)
        solve1(n, m, 1);
    else solve2(n, m, 1);

    return 0;
}
