#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>

using namespace std;

int n;
vector<int> a, b;
vector<int> d1, d2;

const int inf = 1e9;

int main()
{
    freopen("improvements.in","r",stdin);
    freopen("improvements.out","w",stdout);

    int n;
    cin >> n;
    a.resize(n);
    b.resize(n);
    d1.resize(n);
    d2.resize(n);

    for (int i = 0; i < n; ++i)
        cin >> b[i];
    for (int i = 0; i < n; ++i)
//        a[i] = b[i];
        a[b[i] - 1] = i + 1;

    vector<int> e(n + 1, inf);
    e[0] = -inf;
    int last_not_inf = 0;

    for (int i = 0; i < n; ++i) {
        int pos = upper_bound(e.begin(), e.end(), a[i]) - e.begin();
        if (e[pos] == inf) last_not_inf = max(last_not_inf, pos);
        e[pos] = a[i];
        d1[i] = i + 1 - last_not_inf;
//        cerr << "pos == " << pos << endl;
//        for (int i = 0; i <= n; ++i)
//            cerr << e[i] << " ";
//        cerr << endl;
    }

/*    for (int i = 0; i < n; ++i)
        cerr << d1[i] << " ";
    cerr << endl;*/

    e.clear();
    e.resize(n + 1, inf);
    e[0] = -inf;
    last_not_inf = 0;

    reverse(a.begin(), a.end());

    for (int i = 0; i < n; ++i) {
        int pos = upper_bound(e.begin(), e.end(), a[i]) - e.begin();
        if (e[pos] == inf) last_not_inf = max(last_not_inf, pos);
        e[pos] = a[i];
//        cerr << "pos == " << pos << endl;
        d2[n - i - 1] = i + 1 - last_not_inf;
//        cerr << d2[i] << endl;
    }

    int bans = 1e9;

    for (int i = 0; i < n; ++i)
        bans = min(d1[i] + d2[i], bans);

    cout << n - bans << endl;

    return 0;
}
