﻿#define TASKNAME "burrito"
#include <bits/stdc++.h>

#define mp make_pair
#define pb push_back
#define F first
#define S second
#define fst first
#define snd second
#define y1 asldkj
#define y0 lakdja
#define all(a) (int)a.size()
#define sz(a) (int)a.size()
#define pw(a) (1LL << (a))
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pt;
typedef pair <int, int> pii;
typedef vector <int> vi;
typedef vector <vi> vvi;
typedef vector <bool> vb;
typedef vector <ll> vll;
typedef vector <pii> vpii;

const int INF = 1e9;
const ll INFLONG = 1e18;
const double EPS = 1e-10;
const int N = 100100;

int n, A, B;
struct T {
    int a, b, g;
    int ind;
    double s;
    bool operator < (T x) const {
        return a * x.b - b * x.a < 0;
    }          
} p[N];

double sumA, sumB;

bool comp(T x, T y) {
    return x.ind < y.ind;
}

int main() {
    freopen(TASKNAME".in", "r", stdin);
    freopen(TASKNAME".out", "w", stdout);

    scanf("%d%d%d", &n, &A, &B);
    for (int i = 0; i < n; ++i) {
        scanf("%d%d%d", &p[i].g, &p[i].a, &p[i].b);
        p[i].ind = i;
    }

    sort(p, p + n);
    
    for (int i = n - 1; i >= 0; --i) {
        int g = p[i].g, a = p[i].a, b = p[i].b;
        
        if (b == 0 || sumB + g * b < B + EPS) {
            p[i].s = g;
        } else {
            p[i].s = (B + EPS - sumB) * 1.0 / b;
        }
        
        sumB += p[i].s * b;
        sumA += p[i].s * a;
    }
    
    if (sumA < A - EPS) {
        cout << "-1 -1\n";
    } else {
        sort(p, p + n, comp);
        printf("%.20f %.20f\n", sumA, sumB);
        for (int i = 0; i < n; ++i) {
            printf("%.20f ", p[i].s);
        }
    }
    
    return 0;
}