#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
#include <iostream>
using namespace std;

struct quad
{
	int a, b, c, d;
	quad(int a, int b, int c, int d) : a(a), b(b), c(c), d(d) { }
};

int solve(int n, int m, vector<quad> & ans)
{
	if (n == 1 && m == 1) {
		ans.clear();
		return 0;
	}

	int cnt = 0;
	for (int i = 2; i <= m; i += 2) {
		ans.push_back(quad(1, i, n, i));
		cnt++;
	}
	for (int i = 1; i <= n; i += 2) {
		ans.push_back(quad(i, 1, i, m));
		cnt++;
	}
	return cnt;
}

int main()
{
#ifdef jam
	freopen("inp.txt", "rb", stdin);
#else
	freopen("alter.in", "rb", stdin);
	freopen("alter.out", "wb", stdout);
#endif
	// TYPE HERE
	int n, m;
	scanf("%d%d", &n, &m);
	if (n == 1 && m == 1) {
		printf("0\n");
		return 0;
	}

	int ans1;
	int ans2;
	vector<quad> a, b;
	ans1 = solve(n, m, a);
	ans2 = solve(m, n, b);

	if (ans1 < ans2) {
		printf("%d\n", ans1);
		for (int i = 0; i < (int)a.size(); i++) {
			printf("%d %d %d %d\n", a[i].a, a[i].b, a[i].c, a[i].d);
		}
	}
	else {
		printf("%d\n", ans2);
		for (int i = 0; i < (int)b.size(); i++) {
			printf("%d %d %d %d\n", b[i].a, b[i].b, b[i].c, b[i].d);
		}
	}

	return 0;
}