#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
using namespace std;
typedef long long int64;

#define MAXN 100
int n;
char S[MAXN + 3];

int to_num(const char * s, int cnt)
{
	if (cnt == 1) {
		return s[0] - '0';
	}
	else {
		return (s[0] - '0') * 10 + s[1] - '0';
	}
}

vector<int> ans;
bool rec(int i, int64 s, int skip)
{
	if (s == 0 && i < 0) {
		return true;
	}

	if (i < 0) {
		return false;
	}

	bool ret = false;
	int curr;

	// take 1
	if (skip == 0 && !ret) {
		curr = to_num(S + i, 1);
		if ((1ll << (curr - 1ll)) & s) {
			ans.push_back(curr);
			bool val = rec(i - 1, s - (1ll << (curr - 1ll)), 0);
			if (val) {
				ret = true;
			}
			else {
				ans.pop_back();
			}
		}
	}

	if (skip == 1 && !ret) {
		curr = to_num(S + i, 2);
		if ((1ll << (curr - 1ll)) & s && curr >= 10) {
			ans.push_back(curr);
			bool val = rec(i - 1, s - (1ll << (curr - 1ll)), 0);
			if (val) {
				ret = true;
			}
			else {
				ans.pop_back();
			}
		}
	}

	if (skip == 0 && !ret) {
		bool val = rec(i - 1, s, 1);
		if (val) {
			ret = val;
		}
	}

	return ret;
}

int main()
{
#ifdef jam
	freopen("inp.txt", "rb", stdin);
#else
	freopen("joke.in", "rb", stdin);
	freopen("joke.out", "wb", stdout);
#endif

	// TYPE HERE
	scanf("%s", S);
	if (strlen(S) > 9) {
		n = 9 + (strlen(S) - 9) / 2;
	}
	else {
		n = strlen(S);
	}
	
	rec(strlen(S) - 1, (1ll << n) - 1ll, 0);
	for (int i = 0; i < n; i++) {
		printf("%d%s", ans[n - 1 - i], i == n - 1 ? "\n" : " ");
	}

	return 0;
}
