#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

using namespace std;

struct ingr
{
	int g, a, b, id;
	double grab;
} g[100500];

int main()
{
	//FILE *f;
	//freopen_s(&f, "input.txt", "rt", stdin);
	freopen("burrito.in", "rt", stdin);
	freopen("burrito.out", "wt", stdout);

	int n, A, B;

	scanf("%d %d %d", &n, &A, &B);
	for (int i = 0; i < n; ++i) {
		scanf("%d %d %d", &g[i].g, &g[i].a, &g[i].b);
		g[i].id = i;
		g[i].grab = 0.0;
	}
	sort(g, g + n, [](const ingr &a, const ingr &b) {
		return a.a * b.b > b.a * a.b;
	});

	double haveA = 0.0, haveB = 0.0;

	for (int i = 0; i < n; ++i) {
		int canB = B - haveB + 1e-9;
		int fullB = g[i].b * g[i].g;
		if (fullB <= canB) {
			haveA += g[i].g * g[i].a;
			haveB += g[i].g * g[i].b;
			g[i].grab = g[i].g;
		}
		else {
			double grab = canB / double(g[i].b);
			haveA += grab * g[i].a;
			haveB += grab * g[i].b;
			g[i].grab = grab;
			break;
		}
	}
	if (haveA + 1e-9 < A) {
		cout << "-1 -1" << endl;
	}
	else {
		sort(g, g + n, [](const ingr &a, const ingr &b) {
			return a.id < b.id;
		});
		cout << fixed << setprecision(14) << haveA << " " << haveB << endl;
		for (int i = 0; i < n; ++i) {
			cout << g[i].grab << " ";
		}
	}

	return 0;
}
