#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <unordered_map>
#include <queue>
using namespace std;

struct node {
	char ch;
	int r, p, s;
} lal[55];

unordered_map < long long, vector<long long> > gr;

void bfs(long long v)
{
	queue<long long> q;
	q.push(v);
	while (!q.empty()) {
		int k = q.front();
		q.pop();
		if (gr.find(k) != gr.end())
			continue;
		gr.insert(make_pair(k, vector<long long>(9)));

		for (int l = 0; l < 50; ++l) {
			if (k & (1 << l)) {
				if (lal[l].ch == 'R') {
					gr[k][0] |= (1 << (lal[l].r));
					gr[k][1] |= (1 << (lal[l].p));
					gr[k][2] |= (1 << (lal[l].s));
				}
				else if (lal[l].ch == 'P') {
					gr[k][3] |= (1 << (lal[l].r));
					gr[k][4] |= (1 << (lal[l].p));
					gr[k][5] |= (1 << (lal[l].s));
				}
				else {
					gr[k][6] |= (1 << (lal[l].r));
					gr[k][7] |= (1 << (lal[l].p));
					gr[k][8] |= (1 << (lal[l].s));
				}
			}
		}
		for (int i = 0; i < 9; ++i)
			q.push(gr[k][i]);
	}
}

int main()
{
	//FILE *f;
	//freopen_s(&f, "input.txt", "rt", stdin);
	freopen("burrito.in", "rt", stdin);
	freopen("burrito.out", "wt", stdout);

	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		string sl;
		cin >> sl >> lal[i].r >> lal[i].p >> lal[i].s;
		lal[i].ch = sl[0];
	}
	int init = (1 << n) - 1;
	bfs(init);

	cout << "2" << endl;
	cout << "P 1 2 1" << endl;
	cout << "S 1 1 1" << endl;



	return 0;
}
