#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int n, m;

const int maxN = 50;
vector<bool> used(maxN  + 1);
string str;
vector<int> ans;

void fun(int pos){
	if (pos == str.length()){
		int n = maxN;
		while (!used[n]) --n;
		for (int i = 1; i <= n; ++i)
			if (!used[i])
				return;
		for (int v : ans)
			cout << " " << v;
		cout << endl;
		exit(0);
	}
	else{
		int val;

		val = str[pos] - '0';
		if (val <= maxN && !used[val]){
			used[val] = true;
			ans.push_back(val);
			fun(pos + 1);
			ans.pop_back();
			used[val] = false;
		}

		if (pos + 1 < str.length()){
			val = (str[pos] - '0') * 10 + str[pos + 1] - '0';
			if (val <= maxN && !used[val]){
				used[val] = true;
				ans.push_back(val);
				fun(pos + 2);
				ans.pop_back();
				used[val] = false;
			}
		}
	}
}

void deb(){
	vector<int> v;
	for (int i = 1; i <= 50; ++i)
		v.push_back(i);
	random_shuffle(v.begin(), v.end());
	for (int x : v) cout << x;
}

int main()
{
	FILE *f;
	//freopen_s(&f, "input.txt", "rt", stdin);
	freopen("joke.in", "rt", stdin);
	freopen("joke.out", "wt", stdout);

	cin >> str;
	fun(0);
	//deb();
}
