#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <bitset>
#include <string>
#include <cstring>

using namespace std;

int n, m;

void print( int a, int c )
{
	cout << c << "\n";
	for ( int i = 1; i <= n; i++ )
		for ( int j = 1; j <= m; j++ )
		{
			if ( ( i + j ) % 2 == a ) cout << i << " " << j << " " << i << " " << j << "\n";
		}
}

void solve()
{
	cin >> n >> m;
	int b = 0, w = 0;
	for ( int i = 1; i <= n; i++ )
		for ( int j = 1; j <= m; j++ )
		{
			if ( ( i + j ) % 2 == 0 ) w += 1; else b += 1;
		}
	if ( w <= b ) print( 0, w ); else print( 1, b );
}

int main()
{
	freopen("alter.in", "r", stdin);
	freopen("alter.out", "w", stdout);
	time_t start = clock();
	int t = 1;
	for ( int i = 0; i < t; i++ ) solve();
	cerr << fixed << setprecision( 7 ) << "Time: " << 1.0 * ( clock() - start ) / CLOCKS_PER_SEC << "\n";
	return 0;
}