#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <bitset>
#include <string>
#include <cstring>

using namespace std;

int n;
pair<int, int >r[100100];
int a[100100], b[100100], g[100100];
int A, B;
double ans[100100];
const double eps = 1e-9; 

void solve()
{
	scanf("%d%d%d", &n, &A, &B);
	for (int i=1; i<=n; i++)
	{
		scanf("%d%d%d", &g[i], &a[i], &b[i]);
		r[i] = make_pair(a[i]-b[i], i);
	}
	sort(r+1, r+n+1);
	reverse(r+1, r+n+1);
	
	double sumb=0.0, suma=0.0;
	
	for (int i=1; i<=n; i++)
	{
		int now = r[i].second;
		double cn = min(1.0*g[now], (B-sumb)/b[now]  );
		ans[now] = cn;
		suma += cn*a[now];
		sumb += cn*b[now];
	}
	if ( suma + eps < A )
	{
		cout<<"-1 -1"<<endl;
	}
	else
	{
		cout<<suma<<" "<<sumb<<endl;
		for (int i=1; i<=n; i++)
			printf("%.9lf ", ans[i]);
	}
}

int main()
{
	cout<<fixed<<setprecision(9);
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	time_t start = clock();
	int t = 1;
	for ( int i = 0; i < t; i++ ) solve();
	cerr << fixed << setprecision( 7 ) << "Time: " << 1.0 * ( clock() - start ) / CLOCKS_PER_SEC << "\n";
	return 0;
}