#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <bitset>
#include <string>
#include <cstring>

using namespace std;

int n;
string s;
vector< int > positions;
int taken[ 111 ];
bool used[ 55 * 55 ];

void rec( int pos )
{
	// ---------------------
	if ( pos == s.size() )
	{
		if ( positions.size() != 10 ) return;
		int l = positions.back() + 1;
		int r = pos - 1;
		bool flag = true;
		while ( l < r )
		{
			int a = s[ l ] - '0';
			int b = s[ l + 1 ] - '0';
			if ( a == 0 ) flag = false;
			int num = 10 * a + b;
			if ( taken[ num ] > 0 ) flag = false;
			taken[ num ] += 1;
			l += 2;
		}
		if ( flag )
		{
			//for ( int i = 1; i < positions.size(); i++ ) cout << positions[i] << " "; cout << "\n";
			for ( int i = 1; i < positions.size(); i++ ) used[ positions[i] ] = true;
			int a = 0;
			while ( a < s.size() )
			{
				if ( used[ a ] ) 
				{
					cout << s[ a ] << " "; 
					a += 1;
					continue;
				}
				cout << s[a] << s[a + 1] << " ";
				a += 2;
				continue;
			}
			cout << "\n";
			exit( 0 );
		}
		l = positions.back() + 1;
		r = pos - 1;
		while ( l < r )
		{
			int a = s[ l ] - '0';
			int b = s[ l + 1 ] - '0';
			int num = 10 * a + b;
			taken[ num ] -= 1;
			l += 2;
		}
		return;
	}
	rec( pos + 1 );
	// ------------------------------
	if ( ( pos - positions.back() + 1 ) % 2 ) return;
	int digit = s[ pos ] - '0';
	if ( digit == 0 ) return;
	if ( taken[ digit ] > 0 ) return;
	int l = positions.back() + 1;
	int r = pos - 1;
	bool flag = true;
	while ( l < r )
	{
		int a = s[ l ] - '0';
		int b = s[ l + 1 ] - '0';
		if ( a == 0 ) flag = false;
		int num = 10 * a + b;
		if ( taken[ num ] > 0 ) flag = false;
		if ( num > n ) flag = false;
		taken[ num ] += 1;
		l += 2;
	}
	taken[ digit ] += 1;
	positions.push_back( pos );

	if ( flag ) rec( pos + 1 );

	taken[ digit ] -= 1;
	positions.pop_back();
	l = positions.back() + 1;
	r = pos - 1;
	while ( l < r )
	{
		int a = s[ l ] - '0';
		int b = s[ l + 1 ] - '0';
		int num = 10 * a + b;
		taken[ num ] -= 1;
		l += 2;
	}
}

void solve()
{
	cin >> s;
	int sum = 0;
	for ( int i = 1; i <= 50; i++ )
	{
		int ii = i;
		while ( ii )
		{
			sum += 1;
			ii /= 10;
		}
		if ( sum == s.size() ) 
		{
			n = i;
			break;
		}
	}
	//cout << n << "\n";
	if ( n < 10 )
	{
		for ( int i = 0; i < s.size(); i++ ) cout << s[i] << " "; cout << "\n";
		return;
	}
	positions.push_back( -1 );
	rec( 0 );
}

int main()
{
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
	time_t start = clock();
	int t = 1;
	for ( int i = 0; i < t; i++ ) solve();
	cerr << fixed << setprecision( 7 ) << "Time: " << 1.0 * ( clock() - start ) / CLOCKS_PER_SEC << "\n";
	return 0;
}