#include <fstream>
#include <bitset>
#include <string>
#include <vector>

using namespace std;

const int MAXN = 1005;
bitset<MAXN> db[MAXN], u[MAXN];
int a[MAXN];
vector<int> ans;

int main() {
    ifstream in("filter.in");
    ofstream out("filter.out");
    int m, f;
    in >> m >> f;
    for(int i = 0; i < f; i++)
        in >> a[i];
    int n;
    in >> n;
    for(int i = 0; i < n; i++) {
        string s;
        in >> s;
        for(size_t j = 0; j < s.length(); j++) {
            int c = ('0' <= s[j] && s[j] <= '9'? (s[j] - '0') : (10 + s[j] - 'a'));
            int l = j * 4, r = min(m, l + 4);
            for(int k = l; k < r; k++)
                db[i][k] = (c & (1 << (k - l)));
        }
    }
    int q;
    in >> q;
    for(int i = 0; i < q; i++) {
        int user;
        in >> user;
        for(int j = 0; j < f; j++)
            u[i][((long long)a[j] * user) % m] = true;
    }
    for(int i = 0; i < n; i++)
        for(int j = 0; j < q; j++)
            if((db[i] & u[j]) == u[j]) {
                ans.push_back(i);
                break;
            }
    out << ans.size() << ' ';
    for(size_t i = 0; i < ans.size(); i++)
        out << ans[i] << ' ';
    out << '\n';
    return 0;
}
