#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int N = 100010;
vector<double> a, b, s, g;
int n;
double A, B;

#define all(x) x.begin(),x.end()

inline bool cmp(int i, int j) {
	return a[i] - b[i] < a[j] - b[j];
}

int main()
{
	ios_base::sync_with_stdio(false);
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	cin >> n >> A >> B;
	a.resize(n);
	b.resize(n);
	s.resize(n);
	g.resize(n);

	vector<int> srtd(n);
	for (int i = 0; i < n; i++) {
		srtd[i] = i;
	}

	double extraB = 0, sumA = 0;
	for (int i = 0; i < n; i++) {
		cin >> g[i] >> a[i] >> b[i];
		s[i] = g[i];
		extraB += s[i] * b[i], sumA += s[i] * a[i];
	}
	extraB -= B;
	sort(all(srtd), cmp);

	for (int is = 0; is < n; is++) {
		int i = srtd[is];
		if (b[i] * s[i] < extraB) {
			extraB -= b[i] * s[i];
			s[i] = 0;
			sumA -= a[i] * s[i];
		}
		else {
			s[i] -= extraB / b[i];
			sumA -= extraB / b[i] * a[i];
			extraB = 0;
			break;
		}
	}

	if (sumA >= A && (abs(extraB) < 1e-8 || extraB < 0)) {
		double ss = 0;
		for (int i = 0; i < n; i++) ss += b[i] * s[i];
		cout << fixed << setprecision(10) << sumA << " " << ss << endl;
		for (int i = 0; i < n; i++) cout << fixed << setprecision(10) << s[i] << " ";
		cout << endl;
	}
	else {
		cout << -1 << " " << -1;
	}



	return 0;
}

/*int main(){
	freopen("alter.in", "r", stdin);
	freopen("alter.out", "w", stdout);
	int n, m;
	cin >> n >> m;
	cout << n * m / 2 << endl;
	int frst = 2;
	for (int i = 1; i <= n; ++i){
		for (int j = frst; j <= m; j += 2)
		{
			cout << i << ' ' << j << ' ' << i << ' ' << j << endl;
		}
		frst = (frst == 2) ? 1 : 2;
	}
	return 0;
}*/