#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <algorithm>
using namespace std;


int main(){
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);

	int n; cin >> n;
	int cur = 0;
	vector<pair<int, int> > rps;
	for (int i = 0; i < n; ++i){
		int t; cin >> t;
		rps.emplace_back(min(cur, t), max(cur, t));
		cur = t;
	}
	sort(rps.begin(), rps.end(), [](pair<int, int> a, pair<int, int> b){
		return a.first < b.first || a.first == b.first && a.second > b.second;
	});
	set<int> eds;
	int ans = 0;
	for (int i = 0; i < n; ++i){
		int cbeg = rps[i].first;
		while (!eds.empty() && *eds.begin() <= cbeg) eds.erase(eds.begin());
		if (!eds.empty() && *eds.begin() < rps[i].second){
			++ans;

		}
		else {
			eds.insert(rps[i].second);
		}
	}
	cout << n - ans << endl;
	return 0;
}