#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <algorithm>
using namespace std;


int main(){
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);

	int n; cin >> n;
	int cur = 0;
	vector<pair<int, int> > rps, rps1;
	for (int i = 0; i < n; ++i){
		int t; cin >> t;
		rps.emplace_back(min(cur, t), max(cur, t));
		cur = t;
	}
	sort(rps.begin(), rps.end(), [](pair<int, int> a, pair<int, int> b){
		return a.first < b.first || a.first == b.first && a.second > b.second;
	});
	for (auto p : rps){
		if (rps1.empty() || rps1.back().first != p.first){
			rps1.push_back(p);
		}
		else {
			rps1.back().second = max(rps1.back().second, p.second);
		}
	}
	set<int> eds;
	int ans = 0;
	for (int i = 0; i < n; ++i){
		int cbeg = rps1[i].first;
		while (!eds.empty() && *eds.begin() <= cbeg) eds.erase(eds.begin());
		if (!eds.empty() && *eds.begin() < rps1[i].second){
			//++ans;
			for (auto x : eds) if (x < rps1[i].second) ++ans;
			eds.insert(rps1[i].second);
		}
		else {
			eds.insert(rps1[i].second);
		}
	}
	cout << n - ans << endl;
	return 0;
}