#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

const int MAXN = 100020;
const double INF = 1e15;

int n, A, B;
int a[MAXN], b[MAXN], g[MAXN];
double w[MAXN];
vector<pair<double, int>> f;

int main()
{
    freopen("burrito.in", "r", stdin);
    freopen("burrito.out", "w", stdout);

    scanf("%d%d%d", &n, &A, &B);

    double t = INF;

    for (int i = 0; i < n; ++i) {
        scanf("%d%d%d", g + i, a + i, b + i);
        t = INF;
        if (b[i])
            t = (double) a[i] / (double) b[i];
        f.push_back(make_pair(t, i));
    }

    sort(f.rbegin(), f.rend());

    double q = 0;
    int k = 0;
    while (k < f.size() && q < B) {
        int h = f[k].second;
        q += g[h] * b[h];
        w[h] = g[h];
        ++k;
    }

    --k;
    if (q > B) {
        int h = f[k].second;
        q -= g[h] * b[h];
        w[h] = 0;
        w[h] = (double) (B - q) / (double) b[h];
    }

    ++k;

    double t1 = 0, t2 = 0;

    q = 0;
    for (int i = 0; i < n ; ++i) {
        q += w[i] * a[i];
        t1 += w[i] * b[i];
    }

    if (q < A) {
        printf("-1 -1");
    } else {
        printf("%.10F %.10F\n", q, t1);
        for (int i = 0; i < n; ++i) {
            printf("%.10F ", w[i]);
        }
    }

    return 0;
}
