#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

const int MAXN = 100020;
const double INF = 1e15;

int n, A, B;
int main()
{
    freopen("burrito.in", "r", stdin);
    freopen("burrito.out", "w", stdout);

    scanf("%d%d%d", &n, &A, &B);
    vector<int> a;
    vector<int> b;
    vector<int> g;
    vector<pair<double ,int> > order;
    vector<double> ans;
    double cA = 0;
    double cB = 0;
    for(int i = 0; i < n; i ++){
        int ta, tb, tg;
        scanf("%d%d%d", &tg, &ta, &tb);
        a.push_back(ta);
        b.push_back(tb);
        g.push_back(tg);
        if(tb == 0){
            cA += tg*ta;
            ans.push_back(tg);
        }else{
            ans.push_back(0);
            order.push_back(make_pair(double(ta)/double(tb), i));
        }
    }
    sort(order.begin(), order.end());
    reverse(order.begin(), order.end());
    for(int i = 0; i < order.size(); i ++){
        int pos = order[i].second;
        if(cB + b[pos]*g[pos] <= B){
            cB += b[pos]*g[pos];
            cA += a[pos]*g[pos];
            ans[pos] = g[pos];
        }else{
            double x = (double(B)-cB)/double(b[pos]);
            cB += x*b[pos];
            cA += x*a[pos];
            ans[pos] = x;
            break;
        }

    }

    if(cA < A){
        cout << "-1 -1";
        return 0;
    }

    printf("%.10F %.10F\n", cA, cB);
    for(int i = 0; i < n; i ++){
        printf("%.10F ", ans[i]);
    }

    return 0;
}
