#include <cstdio>
#include <iostream>
#include <vector>
#include <string>
#include <cstdlib>
#include <set>
#include <map>
#include <memory.h>
#include <cmath>
#include <queue>
#include <algorithm>

#define fi first
#define se second
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define pii pair <int, int>
#define vi vector <int>
#define pb push_back
#define mp make_pair
#define ld long double

#define TASKNAME "burrito"

typedef long long lint;
typedef long long i64;
typedef long long li;

using namespace std;

struct elem
{
	i64 g, a, b;
	int number;
};

bool operator < (elem first, elem second)
{
	return first.a * second.b > first.b * second.a;
}

const int maxn = 1e5 + 5;
const ld eps = 1.0e-9;

vector <elem> list;
ld answer[maxn];
int n;

int main()
{
	freopen(TASKNAME ".in", "r", stdin);
	freopen(TASKNAME ".out", "w", stdout);
	ld A, B;
	cin >> n >> A >> B;
	ld joy = 0.0;
	ld unhap = 0.0;
	forn(j, n)
	{
		elem e;
		scanf("%lld%lld%lld", &e.g, &e.a, &e.b);
		e.number = j;
		if (e.a == 0)
			continue;
		if (e.b == 0)
		{
			joy += (ld)e.g * e.a;
			answer[j] = e.g;
		}
		else list.pb(e);
	}
	sort(list.begin(), list.end());
	forn(j, list.size())
	{
		ld got = min((ld)list[j].g, (ld)(B - unhap) / list[j].b);
		joy += got * list[j].a;
		unhap += got * list[j].b;
		answer[list[j].number] = got;
	}
	if (joy - A >= -eps && B - unhap >= -eps)
	{
		printf("%.10Lf %.10Lf\n", joy, unhap);
		forn(j, n)
			printf("%.10Lf ", answer[j]);
	}
	else printf("-1 -1");
}