#include <cstdio>
#include <iostream>
#include <vector>
#include <string>
#include <cstdlib>
#include <set>
#include <map>
#include <memory.h>
#include <cmath>
#include <queue>
#include <algorithm>

#define fi first
#define se second
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define pii pair <int, int>
#define vi vector <int>
#define pb push_back
#define mp make_pair

#define TASKNAME "filter"

typedef long long lint;
typedef long long i64;
typedef long long li;

using namespace std;

const int maxn = 1005;

int set_elem[maxn];
int digit_count, m, f;
int digits[maxn][maxn];
//int result[maxn * 4];
bool bit[maxn];
i64 a[maxn];
bool mark[maxn];

int get(char c)
{
	return (c >= '0' && c <= '9' ? c - '0' : 10 + c - 'a');
}

int Q, n;

void solve()
{
	for (i64 uid_number = 0; uid_number < Q; uid_number++)
	{
		i64 uid = set_elem[uid_number];
		vi list;
		forn(hash_func, f)
		{
			i64 j = (uid * a[hash_func]) % m;
			list.pb(j);
		}
		/*printf("result %lld\n", uid);
		forn(i, digit_count)
			printf("i = %d %d\n", i, result[i]);*/
		forn(choice, n) if (!mark[choice])
		{
			bool fail = false;
			forn(i, f)
			{
				int bit = list[i];
				if (!(digits[choice][bit / 4] & (1 << (bit % 4))))
				{
					fail = true;
					break;

				}
			}
			if (!fail)
				mark[choice] = true;
		}
	}

	vi answer;
	forn(choice, n) if (mark[choice])
	{
		answer.pb(choice);
	}
	printf("%d ", answer.size());
	forn(j, answer.size())
		printf("%d ", answer[j]);
}

int main()
{
	freopen(TASKNAME ".in", "r", stdin);
	freopen(TASKNAME ".out", "w", stdout);
	cin >> m >> f;
	forn(j, f)
		cin >> a[j];
	cin >> n;
	forn(j, n)
	{
		string s;
		cin >> s;
		digit_count = s.length(); 
		forn(pos, s.length())
		{
			digits[j][pos] = get(s[pos]);
			
		}
	}
	scanf("%d", &Q);
	forn(j, Q)
		scanf("%d", &set_elem[j]);
	solve();
	
}