#include <cstdio>
#include <iostream>
#include <vector>
#include <string>
#include <cstdlib>
#include <set>
#include <map>
#include <memory.h>
#include <cmath>
#include <queue>
#include <algorithm>

#define fi first
#define se second
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define pii pair <int, int>
#define vi vector <int>
#define pb push_back
#define mp make_pair

#define TASKNAME "improvements"

typedef long long lint;
typedef long long i64;
typedef long long li;

using namespace std;

const int maxn = 300100;
const int INF = 1000000000;

int n;
int p[maxn];
int a[maxn];
int res[maxn];
int rev_res[maxn];
int dp[maxn];

void solve(int *res) {
	for (int i = 0; i <= n; i++)
		dp[i] = INF;
	dp[0] = -INF;
	for (int i = 0; i < n; i++) {
		int pos = lower_bound(dp, dp + n, a[i]) - dp;
		dp[pos] = min(dp[pos], a[i]);
		res[i] = pos;
		/*for (int j = 0; j < n; j++)
			cerr << dp[j] << ' ';
		cerr << endl << endl;*/
	}
	/*for (int i = 0; i < n; i++)
		cerr << res[i] << ' ';
	cerr << endl;*/
}

int main()
{
	freopen(TASKNAME ".in", "r", stdin);
	freopen(TASKNAME ".out", "w", stdout);
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> p[i];
		p[i]--;
		a[p[i]] = i;
	}
	//n++;
	//a[0] = 0;
	/*for (int i = 0; i < n; i++)
		cerr << a[i] << ' ';
	cerr << endl;*/
	solve(res);
	reverse(a, a + n);
	solve(rev_res);
	int r = -INF;
	for (int i = 0; i < n; i++)
		r = max(r, res[i] + rev_res[n - i - 1] - 1);
	cout << r << endl;
}