#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define sz(c) ((int)(c).size())
#define forn(i, n) for (int i = 0; i < (int) n; ++i)
#define pb push_back
#define all(c) (c).begin(), (c).end()
#define fst first
#define snd second
#define fori(i,b,e) for (int i = (b); i < (e); ++i)

typedef vector<int> vi;
typedef long long ll;
typedef long long LL;
typedef long long int64;
typedef pair<int, int> pii;
typedef vector<pii> vii;

inline int getInt() {int x; scanf("%d", &x); return x;}

#define FILE_NAME ""

int bestX, bestY;

const int n = 19;

int a[n][n];

int64 allEval = 0;
int64 allEvalComp = 0;

int dx_[] = {0,1,1,1};
int dy_[] = {1,1,0,-1};

inline bool good(int x, int y) {
    return x >= 0 && y >= 0 && x < n && y < n;
}

int64 f[] = {0, 1, 10, 100, 1000000, 10000000000000};
int64 fComp[] = {0, 50, 50*50*50, 50ll*50*50*50*50, 50ll*50*50*50*50*50*50};
int cnt[3];

int64 eval() {
    int64 res = 0;
    fori(i,0,n)
        fori(t,0,4) {
            int dx = dx_[t], dy = dy_[t];
            cnt[1] = 0;
            cnt[2] = 0;
            int sx = 0, sy = i;
            if (!good(sx + 4*dx, sy + 4*dy)) {
                continue;
            }
            int ex = sx, ey = sy;
            fori(i,0,4) {
                cnt[a[ex][ey]]++;
                ex += dx; ey += dy;
            }
            while (good(ex, ey)) {
                cnt[a[ex][ey]]++;
                if ((cnt[1] == 0) ^ (cnt[2] == 0)) {
                    if (cnt[2] > 0) {
                        if (cnt[2] == 5)
                            return 1e16;
                        res += f[cnt[2]];
                    } else {
                        res -= f[cnt[1]];
                    }
                }
                cnt[a[sx][sy]]--;
                ex += dx; ey += dy;
                sx += dx; sy += dy;
            }
        }
    return res;
}

int64 evalPos(int x, int y) {
//    cerr << 3;
    int64 res = 0;
    fori(t,0,4) {
        int dx = dx_[t], dy = dy_[t];
        int sx = x - dx * 4, sy = y - dy * 4;
        cnt[1] = 0;
        cnt[2] = 0;
        while (!good(sx, sy)) {
            sx += dx;
            sy += dy;
        }
        if (!good(sx + 4*dx, sy + 4*dy)) {
            continue;
        }
        int ex = sx, ey = sy;
        fori(i,0,4) {
            cnt[a[ex][ey]]++;
            ex += dx; ey += dy;
        }
        while (good(ex, ey) && abs(ex-x) <= 4 && abs(ey-y) <= 4) {
            cnt[a[ex][ey]]++;
            if ((cnt[1] == 0) ^ (cnt[2] == 0)) {
                if (cnt[2] > 0) {
                    res += f[cnt[2]];
                } else {
                    res -= f[cnt[1]];
                }
            }
            cnt[a[sx][sy]]--;
            ex += dx; ey += dy;
        }
    }
//    cerr << 4;
    return res;
}

int64 evalPosComp(int x, int y) {
//    cerr << 3;
    int64 res = 0;
    fori(t,0,4) {
        int dx = dx_[t], dy = dy_[t];
        int sx = x - dx * 4, sy = y - dy * 4;
        cnt[1] = 0;
        cnt[2] = 0;
        while (!good(sx, sy)) {
            sx += dx;
            sy += dy;
        }
        if (!good(sx + 4*dx, sy + 4*dy)) {
            continue;
        }
        int ex = sx, ey = sy;
        fori(i,0,4) {
            cnt[a[ex][ey]]++;
            ex += dx; ey += dy;
        }
        while (good(ex, ey) && abs(ex-x) <= 4 && abs(ey-y) <= 4) {
            cnt[a[ex][ey]]++;
            if (!((cnt[1] == 0 && cnt[2] == 0) || (cnt[1] != 0 && cnt[2] != 0))) {
                if (cnt[2] > 0) {
                    res -= fComp[cnt[2]] * 50;
                } else {
                    res += fComp[cnt[1]];
                }
            }
            cnt[a[sx][sy]]--;
            ex += dx; ey += dy;
        }
    }
//    cerr << 4;
    return res;
}

const int minv = 4;
const int maxlev = 1;

int64 goComp(int lev, bool pl) {
//    if (lev < 2)
//        cerr << lev;
    if (lev == 1)
        return 0;
    int64 best = -1e18;
    fori(i,0,n)
        fori(j,0,n)
            if (!a[i][j]) {
                int64 init = evalPos(i, j);
                int64 initComp = evalPosComp(i, j);
                allEval -= init;
                allEvalComp -= initComp;
                a[i][j] = 1;
                int64 v = evalPos(i, j);
                int64 vComp = evalPosComp(i, j);
                if (true) {
                    allEval += v;
                    allEvalComp += vComp;
                    int64 nv = pl ? -allEval : allEvalComp;
                    if (nv > best) {
                        best = nv;
                        bestX = i;
                        bestY = j;
                    }
                    allEval -= v;
                    allEvalComp -= vComp;
                }
                a[i][j] = 0;
                allEval += init;
                allEvalComp += initComp;
            }
    return best;
}

int64 go(int lev) {
    //cerr << lev;
    bool my = lev % 2 == 0;
    int col = my ? 2 : 1;
    int64 best = my ? -1e18 : 1e18;
    fori(i,4,n-4)
        fori(j,4,n-4)
            if (!a[i][j]) {
                a[i][j] = col;
                if (true) {
                    int64 nv = 0;
                    if (lev != maxlev) {
                        nv = go(lev+1);
                    } else {
                        nv = eval();
                    }
                    if (my) {
                        if (nv > best) {
                            best = nv;
                            if (lev == 0) {
                                bestX = i;
                                bestY = j;
                            }
                        }
                    } else {
                        if (nv < best) {
                            best = nv;
                        }
                    }
                }
                a[i][j] = 0;
            }
    return best;
}

bool end(int col) {
    fori(i,0,n)
        fori(j,0,n) {
            fori(t,0,4) {
                int dx = dx_[t], dy = dy_[t];
                if (!good(i + dx * 4, j + dy * 4))
                    continue;
                int x = i, y = j;
                int res = 0;
                fori(i,0,5) {
                    res += a[x][y] == col;
                    x += dx; y += dy;
                }
                if (res == 5)
                    return true;
            }
        }
    return false;
}

void print() {
    fori(i,0,n)
        printf("=");
    printf("\n");
    fori(i,0,n) {
        fori(j,0,n) {
            if (!a[i][j])
                printf(" ");
            else
                printf("%d", a[i][j]);
        }
        printf("\n");
    }
    fori(i,0,n)
        printf("=");
    printf("\n");
}

int main() {
    //assert(freopen(FILE_NAME ".in", "rt", stdin));
    //assert(freopen(FILE_NAME ".out", "wt", stdout));
    int cnt = 0;
    while (true) {
        int x = getInt(), y = getInt();
        /*int x, y;
        if (cnt == 0) {
            x = n/2+1, y = n/2+1;
            cnt++;
        }
        else {
            fori(i,0,n)
                fori(j,0,n)
                    if (a[i][j])
                        a[i][j] = 3- a[i][j];
            go(0);
            fori(i,0,n)
                fori(j,0,n)
                    if (a[i][j])
                        a[i][j] = 3- a[i][j];
            x = bestX+1, y = bestY+1;
        }
        print();*/
        
        /*int x = rand() % 19 + 1, y = rand() % 19 + 1;
        while (a[x][y]) {
            x = rand() % 19 + 1, y = rand() % 19 + 1;
        }*/
        
        if (x == -1 && y == -1)
            return 0;
        x--; y--;
        allEval -= evalPos(x, y);
        a[x][y] = 1;
        allEval += evalPos(x, y);
        //print();
        /*if (end(1)) {
            print();
            return 0;
        }*/
        //cerr << 1;
        go(0);
        //cerr << 2;
        allEval -= evalPos(bestX, bestY);
        allEvalComp -= evalPosComp(bestX, bestY);
        a[bestX][bestY] = 2;
        allEval += evalPos(bestX, bestY);
        allEvalComp += evalPosComp(bestX, bestY);
        printf("%d %d\n", bestX+1, bestY+1);
        cout.flush();
        /*if (end(2)) {
            print();
            return 0;
        }*/
    }
    return 0;
}
