#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <fstream>

using namespace std;

vector< long long > a, b;

inline long long myabs(const long long &a)
{
	return a < 0 ? -a : a;
}

int main()
{
	ifstream fin("knockout.in");
	ofstream fout("knockout.out");

	ios_base::sync_with_stdio(false);

	long long n, m;
	fin >> n >> m;

	a.resize(n);
	b.resize(n);
	for (long long i = 0; i < n; i++) {
		fin >> a[i] >> b[i];
	}

	for (long long i = 0; i < m; i++) {
		long long l, r, t;
		fin >> l >> r >> t;
		int ans = 0;
		for (long long j = 0; j < n; j++) {
			long long dist = myabs(b[j] - a[j]);
			long long full_round = t / dist;

			long long start = a[j];
			long long dir;
			if (a[j] < b[j]) {
				dir = 1;
			} else {
				dir = -1;
			}

			if (full_round % 2 == 1) {
				start = b[j];
				dir = dir * -1;
			}

			long long res = start + dir * (t % dist);

			if (res >= l && res <= r) {
				ans++;
			}
		}

		fout << ans << '\n';
	}
	return 0;
}