#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <memory>
#include <cstdio>
#include <algorithm>
using namespace std;
#define forn(it, from ,to) for(int it = from; it < to; ++it)
#define mems(arr, val) memset(arr, val, sizeof(arr))
#define mp(a, b) make_pair(a, b)
#define all(A) (A).begin(), (A).end()
typedef long long LL;

struct burr{
	int g, a, b, idx;
};

bool comp(burr &a, burr &b)
{
	//if (a.a * b.b == a.b * b.a) return a.idx > b.idx;
	return a.a * b.b > a.b * b.a;
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
	freopen("burrito.in", "r", stdin); freopen("burrito.out", "w", stdout);
#endif
	
	int n;
	double A, B;
	cin >> n >> A >> B;
	vector<burr> bur(n);
	forn(i, 0, n)
	{
		cin >> bur[i].g >> bur[i].a >> bur[i].b;
		bur[i].idx = i;
	}

	sort(all(bur), comp);

	double curA = 0, curB = 0;
	vector<double> ans(n, 0.0);
	forn(i, 0, n)
	{
		if (curB + (double)bur[i].b * (double)bur[i].g < B)
		{
			curB += (double)bur[i].b * (double)bur[i].g;
			ans[bur[i].idx] += bur[i].g;
			curA += bur[i].a * (double)bur[i].g;
		}
		else
		{
			double need = B - curB;
			double part = need / (double)bur[i].b;
			ans[bur[i].idx] = part;
			curA += part * bur[i].a;
			curB += part * bur[i].b;
		}
	}
	if (curA < A)
	{
		cout << "-1 -1";
		return 0;
	}
	printf("%.15f %.15f\n", curA, curB);
	forn(i, 0, ans.size())
		printf("%.15f ", ans[i]);
	return 0;
}