#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <memory>
#include <cstdio>
#include <bitset>
#include <algorithm>
using namespace std;
#define forn(it, from ,to) for(int it = from; it < to; ++it)
#define mems(arr, val) memset(arr, val, sizeof(arr))
#define mp(a, b) make_pair(a, b)
#define all(A) (A).begin(), (A).end()
typedef long long LL;

struct burr{
	int g, a, b, idx;
};

bool comp(burr &a, burr &b)
{
	//if (a.a * b.b == a.b * b.a) return a.idx > b.idx;
	return a.a * b.b > a.b * b.a;
}

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
	freopen("filter.in", "r", stdin); freopen("filter.out", "w", stdout);
#endif

	vector<string> bits(16);
	bits[0] = "0000"; bits[4] = "0010"; bits[8] = "0001"; bits[12] = "0011";
	bits[1] = "1000"; bits[5] = "1010"; bits[9] = "1001"; bits[13] = "1011";
	bits[2] = "0100"; bits[6] = "0110"; bits[10] = "0101"; bits[14] = "0111";
	bits[3] = "1100"; bits[7] = "1110"; bits[11] = "1101"; bits[15] = "1111";

	int m, f;
	cin >> m >> f;
	vector<LL> a(f);
	for (int i = 0; i < f; i++) cin >> a[i];

	int n;
	cin >> n;
	vector<bitset<1000>> hash(n);
	string s;
	for (int i = 0; i < n; i++)
	{
		cin >> s;
		
		for (int j = 0; j < s.length(); j++)
		{
			string tempbit;
			if (isalpha(s[j])) tempbit = bits[10 + s[j] - 'a'];
			else tempbit = bits[s[j] - '0'];

			for (int k = 0; k < 4; k++)
			{
				if (tempbit[k] == '1') hash[i].set(4 * j + k);
			}
		}
	}

	int uc;
	cin >> uc;
	vector<char> good(n, 0);
	forn(i, 0, uc)
	{
		LL userid;
		cin >> userid;
		bitset<1000> curset;
		for (int j = 0; j < a.size(); ++j)
		{
			curset.set((userid * a[j]) % m);
		}

		for (int j = 0; j < n; ++j)
		{
			if (good[j]) continue;
			if ((curset & hash[j]) == curset) good[j] = 1;
		}
	}

	int anscount = 0;
	forn(j, 0, n)
		anscount += good[j];

	cout << anscount;
	forn(i, 0, n)
	{
		if (good[i]) cout << " " << i;
	}

	return 0;
}