#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/stack:64000000")

#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <string>
#include <cstring>
#include <set>
#include <algorithm>
#include <queue>
#include <ctime>
#include <cassert>
#include <cstdlib>
#include <cmath>
#include <stack>
#include <bitset>

using namespace std;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define mp(a, b) make_pair(a,b)
#define ALL(a) a.begin(), a.end()
#define pb(a) push_back(a)
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
#endif
	int m, f; cin >> m >> f;
	vector<int> a(f);
	forn(i, f) {
		ll tmp; cin >> tmp;
		a[i] = tmp%m;
	}
	int n; scanf("%d", &n);
	vector<bitset<1010> > v(n);
	forn(ii, n) {
		string s; cin >> s;
		forn(i, m) {
			char cc = s[i / 4];
			int val;
			if (cc <= '9') val = cc - '0';
			else val = cc - 'a' + 10;
			int tmp = (val >> (i & 3)) & 1;
			if (tmp) v[ii][i] = 1;
		}
	}
	int q; scanf("%d", &q);
	vector<bitset<1010> > u(q);
	forn(ii, q) {
		ll uk; cin >> uk; uk %= m;
		forn(i, f) u[ii][uk*a[i] % m] = 1;
	}
	vector<int> ans;
	forn(ii, n) {
		bool ok = false;
		forn(jj, q) {
			if ((u[jj] & v[ii]) == u[jj]) { ok = true; break; }
		}
		if (ok) ans.pb(ii);
	}
	printf("%d ", sz(ans));
	forn(i, sz(ans)) printf("%d ", ans[i]);
	printf("\n");
	return 0;
}