#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/stack:64000000")

#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <string>
#include <cstring>
#include <set>
#include <algorithm>
#include <queue>
#include <ctime>
#include <cassert>
#include <cstdlib>
#include <cmath>
#include <stack>

using namespace std;

#define forn(i, n) for (int i = 0; i < n; ++i)
#define mp(a, b) make_pair(a,b)
#define ALL(a) a.begin(), a.end()
#define pb(a) push_back(a)
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

ll ABS(ll x) {
	if (x < 0) return -x;
	return x;
}

ll getpos(ll a, ll b, ll t) {
	ll len = ABS(b - a);
	t %= (len * 2);
	if (a < b) {
		if (t <= len) return a + t;
		else return b - (t - len);
	}
	else {
		if (t <= len) return a - t;
		else return b + (t - len);
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);
#endif
	int n, m; scanf("%d%d", &n, &m);
	vector<ll> a(n);
	vector<ll> b(n);
	forn(i, n) cin >> a[i] >> b[i];
	forn(iter, m) {
		ll xi, yi, ti; cin >> xi >> yi >> ti;
		int ans = 0;
		forn(i, n) {
			ll curpos = getpos(a[i], b[i], ti);
			if (curpos >= xi && curpos <= yi) ans++;
		}
		cout << ans << "\n";
	}
	return 0;
}