#define _CRT_SECURE_NO_WARNINGS
#include<cstdio>
#include<iostream>
#include<algorithm>
using namespace std;
const int MAX_N = 200005;
const double EPS = 1e-9;

struct elem
{
	int g, a, b, num;
	elem() {}
	elem(int g, int a, int b, int num) :g(g), a(a), b(b), num(num) {}
};

bool comp(const elem &x, const elem &y)
{
	return (x.b * y.a < x.a * y.b);
}

int less_num(double x, double y)
{
	return (y - x > EPS);
}

int more_num(double x, double y)
{
	return (x - y > EPS);
}

elem mas[MAX_N];
double ans[MAX_N];

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	int n;
	long long total_A, total_B;
	cin >> n >> total_A >> total_B;
	for (int i = 0; i < n; i++)
	{
		scanf("%d%d%d", &mas[i].g, &mas[i].a, &mas[i].b);
		mas[i].num = i;
	}
	sort(mas, mas + n, comp);

	long long sum_A = 0, sum_B = 0;
	for (int i = 0; i < n; i++)
	{
		if (sum_B + (long long)(mas[i].g * mas[i].b) > total_B)
		{
			double kol_g = (double)(total_B - sum_B) / (double)mas[i].b;
			double ans_A = (double)sum_A + kol_g * (double)mas[i].a;
			double ans_B = (double)sum_B + kol_g * (double)mas[i].b;
			ans[mas[i].num] = kol_g;

			if (less_num(ans_A, (double)total_A) || more_num(ans_B, (double)total_B))
			{
				printf("-1 -1");
				return 0;
			}

			printf("%.8lf %.8lf\n", ans_A, ans_B);
			for (int j = 0; j < n; j++)
				printf("%.8lf ", ans[j]);
			return 0;
		}
		else
		{
			long long kol_g = mas[i].g;
			sum_A += kol_g * (long long)mas[i].a;
			sum_B += kol_g * (long long)mas[i].b;
			ans[mas[i].num] = kol_g;
		}
	}

	if (sum_A < total_A || sum_B > total_B)
	{
		printf("-1 -1");
		return 0;
	}
	cout << sum_A << " " << sum_B << "\n";
	for (int i = 0; i < n; i++)
		cout << ans[i] << " ";

	return 0;
}