#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
using namespace std;

const int INF = (int)1e8;
const int N = 200300;
int n;
int ans = 0;
int a[N];
int LIS[N];
int LDS[N];

void findLIS(int* arr)
{
	for (int i = 0; i < n + 6; i++)
		arr[i] = INF;
	arr[0] = -INF;
	for (int i = 0; i < n; i++)
	{
		int idx = lower_bound(arr, arr + n, a[i]) - arr;
		arr[idx] = a[i];
	}
	return;
}

void findLDS(int *arr)
{
	for (int i = 0; i < n; i++)
		a[i] *= -1;
	findLIS(arr);
	for (int i = 0; i < n + 6; i++)
		arr[i] *= -1;
	return;
}

int main()
{
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);

	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d", &a[i]);

	findLIS(LIS);
	findLDS(LDS);

	int idx1 = 0, idx2 = n;
	for (int x = 0; x <= n; x++)
	{
		while (LIS[idx1] <= x) idx1++;
		while (LDS[idx2] <= x) idx2--;
		ans = max(ans, idx1 + idx2 - 1);
	}
	printf("%d\n", ans);

	return 0;
}