#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
using namespace std;

string s;
int n;
int len;
bool used_pos[100];
int used_num[100];
int used_num_2[100];
int a[200][3];
vector<int> positions[60];

int dig_pos[11];

bool check()
{
	for (int i = 1; i <= n; i++)
		used_num_2[i] = used_num[i];
	int idx = 0;
	while (idx < len)
	{
		if (used_pos[idx])
		{
			idx++;
			continue;
		}
		if (idx == len - 1 || used_pos[idx + 1])
			return false;
		int x = a[idx][2];
		if (used_num_2[x] != -1)
			return false;
		used_num_2[x] = idx;
		idx += 2;
	}
	return true;
}

bool print_space[200];

void print_ans()
{
	for (int x = 1; x < 10; x++)
		print_space[ used_num_2[x] ] = true;
	for (int x = 10; x <= n; x++)
		print_space[ used_num_2[x] + 1 ] = true;
	for (int i = 0; i < len; i++)
	{
		cout << s[i];
		if (print_space[i])
			cout << ' ';
	}
	cout << endl;
	return;
}

void brute(int dig)
{
	if (dig == 10)
	{
		if (check())
		{
			print_ans();
			exit(0);
		}
		return;
	}

	for (int i = 0; i < (int)positions[dig].size(); i++)
	{
		int pos = positions[dig][i];
		used_num[dig] = pos;
		used_pos[pos] = true;
		brute(dig + 1);
		used_pos[pos] = false;
	}

}

int main()
{
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);

	cin >> s;
	len = s.length();
	if (len < 10)
	{
		for (int i = 0; i < len; i++)
			cout << s[i] << ' ';
		cout << endl;
		return 0;
	}
	n = 9 + (len - 9) / 2;

	for (int i = 1; i <= n; i++)
		used_num[i] = -1;

	for (int i = 0; i < len; i++)
		a[i][1] = (int)(s[i] - '0');
	for (int i = 0; i < len - 1; i++)
		a[i][2] = a[i][1] * 10 + a[i + 1][1];
	for (int i = 0; i < len - 1; i++)
	{
		int num = a[i][2];
		if (num >= 10 && num <= n)
			positions[num].push_back(i);
	}

	for (int x = n; x >= 10; x--)
	{
		if ((int)positions[x].size() != 1) continue;
		int pos = positions[x][0];
		used_num[x] = pos;
		used_pos[pos] = used_pos[pos + 1] = true;
	}

	for (int i = 0; i < 10; i++)
		positions[i].clear();
	for (int pos = 0; pos < len; pos++)
		if (!used_pos[pos])
			positions[a[pos][1]].push_back(pos);

	brute(1);

	return 0;
}