#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>


typedef long long ll;
typedef long double ld;

using namespace std;

const int MAXF = 120;
const int MAX = 1337;

int f, m, n, q;
int F[MAXF];
int Bits[MAX][MAX];
int User[MAX];

int main()
{
	ios::sync_with_stdio(false);
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);

	cin >> m;
	cin >> f;
    
	for (int i = 0; i < f; ++i)
	{
		cin >> F[i];
		F[i] %= m;
	}

	cin >> n;

	for (int i = 0; i < n; ++i)
	{
		string s; cin >> s;
		for (int j = 0; j < s.length(); ++j)
		{
			int current = 0;
			if (s[j] >= '0' && s[j] <= '9')
			{
				current = s[j] - '0';
			}
			else
			{
				current = s[j] - 'a' + 10;
			}
			for (int k = 0; k < 4; ++k)
			{
				Bits[i][(j << 2) + k] = ((current >> k) & 1);
			}
		}
	}

	cin >> q;
	for (int i = 0; i < q; ++i)
	{
		cin >> User[i];
		User[i] %= m;
	}

	vector<int> Ans;
	for (int i = 0; i < n; ++i)
	{
		bool found = false;
		for (int j = 0; (j < q) && !found; ++j)
		{
			bool foundUser = true;
			for (int k = 0; (k < f) && foundUser; ++k)
			{
				if (Bits[i][(User[j] * F[k]) % m] == 0)
				{
					foundUser = false;
				}
			}

			found |= foundUser;
		}
		if (found)
			Ans.push_back(i);
	}

	cout << Ans.size();
	for (int i = 0; i < Ans.size(); ++i)
		cout << " " << Ans[i];
	
	return 0;
}
