#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>


typedef long long ll;
typedef long double ld;

using namespace std;

int f[22][22];
const int n = 19;

int myx = 19;
int myy = 19;
int rest = 5;

int dx[] = { 1, 0, -1, 1, -1,  1,  0, -1 };
int dy[] = { 1, 1,  1, 0,  0, -1, -1, -1 };

int rx, ry, rd;

bool find(int t)
{
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= n; j++)
		{
			for (int dir = 0; dir < 8; dir++)
			{
				bool bGood = true;
				for (int k = 0; k < t; k++)
				{
					int nextx = i + k*dx[dir];
					int nexty = j + k*dy[dir];
					if (nextx >= 1 && nextx <= n && nexty >= 1 && nexty <= n)
					{
						if (f[nextx][nexty] != 2)
						{
							bGood = false;
							break;
                        }
					}
					else
					{
						bGood = false;
						break;
					}
				}
				{
					int k = t;
					int nextx = i + k*dx[dir];
					int nexty = j + k*dy[dir];
					if (nextx >= 1 && nextx <= n && nexty >= 1 && nexty <= n)
					{
						if (f[nextx][nexty] != 0)
						{
							bGood = false;
						}
					}
					else
					{
						bGood = false;
					}
				}
				if (bGood)
				{
					rx = i;
					ry = j;
					rd = dir;
					return true;
				}
			}
		}
	}
	return false;
}

void move()
{
	cout << myx << " " << myy << endl;
	f[myx][myy] = 1;
	myy--;
	rest--;
}

void fail()
{
	while (true)
	{
		int t = 0;
		t++;
		if (t == 2)
			break;
	}
}

void block(int t)
{
	int k = t;
	int nextx = rx + k*dx[rd];
	int nexty = ry + k*dy[rd];
	if (nextx >= 1 && nextx <= n && nexty >= 1 && nexty <= n)
	{
		if (f[nextx][nexty] != 0)
		{
			fail();
		}
		f[nextx][nexty] = 1;
		cout << nextx << " " << nexty << endl;
	}
	else
	{
		fail();
	}
}

int main()
{
	while (true)
	{
		int x, y;
		cin >> x >> y;
		if (x == -1 && y == -1)
		{
			break;
		}
		f[x][y] = 2;
		if (find(4))
		{
			if (rest == 1)
			{
				move();
			}
			else
			{
				block(4);
			}
		}
		else if (find(3))
		{
			if (rest <= 2)
			{
				move();
			}
			else
			{
				block(3);
			}
		}
		else
		{
			move();
		}
	}
	return 0;
}