#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <sstream>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>
#include <ctime>


typedef long long ll;
typedef long double ld;

using namespace std;

int n;
int nums;
string s;
vector<int> ans;

bool check(int i, long long mask);

bool go(int i, long long mask, int k, int len)
{
	long long sh = (1LL << k);
	if ((mask&sh) == sh)
	{
		return false;
	}
	return check(i + len, mask | sh);
}

bool check(int i, long long mask)
{
	if (i == n)
		return true;
	if (s[i] == '0')
		return false;

	int k = s[i] - '0';
	if (go(i, mask, k, 1))
	{
		ans.push_back(k);
		return true;
	}
	
	if (i!=n-1)
	{
		k *= 10;
		k += s[i + 1] - '0';
		if (go(i, mask, k, 2))
		{
			ans.push_back(k);
			return true;
		}
	}

	return false;
}

int main()
{
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
	cin >> s;

	//int t = 55;
	//vector<int> v;
	//for (int i = 0; i < t; i++)
	//{
	//	v.push_back(i + 1);
	//}
	//srand(time(0));
	//random_shuffle(v.begin(), v.end());
	//for (int i = 0; i < t; i++)
	//{
	//	stringstream ss;
	//	ss << v[i];
	//	string s2;
	//	ss >> s2;
	//	s.append(s2);
	//}

	n = s.length();
	if (n > 9)
	{
		nums = 9 + (n - 9) / 2;
	}
	else
	{
		nums = n;
	}

	check(0, 0);
	for (int i = ans.size()-1; i >=0; i--)
		cout << ans[i] << " ";
	cout << endl;
	return 0;
}