#include <iostream>
#include <string>
#include <unordered_set>
#include <deque>
using namespace std;

int get_max_n(const string& s)
{
	if (s.length() > 9)
		return (s.length() - 9) / 2 + 9;
	else
		return s.length();
}

int max_n;

void for_the_imperor(const string& s, int beg, unordered_set<int>& used, deque<int>& order)
{
	if (beg >= s.length())
	{
		for (auto it = order.begin(); it != order.end(); ++it)
			cout << (*it) << ' ';
		exit(0);
	}
	int curnum = 0, i = 0;
	while (curnum <= max_n)
	{
		curnum = curnum * 10 + (s[beg + i++] - '0');
		if (curnum == 0)
			return;
		if (curnum <= max_n && used.find(curnum) == used.end())
		{
			used.insert(curnum);
			order.push_back(curnum);
			for_the_imperor(s, beg + i, used, order);
			order.pop_back();
			used.erase(curnum);
		}
	}
}

int main()
{
	//freopen("i.txt", "rt", stdin);
	freopen("joke.in", "rt", stdin);
	freopen("joke.out", "w", stdout);
	string s;
	cin >> s;
	max_n = get_max_n(s);
	unordered_set<int> used;
	deque<int> order;
	for_the_imperor(s, 0, used, order);
}