#include <bits/stdc++.h>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

template <typename T1, typename T2> inline bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> inline bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

char c[3] = {'R', 'P', 'S'};

const int N = 100;
const int M = 50000;

struct Input {
	int n;
	int a[N][3], b[N];
	
	bool read () {
		if (!(cin >> n)) {
			return 0;
		}
		forn (i, n) {
			char x;
			cin >> x >> a[i][0] >> a[i][1] >> a[i][2];
			b[i] = 0;
			while (c[b[i]] != x) {
				++b[i];
			}
			a[i][0]--;
			a[i][1]--;
			a[i][2]--;
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	int ans_n;
	int ans_a[N][3], ans_b[N];
	
	void write () {
		cout << ans_n << endl;
		forn  (i, ans_n) {
			cout << c[ans_b[i]] << ' ' << ans_a[i][0] + 1 << ' ' << ans_a[i][1] + 1 << ' ' << ans_a[i][2] + 1 << endl;
		}
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

struct Solution: Data {
	map<vi, int> num;
	vi q[M];
	bool u[M];
	
	void dfs (int v) {
		if (u[v]) {
			return;
		}
		u[v] = 1;
		if (!sz(q[v])) {
			ans_b[v] = 0;
			ans_a[v][0] = v;
			ans_a[v][1] = v;
			ans_a[v][2] = v;
			return;
		}
		ans_b[v] = (b[q[v][0]] + 1) % 3;
		forn (t, 3) {
			int to;
			{
				vi w;
				forn (i, sz(q[v])) {
					if (b[q[v][i]] == t) {
						w.pb(a[q[v][i]][ans_b[v]]);
					}
				}
				sort(all(w));
				w.erase(unique(all(w)), w.end());
				if (num.count(w)) {
					to = num[w];
				} else {
					q[ans_n] = w;
					num[w] = ans_n;
					to = ans_n;
					++ans_n;
				}
			}
			ans_a[v][t] = to;
			dfs(to);
		}
	}
	
	void solve () {
		forn (i, n) {
			q[0].pb(i);
		}
		num[q[0]] = 0;
		ans_n = 1;
		memset(u, 0, sizeof u);
		dfs(0);
		forn (i, ans_n) {
			debug(q[i]);
		}
	}
	
	void clear ();
};

#ifdef SG

Solution EMPTY_SOL;

void Solution::clear () {
	*this = EMPTY_SOL;
}
#else

void Solution::clear () {
}
#endif

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("e.in", "r", stdin);
//	freopen(".out", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	freopen("epic.in", "r", stdin);
	freopen("epic.out", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
