#include <bits/stdc++.h>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

template <typename T1, typename T2> inline bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> inline bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

const int N = 200100;

struct Input {
	int n;
	int a[N];
	
	bool read () {
		if (scanf ("%d", &n) != 1)
			return 0;
		forn(i, n) {
			scanf ("%d", &a[i]);
			a[i]--;
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

const int inf = 1000000000;

struct Solution: Data {
	int tmax[4 * N], tmin[4 * N];
	int sz;
	
	void updmax (int v, int k) {
		v += sz;
		tmax[v] = k;
		v >>= 1;
		while (v > 0) {
			tmax[v] = max(tmax[2 * v], tmax[2 * v + 1]);
			v >>= 1;
		}
	}
	
	int fndmax (int i, int x, int y, int l, int r) {
		if (x > r || y < l) {
			return -inf;
		}
		if (x >= l && y <= r) {
			return tmax[i];
		}
		return max(fndmax(2 * i, x, (x + y) >> 1, l, r), fndmax(2 * i + 1, ((x + y) >> 1) + 1, y, l, r));
	}
	
	void updmin (int v, int k) {
		v += sz;
		tmin[v] = k;
		v >>= 1;
		while (v > 0) {
			tmin[v] = max(tmin[2 * v], tmin[2 * v + 1]);
			v >>= 1;
		}
	}
	
	int fndmin (int i, int x, int y, int l, int r) {
		if (x > r || y < l) {
			return -inf;
		}
		if (x >= l && y <= r) {
			return tmin[i];
		}
		return max(fndmin(2 * i, x, (x + y) >> 1, l, r), fndmin(2 * i + 1, ((x + y) >> 1) + 1, y, l, r));
	}
	
	int dmin[N], dmax[N];
	
	void solve () {	
		sz = 1;
		while (sz < n) sz <<= 1;
		forn(i, 2 * sz) {
			tmin[i] = -inf;
			tmax[i] = -inf;
		}
		ans = 0;
		forn(i, n) {
			dmin[i] = max(1, fndmin(1, 1, sz, a[i] + 1, sz) + 1);
			dmax[i] = max(1, fndmax(1, 1, sz, 1, a[i] + 1) + 1);
			updmax(a[i], dmax[i]);
			updmin(a[i], dmin[i]);
			ans = max(ans, dmin[i] + dmax[i] - 1);
		}
	}
	
	void clear ();
};

#ifdef SG

Solution EMPTY_SOL;

void Solution::clear () {
	*this = EMPTY_SOL;
}
#else

void Solution::clear () {
}
#endif

Solution sol;

int main () {
#ifdef SG
	freopen("i.in", "r", stdin);
//	freopen(".out", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
