#include <bits/stdc++.h>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

template <typename T1, typename T2> inline bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> inline bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

struct Input {
	string s;
	
	bool read () {
		return (getline(cin, s));
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	vector <int> ans;
	
	void write () {
		forn(i, ans.size()) {
			cout << ans[i] << ' ';
		}	
		cout << endl;
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

const int N = 200;

struct Solution: Data {
	
	int glob;
	bool use[N];
	int n;
		
	bool ok (int help) {
		return !use[help] && help > 0 && help <= glob;
	}

	void add (int help) {
		use[help] = 1;
		ans.pb(help);
	}
	
	void erase (int help) {
		use[help] = 0;
		ans.pop_back();
	}
	
	bool calc2 (int pos) {
		if (pos == n) {
			return 1;					
		}		
		int i = pos;
		int help = (int(s[i]) - '0');
		if (ok(help)) {
			add(help);
			if (calc2(pos + 1))
				return 1;
			erase(help);
		}
		if (pos == n - 1) {
			return 0;
		}
		help = 10 * (int(s[i]) - '0') + int(s[i + 1]) - '0';
		if (ok(help)) {
			add(help);
			if (calc2(pos + 2))
				return 1;
			erase(help);
		}
		return 0;
	}
	
	void solve () {
		n = int(s.size());
		memset(use, 0, sizeof(use));	
		int cnt = 0;
		for (int i = 1;;++i) {
			if (i <= 9) {
				cnt++;
			}	else {
				cnt += 2;
			}
			if (cnt == n) {
				glob = i;
				break;
			}
		}
		calc2(0);	
	}
	
	void clear ();
};

#ifdef SG

Solution EMPTY_SOL;

void Solution::clear () {
	*this = EMPTY_SOL;
}
#else

void Solution::clear () {
}
#endif

Solution sol;

int main () {
#ifdef SG
	freopen("j.in", "r", stdin);
//	freopen(".out", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif
	
	
	return 0;
}
