#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <string>
#include <map>
#include <set>
#include <cstdlib>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;


#define pb(a) push_back((a))
#define mp(a, b) make_pair((a), (b))

#define FOR(i, n) for (int i = 0; i < (n); ++i)

vector<pll> c;

void solve_k() {
	int n, m;
	cin >> n >> m;
	c.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> c[i].first >> c[i].second;
	for (int i = 0; i < m; ++i) {
		ll x, y, t;
		cin >> x >> y >> t;
		int ans = 0;
		for (int j = 0; j < n; ++j) {
			int a = c[j].first, b = c[j].second, dif = abs(b - a);
			ll cur = t % (2 * dif);
			ll d;
			if (cur < dif)
				d = a * dif + cur * (b - a);
			else
				d = b * dif + (cur - dif) * (a - b);
			if (d < dif * x)
				continue;
			if (d > dif * y)
				continue;
			++ans;
		}
		cout << ans << "\n";
	}
}

string taskname = "knockout";

int main() {
#ifdef LOCAL_DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen((taskname + ".in").c_str(), "r", stdin);
	freopen((taskname + ".out").c_str(), "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	solve_k();
	return 0;
}