#include <iostream>
#include <assert.h>
#include <cstdio>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
 
using namespace std;
 
const int N = 500050;
 
struct Ans {
    char c;
    int r, p, s;
    Ans () {}
    Ans(char c, int r, int p, int s) : c(c), r(r), p(p), s(s) {}
    void print() {
        c = c - 'a' + 'A';
        printf("%c %d %d %d\n", c, r, p, s);
    }
};
 
int n, m, r[N], s[N], p[N], nom[N], clen[N];
vector<int> last[111][N], way[N];
char c[N];
Ans ans[N];
 
int get(int x, char c) {
    if (c == 'r') return r[x]; else
    if (c == 'p') return p[x]; else
    return s[x];
}
 
char vs(char go) {
    if (go == 'r') return 'p';
    if (go == 's') return 'r';
    return 's';
}
 
int rec(vector<int> w, int len) {
    if (w.size() == 0) {
        return 0;
    }
    int cr = 0, cp = 0, cs = 0;
    for (int i = 0; i < w.size(); i++) {
        if (c[w[i]] == 'r') cr++;
        else if (c[w[i]] == 'p') cp++;
        else cs++;
    }
    char go = 'r';
    if (cp > cr) { go = 'p'; cr = cp; }
    if (cs > cr) { go = 's'; cr = cs; }
    vector<int> rr, pp, ss;
    go = vs(go);
    for (int i = 0; i < w.size(); i++) {
        if (c[w[i]] == 'r') rr.push_back(get(w[i], go)); else
        if (c[w[i]] == 'p') pp.push_back(get(w[i], go)); else
        ss.push_back(get(w[i], go));
    }
    int need = 2;
    for (int i = 0; i < w.size(); i++) {
        if (last[i][w[i]].size() == 0) need = 1e9; else
        need = max(need, (len - clen[last[i][w[i]].back()] + 1));
    }
    clen[m] = len;
    way[len].push_back(m);
    need *= 15;
    if ((cr == w.size()) && (len >= need))  {
        int cur = way[clen[last[0][w[0]].back()] + 1].back();
        ans[m] = Ans(go, cur, cur, cur);
        way[len].pop_back();
        return m++;
    }
    vector<vector<int>> tmp;
    vector<pair<int, int>> ww;
    for (int i = 0; i < w.size(); i++) {
        ww.push_back(make_pair(i, w[i]));
        tmp.push_back(last[i][w[i]]);
    }
    for (int i = 0; i < w.size(); i++) last[i][w[i]].push_back(m);
    int cm = m++;
    int nlen = len + 1;
    if (cr != w.size()) {
        nlen = 0;
        for (int i = 0; i < w.size(); i++) last[i][w[i]].clear();
    }
    ans[cm] = Ans(go, rec(rr, nlen), rec(pp, nlen), rec(ss, nlen));
    way[len].pop_back();
    for (int i = 0; i < ww.size(); i++) {
        int x = ww[i].first;
        int y = ww[i].second;
        last[x][y] = tmp[i];
    }
    return cm;
}
 
int main() {
    freopen("epic.in", "r", stdin);
    freopen("epic.out", "w", stdout);
    scanf("%d\n", &n);
    for (int i = 1; i <= n; i++) {
        scanf("%c %d %d %d\n", &c[i], &r[i], &p[i], &s[i]);
        c[i] = c[i] - 'A' + 'a';
    }
    vector<int> w;
    for (int i = 1; i <= n; i++) w.push_back(i);
    m = 1;
    rec(w, 0);
    printf("%d\n", m - 1);
    for (int i = 1; i < m; i++) {
        if (ans[i].r == 0) ans[i].r = i;
        if (ans[i].p == 0) ans[i].p = i;
        if (ans[i].s == 0) ans[i].s = i;
    }
    for (int i = 1; i < m; i++) {
        ans[i].print();
    }
}