import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class K {

	static BufferedReader in;
	static StringTokenizer st;
	static PrintWriter out;
	static String filename = "knockout";
	static int n, m;
	static int[] a;
	static int[] b;

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	public static void main(String[] args) throws IOException {
		in = new BufferedReader(new FileReader(new File(filename + ".in")));
		out = new PrintWriter(new FileWriter(new File(filename) + ".out"));
		n = nextInt();
		m = nextInt();
		a = new int[n + 1];
		b = new int[n + 1];
		for (int i = 1; i <= n; i++) {
			a[i] = nextInt();
			b[i] = nextInt();
		}
		for (int i = 1; i <= m; i++) {
			out.println(ans(nextInt(), nextInt(), nextInt()));
		}
		out.close();
	}

	public static int ans(int x, int y, int t) {
		int cur_p = 0;
		int cnt = 0;
		for (int i = 1; i <= n; i++) {
			cur_p = currentPoint(i, t);
			if (x <= cur_p && y >= cur_p) {
				cnt++;
			}
		}
		return cnt;
	}

	public static int currentPoint(int i, int t) {
		int d = b[i] - a[i];
		if (d < 0) {
			d = -1;
		}
		int q1 = t / d;
		int q2 = t % d;
		if (a[i] < b[i]) {
			if (q1 % 2 == 0) {
				return a[i] + q2;
			} else {
				return b[i] - q2;
			}
		}
		if (q1 % 2 == 0) {
			return b[i] - q2;
		} else {
			return a[i] + q2;
		}
	}

}
