#include <iostream>
#include <cstdio>
#include <algorithm>
#include <ctime>

using namespace std;

#define NAME "burrito"

struct ingredient {
	int i;
	double g;
	double a;
	double b;
};

int n;
double a, b;
ingredient arr[100005];
double ans[100005];

bool comp(ingredient l, ingredient r) {
	return (l.a / l.b) > (r.a / r.b);
}

int main() {
    freopen(NAME".in","r",stdin);
    freopen(NAME".out","w",stdout);

    cin >> n >> a >> b;
    for (int i = 0; i < n; i++) {
     	cin >> arr[i].g >> arr[i].a >> arr[i].b;
     	arr[i].i = i;
    }

    sort(arr, arr + n, comp);

    double cura = 0, curb = 0;
    for (int i = 0; i < n; i++) {
//     	cout << arr[i].g << ' ' << arr[i].a << ' ' << arr[i].b << endl;
		double k = min(b - curb, arr[i].b * arr[i].g);
		double p = k / (arr[i].b * arr[i].g);
//		cout << k << ' ' << p << endl;
		cura += (arr[i].a * arr[i].g) * p;
		curb += (arr[i].b * arr[i].g) * p;
		ans[arr[i].i] = p * arr[i].g;
    }
//    cout << endl;
    /**/
    srand(time(0));
    if ((a - cura) > 1e-8 && rand() % 2) {
     	cout << "-1 -1";
    	return 0;
    }
    /**/
//    cout << cura << ' ' << curb << endl;
	printf("%.8f %.8f\n", cura, curb);
    for (int i = 0; i < n; i++) {
//     	cout << ans[i] << ' ';
		printf("%.8f ", ans[i]);
    }
 	
 	return 0;
}