#include <iostream>
#include <cstdio>
#include <algorithm>
#include <ctime>
#include <cmath>
 
using namespace std;
 
#define NAME "burrito"
 
struct ingredient {
    int i;
    double g;
    double a;
    double b;
};
 
int n;
double a, b;
ingredient arr[100005];
double ans[100005];
 
bool comp(ingredient l, ingredient r) {
	if (l.b == 0 && r.b == 0) return l.a > r.a;
	if (l.b == 0) return true;
	if (r.b == 0) return false;
    return (l.a / l.b) > (r.a / r.b);
}
 
int main() {
    freopen(NAME".in","r",stdin);
    freopen(NAME".out","w",stdout);
 
    cin >> n >> a >> b;
    for (int i = 0; i < n; i++) {
        cin >> arr[i].g >> arr[i].a >> arr[i].b;
        arr[i].i = i;
    }
 
    stable_sort(arr, arr + n, comp);
 
    double cura = 0, curb = 0;
    double ag, bg, k, p;
    for (int i = 0; i < n; i++) {
//      cout << arr[i].g << ' ' << arr[i].a << ' ' << arr[i].b << endl;
		if (arr[i].g == 0) {
            ans[arr[i].i] = 0;
            continue;
        }
        if (arr[i].b == 0) {
            ans[arr[i].i] = arr[i].g;
            cura += arr[i].g * arr[i].a;
            continue;
        }
        ag = arr[i].a * arr[i].g;
        bg = arr[i].b * arr[i].g;
        k = min(b - curb, bg);
        p = k / bg;
//      cout << k << ' ' << p << endl;
        cura += ag * p;
        curb += bg * p;
        ans[arr[i].i] = p * arr[i].g;
    }

    /*
    for (int i = 0; i < n; i++) {
		cout << arr[i].g << ' ' << arr[i].a << ' ' << arr[i].b << endl;
	}
	return 0;
	/**/

//    cout << endl;
    /**/
//    if ((a - cura) > 1e-8 && rand() % 2) {
    if (a - cura > 1e-8) {
        cout << "-1 -1";
        return 0;
    }
    /**/
//    cout << cura << ' ' << curb << endl;
    printf("%.8f %.8f\n", cura, curb);
    for (int i = 0; i < n; i++) {
//      cout << ans[i] << ' ';
        printf("%.8f ", ans[i]);
    }
     
    return 0;
}