#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <string>
#include <vector>
#include <cstdio>
#include <queue>
#include <stack>
#include <cmath> 
#include <ctime>
#include <map>
#include <set>

#define ll long long
#define f first
#define s second
#define pb push_back
#define mp make_pair
#define ppb pop_back
#define fname "joke"

using namespace std;

const double pi = acos(-1.0);
const ll maxn = (ll)(1e5);

string s;
int a[1000], len, m;
int ans[1000], b[1000], Z;
bool used[1000];

bool check() {
	if (m != Z)
		return false;

	for (int i = 1; i <= m; ++i)
		if (used[i] == false)
			return false;

	return true;
}

void rec(ll pos, ll k) {
	int x = a[pos];
	if (k == 1)
		x = x * 10 + a[pos + 1];
	if (used[x]) return;

	if (x > Z)
		return;

	used[x] = true;
	ans[m++] = x;

	if (pos + k < len - 1) {
		for (int i = 1; i >= 0; --i)
			if (pos + k + 1 + i < len) 
				rec(pos + k + 1, i);
	} else {
		if (check()) {
			for (int i = 0; i < m; ++i)
				cout << ans[i] << ' ';
			exit(0);
		}
	}

	used[x] = false;
	m--;
}

int main() {
	freopen(fname".in", "r", stdin);
	freopen(fname".out", "w", stdout);
	cin >> s;
	len = s.length();

	if (len <= 9) {
		for (int i = 0; i < len; ++i)
			cout << s[i] << ' ';
		return 0;
	}

	Z = 9 + (len - 9) / 2;

	for (int i = 0; i < len; ++i)
		a[i] = s[i] - '0';

	for (int i = 1; i >= 0; --i)
		rec(0, i);			


	return 0;
}
