#include<cstdio>
#include<iostream>
#include<algorithm>

using namespace std;

#define eps 1e-8

int n, m, k = 0, A, B;

struct rec {
	double g, ans;
	int x, y, p;
	double z;
} a[200000];


bool cmp(rec a, rec b) {
	return a.z < b.z;
}
bool cmp1(rec a, rec b) {
	return a.p < b.p;
}

int main() {
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	cin >> n >> A >> B;
	
	for (int i = 0; i < n; i++) {
		scanf("%lf%d%d", &a[i].g, &a[i].x, &a[i].y);
		a[i].z = a[i].y * 1.0 / a[i].x;
		a[i].p = i;
   	}

   	sort(a, a + n, cmp);

//	for (int i = 0; i < n; i++) cerr << a[i].g << " " << a[i].x << " " << a[i].y << " " << a[i].z << endl;

	
	double sum1 = 0, sum2 = 0;
	for (int i = 0; i < n; i++) {
		if (sum2 + a[i].g * a[i].y <= B) {
			a[k++].ans = a[i].g;
			sum1 += a[i].g * a[i].x;
			sum2 += a[i].g * a[i].y;
		} else {
			double mult = (B - sum2 * 1.0) / a[i].y;
			a[k++].ans = mult;
			sum1 += mult * a[i].x;
			sum2 += mult * a[i].y;
			break;
		}
	}

	if (A-sum1 > eps || sum2-B > eps) {
		cout << "-1 -1";
	} else {
		sort(a, a + n, cmp1);
		cout << sum1 << " " << sum2 << endl;
		for (int i = 0; i < n; i++)
			printf("%.8lf ", a[i].ans);
	}	
		
	return 0;
}                              