#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <vector>
#include <queue>
#include <iostream>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef pair<int,int> pt;
typedef vector<int> vi;

const int inf = 1<<30;
const int N = 1<<17;

int n, A, B, a[N], b[N], g[N], p[N];
double s[N], s1, s2;

void no() {
	puts("-1 -1");
	exit(0);
}

bool cmp(int i, int j) {
	if (b[i] == 0) return true;
	if (b[j] == 0) return false;
	return a[i]*b[j] < a[j]*b[i];
}

int main() {
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	scanf("%d %d %d", &n, &A, &B);
	for (int i = 0; i < n; i++)
		scanf("%d %d %d", g+i, a+i, b+i);
	for (int i = 0; i < n; i++) {
		s1 += g[i] * a[i];
		s2 += g[i] * b[i];
		s[i] = g[i];
	}

	if (s1 < A) no();

	for (int i = 0; i < n; i++)
		p[i] = i;

	sort(p, p + n, cmp);

	for (int i = 0; s2 > B && i < n; i++) {
		int idx = p[i];
		if (b[idx] == 0) continue;
		if (s2 - g[idx] * b[idx] >= B) {
			s[idx] = 0;
			s1 -= g[idx] * a[idx];
			s2 -= g[idx] * b[idx];
		} else {
			s[idx] = (s2 - B + 0.0) / b[idx];
			s1 -= s[idx] * a[idx];
			s2 -= s[idx] * b[idx];
			s[idx] = g[idx] - s[idx];
			break;
		}
	}

	if (s1 < A) no();
	if (s2 > B) no();

	printf("%.8lf %.8lf\n", s1, s2);

	for (int i = 0; i < n; i++)
		printf("%.8lf ", s[i]);

	return 0;
}