#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <vector>
#include <queue>
#include <iostream>
#include <algorithm>
using namespace std;

#define pb push_back
#define mp make_pair
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef pair<int,int> pt;
typedef vector<int> vi;

const int inf = 1<<30;
const int N = 1<<17;

int a[N], b[N], n, m;

bool ok(int a, int b, int l, int r, int t) {
	if (a < b) {
		int k = t / (b - a);
		if (k % 2 == 1) {
			int pos = b - t % (b - a);
			if (l <= pos && pos <= r)
				return true;
		} else {
			int pos = a + t % (b - a);
			if (l <= pos && pos <= r)
				return true;
		}
	} else {
		swap(a, b);
		int k = t / (b - a);
		if (k % 2 == 0) {
			int pos = b - t % (b - a);
			if (l <= pos && pos <= r)
				return true;
		} else {
			int pos = a + t % (b - a);
			if (l <= pos && pos <= r)
				return true;
		}
	}
	return false;
}

int main() {
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);

	cin >> n >> m;

	for (int i = 0; i < n; i++)
		cin >> a[i] >> b[i];

	for (int i = 0, l, r, t, ans; i < m; i++) {
		cin >> l >> r >> t;
		ans = 0;
		for (int j = 0; j < n; j++) {
			if (ok(a[j], b[j], l, r, t))
				ans++;
		}
		cout << ans << endl;
	}

	return 0;
}