#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <ctime>
#include <utility>
#include <cassert>
#include <vector>

#define F first
#define S second
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long LL;
typedef pair <int, int> pii;

const int inf = (int)2e9;
const int mod = (int)1e9 + 7;
const int maxn = (int)1e6;
const long double eps = 1e-10;

#define fname "burrito."

struct doner
{
	int a, b, g, p;
} t[maxn];

bool isEqual(long double x, long double y) {
	if (abs(x - y) < eps)
		return true;
	return false;
}

int n;
long double ans[maxn], ans1[maxn], a1, b1, A, B, a, b, cnt;

bool cmp(doner v, doner u)
{
	if (!u.b)
		return false;
	if (!v.b)
		return true;
	if (isEqual(v.a / (v.b + 0.0), u.a / (u.b + 0.0)))
		return false;
	if (v.a / (v.b + 0.0) > u.a / (u.b + 0.0))
		return true;
	return false;
}

void calc() {
	b1 = B;
	a1 = 0;

	for (int i = 1; i <= n; i++)
	{
		cnt = min(b1 / (t[i].b + 0.0), (long double)t[i].g);
		b1 -= cnt * t[i].b;
		a1 += cnt * t[i].a;
		ans1[t[i].p] = cnt;
	}

	return;
}

int main() {
	freopen(fname"in", "r", stdin);
	freopen(fname"out", "w", stdout);

	cin >> n;
	cin >> A >> B;
	for (int i = 1; i <= n; i++)
	{
		cin >> t[i].g >> t[i].a >> t[i].b;
		t[i].p = i;
	}

	a = -inf;
	sort(t + 1, t + 1 + n, cmp);
	calc();
	if ((a1 > a && !isEqual(a1, a)) || (isEqual(a1, a) && b1 < b)) {
		b = b1;
		a = a1;
		for (int i = 1; i <= n; ++i)
			ans[i] = ans1[i];
	}

	if ((!isEqual(a, A) && a < A) || (!isEqual(b, 0.0) && b < 0.0))
	{
		cout << -1 << " " << -1;
		return 0;
	}
	printf("%.11f %.11f\n", (double)a, (double)(B - b));
	for (int i = 1; i <= n; i++)
		printf("%.11f ", (double)ans[i]);
	return 0;
}
