#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <ctime>
#include <utility>
#include <cassert>
#include <vector>

#define F first
#define S second
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long LL;
typedef pair <int, int> pii;

const int inf = (int)1e9;
const int mod = (int)1e9 + 7;
const int maxn = (int)1e5;
const double eps = 1e-9;
const int L = 62;

#define fname "filter."

int m, f, p, n, ans[maxn], v, a[maxn], cnt, x, q;
string s;
LL mask[1050], d[1050][110];

int num(char ch)
{
	if (ch >= '0' && ch <= '9')
		return ch - '0';
   	return ch - 'a' + 10;
}

bool bit(int x, int p)
{
	if (x & (1 << p))
		return true;
  	return false;
}

int main() {
	freopen(fname"in", "r", stdin);
	freopen(fname"out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> m >> f;
	for (int i = 1; i <= f; i++)
	{
		cin >> a[i];
		a[i] %= m;
	}
	cin >> n;
	for (int i = 1; i <= n; i++)
	{
		cin >> s;
		cnt = 0;         
		for (int j = 0; j < s.length(); j++)
		{
			for (int c = 0; c < 4; c++)
			{
				d[i][cnt / L] |= bit(num(s[j]), c) * (1ll << (cnt % L));
				cnt++;
			}
		}
	}

	cin >> q;
	for (int t = 1; t <= q; t++)
	{
		cin >> x;
		x %= m;

	   for (int i = 0; i <= 100; i++)
	   {
	   		mask[i] = 0;
	   }

	
	   for (int i = 1; i <= f; i++)
	   {
	   		p = a[i] * x % m;
	   		mask[p / L] |= (1ll << (p % L));
	   }

	   for (int i = 1; i <= n; i++)
	   {
	   		if (ans[i])
	   			continue;
	   		bool f = true;
	   		for (int j = 0; j <= m / L; j++)
	   		{              
	   			if (d[i][j] != (mask[j] | d[i][j]))
	   				f = false;	
	   		}
	   		if (f)
	   		{
	   			if (!ans[i])
	   				v++;
	   			ans[i] = 1;
	   		}
	   }
	}

	cout << v << " ";
	for (int i = 1; i <= n; i++)
		if (ans[i])
			cout << i - 1 << " ";
	return 0;
}
