#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <ctime>
#include <utility>
#include <cassert>
#include <vector>

#define F first
#define S second
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long LL;
typedef pair <int, int> pii;

const int inf = (int)1e9;
const int mod = (int)1e9 + 7;
const int maxn = (int)1e6;
const double eps = 1e-9;

#define fname "knockout."

int a[maxn], b[maxn];

int pos(int v, int t, int l, int r) {
	t %= abs(2 * (b[v] - a[v]));
	if (l > r)
		swap(l, r);
	if (t <= abs(b[v] - a[v])) {
		if (b[v] >= a[v]) {
			if (a[v] + t >= l && a[v] + t <= r)
				return 1;
			return 0;
		} else {
			if (a[v] - t >= l && a[v] - t <= r)
				return 1;
			return 0;
		}
	} else {
		t -= abs(b[v] - a[v]);
		if (b[v] >= a[v]) {
			if (b[v] - t >= l && b[v] - t <= r)
				return 1;
			return 0;
		} else {
			if (b[v] + t >= l && b[v] + t <= r)
				return 1;
			return 0;
		}
	}
}

int x, y, n, m, t, ans;

int main() {
	freopen(fname"in", "r", stdin);
	freopen(fname"out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 1; i <= n; ++i)
		cin >> a[i] >> b[i];

	for (int i = 1; i <= m; ++i) {
		cin >> x >> y >> t;

		ans = 0;
		for (int j = 1; j <= n; ++j)
			ans += pos(j, t, x, y);

		cout << ans << '\n';
	}

	return 0;
}
