import static java.lang.Math.*;
import java.io.*;
import java.util.*;

public class a {
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	boolean debug = false;

	public String next() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (Exception e) {
				// TODO: handle exception
			}
		}
		return st.nextToken();
	}

	public int nextInt() {
		return Integer.parseInt(next());
	}

	public long nextLong() {
		return Long.parseLong(next());
	}

	int n;
	int[] a;

	public int go(boolean[] skip, int l, int r, int cur) {
		for (int i = cur; i < n; i++) {
			if (skip[i]) {
				continue;
			}
			while (l < n && skip[l]) {
				l++;
			}
			while (r >= 0 && skip[r]) {
				r--;
			}
			if (l >= r) {
				break;
			}
			if (a[i] != l && a[i] != r) {
				int c = 1;
				int x = a[i] - l;
				int y = r - a[i];
				int z = min(x, y);
				while (i + c < n && a[i + c] != l && a[i + c] != r) {
					if (c > z) {
						break;
					}
					c++;
				}

				if (c == z) {
					c = 0;
					while (i + c < n && a[i + c] != l && a[i + c] != r) {
						skip[a[i + c]] = true;
						c++;
					}
					int ans1 = go(Arrays.copyOf(skip, n), l, r, i + 1);
					c = 0;
					while (i + c < n && a[i + c] != l && a[i + c] != r) {
						skip[a[i + c]] = false;
						c++;
					}

					if (x == y) {
						for (int j = a[i] + 1; j <= r; j++) {
							skip[j] = true;
						}
						int ans2 = go(Arrays.copyOf(skip, n), l, r, i + 1);
						for (int j = a[i] + 1; j <= r; j++) {
							skip[j] = false;
						}

						for (int j = l; j < a[i]; j++) {
							skip[j] = true;
						}
						int ans3 = go(Arrays.copyOf(skip, n), l, r, i + 1);
						for (int j = l; j < a[i]; j++) {
							skip[j] = false;
						}

						return max(ans1, max(ans2, ans3));
					} else if (x > y) {
						for (int j = a[i] + 1; j <= r; j++) {
							skip[j] = true;
						}
						int ans2 = go(Arrays.copyOf(skip, n), l, r, i + 1);
						for (int j = a[i] + 1; j <= r; j++) {
							skip[j] = false;
						}

						return max(ans1, ans2);

					} else {
						for (int j = l; j < a[i]; j++) {
							skip[j] = true;
						}
						int ans3 = go(Arrays.copyOf(skip, n), l, r, i + 1);
						for (int j = l; j < a[i]; j++) {
							skip[j] = false;
						}
						return max(ans1, ans3);
					}
				} else if (c < z) {
					c = 0;
					while (i + c < n && a[i + c] != l && a[i + c] != r) {
						skip[a[i + c]] = true;
						c++;
					}
				} else {
					if (x == y) {
						for (int j = a[i] + 1; j <= r; j++) {
							skip[j] = true;
						}
						int ans2 = go(Arrays.copyOf(skip, n), l, r, i + 1);
						for (int j = a[i] + 1; j <= r; j++) {
							skip[j] = false;
						}

						for (int j = l; j < a[i]; j++) {
							skip[j] = true;
						}
						int ans3 = go(Arrays.copyOf(skip, n), l, r, i + 1);
						for (int j = l; j < a[i]; j++) {
							skip[j] = false;
						}

						return max(ans2, ans3);
					} else if (x > y) {
						for (int j = a[i] + 1; j <= r; j++) {
							skip[j] = true;
						}
					} else {
						for (int j = l; j < a[i]; j++) {
							skip[j] = true;
						}
					}
				}
			} else {
				if (a[i] == l) {
					l++;
				} else {
					r--;
				}

			}
		}

		int ans = n;
		for (int j = 0; j < n; j++) {
			if (skip[j]) {
				ans--;
			}
		}
		return ans;
	}

	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader("improvements.in"));
		out = new PrintWriter(new FileWriter("improvements.out"));

		n = nextInt();
		a = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextInt() - 1;
		}

		boolean[] skip = new boolean[n];
		out.println(go(skip, 0, n-1, 0));
		
		out.close();
	}

	public static void main(String[] args) throws Exception {
		new a().run();
	}
}
