#include <stdio.h>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;
#define mk make_pair
#define pb push_back
typedef pair<int, int> PII;
const int maxn = 222222;
int n;
int x[maxn];
int left[maxn];
int right[maxn];
PII c[maxn << 1];
bool U[maxn], used[maxn];

int myG[maxn << 2];
int nextG[maxn << 2];
int idG[maxn];
int lenG;
void run(int u){
    used[u] = true;
    for(int i = idG[u]; i ; i = nextG[i]) if(!used[myG[i]]) run(myG[i]);
}
void addG(int u, int v){
    lenG ++;
    myG[lenG] = v;
    nextG[lenG] = idG[u];
    idG[u] = lenG;
}
int main(){
    freopen("improvements.in","r",stdin);
    freopen("improvements.out","w",stdout);
    scanf("%d",&n);
    for(int i = 0, last = 0; i < n; i ++){
        scanf("%d",x + i);
        left[i] = last;
        right[i] = x[i];
        last = x[i];
        if(left[i] > right[i]) swap(left[i], right[i]);
        c[i << 1] = mk(left[i], i);
        c[i << 1 | 1] = mk(right[i], i);
    }
    sort(c,c + (n << 1));
    set<PII> myset;
    for(int i = 0, j = 0; i < (n << 1); j = i){
        while(j < (n << 1) && c[i].first == c[j].first) j ++;
        for(int k = i; k < j; k ++)
            if(U[c[k].second]) myset.erase(mk(right[c[k].second], c[k].second));
        for(int k = i; k < j; k ++){
            if(U[c[k].second]) continue;
            if(!myset.empty()){
                int u = myset.begin()->second;
                int v = c[k].second;
                if(right[v] > right[u]){
                    addG(v, u);
                    addG(u, v);
                }
            }
        }
        for(int k = i; k < j; k ++){
            if(!U[c[k].second]){
                U[c[k].second] = true;
                myset.insert(mk(right[c[k].second], c[k].second));
            }
        }
        i = j;
    }
    int res = 0;
    for(int i = 0; i < n; i ++){
        if(!used[i]){
            run(i);
            res ++;
        }
    }
    printf("%d\n", res);
    return 0;
}
