#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <utility>
#include <queue>
#include <stack>
#include <bitset>

using namespace std;

#define filename "filter"

const int MAXN = 1050;

int n, m, fn;
int a[MAXN];
bitset <MAXN> df[MAXN];
char s[MAXN];
int user[MAXN];
bool ans[MAXN];
int q;

int main() { 
	assert(freopen(filename ".in", "r", stdin));
	assert(freopen(filename ".out", "w", stdout));

	scanf("%d %d", &m, &fn);
	for (int i = 1; i <= fn; i++)
		scanf("%d", &a[i]);

	scanf("%d\n", &n);
	for (int i = 1; i <= n; i++) {
		gets(s);
		int len = strlen(s);
		
		int pos = 0;
		for (int j = 0; j < len; j++) {
			int x;
			if (s[j] >= '0' && s[j] <= '9')
				x = s[j] - '0';
			else
				x = s[j] - 'a' + 10;
			for (int k = 0; k < 4; k++) {
				if (x & (1 << k)) {
					df[i][pos] = 1;
				}
				pos++;
			}	
		}
		//cout << df[i];
		//cout << endl;
	}

	scanf("%d", &q);
	for (int i = 1; i <= q; i++) {
		scanf("%d", &user[i]);
	}

	for (int i = 1; i <= q; i++) {
		bitset <MAXN> curmask;
		for (int j = 1; j <= fn; j++) {
			int pos = (1ll * a[j] * user[i]) % m;
			curmask[pos] = 1;
		}
		for (int j = 1; j <= n; j++) {
			if ((curmask & df[j]) == curmask)
				ans[j] = true;
		}
	}	

	int ansn = 0;
	for (int i = 1; i <= n; i++)
		if (ans[i])
			ansn++;
	
	printf("%d ", ansn);
	for (int i = 1; i <= n; i++)
		if (ans[i])
			printf("%d ", i - 1);

	return 0;
}