#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cassert>
#include <utility>
#include <queue>
#include <stack>

using namespace std;

#define filename "knockout"

const int MAXN = 1050;         

int n, m;
int a[MAXN], b[MAXN];

int main() { 
	assert(freopen(filename ".in", "r", stdin));
	assert(freopen(filename ".out", "w", stdout));

	scanf("%d %d", &n, &m);

	for (int i = 1; i <= n; i++)
		scanf("%d %d", &a[i], &b[i]);

	for (int i = 1; i <= m; i++) {
		int from, to, t;
		int res = 0;
		scanf("%d %d %d", &from, &to, &t);

		for (int j = 1; j <= n; j++) {  	
			int curt = t;
			int len = 2 * (b[j] - a[j]);
			curt = curt % len;
			int pos;
			if (curt <= len / 2)
				pos = a[j] + curt;
			else {
				curt = curt - (len / 2);
				pos = a[j] - curt;
			}
			
			if (pos >= from && pos <= to)
				res++;
		}

		printf("%d\n", res);
	}

	return 0;
}
