import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;


public class Solution {
	
	private static BufferedReader in;
	private static StringTokenizer st;
	private static PrintWriter out;

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
//		standart();
		file("knockout");
		int n = nextInt();
		int m = nextInt();
		int a[] = new int [n+1];
		int b[] = new int [n+1];
		for (int i = 1; i <=n; i++) {
			a[i] = nextInt();
			b[i] = nextInt();
		}
		for (int i = 1; i <= m; i++) {
			int x = nextInt();
			int y = nextInt();
			int t = nextInt();
			int ans = 0;
			for (int j = 1; j <= n; j++) {
				int curr = getCoor(a[j],b[j],t);
				if(x <= curr && curr <= y){
					ans++;
				}
			}
			out.println(ans);
		}
		out.close();
	}

	private static int getCoor(int a, int b, int t) {
		if(t == 0){
			return a;
		}
		int x = t % Math.abs(a-b);
		int k = t / Math.abs(a-b);
		if(a < b){
			if(k % 2 == 0){
				x = a + x;
			}else{
				x = b - x;
			}
		}else{
			if(k % 2 == 0){
				x = b + x;
			}else{
				x = a - x;
			}
		}
		return x;
	}

	private static long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(next());
	}

	private static double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(next());
	}

	private static int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(next());
	}

	private static String next() throws IOException {
		while(!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	private static void file(String file) throws IOException {
		in = new BufferedReader(new FileReader(new File(file+".in")));
		st = new StringTokenizer("");
		out=  new PrintWriter(new BufferedWriter(new FileWriter(file+".out")));
	}

	private static void standart() {
		in = new BufferedReader(new InputStreamReader(System.in));
		st = new StringTokenizer("");
		out = new PrintWriter(new OutputStreamWriter(System.out));
	}
}
