#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <string>
#include <cstring>
#include <vector>

using namespace std;

  int l,r,i,n,len,sz,tree[4000001],b[1000001],ans;
 
  struct Pair{ int x;int id; int f; } a[1000001];
  bool cmp(Pair q, Pair w){ return q.x < w.x || (q.x == w.x && q.id > w.id) || (q.x == w.x && q.id == 0 && w.id == 0 && q.f > w.f); }

    void update(int x)
{
    x /= 2;
    while(x > 0)
    {
         tree[x] = tree[x*2] + tree[x*2+1];
         x /= 2;
    }
}
    int sum(int l, int r)
{
    l += sz;
    r += sz;
    int s = 0;
    while(l <= r)
    {
         if (l % 2 == 1) s += tree[l];
         if (r % 2 == 0) s += tree[r];
         l = (l + 1) / 2;
         r = (r - 1) / 2;
    }
    return s;
}

int main() {
    freopen("improvements.in","r",stdin);
    freopen("improvements.out","w",stdout);


    cin>>n;
    sz = 1;
    while(sz < 200000)
    {
         sz *= 2;
    }

    for(i = 1; i <= n; i++)
    {
         scanf("%d",&b[i]);
         l = b[i-1]; r = b[i];
         if (l > r) swap(l,r);
         a[++len].x = l;
         a[len].f = r;
         a[len].id = 0;
         a[++len].x = r;
         a[len].id = 1;
    }
    sort(a+1,a+len+1,cmp);

    for(i = 1; i <= len; i++)
    {
         if (a[i].id == 0)
         {
          	  tree[a[i].f+sz]++;
          	  update(a[i].f+sz);
          	  ans += sum(0, a[i].f-1);
         } else
         {
         	  tree[a[i].x+sz]--;
         	  update(a[i].x+sz);
         }
    }
    cout<<n-ans;

}