#include <iostream>
#include <cstdio>
#include <fstream>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <utility>
#include <algorithm>
#include <ctime>
#include <stdio.h>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define sqr(x) ((x)*(x))
#define pii pair<int, int>
#define vi vector<int>
#define ll long long
#define ull unsigned long long
#define sz(a) (int)a.size()
#define file "filter"

const int inf = (int)1e9;
const int mod = (int)1e9 + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int m, f, a[222];
int n;
string s[2222];
vector <int> v[2222];
int q;
int u[2222];

int getval(char c) {
	if(c <= '9' && c >= '0') return c - '0';
	return c - 'a' + 10;
}

vi get(string s) {
	vi ans;
	for(int i = 0; i < sz(s); i++) {
		int x = getval(s[i]);
		for(int j = 0; j < 4; j++) {
			ans.pb(x % 2);
			x /= 2;
		}
	}
	while(sz(ans) > m) ans.pop_back();
	return ans;
}

int main () {

	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);

	cin >> m >> f;
	for(int i = 0; i < f; i++) {
		cin >> a[i];
		a[i] %= m;
	}
	cin >> n;
	for(int i = 0; i < n; i++) {
		cin >> s[i];
		v[i] = get(s[i]);
	}
	cin >> q;
	for(int i = 0; i < q; i++) {
		cin >> u[i];
		u[i] %= m;
	}

	vi ans;

	for(int i = 0; i < n; i++) {
		bool res = 0;
		for(int j = 0; j < q; j++) {
			bool ok = 1;
			for(int t = 0; t < f; t++) {
				int x = (a[t] * u[j]) % m;
				if(!v[i][x]) ok = 0;
			}
			res |= ok;
		}
		if(res) ans.pb(i);
	}

	cout << sz(ans);
	forit(it, ans) cout << " " << *it;
	cout << endl;

	return 0;
}
