#include <iostream>
#include <cstdio>
#include <fstream>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <utility>
#include <algorithm>
#include <ctime>
#include <stdio.h>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define sqr(x) ((x)*(x))
#define pii pair<int, int>
#define vi vector<int>
#define ll long long
#define ull unsigned long long
#define sz(a) (int)a.size()
#define file "improvements"

const int inf = (int)1e9;
const int mod = (int)1e9 + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int d1[212345], d2[212345];
int T[2][212345*4];
int a[212345];
int n;

int get(int v, int tl, int tr, int l, int r, int id){
	if ( l > tr || r < tl ) return 0;
	if ( l <= tl && tr <= r ) return T[id][v];
	int mid = (tl + tr)/2;
	return max(get(2*v, tl, mid, l, r, id), get(2*v+1, mid+1, tr, l, r, id));
}

void update(int v, int tl, int tr, int pos, int val, int id){
	if ( tl == tr ){
		T[id][v] = val;
		return;
	}
	int mid = (tl + tr)/2;
	if ( pos <= mid ) update(2*v, tl, mid, pos, val, id);
	else update(2*v+1, mid+1, tr, pos, val, id);
	T[id][v] = max(T[id][2*v], T[id][2*v+1]);
}

int main () {
	
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);

	scanf("%d", &n);

	for (int i=1;i<=n;i++){
		scanf("%d", &a[i]);	
	}

	int ansx = 0, ansy = 0;

	for (int i=1;i<=n;i++){
		int t = get(1, 1, n, 1, a[i] - 1, 0);
		t++;
		ansx = max(t, ansx);
		update(1, 1, n, a[i], t, 0);
	}

	for (int i=n;i>=1;i--){
		int t = get(1, 1 , n, a[i]+1, n, 1);
		t++;
		ansy = max(t, ansy);
		update(1, 1, n, a[i], t, 1);
	}

	cout <<ansx+ansy-2<<endl;


		



	return 0;
}




