#include <iostream>
#include <fstream>
#include <cstdio>
#include <iomanip>
#include <cassert>
#include <cmath>
#include <math.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <ctime>
#include <string>
#include <cstdlib>

using namespace std;

#define sz(x) ((int)((x).size()))

const int MAXN = (int)(1e5) + 10;
const double EPS = (1e-9);

int n, A, B;
double sm1, sm2;
int g[MAXN], a[MAXN], b[MAXN];
int pos[MAXN];
double s[MAXN];

bool cmp(int i, int j) {
	return a[i] < a[j] || (a[i] == a[j] && b[i] > b[j]);
}

int main() {
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	scanf("%d%d%d", &n, &A, &B);
	sm1 = 0.0;
	sm2 = 0.0;
	for (int i = 0; i < n; i++) {
		scanf("%d%d%d", &g[i], &a[i], &b[i]);
		sm1 += g[i] * 1.0 * a[i];
		sm2 += g[i] * 1.0 * b[i];
		s[i] = g[i];
		pos[i] = i;
	}
	sort(pos, pos + n, cmp);
	for (int i = 0; i < n && sm2 > B; i++) {
		int id = pos[i];
		if (b[id] == 0)
			continue;
		sm1 -= s[id] * 1.0 * a[id];
		sm2 -= s[id] * 1.0 * b[id];
		s[id] = (B - sm2) / b[id];
		s[id] = max(s[id], 0.0);
		s[id] = min(s[id], g[id] + 0.0);
		sm1 += s[id] * 1.0 * a[id];
		sm2 += s[id] * 1.0 * b[id];
	}
	if (sm1 < A|| sm2 > B) {
		puts("-1 -1");
		return 0;
	}
	printf("%.12f %.12f\n", sm1, sm2);
	for (int i = 0; i < n; i++) {
		printf("%.12f%c", s[i], " \n"[i == n - 1]);
	}

	return 0;
}
