#include <iostream>
#include <fstream>
#include <cstdio>
#include <iomanip>
#include <cassert>
#include <cmath>
#include <math.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <ctime>
#include <string>
#include <cstdlib>

using namespace std;

#define sz(x) ((int)((x).size()))

int cntDig(int x) {
	if (x == 0)
		return 1;
	int res = 0;
	while (x > 0) {
		res++;
		x /= 10;
	}
	return res;
}

char str[1050];
string tmp;
int len, n;
bool used[100];
int a[1050], m;

bool go(int pos) {
	if (pos == len) {
		for (int i = 0; i < m; i++) {
			printf("%d%c", a[i], " \n"[i == n - 1]);
		}
		return true;
	}
	int x = str[pos] - '0';
	if (x > 0 && !used[x]) {
		used[x] = true;
		a[m++] = x;
		if (go(pos + 1))
			return true;
		--m;
		used[x] = false;
	}
	if (pos + 1 < n) {
		x = (str[pos] - '0') * 10 + str[pos + 1] - '0';
		if (!used[x]) {
			used[x] = true;
			a[m++] = x;
			if (go(pos + 2))
				return true;
			--m;
			used[x] = false;
		}
	}
	return false;
}

int main() {
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);

	scanf("%s", str);
	tmp = str;
	len = tmp.length();
	n = 0;
	for (int i = 1; i < 100; i++) {
		n += cntDig(i);
		if (n == len)
			break;
	}
	go(0);

	return 0;
}
