/**********************************
**      Solution by NU #2        **
**********************************/
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

#define all(x) (x)begin(), (x).end()
#define File "burrito"
#define F first
#define S second

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const double EPS = 1e-9;
const double PI = acos(-1.0);
const int INF = 2000 * 1000 * 1000;
const int MOD = 1000 * 1000 * 1000 + 7;
const int MAXN = 100010;

struct Item {
  	int a, b, g;
  	int num;

  	bool operator < (const Item& it) const {
  		return a * it.b > b * it.a;
  	}

  	void read() {
  	 	scanf("%d%d%d", &g, &a, &b);
  	}
};

Item ar[MAXN];
int A, B, n;
double res[MAXN];

int main() {
	freopen(File".in", "r", stdin);
	freopen(File".out", "w", stdout);
	
	scanf("%d%d%d", &n, &A, &B);

	for (int i = 0; i < n; i++) {
		ar[i].read();
		ar[i].num = i;
	}

	sort(ar, ar + n);
	double cura = 0, curb = 0;

	for (int i = 0; i < n; i++) {
	 	if (ar[i].g * ar[i].b + curb > B) {
			double temp = (B - curb) / ar[i].b;
			curb = (double)B;
	 	 	cura += temp * ar[i].a;
	 	 	res[ar[i].num] = temp;
	 	} else {
	 	 	curb += ar[i].g * ar[i].b;
	 	 	cura += ar[i].g * ar[i].a;
	 	 	res[ar[i].num] = ar[i].g;
	 	}
	}

	if (cura >= A && curb <= B) {
	 	printf("%.10f %.10f\n", cura, curb);
	 	for (int i = 0; i < n; i++) {
	 	 	printf("%.10f ", res[i]);
	 	}
	} else {
	 	puts("-1 -1");
	}

	return 0;
}
