/**********************************
**      Solution by NU #2        **
**********************************/
#include <bits/stdc++.h>

using namespace std;

#define all(x) (x)begin(), (x).end()
#define File "filter"
#define F first
#define S second

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const double EPS = 1e-9;
const double PI = acos(-1.0);
const int INF = 2000 * 1000 * 1000;
const int MOD = 1000 * 1000 * 1000 + 7;
const int MAXN = 1010;

int num(char c) {
	return (c <= '9') * (c - '0') + (c > '9') * (c - 'a' + 10);
}

int m, f, n;
int a[110];
char s[MAXN][500];
bool used[MAXN];
int q, u;

int get_bit(char *s, int p) {
	int outpos = p >> 2;
	int inpos = p & 3;

   	int temp = num(s[outpos]);

   	return (temp >> (inpos)) & 1;
}

int main() {
	freopen(File".in", "r", stdin);
	freopen(File".out", "w", stdout);
	
	scanf("%d %d ", &m, &f);

	for (int i = 0; i < f; i++) {
	 	scanf("%d ", &a[i]);
	}

	scanf("%d\n", &n);

	for (int i = 0; i < n; i++) {
		gets(s[i]);
	}

	/*for (int i = 0; i < n; i++) {
	 	for (int j = 0; j < m; j++)
	 		cerr << get_bit(s[i], j);
	 	cerr << endl;
	}*/

	scanf("%d", &q);

	while (q--) {
		scanf("%d", &u);

		for (int i = 0; i < n; i++) {
		 	bool contains = true;

		 	for (int j = 0; j < f && contains; j++) {
		 		int pos = (1ll * u * a[j]) % m;
		 		contains &= get_bit(s[i], pos);
		 	}

		 	used[i] |= contains;
		}
	}

	int ans = 0;
	for (int i = 0; i < n; i++)
		ans += used[i];

	printf("%d ", ans);
	for (int i = 0; i < n; i++)
		if (used[i])
			printf("%d ", i);

	return 0;
}
