/**********************************
**      Solution by NU #2        **
**********************************/
#include <bits/stdc++.h>

using namespace std;

#define all(x) (x)begin(), (x).end()
#define File "knockout"
#define F first
#define S second

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const double EPS = 1e-9;
const double PI = acos(-1.0);
const int INF = 2000 * 1000 * 1000;
const int MOD = 1000 * 1000 * 1000 + 7;
const int MAXN = 1010;

int n, m;
int a[MAXN], b[MAXN];
int x, y, t;

int f(int a, int b, int t) {
 	if (a == b)
 		return a;

 	int d = abs(b - a);
 	int temp = t / d;
 	int md = t % d;

 	int dist = 0;
 	if (temp & 1) { // odd
 		if (a > b) {
 			dist = a - md;
 		} else {
 		    dist = b - md;
 		}
 	} else { // even
 		if (a > b) {
			dist = b + md;
 		} else {
 			dist = a + md;
 		}
 	}

 	return dist;
}

int main() {
	freopen(File".in", "r", stdin);
	freopen(File".out", "w", stdout);
	
	scanf("%d%d", &n, &m);
	
	for (int i = 0; i < n; i++) {
	 	scanf("%d%d", &a[i], &b[i]);
	}

	while (m--) {
	 	scanf("%d%d%d", &x, &y, &t);

	 	int ans = 0;
	 	for (int i = 0; i < n; i++) {
			int val = f(a[i], b[i], t);

			if (x <= val && val <= y)
				ans++;
	 	}

	 	printf("%d\n", ans);
	}

	return 0;
}
