#include <stdio.h>
#include <algorithm>
#include <math.h>
#include <vector>
#include <set>
using namespace std;
const int MX = 100005;
int n, x[MX], lt[MX], rt[MX];
pair <int, int> c[2*MX];
bool u[MX], us[MX];
vector <int> g[MX];
void dfs (int v){
    us[v] = 1;
    for (int i = 0; i < g[v].size(); i++){
        int t = g[v][i];
        if (!us[t]) dfs (t);
    }
}
int main(){
    freopen ("improvements.in", "rt", stdin);
    freopen ("improvements.out", "wt", stdout);
    scanf("%d",&n);
    for(int i = 0, tek = 0; i < n ; i ++){
        scanf ("%d", &x[i]);
        lt[i] = tek;
        tek = rt[i] = x[i];
        if (rt[i] < lt[i]) swap (lt[i], rt[i]);
        c[2*i] = make_pair (lt[i], i);
        c[2*i + 1] = make_pair (rt[i], i);
    }
    sort (c, c + 2*n);
    set < pair <int, int> > st;
    for (int i = 0; i < 2*n;){
        int j = i;
        while (j < 2*n && c[i].first == c[j].first) j++;
        for (int k = i; k < j; k++){
            if (u[c[k].second]) st.erase (make_pair(rt[c[k].second], c[k].second));
        }
        for (int k = i; k < j; k++){
            if (u[c[k].second]) continue;
            if (!st.empty()){
                int v = c[k].second;
                int u = st.begin()->second;
                if (rt[v] > rt[u]){
                    g[v].push_back (u);
                    g[u].push_back (v);
                }
            }
        }
        for (int k = i; k < j; k++){
            if (!u[c[k].second]){
                u[c[k].second] = 1;
                st.insert (make_pair (rt[c[k].second], c[k].second));
            }
        }
        i = j;
    }
    int sm = 0;
    for(int i = 0 ; i < n ; i ++)
        if (!us[i]){
            dfs (i);
            sm ++;
        }
    printf ("%d", sm);
    return 0;
}

